// #pragma GCC optimize("popcnt")

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

#define pbc push_back
#define pob pop_back()
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define vin(a)        \
    for (auto& i : a) \
    cin >> i

// mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

template <typename T1, typename T2>
inline void chkmin(T1& x, const T2& y) {
    if (y < x)
        x = y;
}

template <typename T1, typename T2>
inline void chkmax(T1& x, const T2& y) {
    if (x < y)
        x = y;
}

const int MOD = 1e9 + 7;

int add(int a, int b) {
    a += b;
    if (a >= MOD)
        a -= MOD;
    return a;
}

int sub(int a, int b) {
    a -= b;
    if (a < 0)
        a += MOD;
    return a;
}

int mul(int a, int b) {
    return (ll)a * b % MOD;
}

struct State {
    int mask_cnt;
    int sum;
    bool operator<(const State& other) const {
        return mask_cnt < other.mask_cnt;
    }
};

void Merge(vector<State>& dp) {
    if (dp.empty()) {
        return;
    }
    sort(all(dp));
    int top = 0;
    for (int i = 1; i < (int)dp.size(); ++i) {
        if (dp[top].mask_cnt == dp[i].mask_cnt) {
            dp[top].sum = add(dp[top].sum, dp[i].sum);
        } else {
            ++top;
            dp[top] = dp[i];
        }
    }
    dp.resize(top + 1);
}

int n, k;

// ull kTotalMask;
// ull kNextMask;

void ProcessMask(State& state) {
    state.mask_cnt /= (k + 1);
}

vector<vector<int>> masks;

void BuildMasks() {
    masks.assign(k + 1, {});
    for (int mask = 0; mask < (1 << k); ++mask) {
        masks[__builtin_popcount(mask)].push_back(mask);
    }
}

void Print(int mask_cnt, int add_mask) {
    for (int i = 0; i < k; ++i) {
        cerr << add_mask % 2 << " " << mask_cnt % (k + 1) << endl;
        add_mask /= 2;
        mask_cnt /= (k + 1);
    }
}

void ProcessMaskCnt(int& mask_cnt, int add_mask) {
    // cerr << "ProcessMaskCnt:" << endl;
    // Print(mask_cnt, add_mask);
    // cerr << endl;
    for (int p = 1, i = 0; i < k; p *= (k + 1), ++i) {
        if ((add_mask >> i) & 1) {
            mask_cnt += p;
        }
    }
    // Print(mask_cnt, add_mask);
    // cerr << endl;
}

void ProcessState(State state, int val, vector<State>& ndp) {
    int cnt_needed = val;
    // for (auto i : state.cnt) {
    //     cnt_needed -= i;
    // }
    for (int i = 0, mask_cnt = state.mask_cnt; i < k; ++i, mask_cnt /= (k + 1)) {
        cnt_needed -= mask_cnt % (k + 1);
    }
    if (cnt_needed < 0 || cnt_needed > k)
        return;
    for (int add_mask : masks[cnt_needed]) {
        // vector<int> ncnt = state.cnt;
        // ncnt.push_back(0);
        // assert((int)ncnt.size() == k);
        // for (int bit = 0; bit < k; ++bit) {
        //     if ((add_mask >> bit) & 1) {
        //         ncnt[bit]++;
        //     }
        // }
        int new_mask_cnt = state.mask_cnt;
        ProcessMaskCnt(new_mask_cnt, add_mask);
        ndp.push_back(State{
            .mask_cnt = new_mask_cnt,
            .sum = state.sum,
        });
    }
}

vector<State> ndp;

void Relax(int val, vector<State>& dp) {
    ndp.clear();

    for (auto state : dp) {
        // assert((int)state.cnt.size() == k - 1);
        ProcessState(state, val, ndp);
    }

    for (auto& state : ndp) {
        // assert((int)state.cnt.size() == k);
        ProcessMask(state);
    }

    Merge(ndp);
    dp.swap(ndp);
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cout.precision(20), cout.setf(ios::fixed);
    vector<int> b;

    cin >> n >> k;
    BuildMasks();
    b.resize(n);
    vin(b);

    vector<State> dp;
    dp.push_back(State{
        // .cnt = vector<int>(k - 1, 0),
        .mask_cnt = 0,
        .sum = 1,
    });

    for (auto i : b) {
        Relax(i, dp);
    }
    int ans = 0;
    for (auto& [_, sum] : dp) {
        ans = add(ans, sum);
    }
    cout << ans << "\n";
    return 0;
}
