#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

#define pbc push_back
#define pob pop_back()
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define vin(a)        \
    for (auto& i : a) \
    cin >> i

// mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

template <typename T1, typename T2>
inline void chkmin(T1& x, const T2& y) {
    if (y < x)
        x = y;
}

template <typename T1, typename T2>
inline void chkmax(T1& x, const T2& y) {
    if (x < y)
        x = y;
}

const int MOD = 1e9 + 7;

int add(int a, int b) {
    a += b;
    if (a >= MOD)
        a -= MOD;
    return a;
}

int sub(int a, int b) {
    a -= b;
    if (a < 0)
        a += MOD;
    return a;
}

int mul(int a, int b) {
    return (ll)a * b % MOD;
}

struct State {
    ull mask;
    int sum;
    bool operator<(const State& other) const {
        return mask < other.mask;
    }
};

void Merge(vector<State>& dp) {
    sort(all(dp));
    int top = 0;
    for (int i = 1; i < dp.size(); ++i) {
        if (dp[top].mask == dp[i].mask) {
            dp[top].sum = add(dp[top].sum, dp[i].sum);
        } else {
            ++top;
            dp[top] = dp[i];
        }
    }
    dp.resize(top + 1);
}

int n, k;

void ProcessMask(State& state) {
    ull nmask = state.mask;
    for (int i = 0; i < k; ++i) {
        int pos = i + i * k;
        if ((nmask >> pos) & 1) {
            nmask ^= (1ULL << pos);
        }
    }
    nmask >>= k;
    state.mask = nmask;
}

void ProcessState(State state, int val, vector<State>& ndp) {
    for (ull add_mask = 0; add_mask < (1 << k); ++add_mask) {
        ull new_mask = state.mask | (add_mask << (k * (k - 1)));
        if (__builtin_popcountll(new_mask) == val) {
            ndp.push_back(State{
                .mask = new_mask,
                .sum = state.sum,
            });
        }
    }
}

void Relax(int val, vector<State>& dp) {
    for (auto& state : dp) {
        ProcessMask(state);
    }
    Merge(dp);

    vector<State> ndp;

    for (auto state : dp) {
        ProcessState(state, val, ndp);
    }
    Merge(ndp);
    dp.swap(ndp);
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cout.precision(20), cout.setf(ios::fixed);
    vector<int> b;

    cin >> n >> k;
    b.resize(n);
    vin(b);

    vector<State> dp;
    dp.push_back(State{
        .mask = 0,
        .sum = 1,
    });

    for (auto i : b) {
        Relax(i, dp);
    }
    int ans = 0;
    for (auto [mask, sum] : dp) {
        ans = add(ans, sum);
    }
    cout << ans << "\n";
    return 0;
}
