// #pragma GCC optimize("popcnt")

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

#define pbc push_back
#define pob pop_back()
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define vin(a)        \
    for (auto& i : a) \
    cin >> i

// mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

template <typename T1, typename T2>
inline void chkmin(T1& x, const T2& y) {
    if (y < x)
        x = y;
}

template <typename T1, typename T2>
inline void chkmax(T1& x, const T2& y) {
    if (x < y)
        x = y;
}

const int MOD = 1e9 + 7;

int add(int a, int b) {
    a += b;
    if (a >= MOD)
        a -= MOD;
    return a;
}

int sub(int a, int b) {
    a -= b;
    if (a < 0)
        a += MOD;
    return a;
}

int mul(int a, int b) {
    return (ll)a * b % MOD;
}

struct State {
    vector<int> cnt;
    int sum;
    bool operator<(const State& other) const {
        return cnt < other.cnt;
    }
};

void Merge(vector<State>& dp) {
    if (dp.empty()) {
        return;
    }
    sort(all(dp));
    int top = 0;

    // cerr << "dp = " << endl;
    // for (auto [cnt, sum] : dp) {
    //     cerr << cnt.size() << " " << sum << endl;
    // }

    for (int i = 1; i < (int)dp.size(); ++i) {
        if (dp[top].cnt == dp[i].cnt) {
            dp[top].sum = add(dp[top].sum, dp[i].sum);
        } else {
            ++top;
            dp[top] = dp[i];
        }
    }
    dp.resize(top + 1);
    // cerr << "top = " << top << endl;

    // cerr << "dp = " << endl;
    // for (auto [cnt, sum] : dp) {
    //     cerr << cnt.size() << " " << sum << endl;
    // }
}

int n, k;

// ull kTotalMask;
// ull kNextMask;

void ProcessMask(State& state) {
    assert(state.cnt.size() == k);
    state.cnt.erase(state.cnt.begin());
}

vector<vector<ull>> masks;

void BuildMasks() {
    masks.assign(k + 1, {});
    for (ull mask = 0; mask < (1 << k); ++mask) {
        masks[__builtin_popcountll(mask)].push_back(mask);
    }
    // kTotalMask = (1ULL << (k * k)) - 1;
    // kNextMask = kTotalMask;
    // for (int i = 0; i < k; ++i) {
    //     kNextMask ^= (1ULL << (i + i * k));
    // }
}

void ProcessState(State state, int val, vector<State>& ndp) {
    int cnt_needed = val;
    for (auto i : state.cnt) {
        cnt_needed -= i;
    }
    if (cnt_needed < 0 || cnt_needed > k)
        return;
    for (ull add_mask : masks[cnt_needed]) {
        vector<int> ncnt = state.cnt;
        ncnt.push_back(0);
        assert((int)ncnt.size() == k);
        for (int bit = 0; bit < k; ++bit) {
            if ((add_mask >> bit) & 1) {
                ncnt[bit]++;
            }
        }
        ndp.push_back(State{
            .cnt = ncnt,
            .sum = state.sum,
        });
    }
}

void Relax(int val, vector<State>& dp) {
    for (auto& state : dp) {
        // cerr << "val = " << val << " " << state.cnt.size() << endl;
        assert((int)state.cnt.size() == k);
        ProcessMask(state);
    }
    Merge(dp);

    // cerr << "val = " << val << endl;

    vector<State> ndp;
    for (auto state : dp) {
        assert((int)state.cnt.size() == k - 1);
        ProcessState(state, val, ndp);
    }

    for (auto state : ndp) {
        assert((int)state.cnt.size() == k);
    }

    Merge(ndp);
    for (auto state : ndp) {
        assert((int)state.cnt.size() == k);
    }

    dp = ndp;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cout.precision(20), cout.setf(ios::fixed);
    vector<int> b;

    cin >> n >> k;
    BuildMasks();
    b.resize(n);
    vin(b);

    vector<State> dp;
    dp.push_back(State{
        .cnt = vector<int>(k, 0),
        .sum = 1,
    });

    for (auto i : b) {
        // cerr << i << endl;
        Relax(i, dp);
        // cerr << i << endl;
        // cerr << dp.size() << endl;
    }
    int ans = 0;
    for (auto& [_, sum] : dp) {
        ans = add(ans, sum);
    }
    cout << ans << "\n";
    return 0;
}
