#include <bits/stdc++.h>

using namespace std;

#define CE constexpr

#ifdef DBG
#define debugf(s, ...) fprintf(stderr, "(" #__VA_ARGS__ ") " s "\n", __VA_ARGS__)
#else
#define debugf(...) void(0)
#endif

using i64 = int64_t;
using i128 = __int128;

template <int MOD>
struct mint {
    int val = 0;
    CE mint() = default;

    CE mint(int x) : val(x < 0 ? x + MOD : x) {
    }

    template <class Num> CE mint(Num x) : mint(int(x % MOD)) {
    }

    CE mint &operator+=(mint x) {
        val += x.val;
        if (val >= MOD) val -= MOD;
        return *this;
    }

    CE mint &operator-=(mint x) {
        val -= x.val;
        if (val < 0) val += MOD;
        return *this;
    }

    CE mint &operator*=(mint x) {
        val = val * 1LL * x.val % MOD;
        return *this;
    }

    CE mint pow(i64 p) const {
        p %= (MOD - 1);
        if (p < 0) p += MOD - 1;

        mint res = 1;
        mint cur = *this;

        while (p) {
            if (p & 1) res *= cur;
            cur *= cur;
            p >>= 1;
        }
        return res;
    }

    CE mint inv() const {
        return pow(MOD - 2);
    }

    CE mint &operator/=(mint x) {
        return operator*=(x.inv());
    }

    CE friend mint operator+(mint x, mint y) {
        return x += y;
    }
    CE friend mint operator-(mint x, mint y) {
        return x -= y;
    }
    CE friend mint operator*(mint x, mint y) {
        return x *= y;
    }
    CE friend mint operator/(mint x, mint y) {
        return x /= y;
    }

    CE friend bool operator==(mint x, mint y) {
        return x.val == y.val;
    }
};

using imt = mint<998244353>;

struct record {
    int val;
    int task;
    int subtask;


    record(int val, int task, int subtask) : val(val), task(task), subtask(subtask) {
    }
};


void solve() {
    int n;
    cin >> n;

    int s;
    cin >> s;

    vector<vector<int>> tasks(n);
    vector<record> lin;


    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            tasks[i].push_back(x);
            lin.emplace_back(x, i, j);
        }
    }

    int sum_tasks = lin.size();

    vector<vector<int>> dp(sum_tasks + 1, vector<int>(s + 1, -1));
    dp[0][0] = -2;

    int idx = 0;
    for (int j = 0; j < n; ++j) {
        int task_begin_idx = idx;
        for (auto e: tasks[j]) {
            ++idx;
            for (int i = s; i >= 0; --i) {
                dp[idx][i] = dp[idx - 1][i];
                if (i >= e && dp[idx - 1][i - e] != -1) {
                    dp[idx][i] = idx;
                }
            }
        }
        for (int i = 0; i <= s; ++i) {
            if (dp[idx][i] <= task_begin_idx) {
                dp[idx][i] = -1;
            }
        }
    }

    if (dp.back()[s] == -1) {
        cout << "No\n";
    } else {
        cout << "Yes\n";
        vector<int> indices;
        int cur_sum = s;
        int cur_idx = sum_tasks;
        while (cur_sum != 0) {
            int chosen_idx = dp[cur_idx][cur_sum] - 1;
            indices.push_back(chosen_idx);
            cur_sum -= lin[chosen_idx].val;
            cur_idx = chosen_idx;
        }

        vector<vector<int>> ans(n);
        for (auto e: indices) {
            ans[lin[e].task].push_back(lin[e].subtask);
        }

        for (int i = 0; i < n; ++i) {
            cout << ans[i].size() << '\n';
            for (auto e: ans[i]) {
                cout << e + 1 << ' ';
            }
            cout << '\n';
        }


    }


}


int main() {
#ifndef DBG
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t = 1;

//    cin >> t;
    for (int i = 0; i < t; ++i) { solve(); }
    return 0;
}