#include <bits/stdc++.h>

using namespace std;

#define CE constexpr

#ifdef DBG
#define debugf(s, ...) fprintf(stderr, "(" #__VA_ARGS__ ") " s "\n", __VA_ARGS__)
#else
#define debugf(...) void(0)
#endif

using i64 = int64_t;
using i128 = __int128;

template <int MOD>
struct mint {
    int val = 0;
    CE mint() = default;

    CE mint(int x) : val(x < 0 ? x + MOD : x) {
    }

    template <class Num> CE mint(Num x) : mint(int(x % MOD)) {
    }

    CE mint &operator+=(mint x) {
        val += x.val;
        if (val >= MOD) val -= MOD;
        return *this;
    }

    CE mint &operator-=(mint x) {
        val -= x.val;
        if (val < 0) val += MOD;
        return *this;
    }

    CE mint &operator*=(mint x) {
        val = val * 1LL * x.val % MOD;
        return *this;
    }

    CE mint pow(i64 p) const {
        p %= (MOD - 1);
        if (p < 0) p += MOD - 1;

        mint res = 1;
        mint cur = *this;

        while (p) {
            if (p & 1) res *= cur;
            cur *= cur;
            p >>= 1;
        }
        return res;
    }

    CE mint inv() const {
        return pow(MOD - 2);
    }

    CE mint &operator/=(mint x) {
        return operator*=(x.inv());
    }

    CE friend mint operator+(mint x, mint y) {
        return x += y;
    }
    CE friend mint operator-(mint x, mint y) {
        return x -= y;
    }
    CE friend mint operator*(mint x, mint y) {
        return x *= y;
    }
    CE friend mint operator/(mint x, mint y) {
        return x /= y;
    }

    CE friend bool operator==(mint x, mint y) {
        return x.val == y.val;
    }
};

using imt = mint<1'000'000'007>;

constexpr int N = 2'000'001;

struct fct_t {
    imt f[N];
    imt rf[N];
    imt r[N];

    fct_t() {
        f[0] = 1;
        for (int i = 1; i < N; ++i) {
            f[i] = i * f[i - 1];
        }

        rf[N - 1] = f[N - 1].inv();
        for (int i = N - 1; i--;) {
            rf[i] = rf[i + 1] * (i + 1);
        }

        for (int i = 1; i < N; ++i) {
            r[i] = rf[i] * f[i - 1];
        }
    }

    imt binom(int n, int k) {
        if (k < 0 || k > n) return 0;
        return f[n] * rf[n - k] * rf[k];
    }

};

fct_t fct;

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<pair<int, int>> cells(k);
    for (auto &e: cells) {
        cin >> e.first >> e.second;
        --e.first, --e.second;
    }

    cout << (2 * fct.binom(n + m - 2, n - 1) * fct.binom(n + m - 2, m - 1) - 2 * fct.binom(n + m - 2, n) * fct.binom(n + m - 2, m)).val << '\n';



}


int main() {
#ifndef DBG
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t = 1;

//    cin >> t;
    for (int i = 0; i < t; ++i) { solve(); }
    return 0;
}