#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <deque>
#include <cmath>
using namespace std;
using ll = long long;
using ld = long double;
const ld eps = 1e-8;
const ll inf = 1e16;
const ll mod = 1e9 + 7;

vector<vector<ll>> dp;
ll k;

ll f(ll x, ll h, ll ind) {
    if (x < 0) {
        return 0;
    }
    if (h == 0) {
        if (x != 0) {
            return 0;
        }
        return dp[ind][0];
    }
    ll ans = 0;
    for (ll i = 0; i < (1 << k); i++) {
        ll y = 0;
        for (ll j = 0; j < h; j++) {
            y += ((i >> j) & 1);
        }
        ans = (ans + f(x - y, h - 1, ind - 1)) % mod;
    }
    return ans;
}

void solve() {
    ll n;
    cin >> n >> k;
    vector<ll> ls(n);
    for (ll i = 0; i < n; i++) {
        cin >> ls[i];
    }
    if (k == 1) {
        cout << 1;
        return;
    }
    if (k == 2) {
        pair<ll, ll> a = {0, 0};
        if (ls[0] == 0) {
            a.first = 1;
        } else if (ls[0] == 2) {
            a.second = 1;
        } else {
            a.first = 1;
            a.second = 1;
        }
        for (ll i = 1; i < n; i++) {
            if (ls[i] == 0) {
                a.second = 0;
            }
            if (ls[i] == 3) {
                a.first = 0;
            }
            if (ls[i] == 1) {
                a = {(a.second + a.first) % mod, a.first};
            }
            if (ls[i] == 2) {
                a = {a.second, (a.second + a.first) % mod};
            }
        }
        cout << (a.first + a.second) % mod;
        return;
    }
    if (n * k <= 25) {
        ll m = n * k;
        ll ans = 0;
        for (ll i = 0; i < (1 << m); i++) {
            vector<vector<bool>> dp(k, vector<bool>(n, false));
            for (ll x = 0; x < k; x++) {
                for (ll y = 0; y < n; y++) {
                    if (((i >> (5 * x + y)) & 1) == 1) {
                        dp[x][y] = true;
                    }
                }
            }
            vector<ll> have(n, 0);
            for (ll x = 0; x < k; x++) {
                for (ll y = 0; y < n; y++) {
                    if (dp[x][y]) {
                        for (ll j = y; j < min(n, y + k - x); j++) {
                            have[j]++;
                        }
                    }
                }
            }
            bool f = true;
            for (ll j = 0; j < n; j++) {
                if (have[j] != ls[j]) {
                    f = false;
                    break;
                }
            }
            if (f) {
                ans++;
            }
        }
        cout << ans % mod;
        return;
    }
    dp.resize(n + k, vector<ll> (1 << k, 0));
    for (ll i = 0; i < k; i++) {
        dp[i][0] = 1;
    }
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < (1 << k); j++) {
            ll x = ls[i];
            for (ll e = 0; e <= k; e++) {
                x -= ((j >> e) & 1);
            }
            if (x < 0) {
                continue;
            }
            dp[i + k][j] = f(x, k - 1, i + k - 1);
            cout << i << " " << j << " " << dp[i + k][j] << endl;
        }
    }
    ll ans = 0;
    for (ll j = 0; j < (1 << k); j++) {
        ans += dp[n + k - 1][j];
    }
    cout << endl;
    cout << ans % mod;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
