#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <deque>
#include <cmath>
using namespace std;
using ll = long long;
using ld = long double;
const ld eps = 1e-8;
const ll inf = 1e16;
const ll mod = 1e9 + 7;

set<ll> ls;

vector<ll> p, r;
vector<pair<ll, ll>> lr;
vector<ll> maxi;

ll parent(ll x) {
    if (p[x] != x) {
        p[x] = parent(p[x]);
    }
    return p[x];
}

void merge(ll x, ll y) {
    x = parent(x);
    y = parent(y);
    if (x == y) {
        return;
    }
    if (r[x] < r[y]) {
        swap(x, y);
    }
    p[x] = y;
    lr[y] = {min(lr[y].first, lr[x].first), max(lr[y].second, lr[x].second)};
    maxi[y] = max(maxi[y], maxi[x]);
    if (r[x] == r[y]) {
        r[y]++;
    }
}

void solve() {
    ll n;
    cin >> n;
    vector<ll> h(n);
    vector<ll> s(n, 0);
    map<ll, pair<ll, ll>> ma;
    maxi.resize(n);
    p.resize(n);
    r.resize(n, 1);
    lr.resize(n);
    for (ll i = 0; i < n; i++) {
        cin >> h[i];
        ma[i + 1] = {i, i};
        ls.insert(i);
        maxi[i] = h[i];
        p[i] = i;
        lr[i] = {i, i};
    }
    ll m = n - 1;
    while (m--) {
        ll w;
        cin >> w;
        auto it = ls.begin();
        w--;
        while (w--) {
            it++;
        }
        ll x = *it;
        ls.erase(it);
        x = parent(x);
        ll l1 = lr[x].first, r1 = lr[x].second;
        ll y = lr[x].second + 1;
        y = parent(y);
        ll l2 = lr[y].first, r2 = lr[y].second;
        ll a = maxi[x];
        ll b = maxi[y];
        merge(x, y);
        if (parent(y) == x) {
            swap(x, y);
        }
        ll ans1 = 0;
        if (a < b) {
            swap(a, b);
        }
        for (ll i = r1; i >= l1; i--) {
            ans1 += max(0LL, b - h[i]);
            if (h[i] >= b) {
                break;
            }
            h[i] = b;
        }
        for (ll i = l2; i <= r2; i++) {
            ans1 += max(0LL, b - h[i]);
            if (h[i] >= b) {
                break;
            }
            h[i] = b;
        }
        s[y] += ans1 + s[x];
        cout << s[y] << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
