#include <iostream>
#include <vector>
#include <set>
using namespace std;
using ll = long long;
using ld = long double;
const ld eps = 1e-9;
const ll inf = 1e14;
const ll mod = 1e9 + 7;

ll n;
vector<ll> ls;
vector<ll> pref;

ll f(ll ma, ll mi, ll ind, ll ost, ll now) {
    if (ind == n) {
        if (ost == 0) {
            ma = max(ma, now);
            mi = min(mi, now);
            return ma - mi;
        }
        return -inf;
    }
    if (n - ind < ost) {
        return -inf;
    }
    if (ost == 0) {
        ma = max(ma, pref[n] - pref[ind] + now);
        mi = min(mi, pref[n] - pref[ind] + now);
        return ma - mi;
    }
    ll ans = f(ma, mi, ind + 1, ost, now + ls[ind]);
    ll ans2 = f(max(ma, now), min(mi, now), ind + 1, ost - 1, ls[ind]);
    return max(ans, ans2);
}

ll f(ll x, ll y, ll z) {
    return max(max(x, y), z) - min(min(x, y), z);
}

ll f2(ll a, ll b, ll c, ll d) {
    return max(max(a, b), max(c, d)) - min(min(a, b), min(c, d));
}

void solve() {
    ll k, s = 0;
    cin >> n >> k;
    ls.resize(n);
    pref.resize(n + 1, 0);
    for (ll i = 0; i < n; i++) {
        cin >> ls[i];
        s += ls[i];
        pref[i + 1] = pref[i] + ls[i];
    }
    if (k == 2) {
        ll ans = 0;
        for (ll i = 0; i < n - 1; i++) {
            ll x = pref[n] - pref[i + 1];
            ll y = s - x;
            if (x > y) {
                swap(x, y);
            }
            ans = max(ans, y - x);
        }
        cout << ans;
        return;
    }
    if (k == 3) {
        ll ans = max(f(ls[0], ls[1], s - ls[0] - ls[1]), f(ls[n - 1], ls[n - 2], s - ls[n - 1] - ls[n - 2]));
        ans = max(ans, f(ls[0], ls[n - 1], s - ls[0] - ls[n - 1]));
        for (ll i = 0; i < n - 3; i++) {
            ans = max(ans, f(ls[i + 1], pref[i + 1], s - ls[i + 1] - pref[i + 1]));
        }
        cout << ans;
        return;
    }
    if (n <= 15) {
        cout << f(-inf, inf, 1, k - 1, ls[0]);
        return;
    }
    ll ans = 0;
    if (k == 4) {
        for (ll i = 0; i < n - 1; i++) {
            for (ll j = i + 1; j < n - 3; j++) {
                ll x = pref[i + 1];
                ll y = pref[j + 1] - x;
                ll z = ls[n - 1];
                ll a = s - x - z - y;
                ans = max(ans, f2(x, y, z, a));
            }
        }
        for (ll i = 1; i < n - 1; i++) {
            for (ll j = i + 1; j < n - 2; j++) {
                ll x = pref[i + 1] - ls[0];
                ll y = pref[j + 1] - x - ls[0];
                ll z = ls[0];
                ll a = s - x - z - y;
                ans = max(ans, f2(x, y, z, a));
            }
        }
        for (ll i = 0; i < n - 1; i++) {
            for (ll j = i + 2; j < n - 2; j++) {
                ll x = pref[i + 1];
                ll y = pref[j + 1] - x - ls[i + 1];
                ll z = ls[i + 1];
                ll a = s - x - z - y;
                ans = max(ans, f2(x, y, z, a));
            }
        }
        for (ll i = 0; i < n - 1; i++) {
            for (ll j = i + 1; j < n - 3; j++) {
                ll x = pref[i + 1];
                ll y = pref[j + 1] - x;
                ll z = ls[j + 1];
                ll a = s - x - z - y;
                ans = max(ans, f2(x, y, z, a));
            }
        }
        cout << ans;
        return;
    }
    vector<vector<ll>> mini(n, vector<ll> (n, inf));
    for (ll i = 0; i < n; i++) {
        ll mi = ls[i];
        mini[i][i] = mi;
        for (ll j = i + 1; j < n; j++) {
            mi = min(mi, ls[j]);
            mini[i][j] = mi;
        }
    }
    for (ll i = 0; i < n; i++) {
        ll p = 0;
        for (ll j = i; j < n; j++) {
            p += ls[j];
            ll mi;
            ll w = n - (j - i + 1);
            if (i == 0) {
                if (w - 1 < k - 2) {
                    continue;
                }
                mi = mini[j + 1][n - 1];
            } else if (j == n - 1) {
                if (w - 1 < k - 2) {
                    continue;
                }
                mi = mini[0][i - 1];
            } else {
                if (w - 2 < k - 3) {
                    continue;
                }
                mi = min(mini[j + 1][n - 1], mini[0][i - 1]);
            }
            ans = max(ans, p - mi);
        }
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
