#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <random>
#include <chrono>
#define ll long long
#define ull unsigned long long
#define pii pair <int, int>

//#define _GLIBCXX_DEBUG random device rd;
//mt19937_rg(chrono::high_time_resilution()::now()::since_time_apoch() :(count()))
using namespace std;

pii max_(pii a, pii b) {
	return a.second > b.second ? a : b;
}

pii min_(pii a, pii b) {
	return a.second < b.second ? a : b;
}

struct Tree {
	vector <pii> tree;
	vector <int> mod;

	Tree(vector <pii>& a, int p) {
		tree.resize(p * 2 - 1);
		mod.resize(p * 2 - 1);
		build(a, 0, p, 0);
	}

	void push(int v, int l, int r) {
		if (mod[v] == 0)
			return;
		int v1 = v * 2 + 1, v2 = v * 2 + 2;
		tree[v].first += mod[v];
		if (r - l > 1) {
			mod[v1] += mod[v];
			mod[v2] += mod[v];
		}
		mod[v] = 0;
	}

	void modif(int l, int r, int lv, int rv, int v) {
		push(v, lv, rv);
		if (l <= lv && rv <= r) {
			mod[v]++;
			push(v, lv, rv);
			return;
		}
		if (r <= lv || rv <= l)
			return;
		int mid = (lv + rv) / 2;
		modif(l, r, lv, mid, v * 2 + 1);
		modif(l, r, mid, rv, v * 2 + 2);
	}

	void build(vector <pii>& a, int l, int r, int v) {
		if (r - l == 1) {
			tree[v] = a[l];
			return;
		}
		int mid = (l + r) / 2;
		build(a, l, mid, v * 2 + 1);
		build(a, mid, r, v * 2 + 2);
		tree[v] = max_(tree[v * 2 + 1], tree[v * 2 + 2]);
	}

	int get(int l, int r, int lv, int rv, int v) {
		push(v, lv, rv);
		if (l <= lv && rv <= r) {
			return tree[v].second;
		}
		if (r <= lv || rv <= l)
			return 0;
		int mid = (lv + rv) / 2;
		return max(get(l, r, lv, mid, v * 2 + 1), get(l, r, mid, rv, v * 2 + 2));
	}


};

int find_pow(int n) {
	int k = 0;
	while (1 << k < n)
		k++;
	return 1 << k;
}

int lb(vector <pii>& a, int s) {
	int l = -1, r = a.size();
	while (r - l > 1) {
		int mid = (r + l) / 2;
		if (a[mid].first < s)
			l = mid;
		else
			r = mid;
	}
	return r;
}

int ub(vector <pii>& a, int s) {
	int l = 0, r = a.size();
	while (r - l > 1) {
		int mid = (r + l) / 2;
		if (a[mid].first <= s)
			l = mid;
		else
			r = mid;
	}
	return r;
}

void sample() {
	int n;
	cin >> n;
	int p = find_pow(n);
	vector <pii> h(p);
	for (int i = 0; i < n; i++) {
		cin >> h[i].second;
		h[i].first = i;
	}
	Tree t(h, p);
	for (int i = 0; i < n - 1; i++) {
		int k;
		cin >> k;
		int sr = lb(h, k - 1), sl = ub(h, k - 1);
		for (int j = sl; j < n; j++)
			h[j].first--;
		sl = ub(h, k - 1);
		ll ans = 0;

		for (int j = sr; j < sl; j++) {
			ans += max(0, min(t.get(sr, j + 1, 0, p, 0), t.get(j, sl, 0, p, 0)) - h[j].second);
		}
		cout << ans << '\n';
	}

}

int main() {
	sample();
	return 0;
}

/*
8
9 1 8 1 5 2 3 6
3 3 1 3 3 2 1
*/