#include <iostream>
#include <vector>
#include <map>
#include <chrono>
#include <random>
#include <algorithm>
#define _GLIBCXX_DEBUG
#define ll long long
#define ull unsigned long long
#define pii pair <int, int>
using namespace std;
random_device rd;

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

ll randInt(ll L, ll R) {
	return uniform_int_distribution <ll>(L, R) (rng);
}

ll inf = 1e9 + 1;

void solve() {
	int n, k;
	cin >> n >> k;
	vector <ll> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	ll ans = 0;
	vector <ll> prefmin(n), sufmin(n);
	prefmin[0] = inf;
	for (int i = 1; i < n; i++) {
		if (i == 1)
			prefmin[i] = a[i - 1];
		else {
			prefmin[i] = min(a[i - 1], prefmin[i - 2]);
		}
	}
	sufmin[n - 1] = inf;
	for (int i = n - 2; i >= 0; i--) {
		if (i == n - 2) {
			sufmin[i] = a[n - 1];
		}
		else {
			sufmin[i] = min(a[i + 1], sufmin[i + 2]);
		}
	}
	for (int i = 0; i < n; i++) {
		ll sum = 0, mins = 1e9 + 1;
		for (int j = i; j - i + 1 <= n - k + 1 && j < n; j++) {
			sum += a[j];
			ans = max(ans, max(sum - prefmin[i], sum - sufmin[j]));
		}
	}
	cout << ans;
}

int main() {
	solve();
	return 0;
}