#include <iostream>
#include <vector>
#include <map>
#include <chrono>
#include <random>
#include <algorithm>
#define _GLIBCXX_DEBUG
#define ll long long
#define ull unsigned long long
#define pii pair <int, int>
using namespace std;
random_device rd;

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

ll randInt(ll L, ll R) {
	return uniform_int_distribution <ll>(L, R) (rng);
}

ll inf = 1e9 + 1;


void solve2(int n, int k) {
	vector <ll> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	int l = 0, r = 0;
	ll sum = a[0], maxs = a[0], minnow = a[0], minwas = a[0];
	int i = 0;
	for (int j = 1; j < n; j++) {
		while (i + 1 < j && a[i] == 0) {
			i++;
		}
		if (j - i + 1 <= n - k + 1) {
			sum += a[j];
			if (sum > maxs) {
				maxs = sum;
				l = i, r = j;
				minwas = minnow;
			}
			else if (sum == maxs && minnow > minwas) {
				l = i, r = j;
				minwas = minnow;
			}
		}
		else {
			sum -= a[i];
			i++;
			sum += a[j];
			if (sum > maxs) {
				maxs = sum;
				l = i, r = j;
				minwas = minnow;
			}
			else if (sum == maxs && minnow > minwas) {
				l = i, r = j;
				minwas = minnow;
			}
		}
	}
	while (a[r] == 0 && r - 1 >= l)
		r--;
	while (a[l] == 0 && l + 1 <= r)
		l++;
	ll mins = 1e9 + 1;
	for (int j = 0; j < l; j++) {
		mins = min(mins, a[j]);
	}
	for (int j = r + 1; j < n; j++) {
		mins = min(mins, a[j]);
	}
	cout << maxs - mins;
}


void solve() {
	int n, k;
	cin >> n >> k;
	if (k == 2) {
		solve2(n, k);
		return;
	}
	vector <ll> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	ll ans = 0;
	vector <ll> prefmin(n), sufmin(n);
	prefmin[0] = inf;
	for (int i = 1; i < n; i++) {
		if (i == 1)
			prefmin[i] = a[i - 1];
		else {
			prefmin[i] = min(a[i - 1], prefmin[i - 1]);
		}
	}
	sufmin[n - 1] = inf;
	for (int i = n - 2; i >= 0; i--) {
		if (i == n - 2) {
			sufmin[i] = a[i + 1];
		}
		else {
			sufmin[i] = min(a[i + 1], sufmin[i + 1]);
		}
	}
	for (int i = 0; i < n; i++) {
		ll sum = 0;
		for (int j = i; j - i + 1 <= n - k + 1 && j < n; j++) {
			sum += a[j];
			ans = max(ans, max(sum - prefmin[i], sum - sufmin[j]));
		}
	}
	cout << ans;
}

int main() {
	solve();
	return 0;
}