#include <iostream>
#include <vector>
#include <map>
#include <chrono>
#include <random>
#define _GLIBCXX_DEBUG
#define ll long long
#define ull unsigned long long
#define pii pair <int, int>
using namespace std;
random_device rd;

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

ll randInt(ll L, ll R) {
	return uniform_int_distribution <ll>(L, R) (rng);
}

ll inf = 1e18;

map <pii, vector <int>> idx;
bool rec(int now, int s, vector <vector <ll>>& k, vector <int> &used, map <pii, int>& res, vector <ll> &mins, int ind, int c, int cind) {
	if (now > s)
		return false;
	if (now == s) {
		for (int i = 0; i < used.size(); i++) {
			if (used[i] == 0)
				return false;
		}
		cout << "Yes\n";
		for (int i = 0; i < used.size(); i++) {
			cout << used[i] << '\n';
			for (int e : k[i]) {
				for (int cnt = 0; cnt < res[{i, e}]; cnt++)
					cout << idx[{i, e}][cnt] + 1 << ' ';
			}
			cout << '\n';
		}
		return true;
	}
	for (int i = ind; i < k.size(); i++) {
		for (int j = c; j < k[i].size(); j++) { 
			for (int ci = cind; ci < idx[{i, k[i][j]}].size() && s - now - k[i][j] * (ci + 1) >= mins[i + 1]; ci++) {
				// s - now - k[i][j] >= mins[i + 1]
				now += k[i][j] * (ci + 1);
				res[{i, k[i][j]}] = ci + 1;
				used[i] += ci + 1;
				if (rec(now, s, k, used, res, mins, i, j + 1, ci + 1))
					return true;
				used[i] -= (ci + 1);
				now -= k[i][j] * (ci + 1);
				res[{i, k[i][j]}] = 0;
			}
			cind = 0;
		}
		c = 0;
	}
	return false;
}

void solve() {
	int n, s;
	cin >> n >> s;
	vector <vector <ll>> k(n);
	vector <ll> mins(n + 1, inf), sz(n);
	mins[n] = 0;
	for (int i = 0; i < n; i++) {
		cin >> sz[i];
		for (int j = 0; j < sz[i]; j++) {
			int a;
			cin >> a;
			if (a < mins[i])
				mins[i] = a;
			idx[{i, a}].push_back(j);
			if (find(k[i].begin(), k[i].end(), a) == k[i].end()) {
				k[i].push_back(a);
				sort(k[i].begin(), k[i].end());
			}
		}
	}
	for (int i = n - 1; i >= 0; i--) {
		mins[i] = mins[i + 1] + mins[i];
	}
	map <pii, int> res;
	vector <int> used(n);
	if (!rec(0, s, k, used, res, mins, 0, 0, 0))
		cout << "No";
	return;
}

int main() {
	solve();
	return 0;
}

/*

2 4
1
2
2
2 1


*/