class Block:
    def __init__(self, left, right):
        self.left = left
        self.right = right
        self.length = 2
        self.real = 0
        self.potential = 0

    def add_line(self, line: int, side):
        self.length += 1
        if side == 'l':
            if line > self.left:
                self.real += (line - self.left)
                self.left = line
            else:
                self.potential += (self.left - line)
        elif side == 'r':
            if line > self.right and self.left > self.right:
                self.real += (line - self.right)
                self.right = line
            else:
                self.potential += (self.right - line)

    def __add__(self, other):
        if self.right < other.left:
            self.real += (self.potential - ((self.left - other.left) * (self.length - 2)))
            self.potential = (self.left - other.left) * (self.length - 2)
            self.real += 0
        else:
            self.potential = self.potential + other.potential

        if self.left > other.right:
            self.real += (self.potential - ((self.right - other.right) * (self.length - 2)))
            self.potential = (self.right - other.right) * (self.length - 2)
            self.real += 0
        else:
            self.potential = self.potential + other.potential

        self.length = self.length + other.length

        return self


n = int(input())
blocks = list(map(int, input().split()))
instructions = list(map(int, input().split()))
h = None
memory = blocks

for q in instructions:
    ins = q - 1
    a1, a2 = blocks[ins], blocks[ins + 1]

    if isinstance(a1, int) and isinstance(a2, int):
        b = Block(a1, a2)
        blocks = blocks[:ins] + [b] + blocks[ins + 2:]
        print(0)
    elif isinstance(a1, int):
        a2.add_line(a1, 'l')
        blocks = blocks[:ins] + [a2] + blocks[ins + 2:]
        print(a2.real)
    elif isinstance(a2, int):
        a1.add_line(a2, 'r')
        blocks = blocks[:ins] + [a1] + blocks[ins + 2:]
        print(a1.real)
    else:
        a1 = a1 + a2
        print(a1.real)
