#include <iostream>
#include <vector>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
string test = "8 9 1 8 1 5 2 3 6 3 3 1 3 3 2 1";

struct block {
    ll l, r;
    ll h;
};

typedef tree <tuple<ll, ll, vector<ll>>, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

vector<ll> prefmax(vector<ll>& arr) {
    vector<ll> p(arr.size(), -1);
    for (int i = 1; i < arr.size(); i++) {
        p[i] = max(arr[i - 1], p[i - 1]);
    }
    return p;
}

vector<ll> suffmax(vector<ll>& arr) {
    vector<ll> p(arr.size(), -1);
    for (int i = arr.size() - 2; i >= 0; i--) {
        p[i] = max(arr[i + 1], p[i + 1]);
    }
    return p;
}

int main() {
    ll n;
    cin >> n;
    vector<ll> h(n);
    for (ll &o : h) cin >> o;
    ordered_set dsu;
    for (int i = 0; i < n; i++) {
        dsu.insert({i, h[i], {h[i]}});
    }
    for (int _ = 0; _ < n - 1; _++) {
        ll k;
        cin >> k;
        k--;
        auto [i1, mx1, nw] = *dsu.find_by_order(k);
        auto [i2, mx2, h2] = *dsu.find_by_order(k + 1);
        dsu.erase(dsu.find_by_order(k));
        dsu.erase(dsu.find_by_order(k));
        for (ll h_ : h2) {
            nw.push_back(h_);
        }
        vector<ll> pmx = prefmax(nw);
        vector<ll> smx = suffmax(nw);
        ll res = 0;
        for (int i = 0; i < nw.size(); i++) {
            ll l = pmx[i], r = smx[i];
            if (min(l, r) > nw[i]) res += min(l, r) - nw[i];
        }
        dsu.insert({i1, 0, nw});
        cout << res << endl;
    }
    cout << '\n';
}

