#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <queue>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
constexpr ll inf = LLONG_MAX;

typedef tree <int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

vector<int> bfs(int n, int s, vector<vector<int>>& e) {
    vector<int> d(n, -1);
    queue<int> work;
    d[s] = 0;
    work.push(s);
    while (!work.empty()) {
        int v = work.front(); work.pop();
        for (int u : e[v]) {
            if (d[u] == -1) {
                d[u] = d[v] + 1;
                work.push(u);
            }
        }
    }
    return d;
}

vector<ll> dijkstra(int n, int s, vector<vector<pair<ll, ll>>>& e) {
    vector<ll> d(n, inf);
    set<pair<ll, ll>> work;
    d[s] = 0;
    work.insert({0, s});
    while (!work.empty()) {
        auto& [w, v] = *work.begin(); work.erase(work.begin());
        for (auto& [u, w_] : e[v]) {
            if (d[u] > d[v] + w_) {
                work.erase({d[u], u});
                d[u] = d[v] + w_;
                work.insert({d[u], u});
            }
        }
    }
    return d;
}

ll stupid(ll d, ll l, ll r) {
    l = ceil(sqrtl(l)); r = floor(sqrtl(r));
    ll ans = 0;
    for (ll c = 1; d >= 2 * c; c++) {
        if (d % (2 * c) == 0 && l <= (d / (2 * c)) - c / 2 && (d / (2 * c)) - c / 2 + c <= r) ans++;
    }
    return ans;
}

int main() {
    ll d, l, r;
    cin >> d >> l >> r;
    cout << stupid(d, l, r) << endl;
    return 0;
}
