#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <queue>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
constexpr ll inf = LLONG_MAX;
constexpr int inf_ = INT_MAX;

string test = "5 4 2 1 3 4 1";

typedef tree <int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

vector<int> bfs(int n, int s, vector<vector<int>>& e) {
    vector<int> d(n, -1);
    queue<int> work;
    d[s] = 0;
    work.push(s);
    while (!work.empty()) {
        int v = work.front(); work.pop();
        for (int u : e[v]) {
            if (d[u] == -1) {
                d[u] = d[v] + 1;
                work.push(u);
            }
        }
    }
    return d;
}

vector<ll> dijkstra(int n, int s, vector<vector<pair<ll, ll>>>& e) {
    vector<ll> d(n, inf);
    set<pair<ll, ll>> work;
    d[s] = 0;
    work.insert({0, s});
    while (!work.empty()) {
        auto& [w, v] = *work.begin(); work.erase(work.begin());
        for (auto& [u, w_] : e[v]) {
            if (d[u] > d[v] + w_) {
                work.erase({d[u], u});
                d[u] = d[v] + w_;
                work.insert({d[u], u});
            }
        }
    }
    return d;
}

vector<ll> pref(vector<ll>& arr) {
    vector<ll> p(arr.size() + 1, 0);
    for (int i = 0; i < arr.size(); i++) {
        p[i + 1] = p[i] + arr[i];
    }
    return p;
}

int main() {
    int n, k;
    cin >> n >> k;
    vector<ll> arr(n);
    for (ll& o : arr) cin >> o;
    vector<ll> p = pref(arr);
    vector<ll> smn(n + 1, inf_);
    vector<ll> pmn(n + 1, inf_);
    for (int i = 0; i < n; i++) {
        pmn[i + 1] = min(pmn[i], arr[i]);
    }
    for (int i = n; i > 0; i--) {
        smn[i - 1] = min(smn[i], arr[i - 1]);
    }
    k = n - k + 1;
    ll mx = 0;
    for (int i = 0; i <= n - k; i++) {
        mx = max(mx, abs((p[i + k] - p[i]) - min(pmn[i], smn[i + k])));
    }
    cout << mx << endl;
    return 0;
}
