#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <queue>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bitset>
#include <unordered_map>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
constexpr ll inf = LLONG_MAX;
constexpr int W = 1'001;
constexpr int N = 100'001;

string test1 = "2 4 1 2 2 3 1";
string test2 = "2 4 1 2 2 2 1";
string test3 = "3 9 3 1 2 3 1 4 2 1 3";

typedef tree <int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

vector<int> bfs(int n, int s, vector<vector<int>>& e) {
    vector<int> d(n, -1);
    queue<int> work;
    d[s] = 0;
    work.push(s);
    while (!work.empty()) {
        int v = work.front(); work.pop();
        for (int u : e[v]) {
            if (d[u] == -1) {
                d[u] = d[v] + 1;
                work.push(u);
            }
        }
    }
    return d;
}

vector<ll> dijkstra(int n, int s, vector<vector<pair<ll, ll>>>& e) {
    vector<ll> d(n, inf);
    set<pair<ll, ll>> work;
    d[s] = 0;
    work.insert({0, s});
    while (!work.empty()) {
        auto& [w, v] = *work.begin(); work.erase(work.begin());
        for (auto& [u, w_] : e[v]) {
            if (d[u] > d[v] + w_) {
                work.erase({d[u], u});
                d[u] = d[v] + w_;
                work.insert({d[u], u});
            }
        }
    }
    return d;
}

vector<bitset<W>> dp(N, bitset<W>("0"));

int main() {
    int n, s;
    cin >> n >> s;
    vector<vector<int>> w(n);
    vector<int> flat;
    unordered_map<int, int> group;
    vector<int> pref(n + 1, 0);
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i];
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int c;
            cin >> c;
            w[i].push_back(c);
            flat.push_back(c);
            group[flat.size() - 1] = i;
            pref[i + 1]++;
        }
    }
    if (w[0][0] <= s) dp[0][w[0][0]] = true;
    for (int i = 1; i < w[0].size(); i++) {
        dp[i] |= dp[i - 1];
        if (w[0][i] > s) continue;
        dp[i][w[0][i]] = true;
        dp[i] |= (dp[i - 1] << w[0][i]);
    }
    int last = w[0].size() - 1;
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < w[i].size(); j++) {
            dp[last + 1 + j] |= (dp[last] << w[i][j]);
        }
        for (int j = 1; j < w[i].size(); j++) {
            dp[last + 1 + j] |= (dp[last + j]);
            dp[last + 1 + j] |= (dp[last + j] << w[i][j]);
        }
        last += w[i].size();
    }
    if (dp[last][s]) {
        cout << "Yes" << endl;
        vector<int> backtrack;
        for (int i = last; i >= 0 && s != 0; i--) {
            if (i != 0 && i != pref[group[i]] && dp[i - 1][s]) continue;
            else {
                s -= flat[i];
                backtrack.push_back(i);
            }
        }
        vector<vector<int>> ans(n);
        for (int a : backtrack) {
            ans[group[a]].push_back(a - pref[group[a]]);
        }
        for (auto& arr : ans) {
            cout << arr.size() << '\n';
            sort(arr.begin(), arr.end());
            for (int a : arr) {
                cout << a + 1 << ' ';
            }
            cout << '\n';
        }
    }
    else cout << "No" << endl;
    return 0;
}
