#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <queue>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <unordered_set>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
constexpr ll inf = LLONG_MAX;

string test1 = "2 4 1 2 2 3 1";
string test2 = "2 4 1 2 2 2 1";
string test3 = "3 9 3 1 2 3 1 4 2 1 3";

typedef tree <int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

vector<int> bfs(int n, int s, vector<vector<int>>& e) {
    vector<int> d(n, -1);
    queue<int> work;
    d[s] = 0;
    work.push(s);
    while (!work.empty()) {
        int v = work.front(); work.pop();
        for (int u : e[v]) {
            if (d[u] == -1) {
                d[u] = d[v] + 1;
                work.push(u);
            }
        }
    }
    return d;
}

vector<ll> dijkstra(int n, int s, vector<vector<pair<ll, ll>>>& e) {
    vector<ll> d(n, inf);
    set<pair<ll, ll>> work;
    d[s] = 0;
    work.insert({0, s});
    while (!work.empty()) {
        auto& [w, v] = *work.begin(); work.erase(work.begin());
        for (auto& [u, w_] : e[v]) {
            if (d[u] > d[v] + w_) {
                work.erase({d[u], u});
                d[u] = d[v] + w_;
                work.insert({d[u], u});
            }
        }
    }
    return d;
}

int main() {
    int n, s;
    cin >> n >> s;
    vector<vector<ll>> w(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int a;
            cin >> a;
            w[i].push_back(a);
        }
    }
    vector<vector<pair<ll, vector<vector<int>>>>> dp(n);
    vector<unordered_set<ll>> found(n);
    for (int i = 0; i < w[0].size(); i++) {
        int t = dp[0].size();
        for (int j = 0; j < t; j++) {
            if (found[0].find(w[0][i] + dp[0][j].first) != found[0].end()) continue;
            vector<vector<int>> temp = dp[0][j].second;
            temp[0].push_back(i);
            dp[0].push_back({w[0][i] + dp[0][j].first, temp});
            found[0].insert(w[0][i] + dp[0][j].first);
        }
        dp[0].push_back({w[0][i], {{i}}});
        found[0].insert(w[0][i]);
    }
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < w[i].size(); j++) {
            int t = dp[i].size();
            for (int j = 0; j < t; j++) {
                if (found[i].find(w[i][j] + dp[i][j].first) != found[i].end()) continue;
                vector<vector<int>> temp = dp[i][j].second;
                temp[i].push_back(j);
                dp[i].push_back({w[i][j] + dp[i][j].first, temp});
                found[i].insert(w[i][j] + dp[i][j].first);
            }
            for (auto [w_, h] : dp[i - 1]) {
                if (found[i].find(w_ + w[i][j]) != found[i].end()) continue;
                h.push_back({j});
                dp[i].push_back({w_ + w[i][j], h});
                found[i].insert(w_ + w[i][j]);
            }
        }
    }
    for (auto& [w_, h] : dp.back()) {
        if (w_ == s) {
            cout << "Yes" << endl;
            for (auto& arr : h) {
                cout << arr.size() << '\n';
                sort(arr.begin(), arr.end());
                for (int a : arr) cout << a + 1 << ' ';
                cout << '\n';
            }
            return 0;
        }
    }
    cout << "No" << '\n';
    return 0;
}
