#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <queue>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
constexpr ll inf = LLONG_MAX;
constexpr ll mod = 1e9 + 7;

typedef tree <int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

vector<int> bfs(int n, int s, vector<vector<int>>& e) {
    vector<int> d(n, -1);
    queue<int> work;
    d[s] = 0;
    work.push(s);
    while (!work.empty()) {
        int v = work.front(); work.pop();
        for (int u : e[v]) {
            if (d[u] == -1) {
                d[u] = d[v] + 1;
                work.push(u);
            }
        }
    }
    return d;
}

vector<ll> dijkstra(int n, int s, vector<vector<pair<ll, ll>>>& e) {
    vector<ll> d(n, inf);
    set<pair<ll, ll>> work;
    d[s] = 0;
    work.insert({0, s});
    while (!work.empty()) {
        auto& [w, v] = *work.begin(); work.erase(work.begin());
        for (auto& [u, w_] : e[v]) {
            if (d[u] > d[v] + w_) {
                work.erase({d[u], u});
                d[u] = d[v] + w_;
                work.insert({d[u], u});
            }
        }
    }
    return d;
}

ll ans = 0;

void rbf(int v, int u, vector<vector<int>> used, vector<vector<int>>& map, int cnt, int k) {
    if (map[v][u]) cnt++;
    used[v][u] = 1;
    if (v == 0 && u == 0) {
        if (cnt == k) ans++;
    } else if (v == 0) {
        if (!used[v][u - 1]) rbf(v, u - 1, used, map, cnt, k);
    } else if (u == 0) {
        if (!used[v - 1][u]) rbf(v - 1, u, used, map, cnt, k);
    } else {
        if (!used[v][u - 1]) rbf(v, u - 1, used, map, cnt, k);
        if (!used[v - 1][u]) rbf(v - 1, u, used, map, cnt, k);
    }
}

void bf(int v, int u, vector<vector<int>> used, vector<vector<int>>& map, int cnt, int k) {
    if (map[v][u]) cnt++;
    used[v][u] = 1;
    if (v == map.size() - 1 && u == map[0].size() - 1) {
        if (!used[v - 1][u]) rbf(v + 1, u, used, map, cnt, k);
        if (!used[v][u - 1]) rbf(v, u + 1, used, map, cnt, k);
    } else if (v == map.size() - 1) {
        if (!used[v][u + 1]) bf(v, u + 1, used, map, cnt, k);
    } else if (u == map[0].size() - 1) {
        if (!used[v + 1][u]) bf(v + 1, u, used, map, cnt, k);
    } else {
        if (!used[v][u + 1]) bf(v, u + 1, used, map, cnt, k);
        if (!used[v + 1][u]) bf(v + 1, u, used, map, cnt, k);
    }
}

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<int>> map(n, vector<int>(m, 0));
    for (int i = 0; i < k; i++) {
        int x, y;
        cin >> x >> y;
        x--; y--;
        map[x][y] = 1;
    }
    vector<vector<int>> used(n, vector<int>(m, 0));
    bf(1, 0, used, map, 0, k);
    bf(0, 1, used, map, 0, k);
    cout << ans << endl;
    return 0;
}
