//typedef signed int int32;
typedef unsigned int uint32;
//typedef signed long long int64;
//typedef unsigned long long uint64;

#include <iostream>
#include <vector>

struct Task {
    uint32 task, sub_task;
};

struct Combination {
    std::vector<Task> task_nums;
    uint32 points_sum;
    bool empty = false;

    Combination operator+(Combination &other) const {
        std::vector<Task> nums = this->task_nums;
        for (auto &e: other.task_nums) {
            nums.push_back(e);
        }
        return Combination{
                .task_nums = nums,
                .points_sum = this->points_sum + other.points_sum,
        };
    }
};


auto recursive_compare(Combination prev_comb, std::vector<std::vector<Combination>> &combs, uint32 index,
                       uint32 search_value) -> Combination {
    if (index < combs.size()) {
//        if (prev_comb.points_sum >= search_value) return Combination{.empty = true};

        std::vector<Combination> res;
        for (auto &combination: combs[index]) {
            if ((prev_comb + combination).points_sum <= search_value) {
                res.push_back(recursive_compare(prev_comb + combination, combs, index + 1, search_value));
            }
        }
        for (auto comb: res) {
            if (!comb.empty) return comb;
        }
        return Combination{.empty = true};
    } else {
        if (prev_comb.points_sum == search_value) return prev_comb;
        else return Combination{.empty = true};
    }
}


int main() {
    uint32 n{}, s{};
    std::cin >> n >> s;
    std::vector<std::vector<uint32>> tasks;
    for (uint32 i = 0; i < n; ++i) {
        uint32 k{};
        std::cin >> k;
        std::vector<uint32> task(k);
        for (auto &points: task) std::cin >> points;
        tasks.push_back(task);
    }

    std::vector<std::vector<Combination>> task_point_combinations;

    for (uint32 task_i = 0; task_i < tasks.size(); ++task_i) {
        std::vector<Combination> point_combinations;

        for (uint32 point_i = 0; point_i < tasks[task_i].size(); ++point_i) {
            point_combinations.push_back(Combination{
                    .task_nums = {Task{
                        .task = task_i,
                        .sub_task = point_i
                    }},
                    .points_sum = tasks[task_i][point_i],
            });
        }

        for (uint32 comb_size = 1; comb_size <= tasks[task_i].size(); ++comb_size) {
            for (uint32 comb_start_index = 0; comb_start_index < tasks[task_i].size() - comb_size; ++comb_start_index) {
                for (uint32 compare_index = 0; compare_index < tasks[task_i].size(); ++compare_index) {
                    if (compare_index >= comb_start_index && compare_index < comb_start_index + comb_size) continue;
                    std::vector<Task> nums;
                    uint32 sum = 0;
                    for (uint32 i = comb_start_index; i < comb_start_index + comb_size; ++i) {
                        nums.push_back(Task{
                                .task = task_i,
                                .sub_task = i,
                        });
                        sum += tasks[task_i][i];
                    }
                    sum += tasks[task_i][compare_index];
                    nums.push_back(Task{
                            .task = task_i,
                            .sub_task = compare_index,
                    });
                    point_combinations.push_back(Combination{
                            .task_nums = nums,
                            .points_sum = sum,
                    });
                }

                uint32 max_points = 0;
                for (auto &points: tasks[task_i]) max_points += points;
                for (auto &e_comb: point_combinations) {
                    uint32 sum = 0;
                    std::vector<Task> nums;
                    for (uint32 i = comb_start_index; i < comb_start_index + comb_size; ++i) {
                        nums.push_back(Task{
                                .task = task_i,
                                .sub_task = i,
                        });
                        sum += tasks[task_i][i];
                    }

                    Combination comb{
                            .task_nums = nums,
                            .points_sum = sum,
                    };

                    if ((comb + e_comb).points_sum <= max_points) {
                        point_combinations.push_back(comb + e_comb);
                    }
                }
            }
        }

        task_point_combinations.push_back(point_combinations);
    }

    uint32 comb_count = 0;
    for (auto &comb: task_point_combinations) comb_count += comb.size();

    Combination comb = recursive_compare(Combination{.empty=true}, task_point_combinations, 0, s);
    if (!comb.empty) {
        std::vector<std::vector<uint32>> task_nums(n);

        for (auto& task_num: comb.task_nums) {
            task_nums[task_num.task].push_back(task_num.sub_task);
        }

        std::cout << "Yes" << std::endl;
        for (uint32 i = 0; i < n; ++i) {
            std::cout << task_nums[i].size() << std::endl;
            for (auto &task_num: task_nums[i]) {
                std::cout << task_num + 1 << std::endl;
            }
        }
    } else {
        std::cout << "No" << std::endl;
    }
}
