#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;
//template<typename T>
//using ordered_set = tree<T, null_type, less<T>, rb_tree_tag,tree_order_statistics_node_update>;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &a) {
    return in >> a.first >> a.second;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const pair<T1, T2> &a) {
    return out << a.first << ' ' << a.second << '\n';
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &i: a)out << i << ' ';
    return out;
}

typedef long long ll;
typedef long double ld;
namespace Max {
    struct Data {
        ll v;
        int ind;

        Data(ll v = {}, int ind = {}) : v(v), ind(ind) {}

        Data(const vector<ll> &a, int ind) : Data(a[ind], ind) {}

        Data operator+(const Data &other) {
            if (v > other.v)return *this;
            return other;
        }
    };

    struct tree {
        int n;
        vector<Data> d;

        tree(int n = {}) : n(n) {
            d.resize(4 * n);
        }

        tree(const vector<ll> &a) : tree(a.size()) {
            build(0, 0, n, a);
        }


        Data get(int ql, int qr) {
            return get(0, 0, n, ql, qr);
        }

        int downL(int ql, int qr, ll x) {
            return downL(0, 0, n, ql, qr, x);
        }

        int downR(int ql, int qr, ll x) {
            return downR(0, 0, n, ql, qr, x);
        }


    private:

        Data get(int t, int tl, int tr, int ql, int qr) {
            if (tl == ql && tr == qr) {
                return d[t];
            }
            int tm = (tl + tr) / 2;
            if (qr <= tm)return get(2 * t + 1, tl, tm, ql, qr);
            if (ql >= tm)return get(2 * t + 2, tm, tr, ql, qr);
            return get(2 * t + 1, tl, tm, ql, tm) + get(2 * t + 2, tm, tr, tm, qr);
        }

        Data build(int t, int tl, int tr, const vector<ll> &a) {
            if (tl + 1 == tr)return d[t] = {a, tl};
            int tm = (tl + tr) / 2;
            return d[t] = build(2 * t + 1, tl, tm, a) + build(2 * t + 2, tm, tr, a);
        }

        int downL(int t, int tl, int tr, int ql, int qr, ll x) {
            if (d[t].v<x)return -1;
            if (ql >= tr || qr <= tl)return -1;
            if (tl + 1 == tr)return tl;
            int tm = (tl + tr) / 2;
            int res = -1;
            if (d[2 * t + 1].v >= x)res = downL(2 * t + 1, tl, tm, ql, qr, x);
            if (res != -1)return res;
            return downL(2 * t + 2, tm, tr, ql, qr, x);
        }

        int downR(int t, int tl, int tr, int ql, int qr, ll x) {
            if (d[t].v<x)return -1;
            if (ql >= tr || qr <= tl)return -1;
            if (tl + 1 == tr)return tl;
            int tm = (tl + tr) / 2;
            int res = -1;
            if (d[2 * t + 2].v >= x)res = downR(2 * t + 2, tm, tr, ql, qr, x);
            if (res != -1)return res;
            return downR(2 * t + 1, tl, tm, ql, qr, x);
        }
    };
}
namespace Sum {
    struct Data {
        ll v;
        ll d = {0};

        Data(ll v = {}) : v(v) {}

        Data(const vector<ll> &a, int ind) : Data(a[ind]) {}

        Data operator+(const Data &other) {
            return {v + other.v};
        }
    };

    struct tree {
        int n;
        vector<Data> d;

        tree(int n = {}) : n(n) {
            d.resize(4 * n);
        }

        tree(const vector<ll> &a) : tree(a.size()) {
            build(0, 0, n, a);
        }


        Data get(int ql, int qr) {
            return get(0, 0, n, ql, qr);
        }

        void update(int ql, int qr, ll x) {
            if (ql == qr)return;
            update(0, 0, n, ql, qr, x);
        }

    private:
        void push(int t, int tl, int tr) {
            if (d[t].d == 0)return;
            d[t].v = d[t].d * (tr - tl);
            if (tl + 1 != tr) {
                d[2 * t + 1].d = d[2 * t + 2].d = d[t].d;
            }
            d[t].d = 0;
        }

        Data get(int t, int tl, int tr, int ql, int qr) {
            push(t, tl, tr);
            if (tl == ql && tr == qr) {
                return d[t];
            }
            int tm = (tl + tr) / 2;
            if (qr <= tm)return get(2 * t + 1, tl, tm, ql, qr);
            if (ql >= tm)return get(2 * t + 2, tm, tr, ql, qr);
            return get(2 * t + 1, tl, tm, ql, tm) + get(2 * t + 2, tm, tr, tm, qr);
        }

        void update(int t, int tl, int tr, int ql, int qr, ll x) {
            if (tl == ql && tr == qr) {
                d[t].d = x;
                return push(t, tl, tr);
            }
            push(t, tl, tr);
            int tm = (tl + tr) / 2;
            if (ql < tm)update(2 * t + 1, tl, tm, ql, min(tm, qr), x);
            else push(2 * t + 1, tl, tm);
            if (qr > tm)update(2 * t + 2, tm, tr, max(tm, ql), qr, x);
            else push(2 * t + 2, tm, tr);
            d[t] = d[2 * t + 1] + d[2 * t + 2];
        }

        Data build(int t, int tl, int tr, const vector<ll> &a) {
            if (tl + 1 == tr)return d[t] = {a, tl};
            int tm = (tl + tr) / 2;
            return d[t] = build(2 * t + 1, tl, tm, a) + build(2 * t + 2, tm, tr, a);
        }
    };
}
namespace Ind {
    struct Data {
        ll v;
        ll d = {0};

        Data(ll v = {}) : v(v) {}

        Data(const vector<ll> &a, int ind) : Data(a[ind]) {}

        Data operator+(const Data &other) {
            if (v > other.v)return *this;
            return other;
        }
    };

    struct tree {
        int n;
        vector<Data> d;

        tree(int n = {}) : n(n) {
            d.resize(4 * n);
        }

        tree(const vector<ll> &a) : tree(a.size()) {
            build(0, 0, n, a);
        }

        int downL(ll x) {
            if (d[0].v < x)return n;
            return downL(0, 0, n, x);
        }

        void update(int ql, int qr, ll x) {
            if (ql == qr)return;
            update(0, 0, n, ql, qr, x);
        }

    private:
        void push(int t, int tl, int tr) {
            if (d[t].d == 0)return;
            d[t].v += d[t].d;
            if (tl + 1 != tr) {
                d[2 * t + 1].d +=d[t].d;
                d[2 * t + 2].d += d[t].d;
            }
            d[t].d = 0;
        }


        void update(int t, int tl, int tr, int ql, int qr, ll x) {
            if (tl == ql && tr == qr) {
                d[t].d = x;
                return push(t, tl, tr);
            }
            push(t, tl, tr);
            int tm = (tl + tr) / 2;
            if (ql < tm)update(2 * t + 1, tl, tm, ql, min(tm, qr), x);
            else push(2 * t + 1, tl, tm);
            if (qr > tm)update(2 * t + 2, tm, tr, max(tm, ql), qr, x);
            else push(2 * t + 2, tm, tr);
            d[t] = d[2 * t + 1] + d[2 * t + 2];
        }

        Data build(int t, int tl, int tr, const vector<ll> &a) {
            if (tl + 1 == tr)return d[t] = {a, tl};
            int tm = (tl + tr) / 2;
            return d[t] = build(2 * t + 1, tl, tm, a) + build(2 * t + 2, tm, tr, a);
        }

        int downL(int t, int tl, int tr, ll x) {
            push(t, tl, tr);
            if (tl + 1 == tr)return tl;
            int tm = (tl + tr) / 2;
            push(2*t+1, tl, tm);
            push(2*t+2, tm, tr);
            if (d[2 * t + 1].v >= x)return downL(2 * t + 1, tl, tm, x);
            return downL(2 * t + 2, tm, tr, x);
        }
    };
}
struct Test {
    int n;
    vector<ll> a;
    Max::tree mxTree;
    Sum::tree sumTree;
    Ind::tree indTree;
    vector<ll> pref;

    ll get(int l, int r) {
        return pref[r] - pref[l];
    }

    Test() {
        cin >> n;
        a.resize(n);
        cin >> a;
        pref.resize(n + 1, 0);
        for (int i = 0; i < n; i++) {
            pref[i + 1] = pref[i] + a[i];
        }
        mxTree = Max::tree(a);
        sumTree = Sum::tree(a);
        vector<ll> t(n);
        for (int i = 0; i < n; i++)t[i] = i;
        indTree = Ind::tree(t);
        for (int i = 0; i < n - 1; i++) {
            int x;
            cin >> x;
            x--;
            int l = indTree.downL(x);
            int m = indTree.downL(x + 1);
            int r = indTree.downL(x + 2);
            indTree.update(m, n, -1);
            auto mx1 = mxTree.get(l, m);
            auto mx2 = mxTree.get(m, r);
            int up_l = -1;
            int up_r = -1;
            if (mx1.v > mx2.v) {
                int ind = mxTree.downR(l, m, mx2.v);
                up_l = ind + 1;
                up_r = mx2.ind;
            } else {
                int ind = mxTree.downL(m, r, mx1.v);
                up_l = mx1.ind + 1;
                up_r = ind;
            }
            //cout << l << ' ' << m << ' ' << r << ' ' << up_l << ' ' << up_r << ' ' << mx1.v << ' ' << mx2.v << '\n';
            sumTree.update(up_l, up_r, min(mx1.v, mx2.v));
            cout << sumTree.get(l, r).v - get(l, r) << '\n';
        }
    }
};

int main() {
#ifdef home
    freopen(".in", "r", stdin);
    freopen(".out", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int t = 1;
    //cin>>t;
    while (t--)Test();
    return 0;
}
