#include <bits/stdc++.h>

using namespace std;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &a) {
    return in >> a.first >> a.second;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const pair<T1, T2> &a) {
    return out << a.first << ' ' << a.second << '\n';
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (const auto &i: a)out << i << ' ';
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<vector<T>> &a) {
    for (const auto &i: a)out << i << '\n';
    return out;
}

typedef long long ll;
const ll inf = 1e9 + 7;
namespace Tree {
    enum Query {
        Add = 0,
        Set = 0
    };

    template<typename T>
    struct Data {
        T v{};
        int ind{};
        Query q{Add};
        T d{0};

        Data(T v = {}, int ind = {}) : v(v), ind(ind) {}

        Data(const vector<T> &a, int tl) : Data(a[tl], tl) {}

        Data<T> operator+(const Data<T> &other) {
            if (v < other.v)return this;
            return other;
        }
    };

    template<typename T>
    struct SgTree {
        int n;
        vector<Data<T>> d;

        SgTree(int n = {}) : n(n) {
            d.resize(n);
        }

        SgTree(const vector<T> &a) : SgTree(n) {
            build(0, 0, n, a);
        }

        Data<T> build(int t, int tl, int tr, const vector<T> &a) {
            if (tl + 1 == tr)return d[t] = {a, tl};
            int tm = (tl + tr) / 2;
            return build(2 * t + 1, tl, tm, a) + build(2 * t + 2, tm, tr, a);
        }
    };
}
struct Test {
    int n{}, k{};
    vector<ll> a;
    vector<ll> pref;
    vector<ll> suff;
    vector<ll> sum;

    Test() {
        cin >> n >> k;
        a.resize(n);
        cin >> a;
        sum.resize(n + 1, 0);
        for (int i = 0; i < n; i++) {
            sum[i + 1] = sum[i] + a[i];
        }
        pref.resize(n + 1, inf);
        suff.resize(n + 1, inf);
        for (int i = 0; i < n; i++) {
            pref[i + 1] = min(pref[i], a[i]);
        }
        for (int i = n - 1; i >= 0; i--) {
            suff[i] = min(suff[i + 1], a[i]);
        }
        ll ans = 0;
        ll size = n - k + 1;
        for (int i = 0; i + size <= n; i++) {
            ans = max(ans, (sum[i + size] - sum[i]) - min(pref[i], suff[i + size]));
        }
        for (int sz = 1; sz <= size; sz++) {
            ans = max(ans, (sum[sz])-a[sz]);
        }
        cout << ans << '\n';
    }
};

int main() {
#ifdef home
    freopen(".in", "r", stdin);
    freopen(".out", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int t = 1;
    //cin>>t;
    while (t--)Test();
}
