#include <bits/stdc++.h>

using namespace std;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &a) {
    return in >> a.first >> a.second;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const pair<T1, T2> &a) {
    return out << a.first << ' ' << a.second << '\n';
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (const auto &i: a)out << i << ' ';
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<vector<T>> &a) {
    for (const auto &i: a)out << i << '\n';
    return out;
}

typedef long long ll;
const ll inf = 1e9 + 7;
namespace Tree {
    enum Query {
        Add = 0,
        Set = 0
    };

    template<typename T>
    struct Data {
        T v{};
        int ind{};
        Query q{Add};
        T d{0};

        Data(T v = {}, int ind = {}) : v(v), ind(ind) {}

        Data(const vector<T> &a, int tl) : Data(a[tl], tl) {}

        Data<T> operator+(const Data<T> &other) {
            if (v < other.v)return this;
            return other;
        }
    };

    template<typename T>
    struct SgTree {
        int n;
        vector<Data<T>> d;

        SgTree(int n = {}) : n(n) {
            d.resize(n);
        }

        SgTree(const vector<T> &a) : SgTree(n) {
            build(0, 0, n, a);
        }

        Data<T> build(int t, int tl, int tr, const vector<T> &a) {
            if (tl + 1 == tr)return d[t] = {a, tl};
            int tm = (tl + tr) / 2;
            return build(2 * t + 1, tl, tm, a) + build(2 * t + 2, tm, tr, a);
        }
    };
}
struct Test {
    int n{}, s{};
    int m{};
    vector<vector<int>> a;
    vector<vector<int>> p;
    vector<int> used;

    Test() {
        cin >> n >> s;
        a.resize(n);
        for (int i = 0; i < n; i++) {
            int k;
            cin >> k;
            a[i].resize(k);
            cin >> a[i];
            m += k;
        }

        p.resize(m + 1, vector<int>(s + 1));
        used.resize(s + 1, -2);
        used[0]=-1;
        int cnt = 1;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < a[i].size(); j++) {
                for (int w = s; w >= 0; w--) {
                    if (used[w] < i - 1)continue;
                    if (used[w] == i) {
                        p[cnt][w] = -1;
                    }
                    if (w + a[i][j] > s)continue;
                    p[cnt][w + a[i][j]] = cnt;
                    used[w + a[i][j]] = i;
                }
                cnt++;
            }
        }
        if (used[s]!=n-1) {
            cout << "No\n";
            return;
        }
        cout << "Yes\n";
        int now = m;
        int w = s;
        vector<vector<int>> res(n);
        int i = n - 1;
        int j = int(a[n - 1].size()) - 1;
        while (now != 0) {
            if (p[now][s] != -1) {
                res[i].push_back(j + 1);
                s -= a[i][j];
            }
            now--;
            j--;
            if(now==0)break;
            while (j == -1) {
                i--;
                j = int(a[i].size()) - 1;
            }
        }
        for (int ind = 0; ind < n; ind++) {
            cout << res[ind].size() << '\n';
            cout << res[ind]<<'\n';
        }
    }
};

int main() {
#ifdef home
    freopen(".in", "r", stdin);
    freopen(".out", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int t = 1;
    //cin>>t;
    while (t--)Test();
}
