#pragma clang diagnostic push
#pragma ide diagnostic ignored "misc-no-recursion"

#include <bits/stdc++.h>

using namespace std;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &a) {
    return in >> a.first >> a.second;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const pair<T1, T2> &a) {
    return out << a.first << ' ' << a.second << '\n';
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (const auto &i: a)out << i << ' ';
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<vector<T>> &a) {
    for (const auto &i: a)out << i << '\n';
    return out;
}

typedef long long ll;
const ll mod = 1e9 + 7;

struct Test {
    int n{}, m{}, k{};
    vector<pair<int, int>> a;
    vector<int> pos1;
    vector<int> pos2;
    ll ans = 0;

    void check() {
        for (auto [i, j]: a) {
            if (j > pos1[i] || j < (i == 0 ? 0 : pos1[i - 1])) {
                if (j < pos2[n - i - 1] || j > (i == n - 1 ? n : pos2[n - i - 2])) {
                    return;
                }
            }
        }
        ans++;
    }

    void gen2(int v, int prev) {
        if (v == 0) {
            check();
            return;
        }
        if (v==1){
            pos2.push_back(0);
            gen2(v-1,0);
            pos2.pop_back();
            return;
        }
        for (int x = min(prev, pos1[v - 2] - 1); x >= 0; x--) {
            pos2.push_back(x);
            gen2(v - 1, x);
            pos2.pop_back();
        }
    }

    void gen1(int v, int prev = 1) {
        if (v == n - 1) {
            gen2(n - 1, m - 1);
            return;
        }
        if (v == n - 2)prev = m - 1;
        for (int x = prev; x < m; x++) {
            pos1.push_back(x);
            gen1(v + 1, x);
            pos1.pop_back();
        }
    }

    bool check(int i1, int i2) {
        for (auto [x, y]: a) {
            if (x == 0 && y > i1)return false;
            if (x == 1 && y > i2 && y < i1)return false;
            if (x == 2 && y < i2)return false;
        }
        return true;
    }

    void gen3() {
        for (int i1 = 1; i1 < m; ++i1) {
            for (int i2 = 0; i2 < i1; ++i2) {
                ans += check(i1, i2);
            }
        }

    }

    Test() {
        cin >> n >> m >> k;
        a.resize(k);
        cin >> a;
        for (auto &[x, y]: a) {
            x--;
            y--;
        }
        gen1(0);
        cout << (ans * 2) % mod << '\n';
    }
};

int main() {
#ifdef home
    freopen(".in", "r", stdin);
    freopen(".out", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int t = 1;
    //cin>>t;
    while (t--)Test();
}

#pragma clang diagnostic pop