/* NK1 */

#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <set>
#include <cmath>

typedef signed long long SLL;  // MY type

// from 1 to UpTo

int Res( const std::string &S1, const std::string &S2 )
{
  int i = 0;
  auto s = S1.size();
  while (i < s && S1[i] == S2[i])
  {
    i++;
  }
  if (i == s)
    return 0;
  if (S1[i] < S2[i])
    return -1;
  return 1;
}

SLL Simplistic( const std::string &UpTo )
{
  int n = UpTo.size();
  SLL result = 0;
  for (int i = 1; i < n; i++)
    result += i * 4;
  
  std::string test;
  test.resize(n);
  for (int i = 0; i < n; i++)
    test[i] = '1';

  for (char c : {'2', '3', '5', '7'})
  {
    for (int i = n - 1; i >= 0; i--)
    {
      test[i] = c;
      auto res = Res(test, UpTo);
      test[i] = '1';
      if (res == 1)
      {
        break;
      }
      else
        result++;
    }
  }

  return result;
}

inline bool CheckIfSimplistic( const std::string &s )
{
  int pr = 1;
  for (int i = 0; i < s.size(); i++)
  {
    pr *= (s[i] - '0');
    if (pr > 7)
      return false;
  }
  if (pr == 2 || pr == 3 || pr == 5 || pr == 7)
    return true;
  return false;
}

int main( void )
{
  // std::string s;
  // s.resize(100000);
  // s[0] = '1';
  // for (int i = 1; i < 100000; i++)
  //   s[i] = int((rand() / double(RAND_MAX)) * 9) + '0';

  std::string L, R;
  std::cin >> L >> R;

  std::cout << Simplistic(R) - Simplistic(L) + CheckIfSimplistic(L);
}
