/* NK1 */

#include <iostream>
#include <algorithm>
#include <fstream>
#include <string>
#include <vector>
#include <set>
#include <cmath>
#include <list>

typedef signed long long SLL;
typedef int block;
typedef std::list<block> segment;

SLL EvaluateDepth( const std::list<block> &List )
{
  SLL C = 0;
  auto current = List.begin();

  for (int i = 0; i < List.size(); i++)
  {
    auto begin1 = List.begin();
    auto hp = *current;

    int HMaxLeft = -1;

    for (int j = 0; j < i + 1; j++)
    {
      if (*begin1 > HMaxLeft)
        HMaxLeft = *begin1;
      begin1 = std::next(begin1);
    }
    int HMaxRight = -1;

    begin1 = current;
    for (int j = i; j < List.size(); j++)
    {
      if (*begin1 > HMaxRight)
        HMaxRight = *begin1;
      begin1 = std::next(begin1);
    }

    auto depth = std::min(HMaxLeft, HMaxRight) - hp;
    C += depth;
    current = std::next(current);
  }
  return C;
}

int main( void )
{
  int n;
  std::cin >> n;
  std::vector<segment> Segments(n);

  for (int i = 0; i < n; i++)
  {
    int h;
    std::cin >> h;
    Segments[i].push_back(h);
  }
  int SegmentsSize = n;

  for (int i = 0; i < n - 1; i++)
  {
    int k;
    std::cin >> k;
    k -= 1;

    Segments[k].splice(Segments[k].end(), Segments[k + 1]);
    for (int j = k + 2; j < n; j++)
    {
      Segments[j - 1] = Segments[j];
    }
    SegmentsSize--;

    std::cout << EvaluateDepth(Segments[k]) << "\n";
  }
  // std::list<int> test;
  // test.push_back(2);
  // test.push_back(4);
  // test.push_back(9);
  // test.push_back(19);
  // std::list<int> test2;
  // test2.push_back(32);
  // test2.push_back(199);
  // 
  // test.splice(test.end(), test2);
}