/* NK1 */

#include <iostream>
#include <algorithm>
#include <fstream>
#include <string>
#include <vector>
#include <set>
#include <cmath>
#include <list>

typedef signed long long SLL;
struct block
{
  int h;
  int HMaxLeft, HMaxRight;
};
struct segment : public std::list<block>
{
  int MaxH;
};

SLL EvaluateDepth( const std::list<block> &List )
{
  SLL C = 0;
  for (auto &blk : List)
    C += std::min(blk.HMaxLeft, blk.HMaxRight) - blk.h;

  return C;
}

int main( void )
{
  int n;
  std::cin >> n;
  std::vector<segment> Segments(n);

  for (int i = 0; i < n; i++)
  {
    int h;
    std::cin >> h;
    Segments[i].push_back({h, h, h});
    Segments[i].MaxH = h;
  }
  int SegmentsSize = n;

  for (int i = 0; i < n - 1; i++)
  {
    int k;
    std::cin >> k;
    k -= 1;

    auto MaxFrom2 = std::max(Segments[k].MaxH, Segments[k + 1].MaxH);

    for (auto &blk : Segments[k])
      if (Segments[k + 1].MaxH > blk.HMaxRight)
        blk.HMaxRight = Segments[k + 1].MaxH;

    for (auto &blk : Segments[k + 1])
      if (Segments[k].MaxH > blk.HMaxLeft)
        blk.HMaxLeft = Segments[k].MaxH;

    Segments[k].splice(Segments[k].end(), Segments[k + 1]);
    Segments[k].MaxH = MaxFrom2;

    for (int j = k + 2; j < n; j++)
    {
      Segments[j - 1] = Segments[j];
    }
    SegmentsSize--;

    std::cout << EvaluateDepth(Segments[k]) << "\n";
  }
  // std::list<int> test;
  // test.push_back(2);
  // test.push_back(4);
  // test.push_back(9);
  // test.push_back(19);
  // std::list<int> test2;
  // test2.push_back(32);
  // test2.push_back(199);
  // 
  // test.splice(test.end(), test2);
}