/* NK1 */

#include <iostream>
#include <algorithm>
#include <fstream>
#include <string>
#include <vector>
#include <set>
#include <cmath>
#include <list>

typedef signed long long SLL;
struct block
{
  int h;
  int HMaxLeft, HMaxRight;
};
struct segment : public std::list<block>
{
  int MaxH;
};

struct smart_list : public std::list<segment>
{
  segment & operator[]( int n )
  {
    auto beg = begin();
    for (int i = 0; i < n; i++)
      beg = std::next(beg);
    return *beg;
  }

  iterator Get( int n )
  {
    auto beg = begin();
    for (int i = 0; i < n; i++)
      beg = std::next(beg);
    return beg;
  }
};

SLL EvaluateDepth( const std::list<block> &List )
{
  SLL C = 0;
  for (auto &blk : List)
    C += std::min(blk.HMaxLeft, blk.HMaxRight) - blk.h;

  return C;
}

int main( void )
{
  int n = 40000;
  std::cin >> n;
  smart_list Segments;

  for (int i = 0; i < n; i++)
  {
    int h;
    std::cin >> h;
    Segments.push_back({});
    auto x = std::prev(Segments.end());
    x->push_back({h, h, h});
    x->MaxH = h;
  }
  int SegmentsSize = n;

  for (int i = 0; i < n - 1; i++)
  {
    int k = 1;
    std::cin >> k;
    k -= 1;

    auto & SegSeg = Segments[k];
    auto & SegSeg1 = Segments[k + 1];

    auto MaxFrom2 = std::max(SegSeg.MaxH, SegSeg1.MaxH);

    for (auto &blk : SegSeg)
      if (SegSeg1.MaxH > blk.HMaxRight)
        blk.HMaxRight = SegSeg1.MaxH;

    for (auto &blk : SegSeg1)
      if (SegSeg.MaxH > blk.HMaxLeft)
        blk.HMaxLeft = SegSeg.MaxH;

    SegSeg.splice(SegSeg.end(), SegSeg1);
    SegSeg.MaxH = MaxFrom2;

    Segments.erase(Segments.Get(k + 1));
    SegmentsSize--;

    std::cout << EvaluateDepth(SegSeg) << "\n";
  }
  // std::list<int> test;
  // test.push_back(2);
  // test.push_back(4);
  // test.push_back(9);
  // test.push_back(19);
  // std::list<int> test2;
  // test2.push_back(32);
  // test2.push_back(199);
  // 
  // test.splice(test.end(), test2);
}