/* NK1 */

#include <iostream>
#include <map>
#include <cmath>
#include <vector>

typedef signed long long SLL;  // Sneaky typedef

void Div( std::vector<std::pair<int, int>> &V, int d )
{
  int s = ceil(sqrt(d));

  for (int i = 2; i <= s; i++)
  {
    if (d % i == 0)
      V.push_back({i, d / i});
  }
}

inline int SolveSystem( const std::pair<int, int> &D1D2, SLL L, SLL R )
{
  auto sum = D1D2.first + D1D2.second;
  if (sum % 2 != 0)
    return 0;
  auto x = sum / 2;
  auto y1 = x - D1D2.first;
  auto y2 = x - D1D2.second;

  SLL x2 = x * x;

  if (x2 > R || x2 < L)
    return 0;
  int result = 0;

  // y1
  SLL y12 = y1 * y1;
  if (y1 > 0 && y1 < x && y12 <= R && y12 >= L)
    result++;

  // y2
  SLL y22 = y2 * y2;
  if (y2 > 0 && y2 != y1 && y2 < x && y22 <= R && y22 >= L)
    result++;

  return result;
}

int main( void )
{
  SLL L, R;
  int d;
  
  std::cin >> d;
  std::cin >> L >> R;

  std::vector<std::pair<int, int>> D;
  SLL result = 0;

  Div(D, d);
  for (auto &pair : D)
    result += SolveSystem(pair, L, R);

  std::cout << result;
}
