/* NK1 */

#include <iostream>
#include <map>
#include <cmath>
#include <vector>

typedef signed long long SLL;  // Sneaky typedef

void Div( std::vector<std::pair<int, int>> &V, int d )
{
  int s = ceil(sqrt(d));

  for (int i = 1; i <= s; i++)
  {
    if (d % i == 0)
      V.push_back({i, d / i});
  }
}

inline int SolveSystem( const std::pair<int, int> &D1D2, SLL L, SLL R )
{
  auto sum = D1D2.first + D1D2.second;
  if (sum % 2 != 0)
    return 0;
  auto x = sum / 2;

  auto y = x - D1D2.first;
  if (y == 0)
    return 0;
  if (y < 0)
    y = -y;

  if (y >= x)
    return 0;

  SLL y2 = y * y, x2 = x * x;

  if (y2 < L || y2 > R || x2 < L || x2 > R)
    return 0;
  return 1;
}

int main( void )
{
  SLL L, R;
  int d;
  
  std::cin >> d;
  std::cin >> L >> R;

  std::vector<std::pair<int, int>> D;
  SLL result = 0;

  Div(D, d);
  // auto size = D.size();
  // for (int i = 0; i < size; i++)
  //   D.push_back()

  for (auto &pair : D)
    result += SolveSystem(pair, L, R);

  std::cout << result;
}
