/* NK1 */

#include <iostream>
#include <map>
#include <cmath>
#include <vector>
#include <stdint.h>

typedef signed long long SLL;

#define PART_SUM(A, L, R) ((A)[(R) + 1] - (A)[(L)]) // --> [L, R]

int main( void )
{
  int n, k;
  std::cin >> n >> k;

  std::vector<int> A(n);
  for (int i = 0; i < n; i++)
    std::cin >> A[i];

  std::vector<SLL> PartSum(n + 1);
  PartSum[0] = 0;

  for (int i = 0; i < n; i++)
    PartSum[i + 1] = A[i] + PartSum[i];

  SLL MaxDiff = -INT64_MAX;

  for (int i = 0; i < n; i++)
    for (int j = i; j < n; j++)
    {
      int len = j - i + 1;
      if (n - len < k - 1)
        continue;
      SLL PS1 = PART_SUM(PartSum, i, j);
      SLL Min = INT64_MAX;

      for (int x = 0; x < i; x++)
        if (A[x] < Min)
          Min = A[x];
      for (int x = j + 1; x < n; x++)
        if (A[x] < Min)
          Min = A[x];
      if (PS1 - Min > MaxDiff)
        MaxDiff = PS1 - Min;
    }

  std::cout << MaxDiff;
}
