#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <algorithm>
using namespace std;

#define int long long

int n;
vector<int> h;
vector<int> maxl, maxp;
vector<int> k;
vector<long long> pref;
struct block {
    int anc, bas, basl, basp;
    block() {}
};
int tree[400000];

void build(int v, int l, int r) {
    if (r - l == 0)
        return;
    if (r - l == 1)
    {
        tree[v] = 1;
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

void udal(int v, int l, int r, int x) {
    if (l > x || r <= x)
        return;
    if (r - l == 1 && l == x) {
        tree[v] = 0;
        return;
    }
    int m = (l + r) / 2;
    if (m > x) {
        udal(2 * v + 1, l, m, x);
    } else {
        udal(2 * v + 2, m, r, x);
    }
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int kk(int v, int l, int r, int k) {
    if (r - l == 1 && k == tree[v]) {
        return l;
    }
    int m = (l + r) / 2;
    if (tree[2 * v + 1] >= k) {
        return kk(2 * v + 1, l, m, k);
    } else {
        return kk(2 * v + 2, m, r, k - tree[2 * v + 1]);
    }
}

vector<block> blocks;

pair<int, int> anc(int k2) {
    if (k2 == blocks[k2].anc)
        return make_pair(0, k2);
    auto p = anc(blocks[k2].anc);
    blocks[k2].anc = p.second;
    blocks[k2].bas = p.first + blocks[k2].bas;
    return make_pair(p.first + blocks[k2].bas, p.second);
}

void onion(int k1, int k2) {
    k1 = anc(k1).second;
    k2 = anc(k2).second;
    if (h[k1] < h[k2]) {
        blocks[k1].anc = k2;
        blocks[k2].basl = max(0ll, min(h[k2], h[k1]) * (k2 - k1 - 1) - (pref[k2] - pref[k1 + 1])) + blocks[k1].basl;
        blocks[k1].bas = max(0ll, min(h[k2], h[k1]) * (k2 - k1 - 1) - (pref[k2] - pref[k1 + 1]));
    } else {
        blocks[k2].anc = k1;
        blocks[k1].basp = max(0ll, min(h[k2], h[k1]) * (k2 - k1 - 1) - (pref[k2] - pref[k1 + 1])) + blocks[k2].basp;
        blocks[k2].bas = max(0ll, min(h[k2], h[k1]) * (k2 - k1 - 1) - (pref[k2] - pref[k1 + 1]));
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    cin >> n;
    h.resize(n);
    maxl.resize(n, -1);
    maxp.resize(n, -1);
    pref.resize(n + 1, 0);
    k.resize(n - 1);
    blocks.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> h[i];
        pref[i + 1] = pref[i] + h[i];
        blocks[i].anc = i;
        blocks[i].bas = 0;
        blocks[i].basl = 0;
        blocks[i].basp = 0;
    }
    maxl[0] = -1;
    maxp[maxp.size() - 1] = -1;
    for (int i = 1; i < n; i++) {
        int help = i - 1;
        while (help != -1 && h[help] <= h[i])
            help = maxl[help];
        maxl[i] = help;
        help = n - i;
        while (help != -1 && h[help] <= h[n - i - 1])
            help = maxp[help];
        maxp[n - i - 1] = help;
    }
    build(0, 0, n);
    for (int i = 0; i < n - 1; i++) {
        cin >> k[i];
        int k1 = kk(0, 0, n, k[i]), k2 = kk(0, 0, n, k[i] + 1);
        udal(0, 0, n, k2);
        auto u1 = anc(k1);
        auto u2 = anc(k2);
        if (h[u1.second] == h[u2.second]) {
            cout << max(0ll, h[u1.second] * (u2.second - u1.second - 1) - (pref[u2.second] - pref[u1.second + 1])) + blocks[u1.second].basl + blocks[u2.second].basp << '\n';
            onion(k1, k2);
        } else if (h[u1.second] > h[u2.second]) {
            int ind = maxl[u2.second];
            cout << max(0ll, min(h[ind], h[u2.second]) * (u2.second - ind - 1) - (pref[u2.second] - pref[ind + 1])) + blocks[ind].bas + blocks[u1.second].basl + blocks[u2.second].basp << '\n';
            onion(k1, k2);
        } else {
            int ind = maxp[u1.second];
            cout << max(0ll, min(h[ind], h[u1.second]) * (ind - u1.second - 1) - (pref[ind] - pref[u1.second + 1])) + blocks[ind].bas + blocks[u1.second].basl + blocks[u2.second].basp << '\n';
            onion(k1, k2);
        }
    }
}