#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
using namespace std;


int n;
vector<int> h;
vector<int> k;
vector<long long> pref;
struct block {
    int indmax, basl, basp;
};
int tree[400000];

void build(int v, int l, int r) {
    if (r - l == 0)
        return;
    if (r - l == 1)
    {
        tree[v] = 1;
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

void udal(int v, int l, int r, int x) {
    if (l > x || r <= x)
        return;
    if (r - l == 1 && l == x) {
        tree[v] = 0;
        return;
    }
    int m = (l + r) / 2;
    if (m > x) {
        udal(2 * v + 1, l, m, x);
    } else {
        udal(2 * v + 2, m, r, x);
    }
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int kk(int v, int l, int r, int k) {
    if (r - l == 1 && k == tree[v]) {
        return l;
    }
    int m = (l + r) / 2;
    if (tree[2 * v + 1] >= k) {
        return kk(2 * v + 1, l, m, k);
    } else {
        return kk(2 * v + 2, m, r, k - tree[2 * v + 1]);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    cin >> n;
    h.resize(n);
    pref.resize(n + 1, 0);
    k.resize(n - 1);
    vector<block> blocks(n);
    for (int i = 0; i < n; i++) {
        cin >> h[i];
        pref[i + 1] = pref[i] + h[i];
        blocks[i].indmax = i;
        blocks[i].basl = 0;
        blocks[i].basp = 0;
    }
    build(0, 0, n);
    for (int i = 0; i < n - 1; i++) {
        cin >> k[i];
        int k1 = kk(0, 0, n, k[i]), k2 = kk(0, 0, n, k[i] + 1);
        udal(0, 0, n, k2);
        cout << max(0ll, min(h[blocks[k1].indmax], h[blocks[k2].indmax]) * (blocks[k2].indmax - blocks[k1].indmax - 1) - (pref[blocks[k2].indmax] - pref[blocks[k1].indmax + 1])) + blocks[k1].basl + blocks[k2].basp << '\n';
        if (h[blocks[k1].indmax] > h[blocks[k2].indmax]) {
            blocks[k1].basp = max(0ll, min(h[blocks[k1].indmax], h[blocks[k2].indmax]) * (blocks[k2].indmax - blocks[k1].indmax - 1) - (pref[blocks[k2].indmax] - pref[blocks[k1].indmax + 1])) + blocks[k2].basp;
        } else {
            blocks[k1].basp = blocks[k2].basp;
            blocks[k1].basl = max(0ll, min(h[blocks[k1].indmax], h[blocks[k2].indmax]) * (blocks[k2].indmax - blocks[k1].indmax - 1) - (pref[blocks[k2].indmax] - pref[blocks[k1].indmax + 1])) + blocks[k1].basl;
            blocks[k1].indmax = blocks[k2].indmax;
        }
    }
}