#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define all(a) a.begin(),a.end()

using namespace __gnu_pbds;
using namespace std;

template<class T>
using ordered_set = tree<T,
                            null_type,
                            less<T>,
                            rb_tree_tag,
                            tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

struct ST {
    const int c = 21;
    vector<vector<int>> st;

    ST(vector<int>& a) {
        st.resize(c + 1, vector<int>(a.size()));
        st[0] = a;
        for (int len = 1; len <= c; ++len) {
            for (int i = 0; i + (1 << len) <= a.size(); ++i) {
                st[len][i] = max(st[len - 1][i], st[len - 1][i + (1 << (len - 1))]);
            }
        }
    }

    int rmq(int l, int r) {
        int lg = __lg(r - l + 1);
        return max(st[lg][l - 1], st[lg][r - (1 << lg)]);
    }
};

void print(auto a) {
    for (auto val : a) {
        cout << val << ' ';
    }
    cout << '\n';
}

gp_hash_table<int, int> indexes;
void solve() {
    int n;
    cin >> n;

    vector<int> h(n);
    vector<int> srt;
    ordered_set<vector<int>> os;
    for (int i = 0; i < n; ++i) {
        cin >> h[i];
        srt.push_back(h[i]);
        os.insert({i, i, 0});
    }

    sort(all(srt));
    srt.resize(unique(all(srt)) - srt.begin());

    int size = srt.size();
    for (int i = 0; i < size; ++i) {
        indexes[srt[i]] = i;
    }

    ST st(h);
    for (int i = 0, ind; i < n - 1; ++i) {
        cin >> ind;
        auto left = *os.find_by_order(ind - 1);
        auto right = *os.find_by_order(ind);
        int w = left[2] + right[2];
        int mxL = st.rmq(left[0] + 1, left[1] + 1);
        for (int i = right[0]; i <= right[1]; ++i) {
            int mx = st.rmq(right[0] + 1, i + 1);
            if (mx >= mxL) {
                break;
            }
            mx = min(mx, st.rmq(i + 1, right[1] + 1));
            w += (min(mxL, st.rmq(i + 1, right[1] + 1)) - mx);
        }
        int mxR = st.rmq(right[0] + 1, right[1] + 1);
        for (int i = left[1]; i >= left[0]; --i) {
            int mx = st.rmq(i + 1, left[1] + 1);
            if (mx >= mxR) {
                break;
            }
            mx = min(mx, st.rmq(left[0] + 1, i + 1));
            w += (min(mxR, st.rmq(left[0] + 1, i + 1)) - mx);
        }
        cout << w << '\n';
        os.erase(left);
        os.erase(right);
        os.insert({left[0], right[1], w});
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie();
    cin.tie();

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }
    return 0;
}