#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define all(a) a.begin(),a.end()

using namespace __gnu_pbds;
using namespace std;

template<class T>
using ordered_set = tree<T,
                            null_type,
                            less<T>,
                            rb_tree_tag,
                            tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

struct ST {
    const int c = 21;
    vector<vector<int>> st;

    ST(vector<int>& a) {
        st.resize(c + 1, vector<int>(a.size()));
        st[0] = a;
        for (int len = 1; len <= c; ++len) {
            for (int i = 0; i + (1 << len) <= a.size(); ++i) {
                st[len][i] = max(st[len - 1][i], st[len - 1][i + (1 << (len - 1))]);
            }
        }
    }

    int rmq(int l, int r) {
        int lg = __lg(r - l + 1);
        return max(st[lg][l - 1], st[lg][r - (1 << lg)]);
    }
};

struct SGT {
    struct Node {
        ll sum = 0;
        ll mod = -1;

        Node() {};
    };

    vector<Node> tree;

    SGT(int n) : tree(4 * n) {};

    inline void updateV(int v, int vl, int vr, ll& val) {
        tree[v].mod = val;
        tree[v].sum = (vr - vl) * val;
    }

    inline void push(int v, int vl, int vm, int vr) {
        ll& mod = tree[v].mod;
        if (mod == -1) return;
        updateV(2 * v + 1, vl, vm, mod);
        updateV(2 * v + 2, vm, vr, mod);
        mod = -1;
    }

    void set(int v, int vl, int vr, int l, int r, ll val) {
        if (r <= vl || vr <= l) {
            return;
        } else if (l <= vl && vr <= r) {
            tree[v].mod = val;
            tree[v].sum = (vr - vl) * val;
            return;
        }
        int vm = (vl + vr) / 2;
        push(v, vl, vm, vr);
        set(2 * v + 1, vl, vm, l, r, val);
        set(2 * v + 2, vm, vr, l, r, val);
        tree[v].sum = tree[2 * v + 1].sum + tree[2 * v + 2].sum;
    }

    ll sum(int v, int vl, int vr, int l, int r) {
        if (r <= vl || vr <= l) {
            return 0;
        } else if (l <= vl && vr <= r) {
            return tree[v].sum;
        }
        int vm = (vl + vr) / 2;
        push(v, vl, vm, vr);
        return sum(2 * v + 1, vl, vm, l, r) + sum(2 * v + 2, vm, vr, l, r);
    }
};

void print(auto a) {
    for (auto val : a) {
        cout << val << ' ';
    }
    cout << '\n';
}

int findFirstMax(int i, int j, ST& st) {
    ll mx = st.rmq(i + 1, j + 1);
    int l = i - 1, r = j, mid;
    while (l + 1 < r) {
        mid = (l + r) / 2;
        if (st.rmq(i + 1, mid + 1) == mx) {
            r = mid;
        } else {
            l = mid;
        }
    }
    return r;
}

int findLastMax(int i, int j, ST& st) {
    ll mx = st.rmq(i + 1, j + 1);
    int l = i, r = j + 1, mid;
    while (l + 1 < r) {
        mid = (l + r) / 2;
        if (st.rmq(i + 1, mid + 1) == mx) {
            l = mid;
        } else {
            r = mid;
        }
    }
    return l;
}

void solve() {
    int n;
    cin >> n;

    vector<int> h(n);
    SGT pref(n);
    SGT suf(n);
    ordered_set<vector<ll>> os;
    for (int i = 0; i < n; ++i) {
        cin >> h[i];
        pref.set(0, 0, n, i, i + 1, h[i]);
        suf.set(0, 0, n, i, i + 1, h[i]);
        os.insert({i, i, 0});
    }

    ST st(h);
    for (int i = 0, ind; i < n - 1; ++i) {
        cin >> ind;
        auto left = *os.find_by_order(ind - 1);
        auto right = *os.find_by_order(ind);
        ll w = left[2] + right[2];
        int mxL = st.rmq(left[0] + 1, left[1] + 1), l = right[0] - 1, r = right[1] + 1, mid, mx;
        while (l + 1 < r) {
            mid = (l + r) / 2;
            mx = st.rmq(right[0] + 1, mid + 1);
            if (mx >= mxL) {
                r = mid;
            } else {
                l = mid;
            }
        }

        if (r == right[1] + 1) {
            int mx = st.rmq(right[0] + 1, right[1] + 1);
            int ind = findFirstMax(right[0], right[1], st);
            w += ((ind - right[0] + 1) * mx - pref.sum(0, 0, n, right[0], ind + 1));
            pref.set(0, 0, n, right[0], right[1] + 1, mxL);
        } else {
            w += (mxL * (r - right[0]) - pref.sum(0, 0, n, right[0], r));
            pref.set(0, 0, n, right[0], r, mxL);
        }

        int mxR = st.rmq(right[0] + 1, right[1] + 1);
        l = left[0] - 1;
        r = left[1] + 1;
        while (l + 1 < r) {
            mid = (l + r) / 2;
            mx = st.rmq(mid + 1, left[1] + 1);
            if (mx >= mxR) {
                l = mid;
            } else {
                r = mid;
            }
        }

        if (l == left[0] - 1) {
            int mx = st.rmq(left[0] + 1, left[1] + 1);
            int ind = findLastMax(left[0], left[1], st);
            w += ((left[1] - ind + 1) * mx - suf.sum(0, 0, n, ind, left[1] + 1));
            suf.set(0, 0, n, left[0], left[1] + 1, mxR);
        } else {
            w += (mxR * (left[1] - l) - suf.sum(0, 0, n, l + 1, left[1] + 1));
            suf.set(0, 0, n, l + 1, left[1] + 1, mxR);
        }

        cout << w << '\n';
        os.erase(left);
        os.erase(right);
        os.insert({left[0], right[1], w});
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie();
    cin.tie();

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }
    return 0;
}