#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <unordered_map>

#define all(a) a.begin(),a.end()

#define x first
#define y second

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const ll INF = 1e18;

const int N = 2 * 1e6 + 1;
const int mod = 1e9 + 7;

ll fact[N];
ll obr[N];

int n, m;
ll br(ll a, int n) {
    if (n == 0) {
        return 1;
    } else if (n == 1) {
        return a % mod;
    }
    ll res = br(a, n / 2);
    return ((res * res) % mod * (n % 2 ? a : 1)) % mod;
}

ll C(int n, int k) {
    return (fact[n] * obr[n - k]) % mod * obr[k] % mod;
}

vector<pii> A;
vector<pii> B;

auto srt = [](pii a, pii b){
    return (a.x + a.y) < (b.x + b.y);
};

ll ans = 0;

vector<pii> p;
void func(int i) {
    if (i == p.size()) {
        sort(all(A), srt);
        sort(all(B), srt);
        reverse(all(B));
        A.push_back({n, m});
        B.push_back({1, 1});
        int i = 1, j = 1;
        ll res = 0;
        for (auto curr : A) {
            if (curr.x < i || curr.y < j) {
                res = 0;
                break;
            }
            int diff = abs((i - curr.x) + (j - curr.y));
            res += C(diff, abs(i - curr.x));
            res %= mod;
            i = curr.x;
            j = curr.y;
        }
        ll res1 = 0;
        i = n, j = m;
        for (auto curr : B) {
            if (curr.x > i || curr.y > j) {
                res1 = 0;
                break;
            }
            int diff = abs((i - curr.x) + (j - curr.y));
            res1 += C(diff, abs(i - curr.x));
            res1 %= mod;
            i = curr.x;
            j = curr.y;
        }
        ans += (res * res1) % mod;
        ans %= mod;
        return;
    }
    A.push_back(p[i]);
    func(i + 1);
    A.pop_back();
    B.push_back(p[i]);
    func(i + 1);
    B.pop_back();
}

void solve() {
    int k;
    cin >> n >> m >> k;

    p.resize(k);
    for (int i = 0, x, y; i < k; ++i) {
        cin >> x >> y;
        p[i] = {x, y};
    }

    cout << (C(n + m - 2, n - 1) * C(n + m - 2, n - 1)) % mod << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    fact[0] = 1;
    for (ll i = 1; i < N; ++i) {
        fact[i] = (fact[i - 1] * i) % mod;
    }
    obr[N - 1] = br(fact[N - 1], mod - 2);
    for (ll i = N - 2; i >= 0; --i) {
        obr[i] = (obr[i + 1] * (i + 1)) % mod;
    }

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }
}