#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using ll = long long;

using namespace std;
template<typename t>
istream &operator>>(istream &in, vector<t> &v){
    for(int i = 0; i<v.size(); i++){
        in>>v[i];
    }
    return in;
}
template<typename t>
ostream &operator<<(ostream &out, const vector<t> v){
    for(auto x: v)out<<x<<" ";
    return out;
}

struct SegTree {
    vector<ll> t, add;
    ll sz;
    SegTree(vector<ll> v = {1}){
        sz = v.size();
        t.resize(4*sz);
        add.resize(4*sz);
        build(1, 0,sz-1, v);
    }
    void build(ll v, ll tl, ll tr, vector<ll> &a){
        if(tl==tr){
            t[v]=a[tl];
        }
        else{
            ll tm = (tr+tl)/2;
            build(2*v, tl, tm, a);
            build(2*v+1, tm+1, tr, a);
            t[v]=t[2*v]+t[2*v+1];
        }
    }
    void push(ll v, ll tl, ll tr){
        if(add[v]!=0){
            t[v]=add[v]*(tr-tl+1);
            if(tl!=tr){
                add[2*v]=add[v];
                add[2*v+1]=add[v];
            }
            add[v]=0;
        }
    }
    ll get(ll l, ll r){
        if(l>r){
            return 0;
        }
        return _get(1, 0, sz-1, l, r);
    }
    ll _get(ll v, ll tl, ll tr, ll l, ll r){
        push(v, tl, tr);
        if(l<=tl&&tr<=r){
            return t[v];
        }
        ll tm = (tr+tl)/2;
        if(r<=tm){
            return _get(2*v, tl, tm, l, r);
        }
        if(l>=tm+1){
            return _get(2*v+1, tm+1, tr, l, r);
        }
        return _get(2*v, tl, tm, l, tm)+_get(2*v+1, tm+1, tr, tm+1, r);
    }
    void update(ll l, ll r, ll val){
        _update(1, 0, sz-1, l, r, val);
    }
    void _update(ll v, ll tl, ll tr, ll l, ll r, ll val){
        push(v, tl, tr);
        if(tl>r||l>tr){
            return;
        }
        if(l<=tl&&tr<=r){
            add[v]=val;
            push(v, tl, tr);
            return;
        }
        ll tm = (tr+tl)/2;
        _update(2*v, tl, tm, l, r, val);
        _update(2*v+1, tm+1, tr, l, r, val);
        t[v]=t[2*v]+t[2*v+1];
    }
};
struct SegTree1 {
    vector<ll> t, add;
    ll sz;
    SegTree1(vector<ll> v = {1}){
        sz = v.size();
        t.resize(4*sz);
        add.resize(4*sz);
        build(1, 0,sz-1, v);
    }
    void build(ll v, ll tl, ll tr, vector<ll> &a){
        if(tl==tr){
            t[v]=a[tl];
        }
        else{
            ll tm = (tr+tl)/2;
            build(2*v, tl, tm, a);
            build(2*v+1, tm+1, tr, a);
            t[v]=max(t[2*v],t[2*v+1]);
        }
    }
    void push(ll v, ll tl, ll tr){
        if(add[v]!=0){
            t[v]=add[v];
            if(tl!=tr){
                add[2*v]=add[v];
                add[2*v+1]=add[v];
            }
            add[v]=0;
        }
    }
    ll get(ll l, ll r){
        return _get(1, 0, sz-1, l, r);
    }
    ll _get(ll v, ll tl, ll tr, ll l, ll r){
        push(v, tl, tr);
        if(l<=tl&&tr<=r){
            return t[v];
        }
        ll tm = (tr+tl)/2;
        if(r<=tm){
            return _get(2*v, tl, tm, l, r);
        }
        if(l>=tm+1){
            return _get(2*v+1, tm+1, tr, l, r);
        }
        return max(_get(2*v, tl, tm, l, tm),_get(2*v+1, tm+1, tr, tm+1, r));
    }
    void update(ll l, ll r, ll val){
        _update(1, 0, sz-1, l, r, val);
    }
    void _update(ll v, ll tl, ll tr, ll l, ll r, ll val){
        push(v, tl, tr);
        if(tl>r||l>tr){
            return;
        }
        if(l<=tl&&tr<=r){
            add[v]=val;
            push(v, tl, tr);
            return;
        }
        ll tm = (tr+tl)/2;
        _update(2*v, tl, tm, l, r, val);
        _update(2*v+1, tm+1, tr, l, r, val);
        t[v]=max(t[2*v], t[2*v+1]);
    }
    ll down(ll v, ll tl, ll tr, ll val){
        push(v, tl, tr);
        if(tl==tr){
            return tl;
        }
        ll tm = (tl+tr)/2;
        if(t[2*v]>=val){
            return down(2*v, tl, tm, val);
        }
        return down(2*v+1, tm+1, tr, val);
    }
    ll down1(ll v, ll tl, ll tr, ll val){
        push(v, tl, tr);
        if(tl==tr){
            return tl;
        }
        ll tm = (tl+tr)/2;
        if(t[2*v+1]>=val){
            return down1(2*v+1, tm+1, tr, val);
        }
        return down1(2*v, tl, tm, val);
    }
};
struct SparseTable {
    vector<vector<ll>> t;
    ll n;
    SparseTable(vector<ll> v={1}){
        n = v.size();
        t.resize(__lg(n)+2);
        t[0]=v;
        for(int i = 1; i<t.size(); i++){
            t[i].resize(n);
            for(int j = 0; j+(1<<(i-1))<n; j++){
                t[i][j]=max(t[i-1][j], t[i-1][j+(1<<(i-1))]);
            }
        }
    }
    ll get(ll l, ll r){
        if(l>r){
            return 0;
        }
        ll k = __lg(r-l+1);
        cout<<l<<" "<<r<<" "<<k<<"\n";
        return max(t[k][l], t[k][r+1-(1<<k)]);
    }
};
void solve(){
    ll n;
    cin>>n;
    vector<ll> v(n);
    cin>>v;
    vector<ll> t(n-1);
    cin>>t;
    SparseTable sp = v;
    vector<pair<ll, ll>> qu(n-1);
    vector<pair<ll, ll>> segs(n);
    for(int i = 0; i<n; i++){
        segs[i]={i, i};
    }
    for(int i = 0; i<n-1; i++){
        ll ind = t[i]-1;
        segs[ind].second=segs[ind+1].second;
        segs.erase(ind+1+segs.begin());
        qu[i]=segs[ind];
    }
    for(auto [a, b]: qu){
        cout<<a<<" "<<b<<"\n";
    }
    vector<vector<pair<ll, ll>>> qu1(n), qu2(n);
    for(int i = 0; i<qu.size(); i++){
        ll l = qu[i].first, r = qu[i].second;
        ll l1 = l, r1 = r+1;
        while(r1-l1>1){
            ll m1 = (l1+r1)/2;
            ll x = sp.get(l, m1), y = sp.get(m1, r);
            if(x>=y){
                r1 = m1;
            }
            else{
                l1 = m1;
            }
        }
        qu1[l].push_back({l1, i});
        qu2[r].push_back({l1+1, i});
        if(i==qu.size()-1){
            cout<<l<<" "<<r<<" "<<l1<<"\n";
        }
    }
    vector<ll> ttt(n+1, -1);
    ttt[n]=2e9;
    SegTree sg = ttt;
    SegTree1 sg1 = ttt;
    vector<ll> ans(n-1);
    for(int l = n-1; l>-1; l--){
        ll ind = sg1.down(1, 0, sg1.sz-1, v[l]);
        sg1.update(l, ind-1, v[l]);
        sg.update(l, ind-1, v[l]);
        for(auto [a, b]: qu1[l]){
            ans[b]+=sg.get(l, a);
        }
    }
    ttt[n]=-1;
    ttt[0]=2e9;
    sg = ttt;
    sg1 = ttt;
    for(int r = 0; r<n; r++){
        ll ind = sg1.down1(1, 0, sg1.sz-1, v[r]);
        sg1.update(ind+1, r+1, v[r]);
        sg.update(ind+1, r+1, v[r]);
        for(auto [a, b]: qu2[r]){
            ans[b]+=sg.get(a+1, r+1);
        }
    }
    vector<ll> pref(n+1);
    for(int i = 0; i<n; i++){
        pref[i+1]=pref[i]+v[i];
    }
    //cout<<ans<<"\n";
    for(int i = 0; i<n-1; i++){
        ans[i]-=pref[qu[i].second+1]-pref[qu[i].first];
    }
    cout<<ans<<"\n";
}
signed main() {
    ll t = 1;
    //cin>>t;
    while(t--)solve();
}
//8
//9 1 8 1 5 2 3 6
//3 3 1 3 3 2 1