
#include <bits/stdc++.h>
using ll = long long;

using namespace std;
template<typename t>
istream &operator>>(istream &in, vector<t> &v){
    for(int i = 0; i<v.size(); i++){
        in>>v[i];
    }
    return in;
}
template<typename t>
ostream &operator<<(ostream &out, const vector<t> v){
    for(auto x: v)out<<x<<" ";
    return out;
}

struct SegTree {
    vector<ll> t, add;
    ll sz;
    SegTree(vector<ll> v = {1}){
        sz = v.size();
        t.resize(4*sz);
        add.resize(4*sz);
        build(1, 0,sz-1, v);
    }
    void build(ll v, ll tl, ll tr, vector<ll> &a){
        if(tl==tr){
            t[v]=a[tl];
        }
        else{
            ll tm = (tr+tl)/2;
            build(2*v, tl, tm, a);
            build(2*v+1, tm+1, tr, a);
            t[v]=t[2*v]+t[2*v+1];
        }
    }
    void push(ll v, ll tl, ll tr){
        if(add[v]!=0){
            t[v]=add[v]*(tr-tl+1);
            if(tl!=tr){
                add[2*v]=add[v];
                add[2*v+1]=add[v];
            }
            add[v]=0;
        }
    }
    ll get(ll l, ll r){
        if(l>r){
            return 0;
        }
        return _get(1, 0, sz-1, l, r);
    }
    ll _get(ll v, ll tl, ll tr, ll l, ll r){
        push(v, tl, tr);
        if(l<=tl&&tr<=r){
            return t[v];
        }
        ll tm = (tr+tl)/2;
        if(r<=tm){
            return _get(2*v, tl, tm, l, r);
        }
        if(l>=tm+1){
            return _get(2*v+1, tm+1, tr, l, r);
        }
        return _get(2*v, tl, tm, l, tm)+_get(2*v+1, tm+1, tr, tm+1, r);
    }
    void update(ll l, ll r, ll val){
        _update(1, 0, sz-1, l, r, val);
    }
    void _update(ll v, ll tl, ll tr, ll l, ll r, ll val){
        push(v, tl, tr);
        if(tl>r||l>tr){
            return;
        }
        if(l<=tl&&tr<=r){
            add[v]=val;
            push(v, tl, tr);
            return;
        }
        ll tm = (tr+tl)/2;
        _update(2*v, tl, tm, l, r, val);
        _update(2*v+1, tm+1, tr, l, r, val);
        t[v]=t[2*v]+t[2*v+1];
    }
};
struct SegTree1 {
    vector<ll> t, add;
    ll sz;
    SegTree1(vector<ll> v = {1}){
        sz = v.size();
        t.resize(4*sz);
        add.resize(4*sz);
        build(1, 0,sz-1, v);
    }
    void build(ll v, ll tl, ll tr, vector<ll> &a){
        if(tl==tr){
            t[v]=a[tl];
        }
        else{
            ll tm = (tr+tl)/2;
            build(2*v, tl, tm, a);
            build(2*v+1, tm+1, tr, a);
            t[v]=max(t[2*v],t[2*v+1]);
        }
    }
    void push(ll v, ll tl, ll tr){
        if(add[v]!=0){
            t[v]=add[v];
            if(tl!=tr){
                add[2*v]=add[v];
                add[2*v+1]=add[v];
            }
            add[v]=0;
        }
    }
    void update(ll l, ll r, ll val){
        _update(1, 0, sz-1, l, r, val);
    }
    void _update(ll v, ll tl, ll tr, ll l, ll r, ll val){
        push(v, tl, tr);
        if(tl>r||l>tr){
            return;
        }
        if(l<=tl&&tr<=r){
            add[v]=val;
            push(v, tl, tr);
            return;
        }
        ll tm = (tr+tl)/2;
        _update(2*v, tl, tm, l, r, val);
        _update(2*v+1, tm+1, tr, l, r, val);
        t[v]=max(t[2*v], t[2*v+1]);
    }
    ll down(ll v, ll tl, ll tr, ll val){
        push(v, tl, tr);
        if(tl==tr){
            return tl;
        }
        ll tm = (tl+tr)/2;
        push(2*v, tl, tm);
        if(t[2*v]>=val){

            return down(2*v, tl, tm, val);
        }

        return down(2*v+1, tm+1, tr, val);
    }
    ll down1(ll v, ll tl, ll tr, ll val){
        push(v, tl, tr);
        if(tl==tr){
            return tl;
        }
        ll tm = (tl+tr)/2;
        push(2*v+1, tm+1, tr);
        if(t[2*v+1]>=val){
            return down1(2*v+1, tm+1, tr, val);
        }
        return down1(2*v, tl, tm, val);
    }
};
struct SegTree2 {
    vector<ll> t, add;
    ll sz;
    SegTree2(vector<ll> v = {1}){
        sz = v.size();
        t.resize(4*sz);
        add.resize(4*sz);
        build(1, 0,sz-1, v);
    }
    void build(ll v, ll tl, ll tr, vector<ll> &a){
        if(tl==tr){
            t[v]=a[tl];
        }
        else{
            ll tm = (tr+tl)/2;
            build(2*v, tl, tm, a);
            build(2*v+1, tm+1, tr, a);
            t[v]=max(t[2*v],t[2*v+1]);
        }
    }
    void push(ll v, ll tl, ll tr){
        if(add[v]!=0){
            t[v]+=add[v];
            if(tl!=tr){
                add[2*v]+=add[v];
                add[2*v+1]+=add[v];
            }
            add[v]=0;
        }
    }
    void update(ll l, ll r, ll val){
        _update(1, 0, sz-1, l, r, val);
    }
    void _update(ll v, ll tl, ll tr, ll l, ll r, ll val){
        push(v, tl, tr);
        if(tl>r||l>tr){
            return;
        }
        if(l<=tl&&tr<=r){
            add[v]+=val;
            push(v, tl, tr);
            return;
        }
        ll tm = (tr+tl)/2;
        _update(2*v, tl, tm, l, r, val);
        _update(2*v+1, tm+1, tr, l, r, val);
        t[v]=max(t[2*v], t[2*v+1]);
    }
    ll down(ll v, ll tl, ll tr, ll val){
        push(v, tl, tr);
        if(t[v]<val){
            return sz;
        }
        if(tl==tr){
            return tl;
        }
        ll tm = (tl+tr)/2;
        push(2*v, tl, tm);
        if(t[2*v]>=val){

            return down(2*v, tl, tm, val);
        }

        return down(2*v+1, tm+1, tr, val);
    }
    ll down1(ll v, ll tl, ll tr, ll val){
        push(v, tl, tr);
        if(tl==tr){
            return tl;
        }
        ll tm = (tl+tr)/2;
        push(2*v+1, tm+1, tr);
        if(t[2*v+1]>=val){
            return down1(2*v+1, tm+1, tr, val);
        }
        return down1(2*v, tl, tm, val);
    }
};
struct SparseTable {
    vector<vector<ll>> t;
    ll n;
    SparseTable(vector<ll> v={1}){
        n = v.size();
        t.resize(__lg(n)+2);
        t[0]=v;
        for(int i = 1; i<t.size(); i++){
            t[i].resize(n);
            for(int j = 0; j+(1<<(i-1))<n; j++){
                t[i][j]=max(t[i-1][j], t[i-1][j+(1<<(i-1))]);
            }
        }
    }
    ll get(ll l, ll r){
        if(l>r){
            return 0;
        }
        ll k = __lg(r-l+1);
        //cout<<l<<" "<<r<<" "<<k<<"\n";
        return max(t[k][l], t[k][r+1-(1<<k)]);
    }
};
void solve(){
    ll n, k;
    cin>>n>>k;
    vector<ll> v(n);
    cin>>v;
    ll k1 = k*(k+1)/2;
    ll m = 1<<k1;
    vector<vector<ll>> dp(n, vector<ll> (m));
    ll mod = 1e9+7;
    for(int i = 0; i<n; i++){
        if(i<k-1){
            ll k2 = (2*k-i)*(i+1)/2;
            ll m1 = 1<<k2;
            dp[i].resize(m1);
            for(int j = 0; j<m1; j++){
                if(__builtin_popcount(j)!=v[i]){
                    continue;
                }
                if(i==0){
                    dp[i][j]++;
                    continue;
                }
                int cur = 0, cur1 = 0;
                ll m2 = 0, m3 = 0;
                for(int lay = 0; lay<=i; lay++){
                    for(int ind = 0; ind<k-lay; ind++){
                        if(j&(1<<cur)){
                            if(lay>0)m2|=(1<<cur1);
                        }
                        if(lay>0){
                            m3|=(1<<cur1);
                        }
                        cur++;
                        if(lay>0){
                            cur1++;
                        }
                    }cur1++;
                }
                //cout<<i<<" "<<j<<" "<<m2<<"\n";
                for(int j1  = 0; j1<dp[i-1].size(); j1++){
                    if(((j1^m2)&m3)==0){
                        dp[i][j]+=dp[i-1][j1];
                        dp[i][j]%=mod;
                    }
                }
            }
        }
        else{
            for(int j = 0; j<m; j++){
                if(__builtin_popcount(j)!=v[i]){
                    continue;
                }
                if(i==0){
                    dp[i][j]++;
                    continue;
                }
                int cur = 0, cur1 = 0;
                ll m2 = 0, m3 = 0;
                for(int lay = 0; lay<k; lay++){
                    for(int ind = 0; ind<k-lay; ind++){
                        if(j&(1<<cur)){
                            if(lay>0)m2|=(1<<cur1);
                        }
                        if(lay>0){
                            m3|=(1<<cur1);
                        }
                        cur++;
                        if(lay>0){
                            cur1++;
                        }
                    }cur1++;
                }
                //cout<<i<<" "<<j<<" "<<m2<<"\n";
                for(int j1  = 0; j1<dp[i-1].size(); j1++){
                    if(((j1^m2)&m3)==0){
                        dp[i][j]+=dp[i-1][j1];
                        dp[i][j]%=mod;
                    }
                }
            }
        }
    }
    ll ans = 0;
    for(int i = 0; i<dp[n-1].size(); i++){
        ans+=dp[n-1][i];
        ans%=mod;
    }
//    for(int i = 0; i<n; i++){
//        cout<<dp[i]<<"\n";
//    }
    cout<<ans<<"\n";
}
signed main() {
    ll t = 1;
    //cin>>t;
    while(t--)solve();
}
//8
//9 1 8 1 5 2 3 6
//3 3 1 3 3 2 1