#include <iostream>
#include <algorithm>
#include <math.h>
#include <random>
#include <map>
#include <set>
#include <vector>

using namespace std;

#define len(v) (int)((v).size())
typedef long long ll;


const int sz = 21;
int cnt[1 << sz];
int dp[1 << sz], ndp[1 << sz];

const int M = 1e9 + 7;

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	
	for (int i = 0; i < (1 << sz); ++i) {
		cnt[i] = 0;
		for (int j = 0; j < sz; ++j) {
			if (i & (1 << j)) ++cnt[i];
		}
	}

	int n, k;
	cin >> n >> k;

	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	
	if (k == 1) {
		cout << "1\n";
		return 0;
	}

	int w = k * (k - 1) / 2;
	
	vector<pair<int, int>> poses(w);
	vector<vector<int>> get_ind(k, vector<int>(k));

	int cur = 0;
	for (int i = 0; i < k - 1; ++i) {
		for (int j = 0; j <= i; ++j) {
			get_ind[i][j] = cur;
			poses[cur++] = { i, j };
		}
	}

	vector<int> upd(1 << w);
	for (int i = 0; i < (1 << w); ++i) {
		upd[i] = 0;
		for (int j = 0; j < w; ++j) {
			if ((i & (1 << j)) == 0) continue;
			if (poses[j].first == poses[j].second) continue;
			upd[i] |= (1 << get_ind[poses[j].first - 1][poses[j].second]);
		}
	}
	
	vector<vector<int>> good_masks(k + 1);
	for (int i = 0; i < (1 << k); ++i) {
		int u = 0;
		for (int f = 0; f < k - 1; ++f) {
			u |= (((i & (1 << f)) >> f) << get_ind[k - 2][f]);
		}
		good_masks[cnt[i]].push_back(u);
	}

	dp[0] = 1;

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < (1 << w); ++j) {
			if (dp[j] == 0 || cnt[j] > a[i] || cnt[j] + k < a[i]) continue;
			for (int m : good_masks[a[i] - cnt[j]]) {
				ndp[upd[j] | m] += dp[j];
				if (ndp[upd[j] | m] >= M) ndp[upd[j] | m] -= M;
			}
		}
		swap(ndp, dp);
		for (int j = 0; j < (1 << w); ++j) {
			ndp[j] = 0;
		}
	}
	int res = 0;
	for (int i = 0; i < (1 << w); ++i) {
		res = (res + dp[i]) % M;
	}
	cout << res << '\n';
}
