#include <iostream>
#include <vector>
#include <numeric>
#include <set>

using namespace std;
using ll = long long;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--)
        solve();

    return 0;
}

constexpr int INF = 1e9;

class segment_tree_max {
    int n;
    vector<int> t;

    void build(int v, int l, int r, vector<int> &a) {
        if (l + 1 == r) {
            t[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(v * 2 + 1, l, m, a);
        build(v * 2 + 2, m, r, a);
        t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
    }

    int query(int v, int l, int r, int ql, int qr) {
        if (r <= ql || qr <= l) {
            return -INF;
        }
        if (ql <= l && r <= qr) {
            return t[v];
        }
        int m = (l + r) / 2;
        return max(query(v * 2 + 1, l, m, ql, qr), query(v * 2 + 2, m, r, ql, qr));
    }

public:
    segment_tree_max(int n, vector<int> &a) : n(n) {
        t.resize(4 * n);
        build(0, 0, n, a);
    }

    int query(int ql, int qr) {
        return query(0, 0, n, ql, qr);
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> h(n);
    for (int i = 0; i < n; i++) cin >> h[i];
    segment_tree_max tree(n, h);
    vector<pair<int, int>> cur(n);
    for (int i = 0; i < n; i++) cur[i] = {i, i + 1};
    for (int _ = 0; _ < n - 1; _++) {
        int j;
        cin >> j;
        j--;
        cur[j].second = cur[j + 1].second;
        cur.erase(cur.begin() + j + 1);
        int ans = 0;
        for (int i = cur[j].first; i < cur[j].second; i++) {
            ans += max(0, min(tree.query(cur[j].first, i + 1), tree.query(i, cur[j].second)) - h[i]);
        }
        cout << ans << '\n';
    }
}
/*
8
9 1 8 1 5 2 3 6
3 3 1 3 3 2 1

 */