#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>
#include <valarray>

using namespace std;
using ll = long long;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--)
        solve();

    return 0;
}

class segment_tree_sum {
    ll n;
    vector<ll> t;

    void build(ll v, ll l, ll r, vector<ll> &a) {
        if (l + 1 == r) {
            t[v] = a[l];
            return;
        }
        ll m = (l + r) / 2;
        build(v * 2 + 1, l, m, a);
        build(v * 2 + 2, m, r, a);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }

    void update(ll v, ll l, ll r, ll qi, ll qe) {
        if (r <= qi || qi < l) {
            return;
        }
        if (l + 1 == r) {
            t[v] = qe;
            return;
        }
        ll m = (l + r) / 2;
        update(v * 2 + 1, l, m, qi, qe);
        update(v * 2 + 2, m, r, qi, qe);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }

    ll query(ll v, ll l, ll r, ll ql, ll qr) {
        if (r <= ql || qr <= l) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            return t[v];
        }
        ll m = (l + r) / 2;
        return query(v * 2 + 1, l, m, ql, qr) + query(v * 2 + 2, m, r, ql, qr);
    }

public:
    segment_tree_sum() {}

    segment_tree_sum(ll n, ll e = 0) : n(n) {
        vector<ll> a(n, e);
        t.resize(n * 4);
        build(0, 0, n, a);
    }

    segment_tree_sum(ll n, vector<ll> &a) : n(n) {
        t.resize(n * 4);
        build(0, 0, n, a);
    }

    void update(ll qi, ll qe) { update(0, 0, n, qi, qe); }

    ll query(ll ql, ll qr) { return query(0, 0, n, ql, qr); }
};

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for (ll i = 0; i < n; i++) cin >> a[i];
    segment_tree_sum tree(n, a);
    ll cnt_el = n - k + 1;
    vector<ll> lans(n);
    for (ll i = 0; i < n; i++) {
        if (i < cnt_el) lans[i] = tree.query(0, i);
        else            lans[i] = max(lans[i - 1], tree.query(i - cnt_el, i));
    }
    vector<ll> rans(n);
    for (ll i = n - 1; i >= 0; i--) {
        if (i > n - cnt_el - 1) rans[i] = tree.query(i + 1, n);
        else                    rans[i] = max(rans[i + 1], tree.query(i + 1, i + 1 + cnt_el));
    }
    ll ans = 0;
    for (ll i = 0; i < n; i++) {
        if (i < cnt_el && i > n - cnt_el - 1) {}
        else if (i < cnt_el)         ans = max(ans, rans[i] - a[i]);
        else if (i > n - cnt_el + 1) ans = max(ans, lans[i] - a[i]);
        else                         ans = max(ans, max(lans[i], rans[i]) - a[i]);
    }
    cout << ans << '\n';
}