#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>
#include <valarray>

using namespace std;
using ll = long long;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--)
        solve();

    return 0;
}

struct xy {
    int i, j;

    xy() : i(0), j(0) {}

    xy(int x, int y) : i(x), j(y) {}

    bool operator==(const xy &rhs) const { return i == rhs.i && j == rhs.j; }

    bool operator!=(const xy &rhs) const { return !(rhs == *this); }
};

ostream &operator<<(ostream &o, xy &e) {
    o << e.i << ' ' << e.j;
    return o;
}

void solve() {
    int n, s;
    cin >> n >> s;
    vector<int> ns(n);
    int sum_ns = 0;
    vector<vector<int>> inp(n);
    int sum_a_i = 0;
    for (int i = 0; i < n; i++) {
        cin >> ns[i];
        sum_ns += ns[i];
        inp[i].resize(ns[i]);
        for (int j = 0; j < ns[i]; j++) {
            cin >> inp[i][j];
            sum_a_i += inp[i][j];
        }
    }
    if (n == 1) {
        n = ns[0];
        vector<int> a = inp[0];
        vector<vector<int>> dp(n + 1, vector<int>(s + 1, 0));
        dp[0][0] = 1;
        for (int i = 1; i <= n; i++) {
            for (int j = 0; j <= s; j++) {
                if (j >= a[i - 1]) {
                    dp[i][j] = (dp[i - 1][j] | dp[i - 1][j - a[i - 1]]);
                } else {
                    dp[i][j] = dp[i - 1][j];
                }
            }
        }
        if (dp[n][s]) {
            xy c(n, s);
            vector<xy> ans = {c};
            while (c != xy(0, 0)) {
                if (c.j >= a[c.i - 1]) {
                    if (dp[c.i - 1][c.j - a[c.i - 1]] == 1) {
                        c = {c.i - 1, c.j - a[c.i - 1]};
                    } else {
                        c = {c.i - 1, c.j};
                    }
                    ans.push_back(c);
                } else {
                    c = {c.i - 1, c.j};
                    ans.push_back(c);
                }
            }
            cout << "Yes\n";
            reverse(ans.begin(), ans.end());
            vector<int> res;
            for (int i = 1; i < ans.size(); i++) {
                if (ans[i].j != ans[i - 1].j) {
                    res.push_back(ans[i].i);
                }
            }
            cout << res.size() << '\n';
            for (int e : res) {
                cout << e << ' ';
            }
            cout << '\n';
        } else {
            cout << "No\n";
        }
        return;
    }
    if (sum_ns == n) {
        if (sum_a_i == s) {
            cout << "Yes\n";
            for (int i = 0; i < 2 * n; i++) cout << "1\n";
        } else {
            cout << "No\n";
        }
        return;
    }
    const int len = 20;
    if (sum_ns <= len) {
        for (int mask = 0; mask < (1 << (len)); mask++) {
            int ic = 0;
            bool in;
            int curs = 0;
            for (int i = 0; i < n; i++) {
                in = false;
                for (int j = 0; j < ns[i]; j++) {
                    if (mask & (1 << (ic++))) {
                        curs += inp[i][j];
                        in = true;
                    }
                }
                if (!in) {
                    break;
                }
            }
            if (in && curs == s) {
                vector<vector<int>> ans(n);
                ic = 0;
                for (int i = 0; i < n; i++) {
                    for (int j = 0; j < ns[i]; j++) {
                        if (mask & (1 << (ic++))) {
                            ans[i].push_back(j);
                        }
                    }
                }
                cout << "Yes\n";
                for (int i = 0; i < n; i++) {
                    cout << ans[i].size() << '\n';
                    for (int e: ans[i]) cout << e + 1 << ' ';
                    cout << '\n';
                }
                return;
            }
        }
        cout << "No\n";
        return;
    }
}