#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>
#include <valarray>

using namespace std;
using ll = long long;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--)
        solve();

    return 0;
}

struct xy {
    int i, j;

    xy() : i(0), j(0) {}

    xy(int x, int y) : i(x), j(y) {}

    bool operator==(const xy &rhs) const { return i == rhs.i && j == rhs.j; }

    bool operator!=(const xy &rhs) const { return !(rhs == *this); }
};

ostream &operator<<(ostream &o, xy &e) {
    o << e.i << ' ' << e.j;
    return o;
}

void solve() {
    int n, s;
    cin >> n >> s;
    vector<int> ns(n);
    int sum_ns = 0;
    vector<vector<int>> inp(n);
    int sum_a_i = 0;
    for (int i = 0; i < n; i++) {
        cin >> ns[i];
        sum_ns += ns[i];
        inp[i].resize(ns[i]);
        for (int j = 0; j < ns[i]; j++) {
            cin >> inp[i][j];
            sum_a_i += inp[i][j];
        }
    }
    if (n == 1) {
        int n1 = ns[0];
        vector<int> a1 = inp[0];
        vector<vector<int>> dp1(n1 + 1, vector<int>(s + 1, 0));
        dp1[0][0] = 1;
        for (int i = 1; i <= n1; i++) {
            for (int j = 0; j <= s; j++) {
                if (j >= a1[i - 1]) {
                    dp1[i][j] = (dp1[i - 1][j] | dp1[i - 1][j - a1[i - 1]]);
                } else {
                    dp1[i][j] = dp1[i - 1][j];
                }
            }
        }
        if (dp1[n1][s]) {
            xy c(n1, s);
            vector<xy> ans = {c};
            while (c != xy(0, 0)) {
                if (c.j >= a1[c.i - 1]) {
                    if (dp1[c.i - 1][c.j - a1[c.i - 1]] == 1) {
                        c = {c.i - 1, c.j - a1[c.i - 1]};
                    } else {
                        c = {c.i - 1, c.j};
                    }
                    ans.push_back(c);
                } else {
                    c = {c.i - 1, c.j};
                    ans.push_back(c);
                }
            }
            cout << "Yes\n";
            reverse(ans.begin(), ans.end());
            vector<int> res;
            for (int i = 1; i < ans.size(); i++) {
                if (ans[i].j != ans[i - 1].j) {
                    res.push_back(ans[i].i);
                }
            }
            cout << res.size() << '\n';
            for (int e : res) {
                cout << e << ' ';
            }
            cout << '\n';
            return;
        }
        cout << "No\n";
        return;
    }
    if (n == 2) {
        int n1 = ns[0];
        vector<int> a1 = inp[0];
        vector<vector<int>> dp1(n1 + 1, vector<int>(s + 1, 0));
        dp1[0][0] = 1;
        for (int i = 1; i <= n1; i++) {
            for (int j = 0; j <= s; j++) {
                if (j >= a1[i - 1]) dp1[i][j] = (dp1[i - 1][j] | dp1[i - 1][j - a1[i - 1]]);
                else dp1[i][j] = dp1[i - 1][j];
            }
        }
        int n2 = ns[1];
        vector<int> a2 = inp[1];
        vector<vector<int>> dp2(n2 + 1, vector<int>(s + 1, 0));
        dp2[0][0] = 1;
        for (int i = 1; i <= n2; i++) {
            for (int j = 0; j <= s; j++) {
                if (j >= a2[i - 1]) dp2[i][j] = (dp2[i - 1][j] | dp2[i - 1][j - a2[i - 1]]);
                else dp2[i][j] = dp2[i - 1][j];
            }
        }
        for (int w1 = 1; w1 < s; w1++) {
            if (dp1[n1][w1] && dp2[n2][s - w1]) {
                cout << "Yes\n";
                xy c1(n1, w1);
                vector<xy> ans1 = {c1};
                while (c1 != xy(0, 0)) {
                    if (c1.j >= a1[c1.i - 1]) {
                        if (dp1[c1.i - 1][c1.j - a1[c1.i - 1]] == 1) {
                            c1 = {c1.i - 1, c1.j - a1[c1.i - 1]};
                        } else {
                            c1 = {c1.i - 1, c1.j};
                        }
                        ans1.push_back(c1);
                    } else {
                        c1 = {c1.i - 1, c1.j};
                        ans1.push_back(c1);
                    }
                }
                reverse(ans1.begin(), ans1.end());
                vector<int> res1;
                for (int i = 1; i < ans1.size(); i++) {
                    if (ans1[i].j != ans1[i - 1].j) {
                        res1.push_back(ans1[i].i);
                    }
                }
                cout << res1.size() << '\n';
                for (int e : res1) {
                    cout << e << ' ';
                }
                cout << '\n';

                xy c2(n2, s - w1);
                vector<xy> ans2 = {c2};
                while (c2 != xy(0, 0)) {
                    if (c2.j >= a2[c2.i - 1]) {
                        if (dp2[c2.i - 1][c2.j - a2[c2.i - 1]] == 1) {
                            c2 = {c2.i - 1, c2.j - a2[c2.i - 1]};
                        } else {
                            c2 = {c2.i - 1, c2.j};
                        }
                        ans2.push_back(c2);
                    } else {
                        c2 = {c2.i - 1, c2.j};
                        ans2.push_back(c2);
                    }
                }
                reverse(ans2.begin(), ans2.end());
                vector<int> res2;
                for (int i = 1; i < ans2.size(); i++) {
                    if (ans2[i].j != ans2[i - 1].j) {
                        res2.push_back(ans2[i].i);
                    }
                }
                cout << res2.size() << '\n';
                for (int e : res2) {
                    cout << e << ' ';
                }
                cout << '\n';
                return;
            }
        }
        cout << "No\n";
        return;
    }
    if (sum_ns == n) {
        if (sum_a_i == s) {
            cout << "Yes\n";
            for (int i = 0; i < 2 * n; i++) cout << "1\n";
        } else {
            cout << "No\n";
        }
        return;
    }
    const int len = 20;
    if (sum_ns <= len) {
        for (int mask = 0; mask < (1 << (len)); mask++) {
            int ic = 0;
            bool in;
            int curs = 0;
            for (int i = 0; i < n; i++) {
                in = false;
                for (int j = 0; j < ns[i]; j++) {
                    if (mask & (1 << (ic++))) {
                        curs += inp[i][j];
                        in = true;
                    }
                }
                if (!in) {
                    break;
                }
            }
            if (in && curs == s) {
                vector<vector<int>> ans(n);
                ic = 0;
                for (int i = 0; i < n; i++) {
                    for (int j = 0; j < ns[i]; j++) {
                        if (mask & (1 << (ic++))) {
                            ans[i].push_back(j);
                        }
                    }
                }
                cout << "Yes\n";
                for (int i = 0; i < n; i++) {
                    cout << ans[i].size() << '\n';
                    for (int e: ans[i]) cout << e + 1 << ' ';
                    cout << '\n';
                }
                return;
            }
        }
        cout << "No\n";
        return;
    }
}