#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <cassert>

using namespace std;
using ll = long long;

void solve();

int main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr), cout.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--)
        solve();

    return 0;
}

struct xy {
    int i, j;

    xy() : i(0), j(0) {}

    xy(int x, int y) : i(x), j(y) {}

    bool operator==(const xy &rhs) const { return i == rhs.i && j == rhs.j; }

    bool operator!=(const xy &rhs) const { return !(rhs == *this); }
};

ostream &operator<<(ostream &o, xy &e) {
    o << e.i << ' ' << e.j;
    return o;
}

vector<vector<int>> ruckzak(int n, int s, vector<int> &a) {
    vector<vector<int>> dp(n + 1, vector<int>(s + 1, 0));
    dp[0][0] = 1;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= s; j++) {
            if (j >= a[i - 1]) dp[i][j] = (dp[i - 1][j] | dp[i - 1][j - a[i - 1]]);
            else dp[i][j] = dp[i - 1][j];
        }
    }
    return dp;
}

vector<int> cnt_ans(int n, int w, vector<int> &a, vector<vector<int>> &dp) {
    xy c(n, w);
    vector<xy> ans = {c};
    while (c != xy(0, 0)) {
        if (c.j >= a[c.i - 1]) {
            if (dp[c.i - 1][c.j - a[c.i - 1]] == 1) c = {c.i - 1, c.j - a[c.i - 1]};
            else c = {c.i - 1, c.j};
            ans.push_back(c);
        } else {
            c = {c.i - 1, c.j};
            ans.push_back(c);
        }
    }
    reverse(ans.begin(), ans.end());
    vector<int> res;
    for (int i = 1; i < ans.size(); i++)
        if (ans[i].j != ans[i - 1].j)
            res.push_back(ans[i].i);
    return res;
}

void solve() {
    int n, s;
    cin >> n >> s;
    vector<int> ns(n);
    int sum_ns = 0;
    vector<vector<int>> a(n);
    int sum_a_i = 0;
    for (int i = 0; i < n; i++) {
        cin >> ns[i];
        sum_ns += ns[i];
        a[i].resize(ns[i]);
        for (int j = 0; j < ns[i]; j++) {
            cin >> a[i][j];
            sum_a_i += a[i][j];
        }
    }
    vector<vector<int>> ok(n);
    for (int i = 0; i < n; i++) {
        auto cur = ruckzak(ns[i], s, a[i]);
        for (int j = 1; j <= s; j++)
            if (cur[ns[i]][j])
                ok[i].push_back(j);
    }
    vector<vector<int>> dp(n + 1, vector<int>(s + 1, 0));
    dp[0][0] = 1;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= s; j++) {
            for (int e: ok[i - 1]) {
                if (j >= e) dp[i][j] = dp[i][j] | dp[i - 1][j - e];
                else dp[i][j] = dp[i][j];
            }
        }
    }
    if (dp[n][s]) {
        cout << "Yes\n";
        xy c(n, s);
        vector<int> ans;
        while (c != xy(0, 0)) {
            for (int e: ok[c.i - 1]) {
                if (dp[c.i - 1][c.j - e]) {
                    c = {c.i - 1, c.j - e};
                    ans.push_back(e);
                    break;
                }
            }
        }
        reverse(ans.begin(), ans.end());
        for (int i = 0; i < n; i++) {
            auto dp = ruckzak(ns[i], ans[i], a[i]);
            auto res = cnt_ans(ns[i], ans[i], a[i], dp);
            cout << res.size() << '\n';
            for (int e : res) cout << e << ' ';
            cout << '\n';
        }
        return;
    }
    cout << "No\n";
}

/*
2 4
1
2
2
3 1

2 4
1
2
2
2 1

 */