#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>

using namespace std;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--)
        solve();

    return 0;
}

vector<vector<int>> ruckzak(int n, int s, vector<int> &a) {
    vector<vector<int>> dp(n + 1, vector<int>(s + 1, 0));
    dp[0][0] = 1;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= s; j++) {
            if (j >= a[i - 1]) dp[i][j] = (dp[i - 1][j] | dp[i - 1][j - a[i - 1]]);
            else dp[i][j] = dp[i - 1][j];
        }
    }
    return dp;
}

vector<int> cnt_ans(int n, int w, vector<int> &a, vector<vector<int>> &dp) {
    int i = n, j = w;
    vector<pair<int, int>> ans = {{i, j}};
    while (i != 0 || j != 0) {
        if (j >= a[i - 1]) {
            if (dp[i - 1][j - a[i - 1]] == 1) j -= a[i - 1];
        }
        i--;
        ans.emplace_back(i, j);
    }
    reverse(ans.begin(), ans.end());
    vector<int> res;
    for (int i = 1; i < ans.size(); i++)
        if (ans[i].second != ans[i - 1].second)
            res.push_back(ans[i].first);
    return res;
}

void solve() {
    int n, s;
    cin >> n >> s;
    vector<int> ns(n);
    vector<vector<int>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> ns[i];
        a[i].resize(ns[i]);
        for (int j = 0; j < ns[i]; j++) cin >> a[i][j];
    }
    vector<vector<int>> ok(n);
    for (int i = 0; i < n; i++) {
        auto cur = ruckzak(ns[i], s, a[i]);
        for (int j = 1; j <= s; j++)
            if (cur[ns[i]][j])
                ok[i].push_back(j);
    }
    vector<vector<int>> dp(n + 1, vector<int>(s + 1, 0));
    dp[0][0] = 1;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= s; j++) {
            for (int e: ok[i - 1]) {
                if (j >= e) dp[i][j] = dp[i][j] | dp[i - 1][j - e];
                else dp[i][j] = dp[i][j];
            }
        }
    }
    if (dp[n][s]) {
        cout << "Yes\n";
        int i = n, j = s;
        vector<int> ans;
        while (i != 0 || j != 0) {
            for (int e: ok[i - 1]) {
                if (dp[i - 1][j - e]) {
                    i--;
                    j -= e;
                    ans.push_back(e);
                    break;
                }
            }
        }
        reverse(ans.begin(), ans.end());
        for (int i = 0; i < n; i++) {
            auto dp = ruckzak(ns[i], ans[i], a[i]);
            auto res = cnt_ans(ns[i], ans[i], a[i], dp);
            cout << res.size() << '\n';
            for (int e : res) cout << e << ' ';
            cout << '\n';
        }
        return;
    }
    cout << "No\n";
}

/*
2 4
1
2
2
3 1

2 4
1
2
2
2 1

 */