#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;

#define int int64_t

const int maxn = 100005;
const int maxlog = 17;
const int INF = 2e9;

struct node
{
    node(int64_t _sum,int _mn,int _cnt_mn,int _second_mn){sum = _sum;mn = _mn;cnt_mn = _cnt_mn;second_mn = _second_mn;};
    node(){};
    int64_t sum;
    int mn;
    int cnt_mn;
    int second_mn;
};

ordered_set X;
node segTree[2][4*maxn];
int p[2][4*maxn];
int h[maxn];
int rg[maxn];
int maxst[maxn];
pair<int,int> st[maxlog][maxn];
int64_t pr[maxn];

node mrg(node a, node b)
{
    map<int,int> cou;
    cou[a.mn] += a.cnt_mn;
    cou[b.mn] += b.cnt_mn;
    cou[a.second_mn] ++;
    cou[b.second_mn] ++;
    node ans;
    ans.sum = a.sum + b.sum;
    ans.mn = (*cou.begin()).first;
    ans.cnt_mn = (*cou.begin()).second;
    ans.second_mn = (*(++cou.begin())).first;
    return ans;
}

void push(int l,int r,int indV,int j)
{
    if(p[j][indV] < segTree[j][indV].mn)
    {
        return ;
    }
    segTree[j][indV].sum += (p[j][indV]-segTree[j][indV].mn)*segTree[j][indV].cnt_mn;
    segTree[j][indV].mn = p[j][indV];
    if(l != r)
    {
        p[j][indV*2+1] = max(p[j][indV],p[j][indV*2+1]);
        p[j][indV*2+2] = max(p[j][indV],p[j][indV*2+2]);
    }
    return ;
}
void modify(int lx,int rx,int x,int l,int r,int indV,int j)
{
    //cout << segTree[j][indV].second_mn << ' ' << l << ' ' << r << endl;
    push(l,r,indV,j);
    if(l > rx || r < lx || segTree[j][indV].mn >= x)
        return ;
    else if(l >= lx && r <= rx && segTree[j][indV].second_mn > x)
    {
        p[j][indV] = max(p[j][indV],x);
        push(l,r,indV,j);
        return ;
    }
    int m = (l+r)/2;
    modify(lx,rx,x,l,m,indV*2+1,j);
    modify(lx,rx,x,m+1,r,indV*2+2,j);
    segTree[j][indV] = mrg(segTree[j][indV*2+1],segTree[j][indV*2+2]);
   // cout << "4" << endl;
    return ;
}
int64_t get(int lx,int rx,int l,int r,int indV,int j)
{
    //cout << "1" << endl;
    push(l,r,indV,j);
    if(l > rx || r < lx)
        return 0;
    else if(l >= lx && r <= rx)
    {
        return segTree[j][indV].sum;
    }
    int m = (l+r)/2;
    int64_t sl = get(lx,rx,l,m,indV*2+1,j);
    int64_t sr = get(lx,rx,m+1,r,indV*2+2,j);
    //cout << "2" << endl;
    return sl+sr;
}

void build(int l,int r,int indV,int j)
{
    if(l == r)
    {
        segTree[j][indV] = node(h[l],h[l],1,INF);
        p[j][indV] = 0;
        return ;
    }
    int m = (l+r)/2;
    build(l,m,indV*2+1,j);
    build(m+1,r,indV*2+2,j);
    segTree[j][indV] = mrg(segTree[j][indV*2+1],segTree[j][indV*2+2]);
    p[j][indV] = 0;
    return ;
}

pair<int,int> MAX(int l,int r)
{
    return max(st[maxst[r-l+1]][l],st[maxst[r-l+1]][r-(1<<maxst[r-l+1])+1]);
}

void do_op(int k,int n)
{
   // cout << k << ' ' << n << endl;
    auto it = X.find_by_order(k);
    int lg1 = (*it);
    int rg1 = rg[lg1];
    it++;
    int lg2 = (*it);
    int rg2 = rg[lg2];
    rg[lg1] = rg2;
    X.erase(it);
  //  cout << k << ' ' << n << "2" << endl;
    modify(lg1,rg1,MAX(lg2,rg2).first,0,n-1,0,0);
    modify(lg2,rg2,MAX(lg1,rg1).first,0,n-1,0,1);
    int pos = MAX(lg1,rg2).second;
    cout << get(lg1,pos,0,n-1,0,1)+get(pos+1,rg2,0,n-1,0,0)-pr[rg2+1]+pr[lg1] << "\n";

}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    pr[0] = 0;
    for(int j = 0;j < n;++j)
    {
        cin >> h[j];
        pr[j+1] = pr[j] + h[j];
    }
    int tst = 0;
    for(int i = 1;i < maxn;++i)
    {
        maxst[i] = tst;
        if((1<<(tst+1)) <= i+1)
            tst++;
    }
   // cout << "!" << endl;
    build(0,n-1,0,0);
    build(0,n-1,0,1);
    for(int i = 0;i < int64_t(log2(n))+1;++i)
    {
        for(int j = 0;j < n-(1<<i)+1;++j)
        {
            if(i == 0)
                st[i][j] = {h[j],j};
            else
                st[i][j] = max(st[i-1][j],st[i-1][j + (1<<(i-1))]);
        }
    }
   // cout << "!" << endl;
    for(int j = 0;j < n;++j)
    {
        rg[j] = j;
        X.insert(j);
    }
    for(int j = 0;j < n-1;++j)
    {
        int k;
        cin >> k;
        do_op(k-1,n);
    }
}

