#include <iostream>
#include <vector>
#include <functional>

std::vector<unsigned int> buff;

void Loop(unsigned int i, unsigned int to, unsigned int depth, std::function<void(std::vector<unsigned int>&)> func, std::vector<unsigned int>& args, bool starter = true, unsigned max_depth = -1){
    if( starter ){
        args.resize(depth);
        max_depth = depth;
    }
    for(; i < to; ++i){
        if(depth == 1){
            args[max_depth - depth] = i;
            func(args);
        }
        else{
            args[max_depth - depth] = i;
            Loop(i + 1, to, depth - 1, func, args, false, max_depth);
        }
    }
}

unsigned int CountDif(std::vector<unsigned int>& sums){
    unsigned int max_sum = 0;
    unsigned int min_sum = (unsigned int)(-1);

    for(unsigned int i = 0; i < sums.size(); ++i){
        max_sum = sums[i] * (sums[i] > max_sum) + max_sum * (max_sum >= sums[i]);
        min_sum = sums[i] * (sums[i] < min_sum) + min_sum * (min_sum <= sums[i]);
    }

    return max_sum - min_sum;
}

int main(){
    unsigned int n, k, max_dif;

    scanf("%u", &n);
    scanf("%u", &k);

    std::vector<unsigned int> values;
    values.resize(n);

    for(unsigned int i = 0; i < n; ++i){
        scanf("%u", &values[i]);
    }

    auto func = std::function<void(std::vector<unsigned int>&)>([&values, &max_dif](std::vector<unsigned int>& args){
            std::vector<unsigned int> sums;
            sums.resize(args.size() + 1);
            for(unsigned int i = 0; i < sums.size(); ++i){
                sums[i] = 0;
            }
            for(unsigned int i = 0; i <= args[0]; ++i){
                sums[0] += values[i];
            }
            for(unsigned int i = 1; i < args.size(); ++i){
                for(unsigned int j = args[i - 1] + 1; j <= args[i]; ++j){
                    sums[i] += values[j];
                }
            }
            for(unsigned int i = args[args.size() - 1] + 1; i < values.size(); ++i){
                sums[sums.size() - 1] += values[i];
            }

            unsigned int dif = CountDif(sums);
            //printf("Args: %u %u   dif: %u   sums: %u %u %u\n", args[0], args[1], dif, sums[0], sums[1], sums[2]);
            max_dif = dif * (dif > max_dif) + max_dif * (max_dif >= dif);
         });

    Loop(0, n - 1, k - 1, func, buff);

    printf("%u", max_dif);
}
