#include <iostream>
#include <vector>

struct Sys{
    Sys(unsigned int task = 0, unsigned int sub_task = 0, unsigned int score = 0) : task(task), sub_task(sub_task), score(score) {};

    unsigned int task;
    unsigned int sub_task;
    unsigned int score;
};

void SortSys(std::vector<Sys>& vec){
    for(int i = vec.size() - 1; i >= 0; --i){
        for(int j = i - 1; j >= 0; --j){
            if(vec[i].score < vec[j].score){
                Sys tmp = vec[i];
                vec[i] = vec[j];
                vec[j] = tmp;
            }
        }
    }
}

int main(){
    unsigned int n, s, score_sum = 0, total_sum_of_all = 0, total_tasks = 0;
    std::vector<std::vector<unsigned int>> tasks;
    std::vector<std::vector<Sys>> solution;
    std::vector<Sys> possibilities;
    std::vector<int> offset;

    scanf("%u", &n);
    scanf("%u", &s);

    tasks.resize(n);
    solution.resize(n);
    offset.resize(n);

    for(unsigned int i = 0; i < n; ++i){
        offset[i] = 0;
        unsigned int sub_tasks_count = 0;
        scanf("%u", &sub_tasks_count);
        tasks[i].resize(sub_tasks_count);
        unsigned int min_s = (unsigned int)(-1);
        unsigned int min_sub_task = 0;
        for(unsigned int j = 0; j < sub_tasks_count; ++j){
            total_tasks += 1;
            scanf("%u", &tasks[i][j]);
            total_sum_of_all += tasks[i][j];
            min_sub_task = j * (tasks[i][j] < min_s) + min_sub_task * (min_s <= tasks[i][j]);
            min_s = tasks[i][j] * (tasks[i][j] < min_s) + min_s * (min_s <= tasks[i][j]);
        }
        solution[i].push_back(Sys(i, min_sub_task, min_s));

        score_sum += min_s;
    }


    if(score_sum > s or total_sum_of_all < s){
        printf("No");
        return 0;
    }

    possibilities.resize(total_tasks - tasks.size());;

    unsigned int index = 0;

    for(unsigned int i = 0; i < n; ++i){
        for(unsigned int j = 0; j < tasks[i].size(); ++j){
            if(j != solution[i][0].sub_task){
                possibilities[index] = Sys(i, j, tasks[i][j]);
                index += 1;
            }
        }
    }

    int diff = s - score_sum;

    SortSys(possibilities);

    index = 0;


    while( diff > 0 ){
        Sys& var = possibilities[index];
        solution[var.task].push_back(var);
        diff -= var.score;
        index += 1;
    }

    if( diff < 0 ){
        for(unsigned i = 0; i < solution.size(); ++i){
            if( solution[i].size() > 1 ){
                bool perfect_solution = false;
                for( unsigned j = 0; j < solution[i].size(); ++j )
                    perfect_solution = diff + solution[i][j].score == 0 or perfect_solution;
                if( perfect_solution ){
                    for( unsigned j = 0; j < solution[i].size(); ++j ){
                    if( diff + solution[i][j].score == 0 ){
                        solution[i][j].task = -1;
                        offset[i] += 1;
                        diff = 0;
                    }
                    }
                }
                else{
                    int max_score = 0;
                    int max_score_index = 0;
                    for( unsigned j = 0; j < solution[i].size(); ++j ){
                        max_score_index = j * (solution[i][j].score > max_score) + max_score_index * (max_score >= solution[i][j].score);
                        max_score = solution[i][j].score * (solution[i][j].score > max_score) + max_score * (max_score >= solution[i][j].score);
                    }
                    diff += max_score;
                    solution[i][max_score_index].task = -1;
                }
            }
        }
    }

    if( diff == 0 ){
        printf("Yes\n");

        for(int i = 0; i < solution.size(); ++i){

            printf("%u\n", solution[i].size() - offset[i] );
            for(int j = 0; j < solution[i].size(); ++j){
                if(solution[i][j].task != -1){
                    printf("%u\n", solution[i][j].sub_task + 1);
                }
            }
        }
    }
    else{
        printf("No");
    }
    return 0;
}
