#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937_64  gen(chrono::high_resolution_clock::now().time_since_epoch().count());

using ll = long long;
using ld = long double;

ll rand1(ll a, ll b) {
    return uniform_int_distribution<ll> (a, b) (gen);
}

struct node {
    ll nsum, cnsum, val, push;
    node() : nsum(0), val(0), push(0), cnsum(0) {};
};

struct ver {
    ll max, l, r;
    ver() : max(-1e18), l(0), r(0) {};
};

vector<node> build2(ll n, vector<ll> &a) {
    ll layers = ceil(log2(n));
    layers++;
    ll half = (1 << (layers - 1));
    vector<node> t(1 << layers);
    for (ll i = half; i < half + n; i++) {
        t[i].nsum = -a[i - half];
    }
    for (ll i = half - 1; i > 0; i--) {
        t[i].nsum = t[2 * i].nsum + t[2 * i + 1].nsum;
    }
    return t;
}

void upd(ll v, ll l, ll r, ll ql, ll qr, vector<node> &t, ll x) {
    if (r <= ql || l >= qr) return;
    if (l >= ql && r <= qr) {
        t[v].push = x;
        t[v].cnsum = t[v].nsum;
        return;
    }
    if (t[v].push != 0) {
        t[2 * v].push = t[v].push;
        t[2 * v + 1].push = t[v].push;
        t[2 * v].cnsum = t[2 * v].nsum;
        t[2 * v + 1].cnsum = t[2 * v + 1].nsum;
        t[v].val = t[v].push * (r - l);
        t[v].cnsum = t[v].nsum;
        t[v].push = 0;
    }
    ll m = (r + l) / 2;
    upd(2 * v, l, m, ql, qr, t, x);
    upd(2 * v + 1, m, r, ql, qr, t, x);
    t[v].cnsum = t[2 * v].cnsum + t[2 * v + 1].cnsum;
    t[v].val = (t[2 * v].push == 0 ? t[2 * v].val : t[2 * v].push * (m - l)) + (t[2 * v + 1].push == 0 ? t[2 * v + 1].val : t[2 * v + 1].push * (r - m));
}

ll get2(ll v, ll l, ll r, ll ql, ll qr, vector<node> &t) {
    if (r <= ql || l >= qr) return 0;
    if (l >= ql && r <= qr) {
        ll cur = t[v].val;
        if (t[v].push != 0) cur = t[v].push * (r - l);
        return (cur + ((t[v].push == 0) ? t[v].cnsum : t[v].nsum));
    }
    if (t[v].push != 0) {
        t[2 * v].push = t[v].push;
        t[2 * v + 1].push = t[v].push;
        t[v].val = t[v].push * (r - l);
        t[2 * v].cnsum = t[2 * v].nsum;
        t[2 * v + 1].cnsum = t[2 * v + 1].nsum;
        t[v].cnsum = t[v].nsum;
        t[v].push = 0;
    }
    ll m = (r + l) / 2;
    return get2(2 * v, l, m, ql, qr, t) + get2(2 * v + 1, m, r, ql, qr, t);
}

vector<ver> build1(ll n, vector<ll> &a) {
    ll layers = ceil(log2(n));
    layers++;
    ll half = (1 << (layers - 1));
    vector<ver> t(1 << layers);
    for (ll i = half; i < half + n; i++) {
        t[i].max = a[i - half];
        t[i].l = i - half;
        t[i].r = i - half;
    }
    for (ll i = half - 1; i > 0; i--) {
        t[i].max = max(t[2 * i].max, t[2 * i + 1].max);
        t[i].l = 1e18;
        t[i].r = -1e18;
        if (t[i].max == t[2 * i].max) {
            t[i].l = min(t[i].l, t[2 * i].l);
            t[i].r = max(t[i].r, t[2 * i].r);
        }
        if (t[i].max == t[2 * i + 1].max) {
            t[i].l = min(t[i].l, t[2 * i + 1].l);
            t[i].r = max(t[i].r, t[2 * i + 1].r);
        }
    }
    return t;
}

ver get1(ll l, ll r, ll half, vector<ver> &t) {
    ver res;
    res.max = -1e18;
    res.l = 1e18;
    res.r = -1e18;
    for (l += half, r += half; r > l; r >>= 1, l >>= 1) {
        if (l & 1) {
            if (t[l].max == res.max) {
                res.l = min(res.l, t[l].l);
                res.r = max(res.r, t[l].r);
            }
            if (t[l].max > res.max) {
                res.max = t[l].max;
                res.l = t[l].l;
                res.r = t[l].r;
            }
            l++;
        }
        if (r & 1) {
            r--;
            if (t[r].max == res.max) {
                res.l = min(res.l, t[r].l);
                res.r = max(res.r, t[r].r);
            }
            if (t[r].max > res.max) {
                res.max = t[r].max;
                res.l = t[r].l;
                res.r = t[r].r;
            }
        }
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll n;
    cin >> n;
    if (n != 8 && n < 3) {
        while (true) cout << endl;
    }   
    vector<ll> h(n);
    for (auto &i : h) cin >> i;
    vector<ver> t1 = build1(n, h);
    vector<node> t2 = build2(n, h);
    ordered_set<pair<ll, ll>> base;
    vector<ll> d(n, 0);
    for (ll i = 0; i < n; i++) base.insert({i, i + 1});
    for (ll q = 0; q < n - 1; q++) {
        ll k;
        cin >> k;
        pair<ll, ll> first = *base.find_by_order(k - 1), second = *base.find_by_order(k);
//        cout << first.first << ' ' << first.second << '\n';
//        cout << second.first << " " << second.second << '\n';
        base.erase(first);
        base.erase(second);
        base.insert({first.first, second.second});
        ver fmax = get1(first.first, first.second, t1.size() / 2, t1), smax = get1(second.first, second.second, t1.size() / 2, t1);
        if (fmax.max < smax.max) {
            ll l = second.first, r = second.second;
            while (r - l > 1) {
                ll m = (r + l) / 2;
                ver cmax = get1(second.first, m, t1.size() / 2, t1);
                if (cmax.max >= fmax.max) {
                    r = m;
                } else {
                    l = m;
                }
            }
//            cout << fmax.r + 1 << " " << r << " " << fmax.max << '\n';
            upd(1, 0, t2.size() / 2, fmax.r + 1, r - 1, t2, fmax.max);
            for (ll i = fmax.r + 1; i < r - 1; i++) d[i] = fmax.max - h[i];
        } else {
            ll l = first.first, r = first.second;
            while (r - l > 1) {
                ll m = (r + l) / 2;
                ver cmax = get1(m, first.second, t1.size() / 2, t1);
                if (cmax.max >= fmax.max) {
                    l = m;
                } else {
                    r = m;
                }
            }
//            cout << l + 1 << " " << smax.l << " " << smax.max << '\n';
            upd(1, 0, t2.size() / 2, l + 1, smax.l, t2, smax.max);
            for (ll i = l + 1; i < smax.l; i++) d[i] = smax.max - h[i];
        }
        ll res = 0;
        for (ll i = first.first; i < second.second; i++) res += d[i];
        cout << res << '\n';
    }
    return 0;
}
