﻿#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#define int long long

using namespace std;
int n;
vector<int> prhs;
vector<int> h, ks;
vector<vector<int>> sparses;
vector<int> logs;
vector<int> rs;
int get_sum_h(int l, int r) { // c л по р вкл
    if (l == 0) return prhs[r];
    return prhs[r] - prhs[l - 1];
}
void count_sparses() {
    for (int i = 0; i < n; i++) {
        sparses[i][0] = h[i];
    }
    for (int step = 1; step < logs[n] + 1; step++) {
        for (int i = 0; i < n; i++) {
            if (i + (1 << (step)) > n) {
                continue;
            }
            sparses[i][step] = max(sparses[i][step - 1], sparses[i + (1 << (step - 1))][step - 1]);
        }
    }
}
int get_max_h(int l, int r) { // c l по r вкл
    int k = logs[r - l];
    int a = sparses[l][k];
    int b = sparses[r - ((int) (1 << k)) + 1][k];
    return max(a, b);
}
struct segtree {
    int sz = 1;
    vector<int> tree;
    void init(int n) {
        while (sz < n) sz *= 2;
        tree.assign(2 * sz - 1, 0);
    }
    void set(int x, int lx, int rx, int ind, int val) {
        if (rx - lx == 1) {
            tree[x] = val;
            return;
        }
        int m = (lx + rx) / 2;
        if (ind < m) {
            set(2 * x + 1, lx, m, ind, val);
        }
        else {
            set(2 * x + 2, m, rx, ind, val);
        }
        tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
    }
    void set(int ind, int val) {
        set(0, 0, sz, ind, val);
    }
    int get(int x, int lx, int rx, int k) {
        if (rx - lx == 1) {
            return lx;
        }
        int m = (lx + rx) / 2;
        if (k > tree[2 * x + 1]) {
            return get(2 * x + 2, m, rx, k - tree[2 * x + 1]);
        }
        else {
            return get(2 * x + 1, lx, m, k);
        }
    }
    int get(int k) {
        return get(0, 0, sz, k);
    }
};
struct massseg {
    struct node {
        int sm;
        int pl;
    };
    vector<node> tree;
    int sz = 1;
    void init(int n) {
        while (sz < n) sz *= 2;
        tree.assign(2 * sz - 1, { 0, 0 });
    }
    void push(int x, int l, int r) {
        tree[x].sm = get_sum_h(l, r - 1) - (r - l) * tree[x].pl;
        if (r - l != 1) {
            tree[2 * x + 1].pl += tree[x].pl;
            tree[2 * x + 2].pl += tree[x].pl;
        }
        tree[x].pl = 0;
    }
    void add(int x, int lx, int rx, int lq, int rq, int val) {
        push(x, lx, rx);
        if (rx <= lq || rq <= lx) return;
        if (lq <= lx && rx <= rq) {
            tree[x].pl += val;
            push(x, lx, rx);
            return;
        }
        int m = (lx + rx) / 2;
        add(2 * x + 1, lx, m, lq, rq, val);
        add(2 * x + 2, m, rx, lq, rq, val);
        tree[x].sm = tree[2 * x + 1].sm + tree[2 * x + 2].sm;
    }
    int get(int x, int lx, int rx, int lq, int rq) {
        push(x, lx, rx);
        if (rx <= lq || rq <= lx) return 0;
        if (lq <= lx && rx <= rq) {
            return tree[x].sm;
        }
        int m = (lx + rx) / 2;
        int a = get(2 * x + 1, lx, m, lq, rq);
        int b = get(2 * x + 2, m, rx, lq, rq);
        return a + b;
    }
    void add(int l, int r, int v) {
        add(0, 0, sz, l, r, v);
    }
    int get(int l, int r) {
        return get(0, 0, sz, l, r);
    }
};
segtree strad;
massseg nst;
int mergee(int l1, int r1, int l2, int r2) {
    int p1, p2;
    if (r1 - l1 >= r2 - l2) {
        for (int i = l2; i <= r2; i++) {
            int l = l1 - 1;
            int r = r1 + 1;
            int m;
            while (l + 1 != r) {
                m = (l + r) / 2;
                if (get_max_h(m, r1) < h[i]) {
                    r = m;
                }
                else {
                    l = m;
                }
            }
            if (r != r1 + 1) {
                nst.add(-h[i], r, r1 + 1);
            }
            r1++;
        }
    }
    else {
        for (int i = r1; i >= l1; i--) {
            int l = l2 - 1;
            int r = r2 + 1;
            int m;
            while (l + 1 != r) {
                m = (l + r) / 2;
                if (get_max_h(l2, m) < h[i]) {
                    l = m;
                }
                else {
                    r = m;
                }
            }
            if (l != l2 - 1) {
                nst.add(-h[i], l2, l);
            }
            l2--;
        }
    }
    return -nst.get(l1, r2);
}
void solve() {
    cin >> n;
    h.resize(n);
    for (int i = 0; i < n; i++) cin >> h[i];
    ks.resize(n - 1);
    for (int i = 0; i < n - 1; i++) {
        cin >> ks[i];
    }
    prhs.resize(n);
    prhs[0] = h[0];
    for (int i = 1; i < n; i++) {
        prhs[i] = prhs[i - 1] + h[i];
    }
    logs.resize(n + 1);
    logs[1] = 0;
    int pr, st;
    for (int i = 2; i <= n; i++) {
        int pr = 1;
        int st = 0;
        while (pr <= i) {
            pr *= 2;
            st++;
        }
        logs[i] = st - 1;
    }
    sparses.assign(n, vector<int>(logs[n] + 1));
    count_sparses();
    rs.resize(n);
    for (int i = 0; i < n; i++) {
        rs[i] = i;
    }
    
    strad.init(n);
    for (int i = 0; i < n; i++) {
        strad.set(i, 1);
    }
    nst.init(n);
    int l1, r1, l2, r2;
    int ans = 0;
    for (int i = 0; i < n - 1; i++) {
        l1 = strad.get(ks[i]);
        r1 = rs[l1];
        l2 = strad.get(ks[i] + 1);
        r2 = rs[l2];
        ans = 0;
        for (int i = l1 + 1; i < r2; i++) {
            ans += min(get_max_h(l1, i), get_max_h(i, r2)) - h[i];
        }
        cout << ans << '\n';
        strad.set(l2, 0);
        rs[l1] = r2;
    }
}

signed main() {
    solve();
    return 0;
}
