﻿#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <stack>
#include <queue>
#include <iostream>
#define int long long
#define ld long double
using namespace std;
int inf = 2e9;
int n, k;
struct segtree {
    int sz = 1;
    vector<int> tree;
    void init(int n) {
        while (sz < n) sz *= 2;
        tree.assign(2 * sz - 1, inf);
    }
    void set(int x, int lx, int rx, int ind, int val) {
        if (rx - lx == 1) {
            tree[x] = val;
            return;
        }
        int m = (lx + rx) / 2;
        if (ind < m) {
            set(2 * x + 1, lx, m, ind, val);
        }
        else {
            set(2 * x + 2, m, rx, ind, val);
        }
        tree[x] = min(tree[2 * x + 1], tree[2 * x + 2]);
    }
    int get(int x, int lx, int rx, int lq, int rq) {
        if (rq <= lx || rx <= lq) return inf;
        if (lq <= lx && rx <= rq) return tree[x];
        int m = (lx + rx) / 2;
        return min(get(2 * x + 11, lx, m, lq, rq), get(2 * x + 2, m, rx, lq, rq));
    }
    void set(int i, int b) {
        set(0, 0, sz, i, b);
    }
    int get(int l, int r) {
        return get(0, 0, sz, l, r);
    }
};
vector<int> prsum;
int get_s(int l, int r) {
    return prsum[r + 1] - prsum[l];
}
void solve() {
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    prsum.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        prsum[i] = prsum[i - 1] + a[i - 1];
    }
    if (k == 2) {
        int ans = 0;
        int fp, sp;
        for (int i = 0; i < n - 1; i++) {
            fp = get_s(0, i);
            sp = get_s(i + 1, n - 1);
            ans = max(ans, abs(fp - sp));
        }
        cout << ans << '\n';
        return;
    }
    int mxsz = n - k + 1;
    vector<int> mxsml(n);
    vector<int> mxsmr(n);
    for (int i = 0; i < n; i++) {
        if (i - mxsz + 1 <= 0) {
            mxsml[i] = get_s(0, i);
        }
        else {
            mxsml[i] = max(mxsml[i - 1], get_s(i - mxsz + 1, i));
        }
    }
    for (int i = n - 1; i > -1; i--) {
        if (i + mxsz >= n) {
            mxsmr[i] = get_s(i, n - 1);
        }
        else {
            mxsmr[i] = max(mxsmr[i + 1], get_s(i, i + mxsz - 1));
        }
    }
    int fp, sp;
    int ans = 0;
    for (int i = 0; i < n; i++) {
        fp = 0;
        sp = 0;
        if (i != 0) {
            fp = mxsml[i - 1];
        }
        if (i != n - 1) {
            sp = mxsmr[i + 1];
        }
        ans = max(ans, (max(fp, sp) - a[i]));
    }
    cout << ans << '\n';
}
signed main()
{
    solve();
}