#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;

#define int long long

using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;
#define PB push_back
#define all(x) x.begin(), x.end()
#define endl "\n"

void print(vi v){
    for (auto& x: v){
        cout << x << " ";
    }
    cout << endl;
}

// solve

int get_v(vi& v){
    int n = v.size();

    vi ind_l(n);
    int mx = -1;
    int ind = -1;
    for (int i = 0; i < n; i++){
        if (v[i] > mx){
            ind_l[i]= -1;
            mx = v[i];
            ind = i;
        }
        else{
            ind_l[i] = ind;
        }
    }

    vi ind_r(n);

    mx = -1;
    ind = -1;
    for (int i = n - 1; i >= 0; i--){
        if (v[i] > mx){
            ind_r[i]= -1;
            mx = v[i];
            ind = i;
        }
        else{
            ind_r[i] = ind;
        }
    }

    /*
    cout << "v: "; print(v);
    cout << "l: "; print(ind_l);
    cout << "r: "; print(ind_r);
    */

    int ans = 0;
    for (int i = 0; i < n; i++){
        int l = ind_l[i];
        int r = ind_r[i];
        if (l == -1 || r == -1){
            continue;
        }

        int h1 = v[l], h2 = v[r];
        int h = min(h1, h2);
        ans += h - v[i];
    }

    return ans;
}

set<pair<int, vi>> st;



void small_solve(int n){

    for (int i = 0; i < n; i++){
        int x; cin >> x;
        st.insert({i + 1, {x}});
    }

    vi v;
    for (int _ = 0; _ < n - 1; _++){
        int k; cin >> k;
        auto it = st.begin();
        for (int i = 0; i < k - 1; i++){
            it++;
        }

        v = (*it).second;
        int num = (*it).first;
        auto it2 = it;
        it2++;
        for (auto& el: (*it2).second){
            v.PB(el);
        }
        int ans = get_v(v);
        cout << ans << endl;

        st.erase(it);
        st.erase(it2);
        st.insert({num, v});

    }

}


// solve

struct SGT{
    vi tree;
    vi d;
    int n;

    SGT(int n){
        this->n = n;
        tree.assign(4 * n, 0);
        d.assign(4 * n, -1);
    }

    void push(int v, int l, int r){
        if (d[v] == -1) return;
        int m = (l + r) / 2;
        d[v * 2 + 1] = d[v];
        d[v * 2 + 2] = d[v];
        tree[v * 2 + 1] += d[v] * (m - l);
        tree[v * 2 + 2] += d[v] * (r - m);
        d[v] = -1;
    }

    void upd(int v, int l, int r, int ql, int qr, int val){
        if (r <= ql || qr <= l){
            return;
        }
        if (ql <= l && r <= qr){
            d[v] = val;
            tree[v] += val * (r - l);
            return;
        }

        push(v, l, r);
        int m = (l + r) / 2;
        upd(v * 2 + 1, l, m, ql, qr, val);
        upd(v * 2 + 2, m, r, ql, qr, val);
        tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
    }
    void upd(int ql, int qr, int val){
        upd(0, 0, n, ql, qr, val);
    }

    int get(int v, int l, int r, int ql, int qr){
        if (r <= ql || qr <= l){
            return 0;
        }
        if (ql <= l && r <= qr){
            return tree[v];
        }

        push(v, l, r);
        int m = (l + r) / 2;
        int s1 = get(v * 2 + 1, l, m, ql, qr);
        int s2 = get(v * 2 + 2, m, r, ql, qr);
        return s1 + s2;
    }
    int get(int ql, int qr){
        return get(0, 0, n, ql, qr);
    }
};

void solve(){
    int n; cin >> n;
    if (n <= 1000){
        small_solve(n);
        return;
    }

    vi v(n);
    for (int i = 0; i < n; i++){
        cin >> v[i];
    }
    vi stk = {0};
    vi pref = { 0, v[0] };
    SGT tree(n);
    int ans = 0;
    for (int i = 1; i < n; i++){
        int kkk; cin >> kkk;
        int val = v[i];
        while (!stk.empty()){
            if (v[stk.back()] >= val){
                break;
            }
            stk.pop_back();
        }
        if (stk.empty()){
            stk.PB(i);
            continue;
        }

        int l = stk.back() + 1;
        int r = i;

        int prev_V = tree.get(l, r);
        int V = val * (r - l);
        tree.upd(l, r, val);

        int sum = pref.back() - pref[l];
        ans += V - sum;
        cout << ans << endl;

        pref.PB(pref.back() + val);
    }
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--){
        solve();
    }
};

/*
8
9 1 8 1 5 2 3 6
3
3
1
3
3
2
1
 */
