#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define int long long

using ll = long long;
using vi = vector<int>;
#define all(x) x.begin(), x.end()
#define PB push_back

const int inf = 1e9 + 1;
const ll INF = 1e18 + 1;


void print(vi a) {
    for (auto x : a) {
        cout << x << " ";
    }
    cout << endl;
}

void solve2(int n, int k) {
    vector<ll> a(n);
    int sum = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        sum += a[i];
    }

    int ans = 0;
    int sum1 = 0;
    for (int i = 0; i < n - 1; i++) {
        sum1 += a[i];
        int sum2 = sum - sum1;
        ans = max(ans, abs(sum1 - sum2));
    }

    cout << ans << endl;
}

void solve() {
    int n, k; cin >> n >> k;
    if (k == 2) {
        solve2(n, k);
        return;
    }
    vi a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vi pref = { 0ll };
    for (auto x : a) {
        pref.PB(pref.back() + x);
    }

    int max_len = n - k + 1;

    vi seg_pref = { -inf };
    for (int i = 0; i < n; i++) {
        if (i < max_len) {
            seg_pref.PB(pref[i + 1]);
        }
        else {
            int sm = pref[i + 1] - pref[i - max_len + 1];
            seg_pref.PB(max(seg_pref.back(), sm));
        }
    }
    //print(seg_pref);

    vi seg_suf = { -inf };
    for (int i = n - 1; i >= 1; i--) {
        if (i >= n - max_len) {
            seg_suf.PB(pref.back() - pref[i]);
        }
        else {
            int sm = pref[i + max_len] - pref[i];
            seg_suf.PB(max(seg_pref.back(), sm));
        }
    }
    reverse(all(seg_suf));
    //print(seg_suf);

    int ans = 0;
    for (int i = 0; i < n; i++) {
        int mn = a[i];
        int mx = max(seg_pref[i], seg_suf[i + 1]);
        //cout << "check " << i << " " << mn << " " << mx << endl;
        ans = max(ans, mx - mn);
    }

    cout << ans << endl;

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();
}