#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define int long long

using ll = long long;
using vi = vector<int>;
#define all(x) x.begin(), x.end()
#define PB push_back

const int inf = 1e9 + 1;
const ll INF = 1e18 + 1;


void print(vi a){
    for (auto x: a){
        cout << x << " ";
    }
    cout << endl;
}

void solve2(int n, int k){
    vi a(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }

    vi pref_min = {a[0]};
    for (int i = 1; i < n; i++){
        pref_min.PB(min(pref_min.back(), a[i]));
    }
    vi suf_min = {a[n - 1]};
    for (int i = n - 2; i >= 0; i--){
        suf_min.PB(min(suf_min.back(), a[i]));
    }
    reverse(all(suf_min));

    int ans = -INF;

    int sum = 0;
    for (int i = 0; i < n - 1; i++){
        sum += a[i];
        int mn = suf_min[i + 1];
        ans = max(ans, sum - mn);
    }
    sum = 0;
    for (int i = n - 1; i >= 1; i--){
        sum += a[i];
        int mn = pref_min[i - 1];
        ans = max(ans, sum - mn);
    }

    cout << ans;
}

void solve(){
    int n, k; cin >> n >> k;
    if (k == 2){
        solve2(n, k);
        return;
    }
    vi a(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }
    vi pref_min = {a[0]};
    for (int i = 1; i < n; i++){
        pref_min.PB(min(pref_min.back(), a[i]));
    }
    vi suf_min = {a[n - 1]};
    for (int i = n - 2; i >= 0; i--){
        suf_min.PB(min(suf_min.back(), a[i]));
    }
    reverse(all(suf_min));

    vi pref = {0};
    for (auto x: a){
        pref.PB(pref.back() + x);
    }

    int max_len = n - k + 1;

    vi seg_pref = {-inf};
    for (int i = 0; i < n; i++){
        if (i < max_len){
            seg_pref.PB(pref[i + 1]);
        }
        else{
            int sm = pref[i + 1] - pref[i - max_len + 1];
            seg_pref.PB(max(seg_pref.back(), sm));
        }
    }
    //print(seg_pref);

    vi seg_suf = {-inf};
    for (int i = n - 1; i >= 0; i--){
        if (i >= n - max_len){
            seg_suf.PB(pref.back() - pref[i]);
        }
        else{
            int sm = pref[i + max_len] - pref[i];
            seg_suf.PB(max(seg_pref.back(), sm));
        }
    }
    reverse(all(seg_suf));
    //print(seg_suf);

    int ans = -INF;
    for (int i = 0; i < n; i++){
        int mn = a[i];
        int mx = max(seg_pref[i], seg_suf[i + 1]);
        //cout << "check " << i << " " << mn << " " << mx << endl;
        ans = max(ans, mx - mn);
    }

    cout << ans << endl;

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();
}
