#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <set>


using namespace std;

#define int long long

using ll = long long;
using vi = vector<int>;
#define all(x) x.begin(), x.end()
#define PB push_back

const int inf = 1e9 + 1;
const ll INF = 1e18 + 1;


void print(vi a) {
    for (auto x : a) {
        cout << x << " ";
    }
    cout << endl;
}

void solve1(int s) {
    int k; cin >> k;
    vi a(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i];
    }

    vi dp1(s + 1, 0);
    vi dp2(s + 1, 0);

    int val = -1;
    vi take(s + 1, -1);
    dp1[0] = 1;
    for (int i = 0; i < k; i++) {
        dp2 = dp1;
        if (a[i] > s) {
            continue;
        }
        for (int j = 0; j <= s; j++) {
            if (dp1[j]) {
                val = a[i] + j;
                if (val <= s && !dp2[val]) {
                    dp2[val] = 1;
                    take[val] = i;
                }
            }
        }
        dp1 = dp2;
        dp2.assign(s + 1, 0);
    }

    if (!dp1[s]) {
        cout << "NO" << endl;
        return;
    }
    else {
        cout << "YES" << endl;
        vi ans;
        while (s > 0) {
            ans.PB(take[s] + 1);
            s -= a[take[s]];
        }
        cout << ans.size() << endl;
        print(ans);
    }
}

void solve() {
    int n, s; cin >> n >> s;
    if (n == 1) {
        solve1(s);
        return;
    }
    vector<vi> a(n);
    bool flag = true;
    int sk = 0;
    vi vk;
    vi vec;
    for (int i = 0; i < n; i++) {
        int k; cin >> k;
        sk += k;
        vk.PB(k);
        if (k > 1) {
            flag = false;
        }
        while (k--) {
            int x; cin >> x;
            a[i].push_back(x);
            vec.push_back(x);
        }
    }

    if (flag) {
        int sum = 0;
        for (auto v : a) {
            sum += v[0];
        }
        if (sum != s) {
            cout << "NO" << endl;
            return;
        }
        cout << "YES" << endl;
        for (int i = 0; i < n * 2; i++) {
            cout << 1 << endl;
        }
        return;
    }

    vi kk(sk);
    int ind = 0;
    int j = -1;
    for (int i = 0; i < sk; i++) {
        j++;
        if (j >= vk[ind]) {
            j = 0;
            ind++;
        }
        kk[i] = ind;
    }

    bitset<20> bts;
    bitset<20> bts_k;
    int sum = 0;
    int ik = 0;
    for (int mask = 1; mask < (1ll << sk); mask++) {
        bts = mask;
        bts_k = 0;
        sum = 0;
        ik = 0;
        for (int i = 0; i < sk; i++) {
            if (bts[i]) {
                sum += vec[i];
                bts_k[kk[i]] = 1;
            }
        }
        if (sum != s){
            continue;
        }


        bool f = true;
        for (int i = 0; i < vk.size(); i++) {
            if (!bts_k[i]) {
                f = false;
                break;
            }
        }
        if (!f) continue;

        cout << "YES" << endl;
        vector<vi> ans(n);
        int ind = 0;
        int sum_k = 0;
        int last = 0;
        for (int i = 0; i < sk; i++) {
            if (!bts[i]){
                continue;
            }
            int ik = kk[i];
            if (ik != last){
                sum_k += vk[ik - 1];
                last = ik;
            }
            ans[ik].push_back(i - sum_k + 1);
        }
        for (int i = 0; i < n; i++) {
            cout << ans[i].size() << endl;
            print(ans[i]);
        }

        return;
    }

    cout << "NO" << endl;

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();
}