#include <bitset>
#include <set>
#include <vector>
#include <string>
#include <algorithm>
#include <random>
#include <map>
#include <deque>
#include <iostream>

using namespace std;
using ll = long long;

vector <int> t;

void build(int v, int vl, int vr) {
    if (vl + 1 == vr) {
        t[v] = 1;
        return;
    }
    int vm = (vl + vr) / 2;
    build(2 * v, vl, vm);
    build(2 * v + 1, vm, vr);
    t[v] = t[2 * v] + t[2 * v + 1];
}

void upd(int v, int vl, int vr, int pos) {
    t[v]--;
    if (vl + 1 == vr) {
        return;
    }
    int vm = (vl + vr) / 2;
    if (pos < vm) {
        upd(2 * v, vl, vm, pos);
    } else {
        upd(2 * v + 1, vm, vr, pos);
    }
}

int get(int v, int vl, int vr, int x) {
    if (vl + 1 == vr) {
        return vl;
    }
    int vm = (vl + vr) / 2;
    if (t[2 * v] < x) {
        return get(2 * v + 1, vm, vr, x - t[2 * v]);
    }
    return get(2 * v, vl, vm, x);
}

void sol() {
    int n, k;
    cin >> n;
    vector <ll> v(n), p(n);
    vector <int> nxt(n);
    int mn = v[0], mnpos = 0;
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        if (i != 0) {
            p[i] = p[i - 1];
        }
        p[i] += v[i];
        nxt[i] = i + 1;
        if (v[i] < mn) {
            mn = v[i], mnpos = i;
        }
    }
    bool flag = true;
    for (int i = mnpos - 1; i >= 0; i--) {
        if (v[i] < v[i + 1]) {
            flag = false;
            break;
        }
    }
    for (int i = mnpos + 1; i < n; i++) {
        if (v[i] < v[i - 1]) {
            flag = false;
            break;
        }
    }
    if (flag) {
        t.resize(4 * n);
        build(1, 0, n);
        for (int i = 0; i < n - 1; i++) {
            cin >> k;
            int cur = get(1, 0, n, k);
            int sl = get(1, 0, n, k + 1);
            upd(1, 0, n, sl);

            if (cur >= mnpos || sl <= mnpos) {
                cout << 0 << '\n';
                continue;
            }
            int last;
            if (k == (n - i - 1)) {
                last = n - 1;
            } else {
                last = get(1, 0, n, k + 1) - 1;
            }
            if (v[cur] <= v[last]) {
                ll pos = lower_bound(v.begin() + mnpos, v.end(), v[cur]) - v.begin();
                cout << ll(pos - cur - 1) * v[cur] - (p[pos - 1] - p[cur]) << '\n';
            } else {
                int l = cur, r = mnpos;
                while (l + 1 < r) {
                    int m = (l + r) / 2;
                    if (v[m] < v[last]) {
                        r = m;
                    } else {
                        l = m;
                    }
                }
                cout << ll(last - r) * v[last] - (p[last - 1] - p[r - 1]) << '\n';
            }
        }
    } else if (n <= 1000) {
        for (int i = 0; i < n - 1; i++) {
            cin >> k;
            k--;
            int ptr = 0, cur = 0;
            while (ptr < k) {
                ptr++;
                cur = nxt[cur];
            }
            nxt[cur] = nxt[nxt[cur]];
            ll res = 0;
            multiset<ll> s1, s2;
            for (int j = cur + 1; j < nxt[cur]; j++) {
                s2.insert(-v[j]);
            }
            s1.insert(-v[cur]);
            for (int j = cur + 1; j < nxt[cur] - 1; j++) {
                s1.insert(-v[j]);
                ll h = min(-*s1.begin(), -*s2.begin());
                res += h - v[j];
                s2.erase(s2.find(-v[j]));
            }
            cout << res << '\n';
        }
    } else {
        vector <int> l(n, -1);
        vector <pair <ll, int>> st = {{v[0], 0}};
        for (int i = 1; i < n; i++) {
            while (!st.empty() && v[i] > st.back().first) {
                st.pop_back();
            }
            if (!st.empty()) {
                l[i] = st.back().second;
            }
            st.emplace_back(v[i], i);
        }
        ll res = 0, mx = v[0];
        int mxpos = 0;
        vector <ll> ans(n);
        for (int i = 0; i < n - 1; i++) {
            cin >> k;
            k--;
            int pos = l[i + 1];
            if (pos == -1) {
                res = ans[mxpos] + mx * ll(i - mxpos) - (p[i] - p[mxpos]);
            } else {
                res = ans[pos] + v[i + 1] * ll(i - pos) - (p[i] - p[pos]);
            }
            cout << res << '\n';
            ans[i + 1] = res;
            if (v[i + 1] > mx) {
                mx = v[i + 1];
                mxpos = i + 1;
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    //cin >> t;
    while (T--) {
        sol();
    }
}

//8
//9 1 8 1 5 2 3 6
//3 3 1 3 3 2 1