#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define ld long double
#define ff first
#define ss second

struct node {
    int l, r;
    ll mx;
    ll ans;
};

struct point {
    ll mx, p;
};

struct tree {
    int n;
    vector<point> t;
    tree (int N, vector<ll> &h) : n(N) {
        t.resize(2 * n);
        build(0, 0, n, h);
    }
    void build(int v, int l, int r, vector<ll> &h) {
        if (r - l == 1) {
            t[v] = {h[l], 0};
            return;
        }
        int m = (r + l)/2;
        build(2 * v + 1, l, m, h);
        build(2 * v + 2, m, r, h);
        t[v].mx = max(t[2 * v + 1].mx, t[2 * v + 2].mx);
    }
    void push(int v) {
        if (t[v].p != 0) {
            ll x = t[v].p;
            t[2 *v + 1] = {max(x, t[2 *v + 1].mx), max(x, t[2 *v + 1].mx)};
            t[2 *v + 2] = {max(x, t[2 * v + 2].mx), max(x, t[2 * v + 2].mx)};
            t[v].p = 0;
        }
    }
    void update(int v, int l, int r, int ql, int qr, ll x) {
        if (r <= ql || qr <= l) {
            return;
        }
        if (ql <= l && r <= qr) {
            t[v] = {max(x, t[v].mx), max(x, t[v].mx)};
            return;
        }
        push(v);
        int m = (r + l)/2;
        update(2 *v + 1, l, m, ql, qr, x);
        update(2 * v + 2, m, r, ql, qr, x);
        t[v].mx = max(t[2 * v + 1].mx, t[2 * v + 2].mx);
    }
    ll get(int v, int l, int r, int ql, int qr) {
        if (r <= ql || qr <= l) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            return t[v].mx;
        }
        push(v);
        int m = (r + l)/2;
        return max(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
    }
};

struct tree1 {
    int n;
    vector<point> t;
    tree1 (int N) : n(N) {
        t.resize(2 * n);
        build(0, 0, n);
    }
    void build(int v, int l, int r) {
        if (r - l == 1) {
            t[v] = {l, 0};
            return;
        }
        int m = (r + l)/2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
    }
    void push(int v) {
        if (t[v].p != 0) {
            ll x = t[v].p;
            t[2 *v + 1] = {t[2 * v + 1].mx - x, t[2 * v + 1].p + x};
            t[2 *v + 2] = {t[2 * v + 2].mx - x, t[2 * v + 2].p + x};
            t[v].p = 0;
        }
    }
    void update(int v, int l, int r, int ql, int qr) {
        if (r <= ql || qr <= l) {
            return;
        }
        if (ql <= l && r <= qr) {
            t[v] = {t[v].mx - 1, t[v].p+1};
            return;
        }
        push(v);
        int m = (r + l)/2;
        update(2 * v + 1, l, m, ql, qr);
        update(2 * v + 2, m, r, ql, qr);
    }
    int get(int v, int l, int r, int pos) {
        if (r - l == 1) {
            //cout << pos << ' ' << l << ' ' << t[v].mx << '\n';
            return t[v].mx;
        }
        push(v);
        int m = (r + l)/2;
        if (pos < m) return get(2 * v + 1, l, m, pos);
        return get(2 * v + 2, m, r, pos);
    }
};

int n1 = 1;
vector<ll> h;
vector<node> v;
vector<int> parent, sizetree;

int find(int x) {
    if (parent[x] == -1) return x;
    return parent[x] = find(parent[x]);
}

ll d(int x, int l, int r, tree &mx) {
    //cout << mx.get(0, 0, n1, l, x + 1) << ' ' << mx.get(0, 0, n1, x, r) << ' ' << l << ' ' << x << ' ' << r << '\n';
    return min(mx.get(0, 0, n1, l, x + 1), mx.get(0, 0, n1, x, r)) - h[x];
}

void merge(int x, int y, tree &mx) {
    x = find(x);
    y = find(y);
    ll ans = v[x].ans + v[y].ans;
    //cout << x << ' ' << y << '\n';
    //cout << x << ' ' << y << ' ' << ans << '\n';
    int l = v[x].l - 1, r = v[x].r, mid;
    while ( r - l > 1) {
        mid = (r + l)/2;
        if (mx.get(0, 0, n1, mid, v[x].r) < v[y].mx) {
            r = mid;
        } else {
            l = mid;
        }
    }

    for (int i = r; i < v[x].r; ++i) {
        ans -= d(i, v[x].l, v[x].r, mx);
        ans += d(i, v[x].l, v[y].r, mx);
    }
    //cout << r << '\n';

    l = v[y].l - 1, r = v[y].r;
    while (r - l > 1) {
        mid = (r + l)/2;
        if (mx.get(0, 0, n1, v[y].l, mid + 1) < v[x].mx) l = mid;
        else r = mid;
    }
    //cout << l << '\n';

    for (int i = v[y].l; i <= l; ++i) {
        ans -= d(i, v[y].l, v[y].r, mx);
        ans += d(i, v[x].l, v[y].r, mx);
    }

    if (sizetree[x] < sizetree[y]) {
        swap(x, y);
    }
    sizetree[x] += sizetree[y];
    parent[y] = x;
    v[x].l = min(v[x].l, v[y].l);
    v[x].r = max(v[x].r, v[y].r);
    v[x].mx = max(v[x].mx, v[y].mx);
    v[x].ans = ans;
    cout << ans << '\n';
}

int f(int k, tree1 &id) {
    int l = -1, r = n1, mid;
    while (r - l > 1) {
        mid = (r + l)/2;
        ll ind = id.get(0, 0, n1, mid);
        //cout << mid << ' ' << id.get(0, 0, n1, mid) << ' ' << k << '\n';
        if (ind == k) return mid;
        else if (ind < k) l = mid;
        else r = mid;
    }
    return r;
}

void solve() {
    int n; cin >> n;
    while (n1 < n) n1 <<= 1;
    h.resize(n1);
    v.resize(n);
    parent.resize(n, -1);
    sizetree.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> h[i];
        v[i] = {i, i + 1, h[i], 0};
    }
    tree mx(n1, h);
    tree1 id(n1);

    int q = n-1;
    while(q--) {
        int kj; cin >> kj;
        int id1 = f(kj - 1, id), id2 = f(kj, id);
        //cout << id1 << ' ' << id2 << '\n';
        merge(id1, id2, mx);
        id.update(0, 0, n1, id2, n1);
    }
}

int main() {
    solve();
}

