#include <iostream>
#include <vector>
using namespace std;
int n;
vector<long long> a;
struct seg_tree_r{
    int m;
    vector<int> t;
    int f(int tmp1, int tmp2) {
        if (tmp1 == -1) {return tmp2;}
        if (tmp2 == -1) {return tmp1;}
        if (a[tmp1] < a[tmp2]) {return tmp2;}
        if (a[tmp1] > a[tmp2]) {return tmp1;}
        return min(tmp1, tmp2);
    }
    void build(int v, int left, int right) {
        if (left > right) {return;}
        if (left == right) {
            t[v] = left;
            return;
        }
        int mid = (left + right) >> 1;
        build(v << 1, left, mid);
        build((v << 1) + 1, mid + 1, right);
        t[v] = f(t[v << 1], t[(v << 1) + 1]);
    }
    void init(void) {
        m = 1;
        while (m <= n) {
            m <<= 1;
        }
        t.clear();
        t.resize(m << 1, -1);
        build(1, 0, n - 1);
    }
    int ask(int v, int tleft, int tright, int left, int right) {
        if (tleft > tright) {return -1;} if (left > right) {return -1;}
        if (right > tright) {return -1;} if (left < tleft) {return -1;}
        if (tright < left) {return -1;}
        if (tleft == left && tright == right) {return t[v];}
        int mid = (tleft + tright) >> 1;
        int ll = ask(v << 1, tleft, mid, left, min(right, mid));
        int rr = ask((v << 1) + 1, mid + 1, tright, max(left, mid + 1), right);
        return f(ll, rr);
    }
};
seg_tree_r tr;
vector<pair<int, int>> seg;
void solve(int c) {
    long long ans = 0;
    int left = seg[c].first;
    int right = seg[c + 1].second;
    for (int i = left; i <= right; i++) {
        long long lm = 0, rm = a[tr.ask(1, 0, n - 1, i, right)];
//        for (int j = i; j <= right; j++) {rm = max(rm, a[j]);}
        for (int j = i; j >= left; j--) {lm = max(lm, a[j]);}
        ans += min(rm, lm) - a[i];
    }
    cout << ans << ' ';
    seg[c] = {left, right};
    seg.erase(seg.begin() + c + 1);
}
/*
8
9 1 8 1 5 2 3 6
3 3 1 3 3 2 1

*/
void big_solve_AAA(void) {
    cin >> n; a.clear(); a.resize(n);
    seg.clear(); seg.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i]; seg[i] = {i, i};
    }
    tr.init();
    for (int i = 0; i < n - 1; i++) {
        int c; cin >> c; --c; solve(c);
    }
    cout << endl;
}
int main() {
    int ttt____ = 1;
    //cin >> ttt____;
    while (ttt____--) {
        big_solve_AAA();
    }
    return 0;
}
