#include <iostream>
#include <vector>
using namespace std;
int n;
vector<long long> a;
struct seg_tree_r{
    int m;
    vector<int> t;
    int f(int tmp1, int tmp2) {
        if (tmp1 == -1) {return tmp2;}
        if (tmp2 == -1) {return tmp1;}
        if (a[tmp1] < a[tmp2]) {return tmp2;}
        if (a[tmp1] > a[tmp2]) {return tmp1;}
        return max(tmp1, tmp2);
    }
    void build(int v, int left, int right) {
        if (left > right) {return;}
        if (left == right) {
            t[v] = left;
            return;
        }
        int mid = (left + right) >> 1;
        build(v << 1, left, mid);
        build((v << 1) + 1, mid + 1, right);
        t[v] = f(t[v << 1], t[(v << 1) + 1]);
    }
    void init(void) {
        m = 1;
        while (m <= n) {
            m <<= 1;
        }
        t.clear();
        t.resize(m << 1, -1);
        build(1, 0, n - 1);
    }
    int ask(int v, int tleft, int tright, int left, int right) {
        if (tleft > tright) {return -1;} if (left > right) {return -1;}
        if (right > tright) {return -1;} if (left < tleft) {return -1;}
        if (tright < left) {return -1;}
        if (tleft == left && tright == right) {return t[v];}
        return f(ask(v << 1, tleft, ((tleft + tright) >> 1), left, min(right, ((tleft + tright) >> 1))), ask((v << 1) + 1, ((tleft + tright) >> 1) + 1, tright, max(left, ((tleft + tright) >> 1) + 1), right));
    }
};
struct seg_tree_l{
    int m;
    vector<int> t;
    int f(int tmp1, int tmp2) {
        if (tmp1 == -1) {return tmp2;}
        if (tmp2 == -1) {return tmp1;}
        if (a[tmp1] < a[tmp2]) {return tmp2;}
        if (a[tmp1] > a[tmp2]) {return tmp1;}
        return min(tmp1, tmp2);
    }
    void build(int v, int left, int right) {
        if (left > right) {return;}
        if (left == right) {
            t[v] = left;
            return;
        }
        int mid = (left + right) >> 1;
        build(v << 1, left, mid);
        build((v << 1) + 1, mid + 1, right);
        t[v] = f(t[v << 1], t[(v << 1) + 1]);
    }
    void init(void) {
        m = 1;
        while (m <= n) {
            m <<= 1;
        }
        t.clear();
        t.resize(m << 1, -1);
        build(1, 0, n - 1);
    }
    int ask(int v, int tleft, int tright, int left, int right) {
        if (tleft > tright) {return -1;} if (left > right) {return -1;}
        if (right > tright) {return -1;} if (left < tleft) {return -1;}
        if (tright < left) {return -1;}
        if (tleft == left && tright == right) {return t[v];}
        return f(ask(v << 1, tleft, ((tleft + tright) >> 1), left, min(right, ((tleft + tright) >> 1))), ask((v << 1) + 1, ((tleft + tright) >> 1) + 1, tright, max(left, ((tleft + tright) >> 1) + 1), right));
    }
};
seg_tree_l tl;
seg_tree_r tr;
vector<pair<int, int>> seg;
vector<long long> sum;
long long solve_left(int left, int right) {
    long long ans = 0ll;
    int ll;
    while (1) {
        if (left > right) {return break;}
        ll = tl.ask(1, 0, n - 1, left, right);
        ans += max(0ll, a[ll] * (right - ll + 1) - (sum[right + 1] - sum[ll]));
        right = ll - 1;
    }
    return ans;
}
long long solve_right(int left, int right) {
    if (left > right) {return  0ll;}
    int rr = tr.ask(1, 0, n - 1, left, right);
    long long ans = a[rr] * (rr - left + 1) - (sum[rr + 1] - sum[left]); ans = max(0ll, ans);
    return ans + solve_right(rr + 1, right);
}
void solve(int c) {
    int left = seg[c].first;
    int right = seg[c + 1].second;
    int ll = tl.ask(1, 0, n - 1, left, right);
    int rr = tr.ask(1, 0, n - 1, left, right);
    long long ans = a[ll] * (rr - ll - 1) - (sum[rr] - sum[ll + 1]); ans = max(0ll, ans);
    ans += solve_right(rr + 1, right);
    ans += solve_left(left, ll - 1);
    cout << ans << endl;
    seg[c] = {left, right};
    seg.erase(seg.begin() + c + 1);
}
/*
8
9 1 8 1 5 2 3 6
3 3 1 3 3 2 1

*/
void big_solve_AAA(void) {
    cin >> n; a.clear(); a.resize(n);
    seg.clear(); seg.resize(n);
    sum.clear(); sum.resize(n + 1, 0);
    for (int i = 0; i < n; i++) {
        cin >> a[i]; seg[i] = {i, i};
        sum[i + 1] = sum[i] + a[i];
    }
    tr.init(); tl.init();
    for (int i = 0; i < n - 1; i++) {
        int c; cin >> c; --c; solve(c);
    }
}
int main() {
    int ttt____ = 1;
    //cin >> ttt____;
    while (ttt____--) {
        big_solve_AAA();
    }
    return 0;
}
