#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
const ll inf = 1e18;

ll solve (int n, int k, vector<ll>& a) {
    vector<ll> prefMin(n + 1, inf), sufMin(n + 1, inf), prefSum(n + 1);
    for (int i = 0; i < n; ++i) {
        prefSum[i + 1] = prefSum[i] + a[i];
        prefMin[i + 1] = min(prefMin[i], a[i]);
    }
    for (int i = n - 1; i >= 0; --i) {
        sufMin[i] = min(sufMin[i + 1], a[i]);
    }

    ll ans = 0, mn, mx;

    for (int pr = 0; pr < n; ++ pr) {
        mn = prefMin[pr];
        if (pr >= k) {
            mx = prefSum[n] - prefSum[pr];
        } else {
            mx = prefSum[pr + n - k + 1] - prefSum[pr];
            mn = min(mn, sufMin[pr + n - k + 1]);
        }
        ans = max(ans, mx - mn);
    }
    return ans ;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for (int i = 0; i    < n; ++i) cin >> a[i];
    ll ans = solve(n, k, a);
    reverse(a.begin(), a.end());
    ans = max(ans, solve(n, k, a));
    cout << ans << '\n';
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}

