#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
const ll inf = 1e18;

struct info {
    int ngr, nw, cgr, cw, id;
    info(int a, int b, int c, int d, int id) : ngr(a), nw(b), cgr(c), cw(d), id(id) {}
    bool isno() {
        return (ngr == -1) && (nw == -1) && (cgr == -1) && (cw == -1) && (id == -1);
    }
};
const info no = info(-1, -1, -1, -1, -1);

vector<vector<info>> path;



void addSet(int k, int s, int num, vector<int>& c) {
    for (int i = 0; i < k; ++i) {
        for (int w = 0; w <= s; ++w) {
            if (w - c[i] < 0) continue;
            if (!path[num - 1][w - c[i]].isno() && path[num][w].isno()) {
                path[num][w] = info(num - 1, w - c[i], num, w, i);
            }
            if (path[num][w].isno() && !path[num][w - c[i]].isno() && path[num][w - c[i]].id != i) {
                path[num][w] = info(num, w - c[i], num, w, i);
            }
        }
    }
}

void solve() {
    int n, s;
    cin >> n >> s;
    path.assign(n + 1, vector<info>(s + 1, info(-1, -1, -1, -1, -1)));
    path[0][0] = info(-1, -1, 0, 0, 0);
    vector<int> k(n + 1);
    vector<vector<int>> c(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> k[i];
        c[i].resize(k[i]);
        for (int j = 0; j < k[i]; ++j) {
            cin >> c[i][j];
        }
    }
    for (int i = 1; i <= n; ++i) {
        addSet(k[i], s, i, c[i]);
    }

    if (path[n][s].isno()) {
        cout << "No\n";
        return;
    }

    info last = info(n, s, -1, -1, -1);
    vector<vector<ll>> ans(n + 1);
    while (true) {
        if (last.ngr == -1) break;
        last.cgr = last.ngr;
        last.cw = last.nw;
        last.id = path[last.cgr][last.cw].id;
        last.nw = path[last.cgr][last.cw].nw;
        last.ngr = path[last.cgr][last.cw].ngr;

        ans[last.cgr].push_back(last.id + 1);
    }
    cout << "Yes\n";
    for (int i = 1; i <= n; ++i) {
        cout << ans[i].size() << '\n';
        for (int j : ans[i]) {
            cout << j << ' ';
        }
        cout << '\n';
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}

