#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
const ll inf = 1e18;
const int N = 2e6 + 3;
const int mod = 1e9 + 7;

int normalize(ll x) {
    x %= mod;
    if (x < 0) x += mod;
    if (x >= mod) x -= mod;
    return x;
}

struct mint {
    ll vl;

    mint() : vl() {};
    mint(ll vl) : vl(normalize(vl)) {}

    friend mint operator+(mint a, mint b) {
        return {a.vl + b.vl};
    }
    friend mint operator-(mint a, mint b) {
        return {a.vl - b.vl};
    }
    friend mint operator*(mint a, mint b) {
        return {a.vl * b.vl};
    }
};

vector<mint> f(N), rf(N), r(N);

void init() {
    f[0] = f[1] = 1;
    rf[0] = rf[1] = 1;
    r[1] = 1;

    for (int i = 2; i < N; ++i) {
        f[i] = i * f[i - 1];
        r[i] = -1 * r[mod % i] * mint(mod / i);
        rf[i] = rf[i - 1] * r[i];
    }
}

mint cnk(ll n, ll k) {
    return f[n] * rf[k] * rf[n - k];
}

mint solvek0(ll n, ll m) {
    return cnk(n + m, n) * cnk(n + m, n);
}

void solve() {
    init();
    int n, m, k;
    cin >> n >> m >> k;
    --n, --m;
    vector<int> x(k), y(k);
    for (int i = 0; i < k; ++i) {
        cin >> x[i] >> y[i];
        --x[i], --y[i];
    }
    if (k == 0) {
        cout << ((solvek0(n, m).vl % mod) + mod) % mod << '\n';
        return;
    }
    cout << "0\n";
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}

