#include <iostream>
#include <vector>
#include <random>
#include <set>
using namespace std;

using ll = long long;

mt19937 gen;

struct seg {
  ll l, m, r;
  seg(ll left, ll mm, ll rr) {
    l = left;
    m = mm;
    r = rr;
  }
};


ll max(ll a, ll b) {
  if (a > b) {
    return a;
  }
  return b;
}

ll min(ll a, ll b) {
  if (a < b) {
    return a;
  }
  return b;
}


struct Node {
  ll l, r;
  ll y;
  int cnt = 1;
  Node* left = 0;
  Node* right = 0;
  Node(ll llll, ll rrrr) {
    l = llll;
    r = rrrr;
    y = (rand() << 15ll) ^ rand();
  }
};

int get_cnt(Node* v) {
  if (!v) return 0;
  return v->cnt;
}

void fresh(Node* v) {
  if (!v) return;
  v->cnt = 1 + get_cnt(v->left) + get_cnt(v->right);
}


pair<Node*, Node*> split(Node* v, int x) {
  if (!v) {
    return { 0, 0 };
  }
  if (get_cnt(v->left) == x) {
    Node* L = v->left;
    v->left = 0;
    fresh(L);
    fresh(v);
    return { L, v };
  }
  if (get_cnt(v->left) > x) {
    auto res = split(v->left, x);
    v->left = res.second;
    fresh(v->left);
    fresh(res.first);
    fresh(v);
    return { res.first, v };
  } else {
    auto res = split(v->right, x - get_cnt(v->left) - 1);
    v->right = res.first;
    fresh(v->right);
    fresh(res.second);
    fresh(v);
    return { v, res.second };
  } 
}

Node* merge(Node* L, Node* R) {
  if (!L) return R;
  if (!R) return L;
  if (L->y > R->y) {
    L->right = merge(L->right, R);
    fresh(L->right);
    fresh(L);
    return L;
  } else {
    R->left = merge(L, R->left);
    fresh(R->left);
    fresh(R);
    return R;
  }
}

Node* add(Node* root, int l, int r) {
  Node* elem = new Node(l, r);
  return merge(root, elem);
}


pair<seg, Node*> get(Node* root, int k) {
  auto R = split(root, k + 1);
  auto L = split(R.first, k - 1);
  auto M = split(L.second, 1);
  seg res = seg(M.first->l, M.first->r, M.second->r);
  Node* elem = new Node(res.l, res.r);
  return { res,  merge(merge(L.first, elem), R.second) };
}


const int maxn = 1e5;

vector<ll> tr(4 * maxn, 0);
vector<ll> push(4 * maxn, -1);
vector<ll> maxx(4 * maxn, 0);
vector<ll> h(maxn, 0);

int bruh(int i, int j) {
  if (i == -1) return j;
  if (j == -1) return i;
  if (h[i] > h[j]) {
    return i;
  }
  return j;
}

void build(int v, int l, int r, vector<ll>& h) {
  if (r - l == 1) {
    tr[v] = h[l];
    maxx[v] = l;
    return;
  }
  int m = (r + l) / 2;
  build(2 * v, l, m, h);
  build(2 * v + 1, m, r, h);
  tr[v] = tr[2 * v] + tr[2 * v + 1];
  maxx[v] = bruh(maxx[2 * v], maxx[2 * v + 1]);
}

void ref(int v, ll l, ll r) {
  if (push[v] == -1) return;
  tr[v] = (r - l) * push[v];
  if (r - l > 1) {
    push[2 * v] = push[v];
    push[2 * v + 1] = push[v];
  }
  push[v] = -1;
}

void upd(int v, int l, int r, int ql, int qr, ll x) {
  ref(v, l, r);
  if (l >= ql && r <= qr) {
    push[v] = x;
    ref(v, l, r);
    return;
  }
  if (l >= qr || r <= ql) {
    return;
  }
  int m = (r + l) / 2;
  upd(2 * v, l, m, ql, qr, x);
  upd(2 * v + 1, m, r, ql, qr, x);
  tr[v] = tr[2 * v] + tr[2 * v + 1];
}

ll get_sum(int v, int l, int r, int ql, int qr) {
  ref(v, l, r);
  if (l >= ql && r <= qr) {
    return tr[v];
  }
  if (l >= qr || r <= ql) {
    return 0;
  }
  int m = (r + l) / 2;
  return get_sum(2 * v, l, m, ql, qr) + get_sum(2 * v + 1, m, r, ql, qr);
}

ll get_max_l(int v, int l, int r, int ql, int qr, ll x) {
  if (r - l == 1) {
    return l;
  }
  if (l >= qr || r <= ql) {
    return -1;
  }
  int m = (r + l) / 2;
  if (h[maxx[2 * v + 1]] >= x) {
    int i = get_max_l(2 * v + 1, m, r, ql, qr, x);
    if (i == -1) {
      return get_max_l(2 * v, l, m, ql, qr, x);
    }
  } else {
    return get_max_l(2 * v, l, m, ql, qr, x);
  }
}

ll get_max_r(int v, int l, int r, int ql, int qr, ll x) {
  if (r - l == 1) {
    return l;
  }
  if (l >= qr || r <= ql) {
    return -1;
  }
  int m = (r + l) / 2;
  int i = get_max_r(2 * v, l, m, ql, qr, x);
  if (i == -1) {
    return get_max_r(2 * v + 1, m, r, ql, qr, x);
  }
}

ll get_max(int v, int l, int r, int ql, int qr) {
  if (l >= ql && r <= qr) {
    return maxx[v];
  }
  if (l >= qr || r <= ql) {
    return -1;
  }
  int m = (r + l) / 2;
  return bruh(get_max(2 * v, l, m, ql, qr), get_max(2 * v + 1, m, r, ql, qr));
}


int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  int n;
  cin >> n;
  vector<ll> pref(n + 1);
  Node* root = 0;
  set<pair<int, int>> st;
  for (int i = 0; i < n; i++) {
    st.insert({ i, i + 1 });
    root = add(root, i, i + 1);
    cin >> h[i];
    pref[i + 1] = pref[i] + h[i];
  }
  build(1, 0, n, h);
  int q = n - 1;
  vector<int> k(n - 1);
  for (int i = 0; i < n - 1; i++) {
    cin >> k[i];
  }
  for (int i = 0; i < n - 1; i++) {
    
    auto res = get(root, k[i]);
    root = res.second;
    int l = res.first.l;
    int m = res.first.m;
    int r = res.first.r;
    
    int left = get_max(1, 0, n, l, m);
    int right = get_max(1, 0, n, m, r);
    if (h[left] > h[right]) {
      left = get_max_l(1, 0, n, l, m, right);
    } else if (h[left] < h[right]) {
      right = get_max_r(1, 0, n, m, r, left);
    }
    upd(1, 0, n, left + 1, right, min(h[left], h[right]));
    ll ans = get_sum(1, 0, n, l, r);
    ll sum = pref[r] - pref[l];
    ans -= sum;
    cout << ans << endl;
  }
}
