#include <iostream>
#include <vector>
using namespace std;

using ll = long long;

ll max(ll a, ll b) {
  if (a > b) {
    return a;
  }
  return b;
}

void solve() {
  int n, s;
  cin >> n >> s;
  vector<vector<ll>> a(n + 1, vector<ll>(0));
  vector<int> sz(n + 1);
  for (int i = 1; i <= n; i++) {
    cin >> sz[i];
    for (int j = 0; j < sz[i]; j++) {
      ll c;
      cin >> c;
      a[i].push_back(c);
    }
  }
  // dp[i][j] -- sum = j; i-th task used; {subtask of i-th task, delta(1 if we need to go to pref task)} 
  vector<vector<pair<int, int>>> dp(n + 1, vector<pair<int, int>>(s + 1, {-1, -1}));
  dp[0][0] = {0, 0};
  for (int i = 1; i <= n; i++) {
    for (int j = 0; j < sz[i]; j++) {
      for (int w = s; w >= 0; w--) {
        if (w - a[i][j] < 0) break;
        if (dp[i - 1][w - a[i][j]].first != -1) {
          dp[i][w] = { j, 1 };
        }
        else if (dp[i][w - a[i][j]].first != -1) {
          dp[i][w] = { j, 0 };
        }
      }
    }
  }
  if (dp[n][s] == pair<int, int>{-1, -1}) {
    cout << "No\n";
    return;
  }
  cout << "Yes\n";
  vector<vector<int>> ans(n + 1, vector<int>(0));
  int i = n;
  int j = s;
  while (i > 0) {
    pair<int, int> cur = dp[i][j];
    ans[i].push_back(cur.first);
    j -= a[i][cur.first];
    if (cur.second == 1) {
      i--;
    }
  }
  for (int i = 1; i <= n; i++) {
    cout << ans[i].size() << '\n';
    for (int c : ans[i]) {
      cout << c + 1 << ' ';
    }
    cout << '\n';
  }
}

int main() {
  solve();
}