#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#pragma GCC optimize("O3, unroll-loops")
#pragma GCC target("avx2")
using namespace std;

using ll = long long;


const ll mod = 1e9 + 7;
const ll maxn = 1e6;
vector<ll> f = { 1, 1 };
vector<ll> rev = { 1, 1 };

ll max(ll a, ll b) {
  if (a > b) {
    return a;
  }
  return b;
}

ll min(ll a, ll b) {
  if (a < b) {
    return a;
  }
  return b;
}

ll get_rev(ll a) {
  ll p = mod - 2;
  ll res = 1;
  while (p > 0) {
    if (p & 1) {
      res = (res * a) % mod;
    }
    p >>= 1;
    a = (a * a) % mod;
  }
  return res;
}


void fill() {
  for (ll i = 2; i <= maxn; i++) {
    f.push_back((f[i - 1] * i) % mod);
    rev.push_back(get_rev(f[i]));
  }
}

ll c(ll n, ll k) {
  ll res = f[n];
  res = (res * rev[k]) % mod;
  res = (res * rev[n - k]) % mod;
  return res;
}

void next(vector<bool>& a) {
  int sz = a.size();
  for (int i = 0; i < sz - 1; i++) {
    if (a[i] && !a[i + 1]) {
      swap(a[i], a[i + 1]);
      int cnt = 0;
      for (int j = 0; j < i; j++) {
        if (a[j]) cnt++;
        a[j] = false;
      }
      for (int j = 0; j < cnt; j++) {
        a[j] = 1;
      }
      return;
    }
  }
}

void slow(ll n, ll m, ll k) {
  vector<vector<bool>> map(n, vector<bool>(m, 0));
  ll ans = 0;
  for (int i = 0; i < k; i++) {
    int x, y;
    cin >> x >> y;
    x--;
    y--;
    map[x][y] = 1;
  }
    int sz = n + m - 2;
  vector<bool> s(sz, 0);
  for (int i = 0; i < n - 1; i++) {
    s[i] = true;
  }
  ll w = c(n + m - 3, n - 1);
  for (ll ss = 0; ss < w; ss++) {
    vector<vector<bool>> t(n, vector<bool>(m, 0));
    int x = 0, y = 0;
    int cnt = 0;
    for (int i = 0; i < sz; i++) {
      if (s[i])
        x++;
      else
        y++;
      t[x][y] = 1;
      if (map[x][y]) cnt++;
    }
    vector<bool> f(sz, 0);
    for (int i = 0; i < n - 1; i++) {
      f[i] = true;
    }
    int save = cnt;
    for (int ff = 0; ff < w; ff++) {
      x = n - 1;
      y = m - 1;
      cnt = save;
      bool good = true;
      for (int i = 0; i < sz; i++) {
        if (f[i])
          x--;
        else
          y--;
        if (t[x][y]) {
          good = false;
          break;
        }
        if (map[x][y]) cnt++;
      }
      if (good && cnt == k) {
        ans++;
        /*
        cout << ans << ": \n";
        for (int i = 0; i < sz; i++) {
          cout << s[i] << ' ';
        }
        cout << '\n';
        for (int i = 0; i < sz; i++) {
          cout << f[i] << ' ';
        }
        cout << '\n';
        */
      }
      next(f);
    }
    next(s);
  }
  ans = ans + ans;
  if (ans >= mod) {
    ans -= mod;
  }
  cout << ans << '\n';
}

void solve3(ll n, ll m, ll k) {
  vector<int> mid(0);
  vector<int> left(m, 0);
  int maxd = 0;
  int minu = m - 1;
  for (int i = 0; i < k; i++) {
    int x, y;
    cin >> x >> y;
    x--;
    y--;
    if (x == 1) {
      mid.push_back(y);
      left[y] = y;
    }
    else if (x == 0) {
      maxd = max(maxd, y);
    }
    else {
      minu = min(minu, y);
    }
  }
  for (int i = 1; i < m; i++) {
    left[i] = max(left[i - 1], left[i]);
  }
  ll ans = 0;
  for (ll i = max(1, maxd); i < m; i++) {
    if (left[i - 1] > minu) break;
    ans += min(i, minu + 1) - left[i - 1];
    if (ans >= mod) {
      ans -= mod;
    }
  }
  ans = ans + ans;
  if (ans >= mod) {
    ans -= mod;
  }
  cout << ans << '\n';
}

void goyda(ll n, ll m, ll k) {
  vector<vector<bool>> map(n, vector<bool>(m, 0));
  ll ans = 0;
  for (int i = 0; i < k; i++) {
    int x, y;
    cin >> x >> y;
    x--;
    y--;
    map[x][y] = 1;
  }
  int sz = n + m - 2;
  vector<bool> s(sz, 0);
  for (int i = 0; i < n - 1; i++) {
    s[i] = true;
  }
  ll w = c(n + m - 2, n - 1);
  for (ll ss = 0; ss < w; ss++) {
    vector<vector<bool>> t(n, vector<bool>(m, 0));
    int x = 0, y = 0;
    int cnt = 0;
    for (int i = 0; i < sz; i++) {
      if (s[i])
        x++;
      else
        y++;
      t[x][y] = 1;
      if (map[x][y]) cnt++;
    }
    t[n - 1][m - 1] = 0;
    vector<vector<vector<int>>> dp(n, vector<vector<int>>(m, vector<int>(k + 1, 0)));
    dp[0][0][map[0][0]] = 1;
    for (int i = 0; i < n; i++) {
      for (int j = 0; j < m; j++) {
        int add = 0;
        if (map[i][j]) add++;
        if (t[i][j]) continue;
        for (int c = add; c <= k - cnt; c++) {
          if (i > 0 && t[i - 1][j] == 0) {
            dp[i][j][c] += dp[i - 1][j][c - add];
            if (dp[i][j][c] >= mod) {
              dp[i][j][c] -= mod;
            }
          }
          if (j > 0 && t[i][j - 1] == 0) {
            dp[i][j][c] += dp[i][j - 1][c - add];
            if (dp[i][j][c] >= mod) {
              dp[i][j][c] -= mod;
            }
          }
        }
      }
    }
    ans += dp[n - 1][m - 1][k - cnt];
    if(ans >= mod) {
      ans -= mod;
    }
    next(s);
  }
  cout << ans << '\n';
}

void solve() {
  ll n, m, k;
  cin >> n >> m >> k;
  goyda(n, m, k);
  /*
  if (n == 3) {
    solve3(n, m, k);
    return;
  }
  slow(n, m, k);
  */
  //cout << c(n + m - 2, n - 1) << '\n';
}




int main() {
  fill();
  int t = 1;
  //cin >> t;
  while (t--) {
    solve();
  }
}
