#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
using namespace std;

using ll = long long;


const ll mod = 1e9 + 7;
const ll maxn = 1e6;
vector<ll> f = { 1, 1 };
vector<ll> rev = { 1, 1 };

ll max(ll a, ll b) {
  if (a > b) {
    return a;
  }
  return b;
}

ll min(ll a, ll b) {
  if (a < b) {
    return a;
  }
  return b;
}

ll get_rev(ll a) {
  ll p = mod - 2;
  ll res = 1;
  while (p > 0) {
    if (p & 1) {
      res = (res * a) % mod;
    }
    p >>= 1;
    a = (a * a) % mod;
  }
  return res;
}


void fill() {
  for (ll i = 2; i <= maxn; i++) {
    f.push_back((f[i - 1] * i) % mod);
    rev.push_back(get_rev(f[i]));
  }
}

ll c(ll n, ll k) {
  ll res = f[n];
  res = (res * rev[k]) % mod;
  res = (res * rev[n - k]) % mod;
  return res;
}

void next(vector<bool>& a) {
  int sz = a.size();
  for (int i = 0; i < sz - 1; i++) {
    if (a[i] && !a[i + 1]) {
      swap(a[i], a[i + 1]);
      int cnt = 0;
      for (int j = 0; j < i; j++) {
        if (a[j]) cnt++;
        a[j] = false;
      }
      for (int j = 0; j < cnt; j++) {
        a[j] = 1;
      }
      return;
    }
  }
}

void slow(ll n, ll m, ll k) {
  vector<vector<bool>> map(n, vector<bool>(m, 0));
  ll ans = 0;
  for (int i = 0; i < k; i++) {
    int x, y;
    cin >> x >> y;
    x--;
    y--;
    map[x][y] = 1;
  }
    int sz = n + m - 2;
  vector<bool> s(sz, 0);
  for (int i = 0; i < n - 1; i++) {
    s[i] = true;
  }
  ll w = c(n + m - 3, n - 1);
  for (ll ss = 0; ss < w; ss++) {
    vector<vector<bool>> t(n, vector<bool>(m, 0));
    int x = 0, y = 0;
    int cnt = 0;
    for (int i = 0; i < sz; i++) {
      if (s[i])
        x++;
      else
        y++;
      t[x][y] = 1;
      if (map[x][y]) cnt++;
    }
    vector<bool> f(sz, 0);
    for (int i = 0; i < n - 1; i++) {
      f[i] = true;
    }
    int save = cnt;
    for (int ff = 0; ff < w; ff++) {
      x = n - 1;
      y = m - 1;
      cnt = save;
      bool good = true;
      for (int i = 0; i < sz; i++) {
        if (f[i])
          x--;
        else
          y--;
        if (t[x][y]) {
          good = false;
          break;
        }
        if (map[x][y]) cnt++;
      }
      if (good && cnt == k) {
        ans++;
        /*
        cout << ans << ": \n";
        for (int i = 0; i < sz; i++) {
          cout << s[i] << ' ';
        }
        cout << '\n';
        for (int i = 0; i < sz; i++) {
          cout << f[i] << ' ';
        }
        cout << '\n';
        */
      }
      next(f);
    }
    next(s);
  }
  cout << ans * 2;
}

void solve3(ll n, ll m, ll k) {
  vector<int> mid(0);
  vector<int> left(m, 0);
  vector<int> right(m, n - 1);
  int maxd = 0;
  int minu = m - 1;
  for (int i = 0; i < k; i++) {
    int x, y;
    cin >> x >> y;
    x--;
    y--;
    if (x == 1) {
      mid.push_back(y);
      left[y] = y;
      right[y] = y;
    }
    else if (x == 0) {
      maxd = max(maxd, y);
    }
    else {
      minu = min(minu, y);
    }
  }
  for (int i = 1; i < m; i++) {
    left[i] = max(left[i - 1], left[i]);
  }
  for (int i = n - 2; i >= 0; i--) {
    right[i] = min(right[i], right[i + 1]);
  }
  if (maxd > minu && mid.size() > 0) {
    cout << 0;
    return;
  }
  ll ans = 0;
  for (int i = max(1, maxd); i <= minu; i++) {
    ans += i - left[i - 1];
  }
  cout << 2 * ans;
}

void solve() {
  fill();
  ll n, m, k;
  cin >> n >> m >> k;
  if (n == 3) {
    solve3(n, m, k);
    return;
  }
  slow(n, m, k);
  //cout << c(n + m - 2, n - 1) << '\n';
}



int main() {
  int t = 1;
  //cin >> t;
  while (t--) {
    solve();
  }
}
