#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#include <iostream>
#include <vector>
#include <functional>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <unordered_map>
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned int uint;

using namespace std;

struct Node{
    ll val = 0, add = 0, set = -1;
    int ind = 0;
};

vector<int> a, segs, al, ar;
vector<Node> s, l, r;

void build(int v, int tl, int tr){
    if (tr - tl == 1){
        s[v].val = segs[tl]; s[v].ind = tl;
        l[v].val = a[tl]; l[v].ind = tl; al[tl] = a[tl];
        r[v].val = a[tl]; r[v].ind = tl; ar[tl] = a[tl];
        return;
    }
    int m = (tl + tr) / 2, v1 = v * 2 + 1, v2 = v * 2 + 2;
    build(v1, tl, m);
    build(v2, m, tr);

    if (s[v1].val >= s[v2].val) s[v] = s[v1];
    else s[v] = s[v2];
    if (l[v1].val >= l[v2].val) l[v] = l[v1];
    else l[v] = l[v2];
    if (r[v1].val >= r[v2].val) r[v] = r[v1];
    else r[v] = r[v2];
}

void check_prop(int v, int tl, int tr){
    s[v].val += s[v].add;
    if (tr - tl > 1){
        s[v * 2 + 1].add += s[v].add;
        s[v * 2 + 2].add += s[v].add;
    }
    s[v].add = 0;
}

int spusk(int v, int tl, int tr, int i){
    check_prop(v, tl, tr);
    if (tr - tl == 1) return s[v].ind;
    if (s[v * 2 + 1].val + s[v * 2 + 1].add >= i) return spusk(v * 2 + 1, tl, (tl + tr) / 2, i);
    return spusk(v * 2 + 2, (tl + tr) / 2, tr, i);
}

int spusk1(int v, int tl, int tr, int i, int n){
    check_prop(v, tl, tr);
    if (i > s[0].val) return n;
    return spusk(v, tl, tr, i);
}

void upds(int v, int ql, int qr, int tl, int tr, int d){
    check_prop(v, tl, tr);
    if (tl >= qr || tr <= ql) return;
    if (ql <= tl && tr <= qr) {
        s[v].add += d;
        check_prop(v, tl, tr);
        return;
    }
    int m = (tl + tr) / 2, v1 = v * 2 + 1, v2 = v * 2 + 2;
    upds(v1, ql, qr, tl, m, d);
    upds(v2, ql, qr, m, tr, d);

    if (s[v1].val >= s[v2].val) s[v] = s[v1];
    else s[v] = s[v2];
}

void pr(int v, int tl, int tr){
    check_prop(v, tl, tr);
    if (tr - tl == 1){
        cout << s[v].val << '-' << s[v].ind << ' ';
        return;
    }
    int m = (tl + tr) / 2, v1 = v * 2 + 1, v2 = v * 2 + 2;
    pr(v1, tl, m);
    pr(v2, m, tr);
}

ll getr(int v, int ql, int qr, int tl, int tr){
    check_prop(v, tl, tr);
    if (tl >= qr || tr <= ql) return -1;
    if (ql <= tl && tr <= qr) return r[v].val;
    int m = (tl + tr) / 2;
    return max(getr(v * 2 + 1, ql, qr, tl, m), getr(v * 2 + 2, ql, qr, m, tr));
}

ll getl(int v, int ql, int qr, int tl, int tr){
    check_prop(v, tl, tr);
    if (tl >= qr || tr <= ql) return -1;
    if (ql <= tl && tr <= qr) return l[v].val;
    int m = (tl + tr) / 2;
    return max(getl(v * 2 + 1, ql, qr, tl, m), getl(v * 2 + 2, ql, qr, m, tr));
}

void updr(int v, int i, int tl, int tr, int d){
    check_prop(v, tl, tr);
    if (tl > i || tr <= i) return;
    if (tr - tl == 1) {
        r[v].val = d;
        ar[tl] = d;
        return;
    }
    int m = (tl + tr) / 2, v1 = v * 2 + 1, v2 = v * 2 + 2;
    updr(v1, i, tl, m, d);
    updr(v2, i, m, tr, d);

    if (r[v1].val >= r[v2].val) r[v] = r[v1];
    else r[v] = r[v2];
}

void updl(int v, int i, int tl, int tr, int d){
    check_prop(v, tl, tr);
    if (tl > i || tr <= i) return;
    if (tr - tl == 1) {
        l[v].val = d;
        al[tl] = d;
        return;
    }
    int m = (tl + tr) / 2, v1 = v * 2 + 1, v2 = v * 2 + 2;
    updl(v1, i, tl, m, d);
    updl(v2, i, m, tr, d);

    if (l[v1].val >= l[v2].val) l[v] = l[v1];
    else l[v] = l[v2];
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
//    cout.setf(ios::fixed); cout.precision(10);

    int n; cin >> n;
    a.resize(n), segs.resize(n), al.resize(n), ar.resize(n);
    for (int i = 0; i < n; ++i) cin >> a[i], segs[i] = i + 1;
    s.resize(4 * n), l.resize(4 * n), r.resize(4 * n);

    build(0, 0, n);

    for (int i = 0; i < n - 1; ++i){
        int k; cin >> k;
//        cout << spusk(0, 0, n, k) << ' ' << spusk(0, 0, n, k + 1) << '\n';
        int tl = spusk1(0, 0, n, k, n), m = spusk1(0, 0, n, k + 1, n), tr = spusk1(0, 0, n, k + 2, n);
        ll mxl = getl(0, tl, m, 0, n), mxr = getr(0, m, tr, 0, n), ans1 = 0;


        for (int j = tl; j < m; ++j){
            if (mxr > ar[j]) updr(0, j, 0, n, mxr);
            ans1 += min(al[j], ar[j]) - a[j];
        }
        for (int j = m; j < tr; ++j){
            if (mxl > al[j]) updl(0, j, 0, n, mxl);
            ans1 += min(al[j], ar[j]) - a[j];
        }
        cout << ans1 << '\n';

        upds(0, spusk(0, 0, n, k + 1), n, 0, n, -1);
    }
//    pr(0, 0, n);

    return 0;
}
//8
//9 1 8 1 5 2 3 6
//3 3 1 3 3 2 1