//#pragma GCC target("avx2")
//#pragma GCC optimize("O3")
#include <iostream>
#include <cmath>
#include <algorithm>
#include <functional>
#include <vector>
#include <iomanip>
#include <cassert>
#include <string>
#include <unordered_map>
#include <map>
#include <set>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;

using namespace std;

struct Node{
    ll val, sum;
};

vector<Node> t;
vector<int> a;

void build(int v, int l, int r){
    if (r - l == 1){
        t[v] = {a[l], a[l]};
        return;
    }
    int m = (l + r) / 2;
    build(v * 2 + 1, l, m);
    build(v * 2 + 2, m, r);
    t[v] = {min(t[v * 2 + 1].val, t[v * 2 + 2].val), t[v * 2 + 1].sum + t[v * 2 + 2].sum};
}

ll getm(int v, int ql, int qr, int l, int r){
    if (r <= ql || l >= qr) return 1e18;
    if (ql <= l && r <= qr) return t[v].val;

    int m = (l + r) / 2;
    return min(getm(v * 2 + 1, ql, qr, l, m), getm(v * 2 + 2, ql, qr, m, r));
}

ll gets(int v, int ql, int qr, int l, int r){
    if (r <= ql || l >= qr) return 0;
    if (ql <= l && r <= qr) return t[v].sum;

    int m = (l + r) / 2;
    return gets(v * 2 + 1, ql, qr, l, m) + gets(v * 2 + 2, ql, qr, m, r);
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
//    cout.setf(ios::fixed); cout.precision(10);

    int n, k; ll s = 0; cin >> n >> k; int m = n - k + 1;
    a.resize(n), t.resize(4 * n);
    for (int i = 0; i < n; ++i) cin >> a[i], s += a[i];
    build(0, 0, n);
    ll ans = -1;
    if (k == 2){
        ll p = a[0]; s -= a[0];
        for (int i = 1; i < n; ++i){
            ans = max(ans, abs(p - s));
            p += a[i]; s -= a[i];
        }
    } else {
        for (int i = 0; i <= n - m; ++i) {
            ll cur = gets(0, i, i + m, 0, n) - min(getm(0, 0, i, 0, n), getm(0, i + m, n, 0, n));
            ans = max(ans, cur);
        }
    }

    cout << ans;

//    ll la = 0, ra = 1, ans = a[0], l = 0, cur = a[0], ans2 = a[0];
//    for (int i = 1; i < n; ++i){
//        if (i - l == m) cur -= a[l], l++;
//        cur += a[i];
//        if (cur > ans) la = l, ra = i, ans = cur;
//    }
//
//    ll ans1 = 1e18;
//    for (int i = 0; i < n; ++i){
//        if ((i < la || i > ra) && a[i] < ans1) ans1 = a[i];
//    }
//
//    cout << ans - ans1;

    return 0;
}

//4 2
//2 1 3 4

//5 4
//2 1 3 4 1