#include <algorithm>
#include <cassert>
#include <cstdint>
#include <iostream>
#include <set>
#include <vector>
using namespace std;

struct dsu {
  vector<int> p;
  vector<pair<int, int>> val;

  dsu(int n) {
    p.resize(n);
    for (int i = 0; i < n; i++) {
      p[i] = i;
      val[i] = {i, i + 1};
    }
  }

  int get(int i) {
    if (p[i] == i) {
      return i;
    }
    return p[i] = get(p[i]);
  }

  int join(int i, int j) {
    i = get(i);
    j = get(j);
    p[i] = j;
    // i -> j
    val[j] = {val[i].first, val[j].second};
    return j;
  }
};

const int N = 2e5;
int h[N];

void solve() { //
  int n;
  cin >> n;

  for (int i = 0; i < n; i++) {
    cin >> h[i];
  }

  set<pair<int, int>> s;

  for (int i = 0; i < n; i++) {
    s.insert({i, i + 1});
  }

  auto join = [&](int k) -> pair<int, int> {
    auto it = next(s.begin(), k);
    auto jt = next(it);
    auto [l1, r1] = *it;
    auto [l2, r2] = *jt;
    assert(l2 == r1);
    s.erase(it);
    s.erase(jt);
    s.insert({l1, r2});
    return {l1, r2};
  };

  auto answ = [&](int l, int r) {
    vector<int> arr;
    for (int i = l; i < r; i++) {
      arr.push_back(h[i]);
    }

    int n = (r - l);
    vector<int> p(n), s(n);

    // p[i] - max on [0; i]
    for (int i = 0; i < n; i++) {
      p[i] = h[l + i];
      if (i > 0) {
        p[i] = max(p[i - 1], p[i]);
      }
    }

    for (int i = n - 1; i >= 0; i--) {
      s[i] = h[l + i];
      if (i + 1 < n) {
        s[i] = max(s[i], s[i + 1]);
      }
    }

    int64_t ans = 0;
    for (int i = 0; i < n; i++) {
      ans += min(s[i], p[i]) - h[l + i];
    }
    return ans;
  };

  for (int j = 1; j < n; j++) {
    int k;
    cin >> k;
    k--;
    auto [l, r] = join(k);
    cout << answ(l, r) << "\n";
  }
}

int main() {
  int tt = 1;
#ifdef home
  cin >> tt;
#endif
  while (tt--) {
    solve();
    cout << "\n";
  }
}