#include <algorithm>
#include <cassert>
#include <cstdint>
#include <iostream>
#include <set>
#include <vector>
using namespace std;

const int N = 2e5;
int h[N];

struct tree {
  // tree;
  // (l,r) max= v
  // (l, r) sum

  // (l, r) get maximum index
  // sum

  int n, sz;
  vector<int> t;

  tree(int _n) {
    n = _n;
    sz = 1;
    while (sz < n) {
      sz *= 2;
    }
    t.resize(2 * sz - 1);
  }

  void upd(int l, int r, int v) {
    for (int j = l; j < r; j++) {
      t[j] = max(t[j], v);
    }
  }

  int64_t sum(int l, int r) {
    int64_t ans = 0;
    for (int i = l; i < r; i++) {
      ans += t[i];
    }
    return ans;
  }

  pair<int, int> amax(int l, int r) {
    pair<int, int> ans = {-1, l};
    for (int i = l; i < r; i++) {
      ans = max(ans, {t[i], i});
    }
    return ans;
  }
};

void solve() { //
  int n;
  cin >> n;

  for (int i = 0; i < n; i++) {
    cin >> h[i];
  }

  set<pair<int, int>> s;

  for (int i = 0; i < n; i++) {
    s.insert({i, i + 1});
  }

  tree pref(n), suf(n), t(n);
  for (int i = 0; i < n; i++) {
    pref.upd(i, i + 1, h[i]);
    suf.upd(i, i + 1, h[i]);
    t.upd(i, i + 1, h[i]);
  }

  auto join = [&](int k) -> pair<int, int> {
    auto it = next(s.begin(), k);
    auto jt = next(it);
    auto [l1, r1] = *it;
    auto [l2, r2] = *jt;
    assert(l2 == r1);
    s.erase(it);
    s.erase(jt);
    s.insert({l1, r2});

    pref.upd(l2, r2, t.amax(l1, r1).first);
    suf.upd(l1, r1, t.amax(l2, r2).first);

    return {l1, r2};
  };

  auto answ = [&](int l, int r) {
    int j = t.amax(l, r).second;
    return pref.sum(l, j) + suf.sum(j, r) - t.sum(l, r);
  };

  for (int j = 1; j < n; j++) {
    int k;
    cin >> k;
    k--;
    auto [l, r] = join(k);
    cout << answ(l, r) << "\n";
  }
}

int main() {
  cin.tie(nullptr)->sync_with_stdio(0);
  cout.tie(nullptr);
  int tt = 1;
#ifdef home
  cin >> tt;
#endif
  while (tt--) {
    solve();
    cout << "\n";
  }
}