#include <algorithm>
#include <cassert>
#include <cstdint>
#include <iostream>
#include <set>
#include <vector>
using namespace std;

const int N = 2e5;
int h[N];

// tree;
// (l,r) max= v
// (l, r) sum

// (l, r) get maximum index
// sum
struct tree1 {
  int n, sz;

  struct node {
    pair<int, int> mx = {-1, 0};
    int64_t sum = 0;

    node operator*(node other) { return {max(other.mx, mx), sum + other.sum}; }
  };

  vector<node> t;

  tree1(int _n) {
    n = _n;
    sz = 1;
    while (sz < n) {
      sz *= 2;
    }
    t.resize(2 * sz - 1);
    build(0, 0, sz);
  }

  void build(int x, int l, int r) {
    if (r - l == 1) {
      t[x] = {{h[l], l}, h[l]};
      return;
    }
    int m = (l + r) / 2;
    build(2 * x + 1, l, m);
    build(2 * x + 2, m, r);
    t[x] = t[2 * x + 1] * t[2 * x + 2];
  }

  node qry(int l, int r) { return qry(l, r, 0, 0, sz); }

  node qry(int ql, int qr, int x, int l, int r) {
    if (ql <= l && r <= qr) {
      return t[x];
    }

    if (ql >= r || qr <= l) {
      return node();
    }

    int m = (l + r) / 2;
    return qry(ql, qr, 2 * x + 1, l, m) * qry(ql, qr, 2 * x + 2, m, r);
  }
};

struct tree2 {
  int sz, n;

  vector<int> t;
  tree2(int _n) {
    n = _n;
    sz = 1;
    while (sz < n) {
      sz *= 2;
    }
    t.resize(2 * sz - 1);
  }

  // sum
  int64_t sum(int l, int r) {
    int64_t s = 0;
    for (int i = l; i < r; i++) {
      s += t[i];
    }
    return s;
  }
  // upd
  void upd(int l, int r, int v) {
    for (int i = l; i < r; i++) {
      t[i] = max(t[i], v);
    }
  }
};

void solve() { //
  int n;
  cin >> n;

  for (int i = 0; i < n; i++) {
    cin >> h[i];
  }

  set<pair<int, int>> s;

  for (int i = 0; i < n; i++) {
    s.insert({i, i + 1});
  }

  tree1 t(n);
  tree2 pref(n), suf(n);
  for (int i = 0; i < n; i++) {
    pref.upd(i, i + 1, h[i]);
    suf.upd(i, i + 1, h[i]);
  }

  auto join = [&](int k) -> pair<int, int> {
    auto it = next(s.begin(), k);
    auto jt = next(it);
    auto [l1, r1] = *it;
    auto [l2, r2] = *jt;
    assert(l2 == r1);
    s.erase(it);
    s.erase(jt);
    s.insert({l1, r2});

    pref.upd(l2, r2, t.qry(l1, r1).mx.first);
    suf.upd(l1, r1, t.qry(l2, r2).mx.first);

    return {l1, r2};
  };

  auto answ = [&](int l, int r) {
    int j = t.qry(l, r).mx.second;
    return pref.sum(l, j) + suf.sum(j, r) - t.qry(l, r).sum;
  };

  for (int j = 1; j < n; j++) {
    int k;
    cin >> k;
    k--;
    auto [l, r] = join(k);
    cout << answ(l, r) << "\n";
  }
}

int main() {
  cin.tie(nullptr)->sync_with_stdio(0);
  cout.tie(nullptr);
  int tt = 1;
#ifdef home
  cin >> tt;
#endif
  while (tt--) {
    solve();
    cout << "\n";
  }
}