#include <cassert>
#include <cstdint>
#include <iostream>
using namespace std;

const int N = 500;
const int mod = 1e9 + 7;
int f[N][4];

int popc(int x) {
  int s = 0;
  for (int j = 0; j < 8; j++) {
    if ((x >> j) & 1) {
      s++;
    }
  }
  return s;
}

void solve() { //
  int n, k;
  cin >> n >> k;

  assert(k <= 2);

  bool ok = true;

  if (k == 1) {
    for (int i = 0; i < n; i++) {
      int s;
      cin >> s;
      if (s > 1) {
        ok = false;
      }
    }
    cout << ok;
    return;
  }

  int s;
  cin >> s;

  for (int i = 0; i < 4; i++) {
    if (popc(i) == s) {
      f[0][i] = 1;
    }
  }

  for (int i = 1; i < n; i++) {
    cin >> s;
    for (int b1 = 0; b1 < 4; b1++) {
      for (int b2 = 0; b2 < 4; b2++) {
        int k = popc(b2) + popc(b1 / 2);
        if (k == s) {
          (f[i][b2] += f[i - 1][b1]) %= mod;
          // cout << i << ": " << b2 << " += " << b1 << "( " << f[i - 1][b1]
          //      << ")\n";
        }
      }
    }
  }

  int ans = 0;
  for (int b = 0; b < 4; b++) {
    (ans += f[n - 1][b]) %= mod;
  }
  cout << ans;
}

int main() {
  int tt = 1;
  while (tt--) {
    solve();
    cout << "\n";
  }
}