#include <algorithm>
#include <cassert>
#include <cstdint>
#include <iostream>
#include <map>
#include <vector>
using namespace std;

#pragma GCC optimize("Ofast")

const int N = 203;
const int K = 1e6;
const int mod = 1e9 + 7;
int f[N][K];

int popc(int x) {
  int s = 0;
  while (x) {
    s += x & 1;
    x >>= 1;
  }
  return s;
}

int n, k;

int gen(int r, int b) {
  int len = k - 1;

  int s = 0;
  int pos = 0;

  for (int j = 1; j < k; j++) {
    b >>= 1;
    for (int z = 1; z < len; z++) {
      s ^= (1 << pos) * (b & 1);
      b >>= 1;
      pos++;
    }
    s ^= (1 << pos) * (r & 1);
    r >>= 1;
    pos++;
    len--;
  }

  return s;
}

string disp(int x) {
  string s;
  while (x) {
    s.push_back('0' + (x & 1));
    x >>= 1;
  }
  reverse(s.begin(), s.end());
  return s;
}

int h[N];

int t[N][N];

void solve() { //
  cin >> n >> k;

  int kk = max(2, k * (k - 1) / 2);

  f[0][0] = 1;

  map<int, vector<int>> prv, cur;

  prv[0].push_back(0);

  for (int i = 0; i < n; i++) {
    // cout << i << ".\n";
    int s;
    cin >> s;

    for (int b2 = 0; b2 < (1 << k); b2++) {
      for (auto b1 : prv[s - popc(b2)]) {
        // int x = popc(b1) + popc(b2);

        int b3 = gen(b2, b1);
        (f[i + 1][b3] += f[i][b1]) %= mod;
        cur[popc(b3)].push_back(b3);
      }
    }

    for (auto &[_, row] : cur) {
      sort(row.begin(), row.end());
      row.resize(unique(row.begin(), row.end()) - row.begin());
    }

    swap(cur, prv);
    cur.clear();
  }

  int ans = 0;
  for (int b = 0; b < (1 << kk); b++) {
    (ans += f[n][b]) %= mod;
  }
  cout << ans;
}

int main() {
  cin.tie(nullptr)->sync_with_stdio(0);
  cout.tie(nullptr);
  int tt = 1;
  while (tt--) {
    solve();
    cout << "\n";
  }
}