#include <algorithm>
#include <iostream>
#include <queue>
using namespace std;

#pragma GCC optimize("Ofast")

int ans = 0;
int score = 0;
int len = 0;
bool vis = 0;

const int N = 200;
bool used[N][N];
int a[N][N]; // amount of cool points at (i, j)

int n, m, k;

bool us[N][N];

void dfs2(int i, int j) {
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
      us[i][j] = false;
    }
  }
  queue<pair<int, int>> q;
  q.push({i, j});

  auto ok = [](int i, int j) {
    if (i == 0 && j == 0) {
      return !us[i][j];
    }
    return i < m && j < m && i >= 0 && j >= 0 && !used[i][j] && !us[i][j];
  };

  while (!q.empty()) {
    auto [i, j] = q.front();
    q.pop();
    if (!ok(i, j)) {
      continue;
    }
    us[i][j] = true;
    for (int di : {+1, -1}) {
      if (ok(i + di, j)) {
        q.push({i + di, j});
      }
      if (ok(i, j + di)) {
        q.push({i, j + di});
      }
    }
  }
}

void dfs(int i, int j) {
  if (i == 0 && j == 0 && used[i][j]) {
    ans += (len == 2 * n + 2 * m - 4 && score == k && vis);
    return;
  }

  if (i < 0 || j < 0 || i >= n || j >= m || used[i][j]) {
    return;
  }

  dfs2(i, j);
  if ((!used[n - 1][m - 1] && !us[n - 1][m - 1]) && !us[0][0]) {
    return;
  }

  if (i == n - 1 && j == m - 1) {
    vis = true;
  }

  used[i][j] = 1;
  len += 1;
  score += a[i][j];

  for (int di : {-1, +1}) {
    dfs(i + di, j);
    dfs(i, j + di);
  }

  if (i == n - 1 && j == m - 1) {
    vis = false;
  }

  used[i][j] = 0;
  len -= 1;
  score -= a[i][j];
}

int main() {
  cin.tie(nullptr)->sync_with_stdio(0);
  cin >> n >> m >> k;
  for (int l = 0; l < k; l++) {
    int i, j;
    cin >> i >> j;
    i--, j--;
    a[i][j]++;
  }

  dfs(0, 0);
  cout << ans;
}