#include <iostream>
#include <set>
#include <iomanip>
#include <map>
#include <vector>
#include <string>
#include <algorithm>

const int MAX_N = 1e5 + 10;
const int INF = 1e9 + 1321l;

#define pb push_back
#define sz(x) int(x.size())
#define mp make_pair

typedef long long ll;

using namespace std;

// template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, rb_tree_statics_node_update>;
int n;
ll h[MAX_N];
ll k[MAX_N];
pair <ll,ll> segments[MAX_N];


struct node {
    ll mx, sets = -1, ind_of_mx;
    ll sum;
    node () {}
    node (node L, node R) {
        mx = max(L.mx, R.mx);
        sum = L.sum + R.sum;
        if (mx == R.mx) {
            ind_of_mx = R.ind_of_mx;
        } else {
            ind_of_mx = L.ind_of_mx;
        }
        
    }
};

node t[MAX_N * 4];
ll tp[MAX_N * 4];
void inc(int i, int pos, int lx, int rx) {
    // cout << i << " " << lx << " " << rx << endl;
    if (rx - lx == 1) {
        tp[pos] = 1;
        // cout << lx << " SDsadasdADA" << endl;
        return;
    }
    int m = (lx + rx) / 2;
    if (i < m) {
        inc(i, pos * 2 + 1, lx, m);
    } else {
        inc(i, pos * 2 + 2, m, rx);
    }
    tp[pos] = tp[pos * 2 + 1] + tp[pos * 2 + 2];
}
int find_p(int ind, int pos, int lx, int rx) {
    if (rx - lx == 1) {
        return lx;
    }
    int m = (lx + rx) / 2;
    // cout << ind << " " << pos << " " << lx << " " << rx << " " << m << endl;
    // cout << "DATA" << " " << (m - lx) - tp[pos * 2 + 1] << endl;
    if (ind > (m - lx) - tp[pos * 2 + 1]) {
        ind -= (m - lx) - tp[pos * 2 + 1];
        return find_p(ind, pos * 2 + 2, m, rx);
    } else {
        return find_p(ind, pos * 2 + 1, lx, m);
    }
    
}
void build (int pos, int lx, int rx) {
    if (rx - lx == 1) {
        t[pos].mx = h[lx];
        t[pos].sum = h[lx];
        t[pos].ind_of_mx = lx;
        t[pos].sets = -1;
        return;
    }
    int m = (lx + rx) / 2;
    build(pos * 2 + 1, lx, m);
    build(pos * 2 + 2, m, rx);
    t[pos] = {t[pos * 2 + 1], t[pos * 2 + 2]};
    t[pos].sets = -1;
}
void push(int pos, int lx, int rx) {
    if (rx - lx == 1 || t[pos].sets == -1) return;
    int m = (lx + rx) / 2;
    t[pos * 2 + 1].sets = t[pos].sets;
    t[pos * 2 + 2].sets = t[pos].sets;
    t[pos * 2 + 1].mx = t[pos].sets;
    t[pos * 2 + 2].mx = t[pos].sets;
    t[pos * 2 + 1].sum = t[pos].sets * (m - lx);
    t[pos * 2 + 2].sum = t[pos].sets * (rx - m);
    // cout << t[pos].sets << "PUSHJJJ " << pos << endl;
    t[pos].sets = -1;
}
void set_up(int l, int r, int pos, int lx, int rx, int x){
    push(pos, lx, rx);
    // cout << t[pos].sets << "AEWAEAWEAW a"  << " POS " << pos << endl;
    if (rx <= l || r <= lx) return;
    if (l <= lx && rx <= r) {
        t[pos].mx = x;
        t[pos].sets = x;
        // cout << x << "ASDASDASDASD" << endl;
        t[pos].sum = (rx - lx) * x;
        // cout << t[pos].sets << endl;
        // cout << lx << " " << rx << " " << t[pos].sum << " " << pos << endl;
        return;
    }
    int m = (lx + rx) / 2;
    set_up(l, r, pos * 2 + 1, lx, m, x);
    set_up(l, r, pos * 2 + 2, m, rx, x);
    // cout << t[pos].sets << "AEWAEAWEAW a"  << " POS " << pos << endl;
    t[pos] = {t[pos * 2 + 1], t[pos * 2 + 2]};
    // cout << t[pos].sets << "AEWAEAWEAW a"  << " POS " << pos << endl;
    // cout << lx << " " << rx << " " << m << " " << t[pos].sum  << " " << l << " " << r << endl;
}
pair <ll, pair <int,int>> sum(int l, int r, int pos, int lx, int rx) {
    push(pos, lx, rx);
    if (rx <= l || r <= lx) return {0, mp(-INF, -1)};
    if (l <= lx && rx <= r) {
        // cout << lx << " " << rx << "TR|GIAGA" << " " << t[pos].sum << " " << pos << endl;
        return  {t[pos].sum, mp(t[pos].mx, t[pos].ind_of_mx)};
    }
    int m = (lx + rx) / 2;
    auto p1 = sum(l, r, pos * 2 + 1, lx, m);
    auto p2 = sum(l, r, pos * 2 + 2, m, rx);
    return mp(p1.first + p2.first, max(p1.second, p2.second));
}
ll mx_maximum_to_lef(int l, int r, int pos, int lx, int rx, int x) {
    push(pos, lx, rx);
    if (rx <= l || r <= lx) return -1;
    if (rx - lx == 1) {
        if (t[pos].mx >= x) {
            return t[pos].ind_of_mx;
        } else {
            return -1;
        }
    }
    int m = (lx + rx) / 2;
    // cout << pos << " " << lx << " " << rx << " " << x << " " << t[pos * 2 + 2].mx << endl;
    if (t[pos * 2 + 1].mx >= x) {
        int anss = mx_maximum_to_lef(l, r, pos * 2 + 1, lx, m, x);
        if (anss != -1) {
            return anss;
        }
    }
    return mx_maximum_to_lef(l, r, pos * 2 + 2, m, rx, x);
}
int mx_maximum_to_rig(int l, int r, int pos, int lx, int rx, ll x) {
    push(pos, lx, rx);
    if (rx <= l || r <= lx) return -1;
    if (rx - lx == 1) {
        if (t[pos].mx >= x) {
            return t[pos].ind_of_mx;
        } else {
            return -1;
        }
    }
    int m = (lx + rx) / 2;
    // cout << pos << " " << lx << " " << rx << " " << x << " " << t[pos * 2 + 2].mx << endl;
    if (t[pos * 2 + 2].mx >= x) {
        ll anss = mx_maximum_to_rig(l, r, pos * 2 + 2, m, rx, x);
        if (anss != -1) {
            return anss;
        }
    }
    return mx_maximum_to_rig(l, r, pos * 2 + 1, lx, m, x);
}
ll pref[MAX_N];

int main () {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> h[i];
        segments[i] = mp(i, i + 1);
        tp[i] = 0;
        pref[i] = pref[i - 1] + h[i];
        // cout << pref[i] << " ";
    }
    // cout << endl;
    for (int i = 1; i < n; i++) {
        cin >> k[i];
    }
    build(0, 1, n + 1);
    for (int stage = 1; stage < n; stage++) {
        int ind1 = find_p(k[stage], 0, 1, n + 1);
        int ind2 = find_p(k[stage] + 1, 0, 1, n + 1);
        pair <ll,ll> &s1 =  segments[ind1];
        pair <ll,ll> &s2 =  segments[ind2];
        // cout << ind1 << " spp " << ind2 << endl;
        // cout << s1.first << " ss " << s1.second << endl;
        // cout << s2.first << " ss " << s2.second << endl;
        
        auto mx1 = sum(s1.first, s1.second, 0, 1, n + 1);
        auto mx2 = sum(s2.first, s2.second, 0, 1, n + 1);
        // cout << mx1.second.first << " " << mx1.second.second<< endl;
        // cout << mx2.second.first << " " << mx2.second.second<< endl;
        int i1, i2,  mean;
        // cout << t[1].sum <<"ASDAAAAAAAAAAAAAAAA"<< endl;
        if (mx1.second.first > mx2.second.first) {
            i2 = mx2.second.second;
            i1 = mx_maximum_to_rig(s1.first, s1.second, 0, 1, n + 1, mx2.second.first);
            mean = mx2.second.first;
            // cout << i1 << " " << i2  << " " << mean << endl;
            if (i1 + 1 != i2) {
                set_up(i1 + 1, i2, 0, 1, n + 1, mean);
                // cout << i1 << " " << i2 << " adasd " << mean << endl;
            }
        } else {
            i1 = mx1.second.second;
            i2 = mx_maximum_to_lef(s2.first, s2.second, 0, 1, n + 1, mx1.second.first);
            mean = mx1.second.first;
            // cout << i1 << " " << i2 << endl;
            if (i1 + 1 != i2) {
                set_up(i1, i2, 0, 1, n + 1, mean);
                // cout << i1 << " " << i2 << " sadad " << mean << endl;
            }
        } 
        // cout << t[1].sum <<"ASDAAAAAAAAAAAAAAAA"<< endl;
        // cout << "____" << endl;
        ll ans = sum(s1.first, s2.second, 0, 1, n + 1).first ;
        // cout << s2.second - 1 << " " << s1.first - 1 << endl;
        // cout << pref[s2.second - 1] - pref[s1.first - 1] << endl;
        // cout << ans << endl;
        s1.second = s2.second;
        cout << ans - pref[s2.second - 1] + pref[s1.first - 1] << '\n';
        inc(ind2, 0, 1, n + 1);    
    }


}
// 4
// 5 2 1 6
// 1 1 1