#include<bits/stdc++.h>

using namespace std;
using ll = long long;

#pragma GCC optimize("Ofast", "unroll-loops")
//#pragma GCC target("avx2","bmi2","sse4.2")

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

mt19937 gen(chrono::high_resolution_clock().now().time_since_epoch().count());

int getInt(int l, int r) {
    return uniform_int_distribution<int>(l, r)(gen);
}

struct point {
    int x, y;
    point() {};
    point (int X, int Y) {x = X; y = Y;}

    point friend operator+(point a, point b) {
        return point(a.x + b.x, a.y + b.y);
    }

    point friend operator-(point a, point b) {
        return point(a.x - b.x, a.y - b.y);
    }

    point friend operator*(point a, int b) {
        return point(a.x * b, a.y * b);
    }

    point friend operator/(point a, int b) {
        return point(a.x / b, a.y / b);
    }

    int friend operator*(point a, point b) {
        return a.x * b.x + a.y * b.y;
    }

    int friend operator^(point a, point b) {
        return a.x * b.y - a.y * b.x;
    }
};

void solve() {
    ll d, l, r; cin >> d >> l >> r;

    vector<int> pr;

    for (ll i = 2; i * i <= d; i++) {
        while (d % i == 0) {
            pr.push_back(i);
            d /= i;
        }
    }

    int k = pr.size();


    set<pair<__int128_t, __int128_t>> s;

    for (int mask = 1; mask < (1 << k) - 1; mask++) {
        __int128_t a = 1, b = 1;
        for (int i = 0; i < k; i++) {
            if (mask & (1 << i)) a *= pr[i];
            else b *= pr[i];
        }

        if ((a + b) % 2) continue;

        ll x = (a + b) / 2;
        ll y = a - x;

        if (x > 0 && y > 0 && y < x && l <= x * x && x * x <= r && l <= y * y && y * y <= r) {
            //cout << x << " " << y << "\n";
            s.insert({x, y});
        }
    }
    
    cout << s.size() << "\n";
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}