#pragma optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

#define int long long

mt19937 rng(1337);

const int maxn = 4e5 + 4000;
int a[maxn];

struct Node {
    int x, mn, mx, upd;
    Node(int _x = 0) {
        if (_x == 0) {
            mn = 1e9;
            mx = -1e9;
            x = _x;
        } else {
            x = mn = mx = _x;
        }
        upd = 0;
    }
    Node operator + (const Node & other) const {
        Node res;
        res.x = x + other.x;
        res.mn = min(mn, other.mn);
        res.mx = max(mx, other.mx);
        return res;
    }
};

Node tl[maxn], tr[maxn], tb[maxn];

void build(int v, int l, int r) {
    if (l + 1 == r) {
        tl[v] = Node(a[l]);
        tr[v] = Node(a[l]);
        tb[v] = Node(a[l]);
        return;
    }
    int mid = (l + r) / 2;
    build(v * 2, l, mid);
    build(v * 2 + 1, mid, r);
    tl[v] = tl[v * 2] + tl[v * 2 + 1];
    tr[v] = tr[v * 2] + tr[v * 2 + 1];
    tb[v] = tb[v * 2] + tb[v * 2 + 1];
}

void pushl(int v, int l, int r) {
    if (tl[v].upd == 0) return;
    tl[v].x = tl[v].upd * (r - l);
    tl[v].mn = tl[v].mx = tl[v].upd;
    if (l + 1 == r) {
        tl[v].upd = 0;
        return;
    }
    tl[v * 2].upd = tl[v * 2 + 1].upd = tl[v].upd;
    tl[v].upd = 0;
    return;
}


void pushr(int v, int l, int r) {
    if (tr[v].upd == 0) return;
    tr[v].x = tr[v].upd * (r - l);
    tr[v].mn = tr[v].mx = tr[v].upd;
    if (l + 1 == r) {
        tr[v].upd = 0;
        return;
    }
    tr[v * 2].upd = tr[v * 2 + 1].upd = tr[v].upd;
    tr[v].upd = 0;
    return;
}

void updatel(int v, int l, int r, int ql, int qr, int val) {
    pushl(v, l, r);
    if (ql >= r || l >= qr) return;
    if (ql <= l && r <= qr) {
        if (tl[v].mn >= val) {
            return;
        }
        if (tl[v].mx < val) {
            tl[v].upd = val;
            pushl(v, l, r);
            return;
        }
    }
    if (l + 1 == r) return;
    int mid = (l + r) / 2;
    updatel(v * 2, l, mid, ql, qr, val);
    updatel(v * 2 + 1, mid, r, ql, qr, val);
    tl[v] = tl[v * 2] + tl[v * 2 + 1];
    return;
}

void updater(int v, int l, int r, int ql, int qr, int val) {
    pushr(v, l, r);
    if (ql >= r || l >= qr) return;
    if (ql <= l && r <= qr) {
        if (tr[v].mn >= val) {
            return;
        }
        if (tr[v].mx < val) {
            tr[v].upd = val;
            pushr(v, l, r);
            return;
        }
    }
    if (l + 1 == r) return;
    int mid = (l + r) / 2;
    updater(v * 2, l, mid, ql, qr, val);
    updater(v * 2 + 1, mid, r, ql, qr, val);
    tr[v] = tr[v * 2] + tr[v * 2 + 1];
    return;
}

Node query(int v, int l, int r, int ql, int qr) {
    if (ql >= r || l >= qr) return Node();
    if (ql <= l && r <= qr) return tb[v];
    int mid = (l + r) / 2;
    return query(v * 2, l, mid, ql, qr) + query(v * 2 + 1, mid, r, ql, qr);
}

Node getans(int v, int l, int r, int ql, int qr) {
    pushl(v, l, r);
    pushr(v, l, r);
    //cout << l << ' ' << r << " OGOGO\n";
    if (l >= qr || ql >= r) return Node();
    if (ql <= l && r <= qr) {
        if (tl[v].mn >= tr[v].mx) {
            //cout << l << ' ' << r << ' ' << tr[v].x << " Rchoise\n";
            return tr[v];
        }
        if (tr[v].mn >= tl[v].mx) {
            //cout << l << ' ' << r << ' ' << tl[v].x << " Lchoise\n";
            return tl[v];
        }
    }
    int mid = (l + r) / 2;
    Node gans1 = getans(v * 2, l, mid, ql, qr);
    Node gans2 = getans(v * 2 + 1, mid, r, ql, qr);
    return  gans1 + gans2;
}


struct ddNode {
    pair<int, int> x;
    int y, sz;
    ddNode *l, *r;
    ddNode(pair<int, int> _x = {0, 0}) : x(_x), y(rng()), sz(1), l(0), r(0) {}
};

int sz(ddNode * root) {
    return (root == 0 ? 0 : root -> sz);
}

void upd(ddNode * root) {
    if (root == 0) return;
    root -> sz = 1 + sz(root -> r) + sz(root -> l);
}


ddNode* merge(ddNode * L, ddNode * R) {
    if (L == 0) return R;
    if (R == 0) return L;
    if (L -> y < R -> y) {
        L -> r = merge(L -> r, R);
        upd(L);
        return L;
    }
    R -> l = merge(L, R -> l);
    upd(R);
    return R;
}

pair<ddNode*, ddNode*> split(ddNode *root, int k) {
    if (root == 0) return {0, 0};
    if (sz(root -> l) < k) {
        auto pr = split(root -> r, k - sz(root -> l) - 1);
        root -> r = pr.first;
        upd(root);
        return {root, pr.second};
    }
    auto pr = split(root -> l, k);
    root -> l = pr.second;
    upd(root);
    return {pr.first, root};
}

void print(ddNode * root) {
    if (root == 0) return;
    if (root -> l) print(root -> l);
    cout << (root -> x).first << ' ' << (root -> x).second << '\n';
    if (root -> r) print(root -> r);
}

ddNode* insert(ddNode *root, pair<int, int> x, int pos) {
    auto [fs, sc] = split(root, pos);
    return merge(merge(fs, new ddNode(x)), sc);
}

pair<ddNode*, ddNode*> erase(ddNode *root, int k) {
    auto [fs, sc] = split(root, k + 1);
    auto [fs1, fs2] = split(fs, k);
    return {merge(fs1, sc), fs2};
}

void alpush(int v, int l, int r) {
    pushl(v, l, r);
    pushr(v, l, r);
    if (l + 1 == r) {
        //cout << tl[v].x << ' ' << tr[v].x << '\n';
        return;
    }
    int mid = (l + r) / 2;
    alpush(v * 2, l, mid);
    alpush(v * 2 + 1, mid, r);
    tl[v] = tl[v * 2] + tl[v * 2 + 1];
    tr[v] = tr[v * 2] + tr[v * 2 + 1];
}

void solve() {
    int n;
    cin >> n;
    ddNode *root = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        root = insert(root, {i, i + 1}, i);
    }
    build(1, 0, n);
    for (int i = 0; i < n - 1; i++) {
        int kj;
        cin >> kj; kj--;
        auto pr = erase(root, kj);
        pair<int, int> fst = (pr.second) -> x;
        root = pr.first;
        pr = erase(root, kj);
        pair<int, int> scnd = (pr.second) -> x;
        root = pr.first;
        Node lmax = query(1, 0, n, fst.first, fst.second), rmax = query(1, 0, n, scnd.first, scnd.second);
        //cout << lmax.mx << ' ' << rmax.mx << " HIHIHIHA\n";
        updatel(1, 0, n, scnd.first, scnd.second, lmax.mx);
        updater(1, 0, n, fst.first, fst.second, rmax.mx);
        Node ans = getans(1, 0, n, fst.first, scnd.second);
        cout << ans.x - lmax.x - rmax.x << '\n';
        root =  insert(root, {fst.first, scnd.second}, kj);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    solve();
}
