#pragma optimize("Ofast")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int long long

using orset = tree<pair<int, int>, int, less<pair<int, int>>, rb_tree_tag, null_node_update, tree_order_statistics_node_update>;

const int maxn = 4e5 + 4000;
int a[maxn];

struct Node {
    int x, mn, mx, upd;
    Node(int _x = 0) {
        if (_x == 0) {
            mn = 1e9;
            mx = -1e9;
            x = _x;
        }
        upd = -1;
    }
    Node operator + (const Node & other) const {
        Node res;
        res.x = x + other.x;
        res.mn = min(mn, other.mn);
        res.mx = max(mx, other.mx);
        return res;
    }
};

Node tl[maxn], tr[maxn], tb[maxn];

void build(int v, int l, int r) {
    if (l + 1 == r) {
        tl[v] = Node(a[l]);
        tr[v] = Node(a[l]);
        tb[v] = Node(a[l]);
        return;
    }
    int mid = (l + r) / 2;
    build(v * 2, l, mid);
    build(v * 2 + 1, mid, r);
    tl[v] = tl[v * 2] + tl[v * 2 + 1];
    tr[v] = tr[v * 2] + tr[v * 2 + 1];
    tb[v] = tb[v * 2] + tb[v * 2 + 1];
}

void pushl(int v, int l, int r) {
    if (tl[v].upd == -1) return;
    tl[v].x = tl[v].upd * (r - l);
    tl[v].mn = tl[v].mn = tl[v].upd;
    if (l + 1 == r) {
        tl[v].upd = -1;
        return;
    }
    tl[v * 2].upd = tl[v * 2 + 1].upd = tl[v].upd;
    tl[v].upd = -1;
    return;
}


void pushr(int v, int l, int r) {
    if (tr[v].upd == -1) return;
    tr[v].x = tr[v].upd * (r - l);
    tr[v].mn = tr[v].mn = tr[v].upd;
    if (l + 1 == r) {
        tr[v].upd = -1;
        return;
    }
    tr[v * 2].upd = tr[v * 2 + 1].upd = tr[v].upd;
    tr[v].upd = -1;
    return;
}

void updatel(int v, int l, int r, int ql, int qr, int val) {
    pushl(v, l, r);
    if (ql >= r || l >= qr) return;
    if (ql <= l && qr <= r) {
        if (tl[v].mn >= val) {
            return;
        }
        if (tl[v].mx < val) {
            tl[v].upd = val;
            pushl(v, l, r);
            return;
        }
    }
    int mid = (l + r) / 2;
    updatel(v * 2, l, mid, ql, qr, val);
    updatel(v * 2 + 1, mid, r, ql, qr, val);
    tl[v] = tl[v * 2] + tl[v * 2 + 1];
    return;
}

void updater(int v, int l, int r, int ql, int qr, int val) {
    pushr(v, l, r);
    if (ql >= r || l >= qr) return;
    if (ql <= l && qr <= r) {
        if (tr[v].mn >= val) {
            return;
        }
        if (tr[v].mx < val) {
            tr[v].upd = val;
            pushr(v, l, r);
            return;
        }
    }
    int mid = (l + r) / 2;
    updater(v * 2, l, mid, ql, qr, val);
    updater(v * 2 + 1, mid, r, ql, qr, val);
    tr[v] = tr[v * 2] + tr[v * 2 + 1];
    return;
}

Node query(int v, int l, int r, int ql, int qr) {
    if (ql >= r || l >= qr) return Node();
    if (ql <= l && r <= qr) {
        return tb[v];
    }
    int mid = (l + r) / 2;
    return query(v * 2, l, mid, ql, qr) + query(v * 2 + 1, mid, r, ql, qr);
}

Node getans(int v, int l, int r, int ql, int qr) {
    pushl(v, l, r);
    pushr(v, l, r);
    if (l >= qr || ql >= r) return Node();
    if (ql <= l && r <= qr) {
        if (tl[v].mn >= tr[v].mx) {
            return tr[v];
        }
        if (tr[v].mn >= tl[v].mx) {
            return tl[v];
        }
    }
    int mid = (l + r) / 2;
    return getans(v * 2, l, mid, ql, qr) + getans(v * 2 + 1, mid, r, ql, qr);
}

void solve() {
    int n;
    cin >> n;
    orset ab;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        ab.insert({i, i + 1});
    }
    build(1, 0, n);
    for (int i = 0; i < n - 1; i++) {
        int kj;
        cin >> kj; kj--;
        pair<int, int> fst = *ab.find_by_order(kj);
        pair<int, int> scnd = *ab.find_by_order(kj + 1);

        Node lmax = query(1, 0, n, fst.first, fst.second), rmax = query(1, 0, n, fst.first, fst.second);
        updatel(1, 0, n, fst.first, fst.second, rmax.mx);
        updater(1, 0, n, scnd.first, scnd.second, lmax.mx);

        Node ans = getans(1, 0, n, fst.first, scnd.second);
        cout << ans.x - lmax.x - rmax.x << '\n';
        ab.erase(fst);
        ab.erase(scnd);
        ab.insert({fst.first, scnd.second});
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    solve();
}
