#include <iostream>
#include <chrono>
#include <climits>
#include <vector>
#include <algorithm>
#include <string>

#pragma GCC optimeze("O3")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

ull ans = 0;

int find_first_ind(string &t, char s) {
    int n = t.size();
    int ind = 0;
    bool flag = false;
    for (ind = 0; ind < n; ++ind) {
        if (t[ind] >= s or flag) break;
        else if (t[ind] > 1) flag = true;
        else if (t[ind] < 1 and not flag) return n;
    }
    for (int i = ind + 1; i < n; ++i) {
        if (t[i] > 1) break;
        else if (t[i] < 1) {
            ind += 1;
            break;
        }
    }
    return ind;
}

ull count(int n) {
    ans = 0;
    for (int i = 1; i <= n; ++i) {
        ans += 4 * i;
    }
    return ans;
}

ull solve(string &t) {
    int n = t.size();
    ull ans = count(n - 1);
    int ind2, ind3, ind5, ind7;
    ind2 = find_first_ind(t, '2');
    ans += n - ind2;
    ind3 = find_first_ind(t, '3');
    ans += n - ind3;
    ind5 = find_first_ind(t, '5');
    ans += n - ind5;
    ind7 = find_first_ind(t, '7');
    ans += n - ind7;
    return ans;
}

bool check(string &t) {
    int ind = 0, n = t.size();
    bool flag = false;
    for (ind = 0; ind < n; ++ind) {
        if (t[ind] != 1) flag = true;
        if (flag) break;
    }
    if (not flag) return false;
    if (not(t[ind] == '2' or t[ind] == '3' or t[ind] == '5' or t[ind] == '7')) return false;
    for (int i = ind + 1; i < n; ++i) {
        if (t[i] != 1) return false;
    }
    return true;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    string l, r;
    cin >> l >> r;

    cout << solve(r) - solve(l) + check(l) << endl;

    return 0;
}
