#include <iostream>
#include <chrono>
#include <climits>
#include <vector>
#include <algorithm>
#include <string>
#include <random>

#pragma GCC optimeze("O3")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

int find_first_ind(string &t, char s) {
    int n = t.size();
    int ind = 0;
    bool flag = false;
    for (ind = 0; ind < n; ++ind) {
        if (t[ind] >= s or flag) break;
        else if (t[ind] > '1') flag = true;
        else if (t[ind] < '1' and not flag) return n;
    }
    if (t[ind] == s and not flag) {
        for (int i = ind + 1; i < n; ++i) {
            if (t[i] > '1') break;
            else if (t[i] < '1') {
                ind += 1;
                break;
            }
        }
    }
    return ind;
}

ull count(int n) {
    ull ans = 0;
    for (int i = 1; i <= n; ++i) {
        ans += 4 * i;
    }
    return ans;
}

ull solve(string &t) {
    int n = t.size();
    ull ans = count(n - 1);
    int ind2, ind3, ind5, ind7;
    ind2 = find_first_ind(t, '2');
    ans += n - ind2;
    ind3 = find_first_ind(t, '3');
    ans += n - ind3;
    ind5 = find_first_ind(t, '5');
    ans += n - ind5;
    ind7 = find_first_ind(t, '7');
    ans += n - ind7;
    return ans;
}

bool check(string &t) {
    int ind = 0, n = t.size();
    bool flag = false;
    for (ind = 0; ind < n; ++ind) {
        if (t[ind] != '1') flag = true;
        if (flag) break;
    }
    if (not flag) return false;
    if (not(t[ind] == '2' or t[ind] == '3' or t[ind] == '5' or t[ind] == '7')) return false;
    for (int i = ind + 1; i < n; ++i) {
        if (t[i] != '1') return false;
    }
    return true;
}

//ull stupid_solve(ull l, ull r) {
//    ull cnt = 0;
//    for (ull i = l; i <= r; ++i) {
//        ull tmp = i, ans = 1;
//        while (tmp > 0) {
//            ans *= tmp % 10;
//            tmp /= 10;
//        }
//        if (ans == 2 or ans == 3 or ans == 5 or ans == 7 or ans == 11) cnt++;
//    }
//    return cnt;
//}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

//    bool flag = true;
//    string l_s, r_s;
//    ull l, r;
//    while (flag) {
//        l = rnd() % 10000000, r = rnd() % 10000000;
//        if (l > r) swap(l, r);
//        l_s = to_string(l), r_s = to_string(r);
//        cout << solve(r_s) - solve(l_s) + check(l_s) << ' ' << stupid_solve(l, r) << endl;
//        if (solve(r_s) - solve(l_s) + check(l_s) != stupid_solve(l, r)) flag = false;
//    }
//    cout << l_s << ' ' << r_s << endl;
//    cout << solve(r_s) - solve(l_s) + check(l_s) << ' ' << stupid_solve(l, r);

    string l, r;
    cin >> l >> r;
    cout << solve(r) - solve(l) + check(l) << endl;

    return 0;
}
