#include <iostream>
#include <algorithm>
#include <climits>
#include <vector>
#include <chrono>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef tree<
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update> ordered_set;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, k;
    cin >> n >> k;
    vector<int> vec(n), pref_min(n + 1, INT_MAX), suf_min(n + 1, INT_MAX);
    vector<ll> sum(n + 1, 0);
    for (int i = 0; i < n; i++) {
        cin >> vec[i];
        pref_min[i + 1] = min(pref_min[i], vec[i]);
        sum[i + 1] = sum[i] + vec[i];
    }
    for (int i = n - 1; i >= 0; i--) suf_min[i] = min(vec[i], suf_min[i + 1]);
    ll ans = 0;
    int d = n - k;
    for (int i = 0; i + d < n; i++) ans = max(ans, sum[i + d + 1] - sum[i] - min(pref_min[i], suf_min[i + d + 1]));
    if (k != 2) {
        for (int i = 0; i < n; i++) {
            ll tmp_max = 0;
            if (i <= d + 1) tmp_max = sum[i];
            if (i >= n - d - 2) tmp_max = max(tmp_max, sum[n] - sum[i + 1]);
            for (int j = 0; j + d < i; j++) tmp_max = max(tmp_max, sum[j + d + 1] - sum[j]);
            for (int j = n - d - 1; j > i; j--) tmp_max = max(tmp_max, sum[j + d + 1] - sum[j]);
            ans = max(ans, tmp_max - vec[i]);
        }
    }
    cout << ans;
    return 0;
}
