#include <iostream>
#include <algorithm>
#include <climits>
#include <vector>
#include <chrono>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef tree<
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update> ordered_set;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, k;
    cin >> n >> k;
    vector<int> vec(n), pref_min(n + 1, INT_MAX), suf_min(n + 1, INT_MAX);
    vector<ll> sum(n + 1, 0);
    for (int i = 0; i < n; i++) {
        cin >> vec[i];
        pref_min[i + 1] = min(pref_min[i], vec[i]);
        sum[i + 1] = sum[i] + vec[i];
    }
    for (int i = n - 1; i >= 0; i--) suf_min[i] = min(vec[i], suf_min[i + 1]);
    ll ans = 0;
    int d = n - k;
    for (int i = 0; i + d < n; i++) ans = max(ans, sum[i + d + 1] - sum[i] - min(pref_min[i], suf_min[i + d + 1]));
    if (k != 2) {
        vector<ll> pref_max(n + 1, 0), suf_max(n + 1, 0);
        ll tmp_sum = 0;
        for (int x = 0; x < n; x++) {
            tmp_sum += vec[x];
            if (x - d - 1 >= 0) tmp_sum -= vec[x - d - 1];
            pref_max[x + 1] = max(pref_max[x], tmp_sum);
        }
        tmp_sum = 0;
        for (int x = n - 1; x >= 0; x--) {
            tmp_sum += vec[x];
            if (x + d + 1 < n) tmp_sum -= vec[x + d + 1];
            suf_max[x] = max(suf_max[x + 1], tmp_sum);
        }
        for (int i = 0; i < n; i++) {
            ll tmp_max = max(pref_max[i], suf_max[i + 1]);
            ans = max(ans, tmp_max - vec[i]);
        }
    }
    cout << ans;
    return 0;
}
