#include <iostream>
#include <algorithm>
#include <climits>
#include <vector>
#include <chrono>
#include <cmath>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef tree<
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update> ordered_set;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, s;
    cin >> n >> s;
    vector<pair<int, pair<int, int>>> vec;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int c;
            cin >> c;
            vec.push_back({c, {i, j}});
        }
    }
    sort(vec.begin(), vec.end());
    int l = (int) vec.size();
    vector<bool> dp(s + 1, false);
    vector<pair<int, pair<int, int>>> prev(max(l + 1, s + 1), {-1, {-1, -1}});
    dp[0] = true;
    for (int i = 0; i < l; i++) {
        for (int j = s; j >= vec[i].first; j--) {
            if (not dp[j] and dp[j - vec[i].first]) {
                dp[j] = dp[j - vec[i].first];
                prev[j] = vec[i];
            }
        }
    }
    if (dp[s]) {
        cout << "Yes" << endl;
        vector<vector<int>> ans(n);
        pair<int, pair<int, int>> p = prev[s];
        int tmp_s = s;
        while (p.first != -1) {
            ans[p.second.first].push_back(p.second.second);
            tmp_s -= p.first;
            p = prev[tmp_s];
        }
        for (int i = 0; i < n; i++) {
            cout << ans[i].size() << endl;
            for (auto x: ans[i]) cout << x + 1 << ' ';
            cout << endl;
        }
    } else cout << "No" << endl;
    return 0;
}
