#include <iostream>
#include <algorithm>
#include <climits>
#include <vector>
#include <chrono>
#include <cmath>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef tree<
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update> ordered_set;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

vector<int> sum;

bool go(const vector<vector<int>> &can, int s, int ind, int n) {
    if (s < n - ind) return false;
    if (ind >= n) return s == 0;
    for (auto x: can[ind]) {
        sum[ind] = x;
        if (go(can, s - x, ind + 1, n)) return true;
    }
    return false;
}

vector<vector<int>>
check(const vector<vector<int>> &can, const vector<vector<int>> &prev, const vector<vector<int>> &vec, const int s) {
    int n = can.size();
    sum.resize(n);
    if (not go(can, s, 0, n)) return {};
    vector<vector<int>> ans(n);
    for (int i = 0; i < n; i++) {
        int p = prev[i][sum[i]];
        int tmp_s = sum[i];
        while (tmp_s > 0) {
            ans[i].push_back(p);
            tmp_s -= vec[i][p];
            p = prev[i][tmp_s];
        }
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, s;
    cin >> n >> s;
    vector<vector<int>> vec(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        vec[i].resize(k);
        for (int j = 0; j < k; j++) cin >> vec[i][j];
    }
    vector<vector<bool>> dp(n);
    vector<vector<int>> prev(n);
    vector<vector<int>> can(n);
    for (int x = 0; x < n; x++) {
        ll cur_s = 0;
        for (auto t: vec[x]) if (t <= s) cur_s += t;
        cur_s = min(cur_s, s * 1ll);
        dp[x].resize(cur_s + 1);
        prev[x].resize(cur_s + 1);
        dp[x][0] = true;
        for (int i = 0; i < vec[x].size(); i++) {
            for (int j = cur_s; j >= vec[x][i]; j--) {
                if (not dp[x][j] and dp[x][j - vec[x][i]]) {
                    dp[x][j] = dp[x][j - vec[x][i]];
                    prev[x][j] = i;
                    can[x].push_back(j);
                }
            }
        }
        sort(can[x].begin(), can[x].end());
    }
    auto ans = check(can, prev, vec, s);
    if (ans.size() > 0) {
        cout << "Yes" << endl;
        for (int i = 0; i < n; i++) {
            cout << ans[i].size() << endl;
            for (auto x: ans[i]) cout << x + 1 << ' ';
            cout << endl;
        }
    } else cout << "No" << endl;
    return 0;
}
