#include <iostream>
#include <algorithm>
#include <climits>
#include <vector>
#include <chrono>
#include <cmath>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef tree<
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update> ordered_set;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

constexpr ll MOD = 1e9 + 7;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m, k;
    cin >> n >> m >> k;

    vector<pair<int, int>> coord(k);
    for (int i = 0; i < k; i++) cin >> coord[i].first >> coord[i].second;
    sort(coord.begin(), coord.end());
    ll ans = 0;
    ll sum = 0;
    vector<int> cnt_f(m + 2, 0), cnt_s(m + 1, 0);
    for (auto [x, y]: coord) {
        if (x == 1) cnt_f[y]++;
    }
    for (int i = 1; i <= m; i++) cnt_s[i] += cnt_s[i];
    for (int i = m; i >= 0; i--) cnt_f[i] += cnt_f[i + 1];
    for (int i = 0; i <= m - 2; i++) {
        sum = cnt_s[i] + cnt_f[i + 3];
        if (sum == 0) ans = (ans + 2) % MOD;
    }
    cout << ans;
    return 0;
}
