#include <bits/stdc++.h>

using namespace std;

using ll = long long;

struct node{
    ll sum = 0;
    ll mod = -1;
};

const int inf = 1'000'000'000;
const int N = 100000;

struct segtree{
    node d[4 * N];
    void push(int u, int l, int r){
        if(d[u].mod != -1){
            if(l + 1 != r){
                d[u * 2 + 1].mod = d[u].mod;
                d[u * 2 + 2].mod = d[u].mod;
            }
            d[u].sum = d[u].mod * (r - l);
            d[u].mod = -1;
        }
    }
    vector<int> v;
    void build(int u, int l, int r){
        if(l + 1 == r){
            d[u].sum = v[l];
        }else{
            int m = (l + r) / 2;
            build(u * 2 + 1, l, m);
            build(u * 2 + 2, m, r);
            d[u].sum = d[u * 2 + 1].sum + d[u * 2 + 2].sum;
        }
    }
    ll get(int u, int l, int r, int ql, int qr){
        if((ql >= r) || (qr <= l)){
            return 0;
        }
        push(u, l, r);
        if((ql <= l) && (r <= qr)){
            return d[u].sum;
        }
        int m = (l + r) / 2;
        return get(u * 2 + 1, l, m, ql, qr) + get(u * 2 + 2, m, r, ql, qr);
    }
    ll gett(int u, int l, int r, int ind){
        push(u, l, r);
        if(l + 1 == r){
            return d[u].sum;
        }else{
            int m = (l + r) / 2;
            if(ind < m){
                return gett(u * 2 + 1, l, m, ind);
            }else{
                return gett(u * 2 + 2, m, r, ind);
            }
        }
    }
    void update(int u, int l, int r, int ql, int qr, int nv){
        if((ql >= r) || (qr <= l)){
            return;
        }
        push(u, l, r);
        if((ql <= l) && (r <= qr)){
            d[u].mod = nv;
            return;
        }
        int m = (l + r) / 2;
        update(u * 2 + 1, l, m, ql, qr, nv);
        update(u * 2 + 2, m, r, ql, qr, nv);
        push(u * 2 + 1, l, m);
        push(u * 2 + 2, m, r);
        d[u].sum = d[u * 2 + 1].sum + d[u * 2 + 2].sum;
    }
    void vivo(int u, int l, int r){
        push(u, l, r);
        if(l + 1 == r){
            cout << d[u].sum << " ";
        }else{
            int m = (l + r) / 2;
            vivo(u * 2 + 1, l, m);
            vivo(u * 2 + 2, m, r);
        }
        if(u == 0){
            cout << endl;
        }
    }
};

struct node2{
    int mx = 0;
    int mod = 0;
};

struct segtree2{
    node2 d[4 * N];
    void push(int u, int l, int r){
        if(d[u].mod != 0){
            if(l + 1 != r){
                d[u * 2 + 1].mod += d[u].mod;
                d[u * 2 + 2].mod += d[u].mod;
            }
            d[u].mx += d[u].mod;
            d[u].mod = 0;
        }
    }
    vector<int> v;
    void build(int u, int l, int r){
        if(l + 1 == r){
            d[u].mx = v[l];
        }else{
            int m = (l + r) / 2;
            build(u * 2 + 1, l, m);
            build(u * 2 + 2, m, r);
            d[u].mx = max(d[u * 2 + 1].mx, d[u * 2 + 2].mx);
        }
    }
    void update(int u, int l, int r, int ql, int qr, int nv){
        if((ql >= r) || (qr <= l)){
            return;
        }
        push(u, l, r);
        if((ql <= l) && (r <= qr)){
            d[u].mod += nv;
            return;
        }
        int m = (l + r) / 2;
        update(u * 2 + 1, l, m, ql, qr, nv);
        update(u * 2 + 2, m, r, ql, qr, nv);
        push(u * 2 + 1, l, m);
        push(u * 2 + 2, m, r);
        d[u].mx = max(d[u * 2 + 1].mx, d[u * 2 + 2].mx);
    }
    int get(int u, int l, int r, int k){
        push(u, l, r);
        if(l + 1 == r){
            if(d[u].mx == k){
                return l;
            }else{
                return r;
            }
        }else{
            int m = (l + r) / 2;
            push(u * 2 + 1, l, m);
            push(u * 2 + 2, m, r);
            if(d[u * 2 + 1].mx >= k){
                return get(u * 2 + 1, l, m, k);
            }else{
                return get(u * 2 + 2, m, r, k);
            }
        }
    }
    void vivo(int u, int l, int r){
        push(u, l, r);
        if(l + 1 == r){
            cout << d[u].mx << " ";
        }else{
            int m = (l + r) / 2;
            vivo(u * 2 + 1, l, m);
            vivo(u * 2 + 2, m, r);
        }
        if(u == 0){
            cout << endl;
        }
    }
};

segtree stl, str;
segtree2 ind;
vector<ll> p;

ll get(int l, int r){
    return p[r] - p[l];
}

void solve(){
    int n;
    cin >> n;
    vector<int> a(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    p.resize(n + 1);
    for(int i = 0; i < n; i++){
        p[i + 1] = p[i] + a[i];
    }
    stl.v = a;
    stl.build(0, 0, n);
    str.v = a;
    str.build(0, 0, n);
    ind.v.resize(n);
    for(int i = 0; i < n; i++){
        ind.v[i] = i;
    }
    ind.build(0, 0, n);
    for(int _ = 0; _ < n - 1; _++){
        int k;
        cin >> k;
        k--;
        int l1 = ind.get(0, 0, n, k);
        int r1 = ind.get(0, 0, n, k + 1);
        int r2 = ind.get(0, 0, n, k + 2);
        //cout << l1 << " " << r1 << " " << r2 << endl;
        int x = stl.gett(0, 0, n, r1 - 1);
        int l = r1 - 1, r = r2;
        while(l + 1 != r){
            int m = (l + r) / 2;
            if(stl.gett(0, 0, n, m) <= x){
                l = m;
            }else{
                r = m;
            }
        }
        stl.update(0, 0, n, r1, r, x);
        x = str.gett(0, 0, n, r1);
        l = l1 - 1, r = r1;
        while(l + 1 != r){
            int m = (l + r) / 2;
            if(str.gett(0, 0, n, m) <= x){
                r = m;
            }else{
                l = m;
            }
        }
        str.update(0, 0, n, r, r1, x);
        ind.update(0, 0, n, r1, n, -1);
        l = l1, r = r2;
        while(l + 1 != r){
            int m = (l + r) / 2;
            if(stl.gett(0, 0, n, m) <= str.gett(0, 0, n, m)){
                l = m;
            }else{
                r = m;
            }
        }
        //cout << "aaa " << l1 << " " << r << " " << r2 << endl;
        //cout << stl.get(0, 0, n, l1, r) << " " <<  str.get(0, 0, n, r, r2) << " " <<  get(l1, r2) << endl;
        ll ans = stl.get(0, 0, n, l1, r) + str.get(0, 0, n, r, r2) - get(l1, r2);
        cout << ans << endl;
        //stl.vivo(0, 0, n);
        //str.vivo(0, 0, n);
    }
}

int main(){
#ifdef lisie_bimbi    
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif    
    int t = 1;
    while(t--){
        solve();
    }
}