#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,bmi2,fma")

#ifndef lisie_bimbi
#define endl '\n'
#endif

using ll = long long;

const int mod = 1'000'000'007;

int add(int a, int b){
    if(a + b < mod){
        return a + b;
    }else{
        return (a + b - mod);
    }
}

int mul(int a, int b){
    return ((ll)a * b) % mod;
}

int sub(int a, int b){
    if(a >= b){
        return a - b;
    }else{
        return a - b + mod;
    }
}

int binpow(int a, int x){
    if(x == 0){
        return 1;
    }
    int ans = binpow(a, x / 2);
    ans = mul(ans, ans);
    if(x % 2 == 1){
        ans = mul(ans, a);
    }
    return ans;
}

int del(int a, int b){
    return mul(a, binpow(b, mod - 2));
}

bool cmp(pair<int, int> a, pair<int, int> b){
    if((a.first + a.second) != (b.first + b.second)){
        return ((a.first + a.second) < (b.first + b.second));
    }else{
        return (a.first < b.first);
    }
}

const int N = 2'000'010;

int fac[N];
int fac1[N];

int cnk(int n, int k){
    if((k > n) || (k < 0)){
        return 0;
    }
    return mul(fac[n], mul(fac1[k], fac1[n - k]));
}

int put(pair<int, int> a, pair<int, int> b){
    if(a == b){
        return 1;
    }
    if((b.first < a.first) || (b.second < a.second)){
        return 0;
    }
    return cnk(b.first - a.first + b.second - a.second, b.first - a.first);
}

bool check(pair<int, int> a, pair<int, int> b){
    if(a == b){
        return 1;
    }
    if((b.first < a.first) || (b.second < a.second)){
        return 0;
    }
    return 1;
}


int get(pair<int, int> a, pair<int, int> b, pair<int, int> c, pair<int, int> d){
    if(check(a, b) && check(c, d)){
        return sub(mul(put(a, b), put(c, d)), mul(put(a, d), put(c, b)));
    }else{
        return 0;
    }
}

int get2(pair<int, int> a, pair<int, int> b, pair<int, int> c, pair<int, int> d, pair<int, int> e){
    if((check(a, e) && check(e, b)) || (check(c, e) && check(e, d))){
        int ans = sub(add(mul(put(c, d), mul(put(a, e), put(e, b))), mul(put(a, b), mul(put(c, e), put(e, d)))),
         mul(mul(put(a, e), put(e, b)), mul(put(c, e), put(e, d))));
        return ans;
    }else{
        return 0;
    }
}

int get1(pair<int, int> a, pair<int, int> b, pair<int, int> c, pair<int, int> d, pair<int, int> e){
    if((check(a, e) && check(e, b)) || (check(c, e) && check(e, d))){
        return sub(get2(a, b, c, d, e), get2(a, d, c, b, e));
    }else{
        return 0;
    }
}

ostream& operator<<(ostream &out, pair<int, int> a){
    cout << a.first << " " << a.second;
    return out;
}

void solve(){
    fac[0] = 1;
    for(int i = 1; i < N; i++){
        fac[i] = mul(fac[i - 1], i);
    }
    fac1[N - 1] = del(1, fac[N - 1]);
    for(int i = N - 2; i >= 0; i--){
        fac1[i] = mul(fac1[i + 1], i + 1);
    }
    int n, m, k;
    cin >> n >> m >> k;
    vector<pair<int, int>> z;
    for(int i = 0; i < k; i++){
        int x, y;
        cin >> x >> y;
        x--;y--;
        if((x == 0) && (y == 0)){
            continue;
        }
        if((x == 0) && (y == 1)){
            continue;
        }
        if((x == 1) && (y == 0)){
            continue;
        }
        if((x == n - 1) && (y == m - 1)){
            continue;
        }
        if((x == n - 2) && (y == m - 1)){
            continue;
        }
        if((x == n - 1) && (y == m - 2)){
            continue;
        }
        z.push_back({x, y});
    }
    z.push_back({0, 1});
    z.push_back({1, 0});
    z.push_back({n - 2, m - 1});
    z.push_back({n - 1, m - 2});
    sort(z.begin(), z.end(), cmp);
    k = z.size();
    vector<vector<int>> dp(k, vector<int>(k));
    dp[0][1] = 1;
    for(int i = 0; i < k; i++){
        for(int j = 0; j < k; j++){
            if((i == 0) && (j < 1)){
                continue;
            }
            if(i == j){
                continue;
            }
            if(i < j){
                if(j + 1 < k){
                    dp[j + 1][j] = add(dp[j + 1][j], mul(dp[i][j], put(z[i], z[j + 1])));
                    dp[i][j + 1] = add(dp[i][j + 1], mul(dp[i][j], put(z[j], z[j + 1])));
                }
            }else{
                if(i + 1 < k){
                    dp[i][i + 1] = add(dp[i][i + 1], mul(dp[i][j], put(z[j], z[i + 1])));
                    dp[i + 1][j] = add(dp[i + 1][j], mul(dp[i][j], put(z[i], z[i + 1])));
                }
            }
        }
    }
    int ans = sub(dp[k - 2][k - 1], dp[k - 1][k - 2]);
    cout << mul(ans, 2) << endl;
}

signed main(){
#ifdef lisie_bimbi    
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif    
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
    return 0;
}