#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,bmi2,fma")

#ifndef lisie_bimbi
#define endl '\n'
#endif

using ll = long long;


const int mod = 1'000'000'007;

int add(int a, int b){
    if(a + b < mod){
        return a + b;
    }else{
        return (a + b - mod);
    }
}

int mul(int a, int b){
    return ((ll)a * b) % mod;
}

int sub(int a, int b){
    if(a >= b){
        return a - b;
    }else{
        return a - b + mod;
    }
}

int binpow(int a, int x){
    if(x == 0){
        return 1;
    }
    int ans = binpow(a, x / 2);
    ans = mul(ans, ans);
    if(x % 2 == 1){
        ans = mul(ans, a);
    }
    return ans;
}

int del(int a, int b){
    return mul(a, binpow(b, mod - 2));
}

bool cmp(pair<int, int> a, pair<int, int> b){
    if((a.first + a.second) != (b.first + b.second)){
        return ((a.first + a.second) < (b.first + b.second));
    }else{
        return (a.first < b.first);
    }
}

const int N = 2'000'010;

int fac[N];

int cnk(int n, int k){
    if((k > n) || (k < 0)){
        return 0;
    }
    return del(fac[n], mul(fac[k], fac[n - k]));
}

int put(pair<int, int> a, pair<int, int> b){
    if(a == b){
        return 1;
    }
    if(!cmp(a, b)){
        return 0;
    }
    if((b.first < a.first) || (b.second < a.second)){
        return 0;
    }
    return cnk(b.first - a.first + b.second - a.second, b.first - a.first);
}


void solve(){
    fac[0] = 1;
    for(int i = 1; i < N; i++){
        fac[i] = mul(fac[i - 1], i);
    }
    int n, m, k;
    cin >> n >> m >> k;
    if(k == 0){
        int ans = mul(sub(mul(put({0, 1}, {n - 2, m - 1}), put({1, 0}, {n - 1, m - 2})), mul(put({0, 1}, {n - 1, m - 2}), put({1, 0}, {n - 2, m - 1}))), 2);
        cout << ans << endl;
        return;
    }
    vector<vector<int>> z(n + m + 1, vector<int>(n + m + 1));
    for(int i = 0; i < k; i++){
        int x, y;
        cin >> x >> y;
        x--;y--;
        z[x + y][x] = 1;
    }
    int now = 1;
    vector<vector<int>> d(n + m + 1, vector<int>(n + m + 1));
    d[0][1] = 1;
    auto d1 = d;
    for(; now < n - 1 + m - 1 - 1; ){
        vector<int> dd;
        now++;
        for(int i = 0; i < n + m + 1; i++){
            if(z[now][i]){
                dd.push_back(i);
            }
        }
        if(dd.size() > 2){
            cout << "0\n";
            return;
        }
        for(int i = 0; i < n + m + 1; i++){
            for(int j = i + 1; j < n + m + 1; j++){
                d1[i][j] = d[i][j];
                if(i > 0){
                    d1[i][j] = add(d1[i][j], d[i - 1][j]);
                }
                if(j > 0){
                    d1[i][j] = add(d1[i][j], d[i][j - 1]);
                }
                if((i > 0) && (j > 0)){
                    d1[i][j] = add(d1[i][j], d[i - 1][j - 1]);
                }
                for(auto t : dd){
                    if((i != t) && (j != t)){
                        d1[i][j] = 0;
                    }
                }
            }
        }
        swap(d, d1);
    }
    cout << add(d[n - 2][n - 1], d[n - 2][n - 1]) << endl;
}

signed main(){
#ifdef lisie_bimbi    
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif    
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
    return 0;
}