#include <algorithm>
#include <cstring>
#include <iostream>
#include <set>
#include <vector>

using namespace std;

using ll = long long;

int solve_corr(string _L, string _R) {
    int p = 1;
    int L = 0;
    for (int i = (int)_L.size() - 1; i >= 0; --i) {
        L += (_L[i] - '0') * p;
        p *= 10;
    }
    p = 1;
    int R = 0;
    for (int i = (int)_R.size() - 1; i >= 0; --i) {
        R += (_R[i] - '0') * p;
        p *= 10;
    }

    set<int> P = {2, 3, 5, 7};
    int ans = 0;
    for (int i = L; i <= R; ++i) {
        int cur = 1;
        int j = i;
        while (j > 0) {
            cur *= (j % 10);
            j /= 10;
        }
        if (P.count(cur)) {
            ++ans;
        }
    }
    return ans;
}

ll get(string _s) {
    string s = _s;
    if (s == "0") {
        return 0;
    }
    int n = (int)s.size();
    vector<vector<vector<ll>>> dp(n + 1, vector<vector<ll>>(2, {0, 0, 0}));
    set<int> P = {2, 3, 5, 7};

    int x0 = (s[0] - '0');
    if (x0 > 1) {
        ++dp[1][0][0];
    } else {
        ++dp[1][0][1];
    }
    for (int val : P) {
        if (x0 > val) {
            ++dp[1][1][0];
        } else if (x0 == val) {
            ++dp[1][1][1];
        } else {
            ++dp[1][1][2];
        }
    }

    for (int L = 1; L < n; ++L) {
        int x = (s[L] - '0');
        dp[L + 1][0][0] += dp[L][0][0];
        dp[L + 1][0][2] += dp[L][0][2];
        dp[L + 1][1][0] += dp[L][1][0];
        dp[L + 1][1][2] += dp[L][1][2];
        if (x > 1) {
            dp[L + 1][0][0] += dp[L][0][1];
            dp[L + 1][1][0] += dp[L][1][1];
        } else if (x == 1) {
            dp[L + 1][0][1] += dp[L][0][1];
            dp[L + 1][1][1] += dp[L][1][1];
        } else {
            dp[L + 1][0][2] += dp[L][0][1];
            dp[L + 1][1][2] += dp[L][1][1];
        }

        for (int val : P) {
            dp[L + 1][1][0] += dp[L][0][0];
            dp[L + 1][1][2] += dp[L][0][2];
            if (x > val) {
                dp[L + 1][1][0] += dp[L][0][1];
            } else if (x == val) {
                dp[L + 1][1][1] += dp[L][0][1];
            } else {
                dp[L + 1][1][2] += dp[L][0][1];
            }
        }
    }

    ll ans = 0;
    for (int L = 1; L <= n; ++L) {
        ans += dp[L][1][0] + dp[L][1][1];
        if (L < n) {
            ans += dp[L][1][2];
        }
    }

    return ans;
}

ll solve(string L, string R) {
    if (L == "1") {
        return get(R) - get("0");
    }
    string tL = L;
    for (int i = (int)L.size() - 1; i >= 0; --i) {
        int x = (L[i] - '0');
        if (x == 0) {
            tL[i] = '9';
        } else {
            tL[i] = (char)('0' + (x - 1));
            break;
        }
    }
    if (tL[0] == '0') {
        tL = tL.substr(1, (int)L.size() - 1);
    }
    return get(R) - get(tL);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cin.precision(30);
    cout.tie(nullptr), cout.precision(30);

    string L, R;
    cin >> L >> R;
    cout << solve(L, R) << endl;

    return 0;
}
