#include <algorithm>
#include <cstring>
#include <iostream>
#include <list>
#include <set>
#include <vector>

using namespace std;

using ll = long long;

int n;
vector<ll> a;
vector<int> q;

struct S {
    int L;
    int R;
    ll ans;
    S* Prev;
    S* Next;

    S() {
        L = -1;
        R = -1;
        ans = 0;
        Prev = nullptr;
        Next = nullptr;
    }

    S(int _L, int _R, ll _ans, S* _Prev, S* _Next) {
        L = _L;
        R = _R;
        ans = _ans;
        Prev = _Prev;
        Next = _Next;
    }
};

vector<ll> solve_corr() {
    vector<S> b;
    for (int i = 0; i < n; ++i) {
        if (i > 0) {
            b.push_back(S(i, i, 0, &b[i - 1], nullptr));
            b[i - 1].Next = &b[i];
        } else {
            b.push_back(S(i, i, 0, nullptr, nullptr));
        }
    }
    
    vector<ll> U;
    for (int k : q) {
        int L = b[k].L;
        int R = b[k + 1].R;
        S* Prev = b[k].Prev;
        S* Next = b[k + 1].Next;
        vector<ll> MaxPref(n + 1, 0), MaxSuff(n + 1, 0);
        for (int i = L; i <= R; ++i) {
            MaxPref[i + 1] = max(MaxPref[i], a[i]);
        }
        for (int i = R; i >= L; --i) {
            MaxSuff[i] = max(MaxSuff[i + 1], a[i]);
        }
        ll ans = 0;
        for (int i = L; i <= R; ++i) {
            ans += min(MaxPref[i + 1], MaxSuff[i]) - a[i];
        }
        b[k] = S(L, R, ans, Prev, Next);
        b.erase(b.begin() + k + 1);
        U.push_back(ans);
    }

    return U;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cin.precision(30);
    cout.tie(nullptr), cout.precision(30);

    cin >> n;
    a.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    q.assign(n - 1, 0);
    for (int iq = 0; iq < n - 1; ++iq) {
        cin >> q[iq];
        --q[iq];
    }

    vector<ll> ans = solve_corr();
    for (ll val : ans) {
        cout << val << endl;
    }

    return 0;
}
