#include <algorithm>
#include <cstring>
#include <iostream>
#include <list>
#include <map>
#include <set>
#include <unordered_map>
#include <vector>

using namespace std;

using ll = long long;

const int inf = 1000000007;

int n, k;
vector<int> a;

int solve_corr() {
    int ans = 0;
    for (int mask = 0; mask < (1 << (n * k)); ++mask) {
        bool ok = true;
        for (int i = 0; i < n && ok; ++i) {
            int cur = 0;
            for (int j = i; j >= max(i - k + 1, 0); --j) {
                for (int z = 0; z < k + j - i; ++z) {
                    cur += ((mask >> (j * k + z)) & 1);
                }
            }
            ok = ok && (cur == a[i]);
        }
        if (ok) {
            ++ans;
        }
    }
    return ans % inf;
}

int solve(int g) {
    if (k == 1) {
        return 1;
    }
    vector<vector<map<vector<int>, int>>> dp(n, vector<map<vector<int>, int>>(k * (k - 1) / 2 + 1));
    for (int mask = 0; mask < (1 << k); ++mask) {
        vector<int> cur_mask;
        int S_mask = 0;
        for (int i = 0; i < k; ++i) {
            int x = ((mask >> i) & 1);
            S_mask += x;
            cur_mask.push_back(S_mask);
        }
        cur_mask.pop_back();
        if (S_mask == a[0]) {
            ++dp[0][cur_mask.back()][cur_mask];
        }
    }
    for (int i = 1; i < n; ++i) {
        for (int mask = 0; mask < (1 << k); ++mask) {
            vector<int> cur_mask;
            int S_mask = 0;
            for (int i = 0; i < k; ++i) {
                int x = ((mask >> i) & 1);
                S_mask += x;
                cur_mask.push_back(S_mask);
            }
            cur_mask.pop_back();
            if (a[i] - S_mask < 0 || a[i] - S_mask > k * (k - 1) / 2) {
                continue;
            }
            for (pair<vector<int>, int> w : dp[i - 1][a[i] - S_mask]) {
                vector<int> cur = cur_mask;
                for (int i = 1; i < k - 1; ++i) {
                    cur[i] += w.first[i - 1];
                }
                dp[i][cur.back()][cur] = (dp[i][cur.back()][cur] + w.second) % inf;
            }
        }
    }
    /*for (auto x : dp[0]) {
        for (auto z : x.first) {
            cout << z << ' ';
        }
        cout << '|' << x.second << endl;
    }*/

    int ans = 0;
    for (auto w : dp[n - 1]) {
        for (auto z : w) {
            ans = (ans + z.second) % inf;
        }
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cin.precision(30);
    cout.tie(nullptr), cout.precision(30);

    cin >> n >> k;
    a.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int g;
    if (k <= 2) {
        g = 1;
    } else if (k <= 3) {
        g = 2;
    } else if (k <= 4) {
        g = 3;
    } else if (k <= 5) {
        g = 4;
    } else if (k <= 6) {
        g = 5;
    } else if (n * k <= 25) {
        g = 6;
    } else {
        g = 7;
    }

    cout << solve(g) << endl;

    return 0;
}
