#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

using ll = long long;

int n, s;
vector<vector<int>> a;

void solve_corr() {
    vector<vector<int>> dp(n, vector<int>(s + 1));
    vector<vector<int>> wdp(n, vector<int>(s + 1, -1));
    for (int i = 0; i < n; ++i) {
        dp[i][0] = 1;
        for (int j = 0; j < (int)a[i].size(); ++j) {
            vector<int> pr(s + 1);
            for (int c = 0; c <= s; ++c) {
                pr[c] = dp[i][c];
            }
            for (int c = 0; c <= s - a[i][j]; ++c) {
                if (pr[c]) {
                    dp[i][c + a[i][j]] = 1;
                    wdp[i][c + a[i][j]] = j;
                }
            }
        }
        dp[i][0] = 0;
    }
    
    vector<int> f(s + 1);
    vector<vector<int>> wf(n, vector<int>(s + 1, -1));
    for (int c = 0; c <= s; ++c) {
        f[c] = dp[0][c];
        wf[0][c] = c;
    }
    for (int i = 1; i < n; ++i) {
        vector<int> pr(s + 1);
        for (int c = 0; c <= s; ++c) {
            pr[c] = f[c];
        }
        f.assign(s + 1, 0);
        for (int c = 0; c <= s; ++c) {
            if (pr[c] == 0) {
                continue;
            }
            for (int cp = 0; cp <= s - c; ++cp) {
                if (dp[i][cp] == 0) {
                    continue;
                }
                f[c + cp] = 1;
                wf[i][c + cp] = cp;
            }
        }
    }

    if (f[s] == 0) {
        cout << "No" << endl;
        return;
    }

    cout << "Yes" << endl;
    vector<int> cost(n);
    int cur = s;
    for (int i = n - 1; i >= 0; --i) {
        cost[i] = wf[i][cur];
        cur -= wf[i][cur];
    }

    for (int i = 0; i < n; ++i) {
        cur = cost[i];
        vector<int> ans;
        while (cur > 0) {
            ans.push_back(wdp[i][cur]);
            cur -= a[i][wdp[i][cur]];
        }
        cout << (int)ans.size() << endl;
        for (int z : ans) {
            cout << (z + 1) << ' ';
        }
        cout << endl;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cin.precision(30);
    cout.tie(nullptr), cout.precision(30);

    cin >> n >> s;
    a.assign(n, vector<int>());
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        a[i].assign(k, 0);
        for (int j = 0; j < k; ++j) {
            cin >> a[i][j];
        }
    }

    solve_corr();

    return 0;
}
