#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

using ll = long long;

const ll inf = 1000000007;

ll n, m;
int k;
vector<pair<ll, ll>> a;

inline ll mod2(ll x, ll y) {
    return (x % y + y) % y;
}

inline ll div2(ll x, ll y) {
    return (x - mod2(x, y)) / y;
}

ll power_modp(ll a, ll n, ll p) {
    if (n == 0) {
        return mod2(1, p);
    } else if (n % 2 == 0) {
        ll x = power_modp(a, n / 2, p);
        return mod2(x * x, p);
    } else {
        ll x = power_modp(a, n / 2, p);
        return mod2(mod2(x * x, p) * a, p);
    }
}

// prime
ll invert_modp(ll a, ll p) {
    return power_modp(a, p - 2, p);
}

ll solve() {
    ll L = (n + m - 2);
    vector<int> F(L + 1, 1);
    for (ll i = 1; i <= L; ++i) {
        F[i] = mod2(F[i - 1] * i, inf);
    }
    
    if (k == 0) {
        return mod2(F[n + m - 2] * mod2(invert_modp(F[n - 1], inf) * invert_modp(F[m - 1], inf), inf), inf);
    }
/*
    if (k <= 16) {
        ll ans = 0;
        for (int mask = 0; mask < (1 << k); ++mask) {
            vector<int> 
        }
    }  */  

    return 0;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cin.precision(30);
    cout.tie(nullptr), cout.precision(30);

    cin >> n >> m >> k;
    a.assign(k, {0, 0});
    for (int i = 0; i < k; i++) {
        cin >> a[i].first >> a[i].second;
        --a[i].first, --a[i].second;
    }

    cout << solve() << endl;

    return 0;
}
