#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

using ll = long long;

const ll inf = 1000000007;

ll n, m;
int k;
vector<pair<ll, ll>> a;

inline ll mod2(ll x, ll y) {
    return (x % y + y) % y;
}

inline ll div2(ll x, ll y) {
    return (x - mod2(x, y)) / y;
}

ll power_modp(ll a, ll n, ll p) {
    if (n == 0) {
        return mod2(1, p);
    } else if (n % 2 == 0) {
        ll x = power_modp(a, n / 2, p);
        return mod2(x * x, p);
    } else {
        ll x = power_modp(a, n / 2, p);
        return mod2(mod2(x * x, p) * a, p);
    }
}

// prime
ll invert_modp(ll a, ll p) {
    return power_modp(a, p - 2, p);
}

void gen(int M, int len, vector<int>& cur, vector<vector<int>>& P) {
    if ((int)cur.size() == len) {
        P.push_back(cur);
        return;
    }
    int st = 0;
    if (!cur.empty()) {
        st = cur.back() + 1;
    }
    for (int last = st; last <= M + (int)cur.size() - len; ++last) {
        cur.push_back(last);
        gen(M, len, cur, P);
        cur.pop_back();
    }
}

ll solve_corr() {
    vector<int> cur;
    vector<vector<int>> P;
    gen(n + m - 2, n - 1, cur, P);

    ll ans = 0;
    for (vector<int>& F : P) {
        for (vector<int>& S : P) {
            vector<vector<int>> q(n, vector<int>(m));
            vector<int> moveF(n + m - 2), moveS(n + m - 2);
            for (int i = 0; i < n - 1; ++i) {
                moveF[F[i]] = 1;
                moveS[S[i]] = 1;
            }
            int x = 0, y = 0;
            for (int i = 0; i < n + m - 2; ++i) {
                ++q[x][y];
                if (moveF[i]) {
                    ++x;
                } else {
                    ++y;
                }
            }
            for (int i = 0; i < n + m - 2; ++i) {
                ++q[x][y];
                if (moveS[i]) {
                    --x;
                } else {
                    --y;
                }
            }
            int M = 0;
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    M = max(M, q[i][j]);
                }
            }
            if (M > 1) {
                continue;
            }
            bool ok = true;
            for (int i = 0; i < k; ++i) {
                ok = ok && (q[a[i].first][a[i].second]);
            }
            if (ok) {
                ++ans;
            }
        }
    }

    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cin.precision(30);
    cout.tie(nullptr), cout.precision(30);

    cin >> n >> m >> k;
    a.assign(k, {0, 0});
    for (int i = 0; i < k; i++) {
        cin >> a[i].first >> a[i].second;
        --a[i].first, --a[i].second;
    }

    cout << solve_corr() << endl;

    return 0;
}
