#include <iostream>
#include <vector>

using namespace std;
typedef long long ll;

// <<<<< FIRST SegTree

typedef ll T1;

T1 nothing1 = 0;
T1 no_act1 = -1;

T1 merge1(T1 a, T1 b) {
    return a + b;
}
T1 change1(T1 a, T1 e, int l, int r) {
    if (e == no_act1) return a;
    return e * (r - l);
}
T1 merge1_act(T1 a, T1 b) {
    if (b == no_act1) return a;
    return b;
}

struct SegTree1 {
    vector<T1> tree;
    vector<T1> act;

    SegTree1(vector<T1> &a) {
        tree.resize(4 * a.size(), nothing1);
        act.resize(4 * a.size(), no_act1);
        build(0, 0, a.size(), a);
    }

    void build(int v, int l, int r, vector<T1> &a) {
        if (l == r - 1) {
            tree[v] = a[l];
            return;
        }

        int m = (l + r) / 2;
        build(2 * v + 1, l, m, a);
        build(2 * v + 2, m, r, a);

        tree[v] = merge1(tree[2 * v + 1], tree[2 * v + 2]);
    }

    void push(int v, int l, int r) {
        int m = (l + r) / 2;
        tree[2 * v + 1] = change1(tree[2 * v + 1], act[v], l, m);
        tree[2 * v + 2] = change1(tree[2 * v + 2], act[v], m, r);
        act[2 * v + 1] = merge1_act(act[2 * v + 1], act[v]);
        act[2 * v + 2] = merge1_act(act[2 * v + 2], act[v]);
        act[v] = no_act1;
    }

    T1 get(int v, int l, int r, int ql, int qr) {
        if (ql <= l && r <= qr) return tree[v];
        if (qr <= l || r <= ql) return nothing1;

        push(v, l, r);

        int m = (l + r) / 2;
        return merge1(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
    }

    void upd(int v, int l, int r, int ql, int qr, T1 e) {
        if (ql <= l && r <= qr) {
            tree[v] = change1(tree[v], e, l, r);
            act[v] = merge1_act(act[v], e);
            return;
        }
        if (qr <= l || r <= ql) return;

        push(v, l, r);

        int m = (l + r) / 2;
        upd(2 * v + 1, l, m, ql, qr, e);
        upd(2 * v + 2, m, r, ql, qr, e);

        tree[v] = merge1(tree[2 * v + 1], tree[2 * v + 2]);
    }
};

// FIRST SegTree >>>>>



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n; cin >> n;
    vector<ll> temp(n, 1);
    SegTree1 real(temp);
    vector<pair<int, int>> seg(n);
    vector<int> mx(n);
    vector<ll> h(n);
    for (auto &i : h) cin >> i;
    SegTree1 d(h);
    for (int i = 0; i < n; i++) {
        seg[i] = {i, i};
        mx[i] = i;
    }
    vector<ll> pref(n+1);
    pref[0] = 0;
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + h[i];
    }

    auto index = [&] (int k) {
        for (int i = 0; i < n; i++) {
            if (real.get(0, 0, n, 0, i) == k && real.get(0, 0, n, i, i + 1) == 1) return i;
        }
    };

    for (int i = 0; i < n - 1; i++) {
        int k; cin >> k; k--;
        int a = index(k), b = index(k + 1);
        if (h[mx[a]] >= h[mx[b]]) {
            for (int i = seg[a].second; i >= mx[a]; i--) {
                if (d.get(0, 0, n, i, i + 1) >= h[mx[b]]) {
                    d.upd(0, 0, n, i + 1, mx[b], h[mx[b]]);
                    break;
                }
            }
        } else {
            for (int i = seg[b].first; i <= mx[b]; i++) {
                if (d.get(0, 0, n, i, i + 1) >= h[mx[a]]) {
                    d.upd(0, 0, n, mx[a], i, h[mx[a]]);
                    break;
                }
            }
            mx[a] = mx[b];
        }
        ll s = pref[seg[b].second + 1] - pref[seg[a].first];
        // for (int i = seg[a].first; i <= seg[b].second; i++) s += h[i];

        cout << d.get(0, 0, n, seg[a].first, seg[b].second + 1) - s << '\n';

        real.upd(0, 0, n, b, b + 1, 0);
        seg[a].second = seg[b].second;
    }
}