﻿#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <bits/stdc++.h>

using namespace std;

#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"

using namespace __gnu_pbds;

#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

#define x first
#define y second
#define int long long

struct seg2 {
	int d, maxx, sz;

	seg2(int d, int maxx, int sz) : d(d), maxx(maxx), sz(sz) {

	}

	seg2() {
	}
};

vector<int> prefh;

int geth(int l, int r) {
	return prefh[r] - prefh[l];
}


struct SegTree {
	int n;
	vector<seg2> v;
	vector<int> push;

	seg2 merge(seg2 a, seg2 b) {
		return { a.d + b.d, max(a.maxx, b.maxx), a.sz + b.sz };
	}

	void pushh(int ind, int l, int r) {
		if (push[ind] == 0) {
			return;
		}
		if (l + 1 == r) {
			v[ind].d = push[ind] * v[ind].sz;
			v[ind].maxx = push[ind];
		}
		else {
			v[ind].d = push[ind] * v[ind].sz;
			v[ind].maxx = push[ind];
			push[2 * ind + 1] = push[ind];
			push[2 * ind + 2] = push[ind];
		}
		push[ind] = 0;
	}

	void build2(int ind, int l, int r) {
		if (l + 1 == r) {
			v[ind] = seg2(geth(l, r), geth(l, r), 1);
			return;
		}
		int mid = (l + r) / 2;
		build2(2 * ind + 1, l, mid);
		build2(2 * ind + 2, mid, r);
		v[ind] = merge(v[2 * ind + 1], v[2 * ind + 2]);
	}

	void build() {
		n = prefh.size() - 1;
		v.resize(n * 4);
		push.resize(n * 4, 0);

		build2(0, 0, n);
	}

	void updatemass(int ind, int ql, int qr, int zn, int l, int r) {
		pushh(ind, l, r);
		if (ql <= l && r <= qr && v[ind].maxx <= zn) {
			push[ind] = zn;
			pushh(ind, l, r);
			return;
		}
		if (r <= ql || qr <= l) {
			return;
		}
		int mid = (l + r) / 2;
		updatemass(2 * ind + 1, ql, qr, zn, l, mid);
		updatemass(2 * ind + 2, ql, qr, zn, mid, r);
		v[ind] = merge(v[2 * ind + 1], v[2 * ind + 2]);
	}

	seg2 getsum(int ind, int ql, int qr, int l, int r) {
		pushh(ind, l, r);
		if (ql <= l && r <= qr) {
			return v[ind];
		}
		if (r <= ql || qr <= l) {
			return { 0, 0, 0 };
		}
		int mid = (l + r) / 2;
		return merge(getsum(2 * ind + 1, ql, qr, l, mid), getsum(2 * ind + 2, ql, qr, mid, r));
	}
};

vector<int> lvl;

struct seg {
	int d, maxh, lmaxd, rmaxd, midd;
	pair<int, int> indh;

	seg(int d, int h, int ind) : d(d), maxh(h), indh(make_pair(ind, ind + 1)), lmaxd(0), rmaxd(0), midd(0) {

	}

	seg(int d, int h, pair<int, int> ind, int lmaxdd, int rmaxdd, int midd) : d(d), maxh(h), indh(ind), lmaxd(lmaxdd), rmaxd(rmaxdd), midd(midd) {

	}

	seg() {

	}
};

/*
	seg merge(seg a, seg b) {
		int maxh, lmaxd, rmaxd;
		pair<int, int> indh;
		int l = a.indh.y, r = b.indh.x;
		int d;
		int midd = 0;
		if (a.maxh > b.maxh) {
			maxh = a.maxh;
			midd = a.midd;
			indh = a.indh;
			lmaxd = a.lmaxd;
			rmaxd = max(b.maxh * (r - l) - geth(l, r), 0ll) +
				b.rmaxd + b.midd;
			d = lmaxd + rmaxd + midd;
		}
		else if (a.maxh < b.maxh) {
			maxh = b.maxh;
			midd = b.midd;
			indh = b.indh;
			lmaxd = max(a.maxh * (r - l) - geth(l, r), 0ll) +
				a.lmaxd + a.midd;
			rmaxd = b.rmaxd;
			d = lmaxd + rmaxd + midd;
		}else {
			maxh = a.maxh;
			indh = {a.indh.x, b.indh.y};

			lmaxd = a.lmaxd;
			rmaxd = b.rmaxd;
			midd = max((a.maxh * (r - l) - geth(l, r)), 0ll) + a.midd + b.midd;
			d = lmaxd + rmaxd + midd;
		}
		return { d, maxh, indh, lmaxd, rmaxd, midd };
	}*/


SegTree t;

seg merge(seg a, seg b) {
	int maxh, lmaxd, rmaxd;
	pair<int, int> indh;
	int l = a.indh.y, r = b.indh.x;
	int d;
	int midd = 0;
	int dob = 0;
	t.updatemass(0, l, r, min(a.maxh, b.maxh), 0, t.n);
	/*for (int i = l; i < r; i++) {
			if (lvl[i] < min(a.maxh, b.maxh)) {
				lvl[i] = min(a.maxh, b.maxh);
			}
		dob += lvl[i];
	}*/
	dob = t.getsum(0, l, r, 0, t.n).d;
	if (a.maxh > b.maxh) {
		maxh = a.maxh;
		midd = a.midd;
		indh = a.indh;
		lmaxd = a.lmaxd;
		rmaxd = dob - geth(l, r) +
			b.rmaxd + b.midd;
		d = lmaxd + rmaxd + midd;
	}
	else if (a.maxh < b.maxh) {
		maxh = b.maxh;
		midd = b.midd;
		indh = b.indh;
		lmaxd = dob - geth(l, r) +
			a.lmaxd + a.midd;
		rmaxd = b.rmaxd;
		d = lmaxd + rmaxd + midd;
	}
	else {
		maxh = a.maxh;
		indh = { a.indh.x, b.indh.y };

		lmaxd = a.lmaxd;
		rmaxd = b.rmaxd;
		midd = dob - geth(l, r) + a.midd + b.midd;
		d = lmaxd + rmaxd + midd;
	}
	return { d, maxh, indh, lmaxd, rmaxd, midd };
}

void solve() {
	int n;
	cin >> n;
	ordered_set os;
	prefh.resize(n + 1);
	lvl.resize(n);
	for (int i = 1; i <= n; i++) {
		cin >> prefh[i];
		lvl[i - 1] = prefh[i];
		prefh[i] += prefh[i - 1];
	}
	t.build();
	//vector<int> rgr(n);
	for (int i = 0; i < n; i++) {
		//rgr[i] = i + 1;
		os.insert(i);
	}
	//SegTree t;
	//t.build();
	vector<seg> segs(n);
	for (int i = 0; i < n; i++) {
		segs[i] = seg(0, geth(i, i + 1), i);
	}
	int a;
	for (int i = 0; i < n - 1; i++) {
		cin >> a; a--;
		int l = *os.find_by_order(a), r = *os.find_by_order(a + 1);
		//cout << l << ' ' << r << '\n';
		os.erase(r);
		//rgr[l] = rgr[r];
		segs[l] = merge(segs[l], segs[r]);
		//r = rgr[r];
		//seg tt = segs[l];
		cout << segs[l].d << '\n';
		//cout << tt.d << ' ' << tt.indh.x << ' ' << tt.indh.y << ' ' << tt.maxh << ' ' << tt.lmaxd << ' ' << tt.rmaxd << "\n\n";
		/*
		cout << l << ' ' << r << '\n';
		seg tt = t.getsum(0, l, r, 0, n);

		cout << t.getsum(0, l, r, 0, n).d << '\n';*/
	}

	//cin >> a;
}

signed main() {
	int _ = 1;
	//cin >> _;
	while (_--) {
		solve();
	}

}

/*
8
9 1 8 1 5 2 3 6
3 3 1 3 3 2 1

0
4
0
0
-1
13
16

10
5 4 3 2 3 5 5 6 5 4


6
5 5 1 2 5 5
2

3

2

1

1




*/
