﻿#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <bits/stdc++.h>

using namespace std;

#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"

using namespace __gnu_pbds;

#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

#define first x
#define second y
#define int long long

struct seg {
	int d, sz, maxh, indh, lmaxd, rmaxd;

	seg(int d, int sz, int h, int ind) : d(d), sz(sz), maxh(h), indh(ind), lmaxd(0), rmaxd(0) {

	}

	seg(int d, int sz, int h, int ind, int lmaxdd, int rmaxdd) : d(d), sz(sz), maxh(h), indh(ind), lmaxd(lmaxdd), rmaxd(rmaxdd) {

	}

	seg() {
	}
};

bool operator==(const seg a, const seg b) {
	if (a.d == -1 && b.d == -1) {
		return true;
	}
	return false;
}

vector<int> prefh;

int geth(int l, int r) {
	return prefh[r] - prefh[l];
}

seg merge(seg a, seg b) {
	if (a == seg(-1, -1, -1, -1)) {
		return b;
	}
	if (b == seg(-1, -1, -1, -1)) {
		return a;
	}
	int sz = a.sz + b.sz;
	int maxh, indh, lmaxd, rmaxd;
	int l = a.indh + 1, r = b.indh;
	int d;
	if (a.maxh >= b.maxh) {
		maxh = a.maxh;
		indh = a.indh;
		lmaxd = a.lmaxd;
		rmaxd = max(b.maxh * (r - l) - geth(l, r), 0ll) +
			b.rmaxd;
		d = lmaxd + rmaxd;
	}
	else {
		maxh = b.maxh;
		indh = b.indh;
		lmaxd = max(a.maxh * (r - l) - geth(l, r), 0ll) +
			a.lmaxd;
		rmaxd = b.rmaxd;
		d = lmaxd + rmaxd;
	}
	return { d, sz, maxh, indh, lmaxd, rmaxd };
}

struct SegTree {
	vector<seg> v;
	vector<int> push;



	/*void pushh(int ind, int l, int r) {
		if (push[ind] == 0) {
			return;
		}
		if (l + 1 == r) {
			v[ind].d = push[ind] * v[ind].sz - geth(l, r);
		}
		else {
			v[ind].d = push[ind] * v[ind].sz - geth(l, r);
			push[2 * ind + 1] = push[ind];
			push[2 * ind + 2] = push[ind];
		}
	}*/

	void build2(int ind, int l, int r) {
		if (l + 1 == r) {
			v[ind] = { 0, 1 , geth(l, r), l };
			return;
		}
		int mid = (l + r) / 2;
		build2(2 * ind + 1, l, mid);
		build2(2 * ind + 2, mid, r);
		v[ind] = merge(v[2 * ind + 1], v[2 * ind + 2]);
	}

	void build() {
		v.resize(prefh.size() * 4);
		push.resize(prefh.size() * 4);

		build2(0, 0, prefh.size() - 1);
	}

	/*void updatemass(int ind, int ql, int qr, int zn, int l, int r) {
		if (ql <= l && r <= qr) {
			push[ind] = zn;
			v[ind].d = v[ind].sz * zn;
			return;
		}
		if (r <= ql || qr <= l) {
			return;
		}
		int mid = (l + r) / 2;
		updatemass(2 * ind + 1, ql, qr, zn, l, mid);
		updatemass(2 * ind + 2, ql, qr, zn, mid, r);
		v[ind] = merge(v[2 * ind + 1], v[2 * ind + 2]);
	}*/

	seg getsum(int ind, int ql, int qr, int l, int r) {
		if (ql <= l && r <= qr) {
			return v[ind];
		}
		if (r <= ql || qr <= l) {
			return { -1, -1, -1, -1 };
		}
		int mid = (l + r) / 2;
		return merge(getsum(2 * ind + 1, ql, qr, l, mid), getsum(2 * ind + 2, ql, qr, mid, r));
	}
};

void solve() {
	int n;
	cin >> n;
	ordered_set os;
	prefh.resize(n + 1);
	for (int i = 1; i <= n; i++) {
		cin >> prefh[i];
		prefh[i] += prefh[i - 1];
	}
	//vector<int> rgr(n);
	for (int i = 0; i < n; i++) {
		//rgr[i] = i + 1;
		os.insert(i);
	}
	//SegTree t;
	//t.build();
	vector<seg> segs(n);
	for (int i = 0; i < n; i++) {
		segs[i] = seg(0, 1, geth(i, i + 1), i);
	}
	int a;
	for (int i = 0; i < n - 1; i++) {
		cin >> a; a--;
		int l = *os.find_by_order(a), r = *os.find_by_order(a + 1);
		os.erase(r);
		//rgr[l] = rgr[r];
		segs[l] = merge(segs[l], segs[r]);
		//r = rgr[r];
		cout << segs[l].d << '\n';
		/*
		cout << l << ' ' << r << '\n';
		seg tt = t.getsum(0, l, r, 0, n);
		cout << tt.d << ' ' << tt.sz << ' ' << tt.indh << ' ' << tt.maxh << ' ' << tt.lmaxd << ' ' << tt.rmaxd << '\n';
		cout << t.getsum(0, l, r, 0, n).d << '\n';*/
	}

	//cin >> a;
}

signed main() {
	int _ = 1;
	//cin >> _;
	while (_--) {
		solve();
	}

}

/*
8
9 1 8 1 5 2 3 6
3 3 1 3 3 2 1

0
4
0
0
-1
13
16




*/
