#include <iostream>
#include <cstdint>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_set>
#include <bitset>

using namespace std;

#define FAST ios::sync_with_stdio(0), cout.tie(0); cin.tie(0);
#define ll int64_t
#define int int64_t
#define endl '\n'

void solve();

int32_t main() {
    FAST;

    int64_t t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}

int n, m, k;
ll cnt = 0;

vector<vector<bool>> used;
vector<vector<bool>> g, g2;

bool ok(int x, int y) {
    return 1 <= x && x <= n && 1 <= y && y <= m;
}


bool check() {
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (g[i][j]) return false;
        }
    }
    return true;
}

void dfs2(int x, int y) {
    used[x][y] = true;
    g[x][y] = false;
    vector<pair<int, int>> dirs{{0, -1}, {-1, 0}};

    if (x == 1 && y == 1) {
        used[x][y] = false;

        if (check()) {
            cnt++;
        }

        cnt %= 1000000000 + 7;
        return;
    }
    
    used[1][1] = false;
    for (auto &[dx, dy] : dirs) {
        if (ok(x + dx, y + dy) && !used[x + dx][y + dy]) {
            dfs2(x + dx, y + dy);
        }
    }

    used[x][y] = false;
    if (g2[x][y]) g[x][y] = true;
}

void dfs1(int x, int y) {
    used[x][y] = true;
    g[x][y] = false;
    vector<pair<int, int>> dirs{{0, 1}, {1, 0}};

    if (x == n && y == m) {
        used[x][y] = false;
        dfs2(n, m);
        return;
    }

    for (auto &[dx, dy] : dirs) {
        if (ok(x + dx, y + dy)) {
            dfs1(x + dx, y + dy);
        }
    }

    used[x][y] = false;
    if (g2[x][y]) g[x][y] = true;
}

void solve() {
    cin >> n >> m >> k;

    if (k == 0) {
        vector<vector<ll>> dp(n, vector<ll>(m, 0));

        dp[0][0] = 1;
        for (ll i = 0; i < n; i++) {
            for (ll j = 0; j < m; j++) {
                if (i == 0 && j == 0) continue;
                if (i == 0) {
                    dp[i][j] = dp[i][j - 1];
                } else if (j == 0) {
                    dp[i][j] == dp[i - 1][j];
                } else {
                    dp[i][j] = dp[i - 1][j] + dp[i][j - 1];
                }
            }
        }

        cout << dp[n - 1][m - 1] * 2 % (1000000000 + 7) << endl;
        exit(0);
    }

    g.resize(n + 2, vector<bool>(m + 2, false));
    used.resize(n + 2, vector<bool>(m + 2, false));

    for (int i = 0; i < k; i++) {
        int x, y;
        cin >> x >> y;

        g[x][y] = true;
    }
    g2 = g;
    
    dfs1(1, 1);

    cout << cnt << endl;
}