#include <iostream>
#include <cstdint>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_set>
#include <bitset>

using namespace std;

#define FAST ios::sync_with_stdio(0), cout.tie(0); cin.tie(0);
#define ll int64_t
#define int int64_t
#define endl '\n'

void solve();

int32_t main() {
    FAST;

    int64_t t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}

int n, m, k;
ll cnt = 0;

bool ok(int x, int y) {
    return 1 <= x && x <= n && 1 <= y && y <= m;
}

vector<vector<bool>> used;
vector<vector<bool>> g;

bool check2(int x, int y) {
    for (int i = 1; i <= n; i++) {
        if (used[i][y + 1]) return false;
    }
    for (int j = 1; j <= m; j++) {
        if (used[x + 1][j]) return false;
    }
    return true;
}

void dfs2(int x, int y) {
    used[x][y] = false;
    vector<pair<int, int>> dirs{{0, -1}, {-1, 0}};
    auto used2 = used;

    if (x == 1 && y == 1) {
        cnt++;

        cnt %= 1000000000 + 7;
        return;
    }

    for (auto &[dx, dy] : dirs) {
        if (ok(x + dx, y + dy) && check2(x + dx, y + dy)) {
            dfs2(x + dx, y + dy);
        }
    }

    used = used2;
}

bool check1(int x, int y) {
    for (int i = 1; i <= n; i++) {
        if (used[i][y - 1]) return false;
    }
    for (int j = 1; j <= m; j++) {
        if (used[x - 1][j]) return false;
    }
    return true;
}

void dfs1(int x, int y) {
    used[x][y] = false;
    vector<pair<int, int>> dirs{{0, 1}, {1, 0}};
    auto used2 = used;

    if (x == n && y == m) {
        dfs2(n, m);
        return;
    }

    for (auto &[dx, dy] : dirs) {
        if (ok(x + dx, y + dy) && check1(x + dx, y + dy)) {
            dfs1(x + dx, y + dy);
        }
    }

    used = used2;
}

void solve() {
    cin >> n >> m >> k;

    used.resize(n + 2, vector<bool>(m + 2, false));
    g.resize(n + 2, vector<bool>(m + 2, false));

    for (int i = 0; i < k; i ++) {
        int x, y;
        cin >> x >> y;

        g[x][y] = true;
        used[x][y] = true;
    }
    
    dfs1(1, 1);

    cout << cnt / 10 << endl;
}