#include<bits/stdc++.h>
using namespace std;

using ll = long long;

int mod = 1e9 + 7;

int add(int a, int b) {
	return a + b >= mod ? a + b - mod : a + b;
}
int sub(int a, int b) {
	return a >= b ? a - b : a + mod - b;
}
int mul(int a, int b) {
	return 1ll * a * b % mod;
}
int inv(int x) {
	return x == 1 ? 1 : sub(0, mul(mod / x, inv(mod % x)));
}

const int N = 3e6;

int fact[N], ifact[N];

int C(int n, int k) {
	if (n < 0 || k < 0 || n < k) return 0;
	return mul(fact[n], mul(ifact[k], ifact[n - k]));
}

int catalan(int n) {
	return sub(C(2 * n, n), C(2 * n, n + 1));
}
int go(pair<int, int> start, pair<int, int> finish) {
	int dx = finish.first - start.first, dy = finish.second - start.second;
	return C(dx + dy, dx);
}

int main() {
	cin.tie(nullptr)->sync_with_stdio(false);

	fact[0] = 1;
	for (int i = 1; i < N; ++i) fact[i] = mul(i, fact[i - 1]);

	ifact[N - 1] = inv(fact[N - 1]);
	for (int i = N - 1; i; --i) ifact[i - 1] = mul(i, ifact[i]);

	int n, m, k;
	cin >> n >> m >> k;
	n--, m--;
	vector<pair<int, int>> pts(k);
	for (auto& [x, y] : pts) cin >> x >> y, --x, --y;
	pts.emplace_back(0, 0);
	pts.emplace_back(0, 1);
	sort(pts.begin(), pts.end());
	pts.resize(unique(pts.begin(), pts.end()) - pts.begin());
	vector<vector<int>> dp(pts.size(), vector<int>(pts.size(), 0));
	dp[0][1] = 1;
	for (int i = 2; i < pts.size(); ++i) {
		vector<pair<int, int>> xy;
		for (int j = 0; j < i - 1; ++j) xy.emplace_back(j, i - 1), xy.emplace_back(i - 1, j);
		for (auto& pt : xy) {
			auto [x, y] = pt;
			dp[i][y] = add(dp[i][y], mul(go(pts[x], pts[i]), dp[x][y]));
			dp[x][i] = add(dp[x][i], mul(go(pts[y], pts[i]), dp[x][y]));
		}
	}
	vector<pair<int, int>> xy;
	for (int j = 0; j < pts.size() - 1; ++j) xy.emplace_back(j, pts.size() - 1), xy.emplace_back(pts.size() - 1, j);
	int ret = 0;
	for (auto& pt : xy) {
		auto [x, y] = pt;
		ret = add(ret, mul(mul(go(pts[x], {n, m - 1}), go(pts[y], {n, m})), dp[x][y]));
		ret = sub(ret, mul(mul(go(pts[x], {n, m}), go(pts[y], {n, m - 1})), dp[x][y]));
	}
	cout << mul(2, ret);
}