#include<bits/stdc++.h>
using namespace std;

using ll = long long;

int mod = 1e9 + 7;

int add(int a, int b) {
	return a + b >= mod ? a + b - mod : a + b;
}
int sub(int a, int b) {
	return a >= b ? a - b : a + mod - b;
}
int mul(int a, int b) {
	return 1ll * a * b % mod;
}
int inv(int x) {
	return x == 1 ? 1 : sub(0, mul(mod / x, inv(mod % x)));
}

const int N = 3e6;

int fact[N], ifact[N];

int C(int n, int k) {
	if (n < 0 || k < 0 || n < k) return 0;
	return mul(fact[n], mul(ifact[k], ifact[n - k]));
}

int catalan(int n) {
	return sub(C(2 * n, n), C(2 * n, n + 1));
}
int go(pair<int, int> start, pair<int, int> finish) {
	int dx = finish.first - start.first, dy = finish.second - start.second;
	return C(dx + dy, dx);
}

int main() {
	cin.tie(nullptr)->sync_with_stdio(false);

	fact[0] = 1;
	for (int i = 1; i < N; ++i) fact[i] = mul(i, fact[i - 1]);

	ifact[N - 1] = inv(fact[N - 1]);
	for (int i = N - 1; i; --i) ifact[i - 1] = mul(i, ifact[i]);

	int n, m, k;
	cin >> n >> m >> k;
	n--, m--;
	if (k == 0) {
		cout << mul(2, sub(mul(C(n + m - 1, n), C(n + m - 1, n)), mul(C(n + m - 2, n), C(n + m, n))));
		return 0;
	}
	vector<pair<int, int>> pts(k);
	for (auto& [x, y] : pts) cin >> x >> y;
	pts.emplace_back(0, 0);
	pts.emplace_back(0, 1);
	sort(pts.begin(), pts.end());
	vector<vector<int>> dp(pts.size(), vector<int>(pts.size(), 0));
	dp[0][1] = 1;
	for (int i = 2; i < pts.size(); ++i) {
		for (int j = 0; j < i - 1; ++j) {
			dp[i][j] = add(dp[i][j], mul(go(pts[i - 1], pts[i]), dp[i - 1][j]));
			dp[j][i] = add(dp[j][i], mul(go(pts[i - 1], pts[i]), dp[j][i - 1]));
			dp[i][i - 1] = add(dp[i][i - 1], mul(go(pts[j], pts[i]), dp[j][i - 1]));
			dp[i - 1][i] = add(dp[i - 1][i], mul(go(pts[j], pts[i]), dp[i - 1][j]));
		}
	}
	int t1 = 0, t2 = 0;
	for (int i = 0; i < pts.size(); ++i) {
		int x = i, y = pts.size() - 1;
		int val = mul(mul(go(pts[x], {n, m - 1}), go(pts[y], {n, m})), dp[x][y]);
		t1 = add(t1, val);
	}
	for (int i = 0; i < pts.size(); ++i) {
		int x = pts.size() - 1, y = i;
		int val = mul(mul(go(pts[x], {n, m - 1}), go(pts[y], {n, m})), dp[x][y]);
		t1 = add(t1, val);
	}
	for (int i = 0; i < pts.size(); ++i) {
		int x = i, y = pts.size() - 1;
		int val = mul(mul(go(pts[x], {n, m}), go(pts[y], {n, m - 1})), dp[x][y]);
		t2 = add(t2, val);
	}
	for (int i = 0; i < pts.size(); ++i) {
		int x = pts.size() - 1, y = i;
		int val = mul(mul(go(pts[x], {n, m}), go(pts[y], {n, m - 1})), dp[x][y]);
		t2 = add(t2, val);
	}
	cout << sub(t1, t2);
}