﻿#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <algorithm>
#include <cmath>
#include <iomanip>

using namespace std;

//#define int long long

const int MOD = 1000'000'000 + 7;

const int MAXN = 200;
const int MAXMASK = (1ll << 16);

int dp[MAXN][MAXMASK];
int suf_dp[MAXN][MAXMASK];
int mask_sum[MAXMASK];

signed main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif


	int n, k;
	cin >> n >> k;

	vector<int> a(n, 0);

	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	int max_mask = (1ll << (k * k));


	for (int mask = 0; mask < max_mask; mask++) {
		vector<vector<int>> c(k, vector<int>(k));
		int sum = 0;
		for (int i1 = 0; i1 < k; i1++) {
			for (int i2 = 0; i2 < k; i2++) {
				c[i2][i1] = ((mask >> (k * i1 + i2)) & 1);
				sum += c[i2][i1] * (i1 >= i2);
			}
		}
		mask_sum[mask] = sum;
	}

	//vector<vector<int>> dp(n, vector<int>(max_mask, 0));
	//vector<vector<int>> suf_dp(n, vector<int>(max_mask, 0));

	for (int i = 0; i < n;i++) {
		for (int mask = 0; mask < max_mask; mask++) {
			bool valid = true;
			int sum = mask_sum[mask];
			if (i < k - 1) {
				for (int i1 = 0; i1 < k; i1++) {
					for (int i2 = 0; i2 < k; i2++) {
						if (((mask >> (k * i1 + i2)) & 1) && (i - k + 1 + i1) < 0) {
							valid = false;
						}
					}
				}
			}
			if (sum != a[i] || !valid) {
				continue;
			}
			int pref = (mask >> k);
			int suf = mask ^ ((mask >> (k * (k - 1))) << (k * (k - 1)));
			swap(pref, suf);
			//cout << "~~~~~" << endl;
			if (i != 0) {
				dp[i][mask] = suf_dp[i - 1][pref];
				//cout << suf_dp[i - 1][pref] << " " << pref << endl;
			}
			else {
				dp[i][mask] = 1;
			}
			suf_dp[i][suf] = (suf_dp[i][suf] + dp[i][mask]) % MOD;
			//cout << i << " " << mask << " " << dp[i][mask] << endl;
			//for (auto it: c) {
			//	for (auto tt: it) {
			//		cout << tt << " ";
			//	}
			//	cout << endl;
			//}
		}
	}

	int ans = 0;

	for (int mask = 0; mask < max_mask;mask++) {
		ans = (ans + dp[n - 1][mask]) % MOD;
	}

	cout << ans << endl;

}

