﻿#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <algorithm>
#include <cmath>
#include <iomanip>

using namespace std;

#define int long long

const int INF = 1e18;

struct Segtree {

	int n;
	vector<int> tree;

	Segtree(int _n) {
		n = _n;
		tree.resize(4 * n + 10, INF);
	}

	void set(int v, int l, int r, int pos, int x) {
		if (l > pos || r <= pos) {
			return;
		}
		if (r - l == 1) {
			tree[v] = min(tree[v], x);
			return;
		}
		int m = (l + r) / 2;
		if (pos < m) {
			set(2 * v + 1, l, m, pos, x);
		}
		else {
			set(2 * v + 2, m, r, pos, x);
		}
		tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
	}

	int get(int v, int l, int r, int ql, int qr) {
		if (l >= ql && r <= qr) {
			return tree[v];
		}
		if (l >= qr || r <= ql) {
			return INF;
		}
		int m = (l + r) / 2;
		return min(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
	}

};

int slv(int n, int k, vector<int> a) {
	vector<int> prefmin(n + 1, INF);
	vector<int> sufmin(n + 1, INF);

	for (int i = 0; i < n; i++) {
		prefmin[i + 1] = min(prefmin[i], a[i]);
	}

	for (int i = 0; i < n; i++) {
		sufmin[i + 1] = min(sufmin[i], a[n - i - 1]);
	}
	vector<int> pref(n + 1);
	for (int i = 0; i < n;i++) {
		pref[i + 1] = pref[i] + a[i];
	}

	int ans = 0;

	Segtree tree(n + 1);

	for (int i = 0; i < n;i++) {
		tree.set(0, 0, n + 1, i, pref[i] + prefmin[i]);
		int ost = n - i - 1;
		ans = max(ans, pref[i + 1] - tree.get(0, 0, n + 1, max(0ll, k - 1 - ost), n + 1));
	}

	return ans;

}

signed main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, k;
	cin >> n >> k;

	vector<int> a(n, 0);

	int sum = 0;

	for (int i = 0; i < n; i++) {
		cin >> a[i];
		sum += a[i];
	}

	if (k == 2) {
		cout << sum - 2 * min(a[0], a[n - 1]) << endl;
		return 0;
	}

	int ans = slv(n, k, a);
	reverse(a.begin(), a.end());
	ans = max(ans, slv(n, k, a));

	cout << ans << endl;

}

