﻿#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <algorithm>
#include <cmath>
#include <iomanip>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()

const int INF = 1e18;
const int MOD = 1000'000'007;


signed main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, m, k;
	cin >> n >> m >> k;

	vector<vector<int>> vert(m);

	for (int i = 0; i < k; i++) {
		int x, y;
		cin >> x >> y;
		x--;
		y--;
		vert[y].push_back(x);
	}

	for (int i = 0; i < m;i++) {
		sort(vert[i].begin(), vert[i].end());
	}

	vector<vector<vector<int>>> dp(m, vector<vector<int>>(n, vector<int>(n, 0)));

	for (int i = 1; i < n; i++) {
		if (!vert[0].size() || vert[0].back() <= i) {
			dp[0][0][i] = 1;
		}
	}

	for (int layer = 0; layer < m - 2; layer++) {
		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j < n; j++) {
				//cerr << layer << " " << i << " " << j << " " << dp[layer][i][j] << endl;
				if (dp[layer][i][j] == 0) {
					continue;
				}
				for (int i2 = i; i2 < j; i2++) {
					for (int j2 = j; j2 < n; j2++) {
						//cerr << layer << " " << i << " " << j << " " << i2 << " " << j2 << " " << lower_bound(all(vert[layer]), j) - upper_bound(all(vert[layer]), i2) << endl;
						if (lower_bound(all(vert[layer + 1]), j) - upper_bound(all(vert[layer + 1]), i2) > 0) {
							continue;
						}
						dp[layer + 1][i2][j2] = (dp[layer + 1][i2][j2] + dp[layer][i][j]) % MOD;
					}
				}
			}
		}
	}
	

	int ans = 0;

	for (int i = 0; i < n - 1;i++) {
		if (!vert[m - 1].size() || i <= vert[m - 1][0]) {
			ans = (ans + dp[m - 2][i][n - 1]) % MOD;
		}
	}

	cout << (ans * 2) % MOD << endl;

}

