#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e18 + 123;
const int maxN = 1e5 + 3;

vector <int> h(maxN);

struct Node
{
    int sum;
    int mx;
    int push;
};

Node comb(Node a, Node b)
{
    return {a.sum+b.sum, max(a.mx, b.mx), 0};
}

vector <Node> tree(4*maxN);

void init(int i, int l, int r)
{
    if (r-l == 1)
    {
        tree[i] = {h[l], h[l], 0LL};
        return;
    }
    int mid = (l + r) / 2;
    init(i*2+1, l, mid);
    init(i*2+2, mid, r);
    tree[i] = comb(tree[i*2+1], tree[i*2+2]);
}

void push(int i, int l, int r)
{
    if (r-l == 1) return;
    if (tree[i].push)
    {
        int mid = (l + r) / 2;
        tree[i*2+1] = {tree[i].push*(mid-l), tree[i].push, tree[i].push};
        tree[i*2+2] = {tree[i].push*(r-mid), tree[i].push, tree[i].push};
        tree[i].push = 0;
    }
    return;
}

void upd(int i, int l, int r, int ql, int qr, int k)
{
    if (ql >= r || qr <= l) return;
    if (r-l == 1)
    {
        tree[i].sum = k;
        tree[i].mx = k;
        return;
    }
    if (ql <= l && qr >= r)
    {
        tree[i].sum = k*(r-l);
        tree[i].mx = k;
        tree[i].push = k;
        return;
    }
    int mid = (l + r) / 2;
    push(i, l, r);
    upd(i*2+1, l, mid, ql, qr, k);
    upd(i*2+2, mid, r, ql, qr, k);
    return;
}

int get_sum(int i, int l, int r, int ql, int qr)
{
    if (ql >= r || qr <= l) return 0;
    if (r-l == 1)
    {
        return tree[i].sum;
    }
    if (ql <= l && qr >= r) return tree[i].sum;
    int mid = (l + r) / 2;
    push(i, l, r);
    int a = get_sum(i*2+1, l, mid, ql, qr);
    int b = get_sum(i*2+2, mid, r, ql, qr);
    return a+b;
}

int get_max(int i, int l, int r, int ql, int qr)
{
    if (ql >= r || qr <= l) return 0;
    if (r-l == 1)
    {
        return tree[i].mx;
    }
    if (ql <= l && qr >= r) return tree[i].mx;
    int mid = (l + r) / 2;
    push(i, l, r);
    int a = get_max(i*2+1, l, mid, ql, qr);
    int b = get_max(i*2+2, mid, r, ql, qr);
    return a+b;
}

struct seg
{
    int l;
    int r;
    int maxL;
    int maxR;
    int wL;
    int wM;
    int wR;
};

void solve()
{
    int n;
    cin >> n;
    vector <int> k(n-1);
    vector <seg> s;
    for (int i=0; i<n; i++)
    {
        cin >> h[i];
        s.push_back({i, i, i, i, 0, 0});
    }
    for (int i=0; i<n-1; i++)
    {
        cin >> k[i];
        k[i]--;
    }
    init(0, 0, n);

    for (int i=0; i<n-1; i++)
    {
        seg left = s[k[i]], right = s[k[i]+1];
        int left_mx = h[left.maxR], right_mx = h[right.maxL];
        int l = left.maxR + 1, r = right.maxL;
        if (left_mx == right_mx)
        {
            int w = (r-l) * left_mx - get_sum(0LL, 0LL, n, l, r);
            cout << left.wL + left.wM + w + right.wM + right.wR << '\n';
            left.maxR = r;
            left.r = right.r;
            left.wM += w + right.wM;
            left.wR = right.wR;
            vector<seg>::iterator it = s.begin() + k[i]+1;
            s.erase(it);
            s[k[i]] = left;
        }
        else if (left_mx > right_mx)
        {
            int ind = left.r;
            while (h[ind] < right_mx) ind--;
            ind++;
            int w = (r-ind) * right_mx - get_sum(0LL, 0LL, n, ind, r);
            cout << left.wL + left.wM + w + right.wM + right.wR << '\n';
            left.r = right.r;
            left.wR = w + right.wM + right.wR;
            vector<seg>::iterator it = s.begin() + k[i]+1;
            s.erase(it);
            s[k[i]] = left;
        }
        else
        {
            int ind = right.l;
            while (h[ind] < left_mx) ind++;
            int w = (ind-l) * right_mx - get_sum(0LL, 0LL, n, l, ind);
            cout << left.wL + left.wM + w + right.wM + right.wR << '\n';
            left.maxL = right.maxL;
            left.maxR = right.maxR;
            left.r = right.r;
            left.wL += left.wM + w;
            left.wM = right.wM;
            left.wR = right.wR;
            vector<seg>::iterator it = s.begin() + k[i]+1;
            s.erase(it);
            s[k[i]] = left;
        }
    }

    return;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tests = 1;

    for (int i=0; i<tests; i++)
    {
        solve();
        cout << '\n';
    }

    return 0;
}
