
#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e18 + 123;
const int maxN = 1e5 + 3;

vector <int> h(maxN);

struct Node
{
    int sum;
    int push;
};

Node comb(Node a, Node b)
{
    return {a.sum+b.sum, 0};
}

vector <Node> tree(4*maxN);
vector <Node> tree0(4*maxN);

void init(int i, int l, int r)
{
    if (r-l == 1)
    {
        tree[i] = {h[l], 0LL};
        return;
    }
    int mid = (l + r) / 2;
    init(i*2+1, l, mid);
    init(i*2+2, mid, r);
    tree[i] = comb(tree[i*2+1], tree[i*2+2]);
    if (i == 0) tree0 = tree;
}

void push(int i, int l, int r)
{
    if (r-l == 1) return;
    if (tree[i].push)
    {
        int mid = (l + r) / 2;
        tree[i*2+1] = {tree[i].push*(mid-l), tree[i].push};
        tree[i*2+2] = {tree[i].push*(r-mid), tree[i].push};
        tree[i].push = 0;
    }
    return;
}

void upd(int i, int l, int r, int ql, int qr, int k)
{
    if (ql >= r || qr <= l) return;
    if (r-l == 1)
    {
        tree[i].sum = k;
        return;
    }
    if (ql <= l && qr >= r)
    {
        tree[i].sum = k*(r-l);
        tree[i].push = k;
        return;
    }
    int mid = (l + r) / 2;
    push(i, l, r);
    upd(i*2+1, l, mid, ql, qr, k);
    upd(i*2+2, mid, r, ql, qr, k);
    tree[i] = comb(tree[i*2+1], tree[i*2+2]);
    return;
}

int get_sum(int i, int l, int r, int ql, int qr)
{
    if (ql >= r || qr <= l) return 0;
    if (r-l == 1)
    {
        return tree[i].sum;
    }
    if (ql <= l && qr >= r) return tree[i].sum;
    int mid = (l + r) / 2;
    push(i, l, r);
    int a = get_sum(i*2+1, l, mid, ql, qr);
    int b = get_sum(i*2+2, mid, r, ql, qr);
    return a+b;
}

int get_start_sum(int i, int l, int r, int ql, int qr)
{
    if (ql >= r || qr <= l) return 0;
    if (r-l == 1)
    {
        return tree0[i].sum;
    }
    if (ql <= l && qr >= r) return tree0[i].sum;
    int mid = (l + r) / 2;
    int a = get_start_sum(i*2+1, l, mid, ql, qr);
    int b = get_start_sum(i*2+2, mid, r, ql, qr);
    return a+b;
}

struct seg
{
    int l;
    int r;
    int maxL;
    int maxR;
};

void solve()
{
    int n;
    cin >> n;
    vector <int> k(n-1);
    vector <seg> s;
    for (int i=0; i<n; i++)
    {
        cin >> h[i];
        s.push_back({i, i, i, i});
    }
    for (int i=0; i<n-1; i++)
    {
        cin >> k[i];
        k[i]--;
    }
    init(0, 0, n);

    for (int i=0; i<n-1; i++)
    {
        seg left = s[k[i]], right = s[k[i]+1];
        int left_mx = h[left.maxR], right_mx = h[right.maxL];
        int l = left.maxR + 1, r = right.maxL;
        if (left_mx == right_mx)
        {
            upd(0LL, 0LL, n, l, r, left_mx);
            left.maxR = r;
            left.r = right.r;
        }
        else if (left_mx > right_mx)
        {
            int lg=l-1, rg=left.r+1;
            while (rg-lg > 1)
            {
                int mid = (lg + rg) / 2;
                int x = get_sum(0LL, 0LL, n, mid, mid+1);
                if (x >= right_mx)
                {
                    lg = mid;
                }
                else
                {
                    rg = mid;
                }
            }
            int ind = lg; ind++;
            upd(0LL, 0LL, n, ind, r, right_mx);
            left.r = right.r;
        }
        else
        {
            int lg=right.l-1, rg=r;
            while (rg-lg > 1)
            {
                int mid = (lg + rg) / 2;
                int x = get_sum(0LL, 0LL, n, mid, mid+1);
                if (x >= left_mx)
                {
                    rg = mid;
                }
                else
                {
                    lg = mid;
                }
            }
            int ind = rg; ind--;
            upd(0LL, 0LL, n, l, ind, left_mx);
            left.maxL = right.maxL;
            left.maxR = right.maxR;
            left.r = right.r;
        }
        cout << get_sum(0LL, 0LL, n, left.l, left.r+1) - get_start_sum(0LL, 0LL, n, left.l, left.r+1) << '\n';
        vector<seg>::iterator it = s.begin() + k[i]+1;
        s.erase(it);
        s[k[i]] = left;
    }

    return;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tests = 1;

    for (int i=0; i<tests; i++)
    {
        solve();
        cout << '\n';
    }

    return 0;
}
