#include <bits/stdc++.h>

using namespace std;

#define x first
#define y second

using ll = long long;

const int N = 100100;
ll pref[N];
int h[N];

ll get_sum(int l, int r) {
    return pref[r + 1] - pref[l];
}

struct node {
    ll ans;
    deque<pair<int, int>> stl, str;
};

node nd[N];

void merge(node &a, node &b) {
    int lev = min(a.str[0].x, b.stl[0].x);
    ll nwans = a.ans + b.ans;
    while (true) {
        // cout << a.str.size() << ' ' << b.stl.size() << '\n';
        if (a.str[0].x > b.stl[0].x) {
            if (b.stl.size() == 1) {
                break;
            }
            b.stl.pop_front();
            int nwlev = min(a.str[0].x, b.stl[0].x);
            nwans += 1ll * (nwlev - lev) * (b.stl[0].y - a.str[0].y - 1);
            lev = nwlev;
        } else {
            if (a.str.size() == 1) {
                break;
            }
            a.str.pop_front();
            int nwlev = min(a.str[0].x, b.stl[0].x);
            nwans += 1ll * (nwlev - lev) * (b.stl[0].y - a.str[0].y - 1);
            lev = nwlev;
        }
    }
    a.ans = nwans;
    if (a.str.back() > b.stl.back()) {
        if (a.str.size() < b.str.size()) {
            swap(a.str, b.str);
            for (int i = 0; i < b.str.size(); i++) {
                a.str.push_back(b.str[i]);
            }
        } else {
            for (int i = b.str.size() - 1; i >= 0; i--) {
                a.str.push_front(b.str[i]);
            }
        }
    } else {
        swap(a.str, b.str);
        if (a.stl.size() < b.stl.size()) {
            swap(a.stl, b.stl);
            for (int i = b.stl.size() - 1; i >= 0; i--) {
                a.stl.push_front(b.stl[i]);
            }
        } else {
            for (int i = 0; i < b.stl.size(); i++) {
                a.stl.push_back(b.stl[i]);
            }
        }
    }
}

struct segment_tree {
    vector<int> st;
    size_t sz;
    segment_tree(int n) {
        sz = 1;
        while (sz < n) {
            sz <<= 1;
        }
        st.resize(2 * sz, 0);
    }
    void add(int i, int v) {
        i += sz;
        while (i) {
            st[i] += v;
            i >>= 1;
        }
    }
    int get(int l, int r) {
        l += sz; r += sz;
        int res = 0;
        while (l <= r) {
            if (l & 1) {
                res += st[l++];
            }
            if (~r & 1) {
                res += st[r--];
            }
            l >>= 1;
            r >>= 1;
        }
        return res;
    }
};

int32_t main() {
    int n;
    cin >> n;
    pref[0] = 0;
    for (int i = 0; i < n; i++) {
        cin >> h[i];
        pref[i + 1] = pref[i] + h[i];
        nd[i].ans = 0;
        nd[i].str.emplace_back(h[i], i);
        nd[i].stl.emplace_back(h[i], i);
    }
    segment_tree st(n);
    for (int i = 0; i < n; i++) {
        st.add(i, 1);
    }
    for (int _ = 0; _ < n - 1; _++) {
        int hh;
        cin >> hh;
        int i, j;
        {
            int l = 0, r = n - 1;
            while (l != r) {
                int mid = (r + l) / 2;
                if (st.get(0, mid) >= hh) {
                    r = mid;
                } else {
                    l = mid + 1;
                }
            }
            i = l;
        }
        {
            int l = 0, r = n - 1;
            while (l != r) {
                int mid = (r + l) / 2;
                if (st.get(0, mid) >= hh + 1) {
                    r = mid;
                } else {
                    l = mid + 1;
                }
            }
            j = l;
        }
        merge(nd[i], nd[j]);
        cout << nd[i].ans << '\n';
        st.add(j, -1);
    }
}