#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>

using namespace std;

#define int long long

vector<int> getPossible(vector<int>& aa, int sz, int s) {
    vector<vector<int>> dp(sz + 1, vector<int>(s + 1, 0));
    dp[0][0] = 1;
    for (int i = 1; i <= sz; i++) {
        dp[i] = dp[i - 1];
        for (int j = aa[i]; j <= s; j++) {
            if (dp[i - 1][j - aa[i]]) {
                dp[i][j] = 1;
            }
        }
    }
    vector<int> p;
    for (int i = 1; i <= s; i++) {
        if (dp[sz][i]) {
            p.push_back(i);
        }
    }
    return p;
}

vector<int> vosst(vector<int>& aa, int sz, int s, int w) {
    vector<vector<int>> dp(sz + 1, vector<int>(s + 1, 0));
    dp[0][0] = 1;
    for (int i = 1; i <= sz; i++) {
        dp[i] = dp[i - 1];
        for (int j = aa[i]; j <= s; j++) {
            if (dp[i - 1][j - aa[i]]) {
                dp[i][j] = 1;
            }
        }
    }
    for (int i = 1; i <= sz; i++) {
        if (dp[i][w]) {
            int x = i, y = w;
            vector<int> ans;
            while (y != 0) {
                if (dp[x - 1][y]) {
                    x--;
                } else if (dp[x - 1][y - aa[x]]) {
                    ans.push_back(x);
                    y -= aa[x];
                    x--;
                } else {
                    y--;
                }
            }
            reverse(ans.begin(), ans.end());
            return ans;
        }
    }
    return {};
}

void solve() {
    int n, s; cin >> n >> s;
    vector<vector<int>> a(n);
    int mnk = 1e9, sk = 0;
    for (int i = 0; i < n; i++) {
        int k; cin >> k;
        mnk = min(mnk, k);
        sk += k;
        a[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> a[i][j];
        }
    }
    if (sk <= 20) {
        vector<pair<int, int>> v;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < a[i].size(); j++) {
                v.push_back({i, j});
            }
        }
        for (int i = 1; i < (1 << sk); i++) {
            int curr = 0;
            for (int j = 0; j < sk; j++) {
                if ((i >> j) & 1) {
                    curr += a[v[j].first][v[j].second];
                }
            }
            if (s == curr) {
                vector<vector<int>> ans(n);
                for (int j = 0; j < sk; j++) {
                    if ((i >> j) & 1) {
                        ans[v[j].first].push_back(v[j].second + 1);
                    }
                }
                bool ok = true;
                for (int j = 0; j < n; j++) {
                    if (ans[j].size() == 0) {
                        ok = false;
                        break;
                    }
                }
                if (!ok) {
                    continue;
                }
                cout << "Yes" << '\n';
                for (int j = 0; j < n; j++) {
                    cout << ans[j].size() << '\n';
                    for (auto x : ans[j]) {
                        cout << x << ' ';
                    }
                    cout << '\n';
                }
                return;
            }
        }
        cout << "No";
        return;
    }
    if (n == 1) {
        int sz = a[0].size();
        vector<int> aa = {0};
        for (auto x : a[0]) {
            aa.push_back(x);
        }
        vector<vector<int>> dp(sz + 1, vector<int>(s + 1, 0));
        dp[0][0] = 1;
        for (int i = 1; i <= sz; i++) {
            dp[i] = dp[i - 1];
            for (int j = aa[i]; j <= s; j++) {
                if (dp[i - 1][j - aa[i]]) {
                    dp[i][j] = 1;
                }
            }
        }
        for (int i = 1; i <= sz; i++) {
            if (dp[i][s]) {
                int x = i, y = s;
                vector<int> ans;
                while (y != 0) {
                    if (dp[x - 1][y]) {
                        x--;
                    } else if (dp[x - 1][y - aa[x]]) {
                        ans.push_back(x);
                        y -= aa[x];
                        x--;
                    } else {
                        y--;
                    }
                }
                reverse(ans.begin(), ans.end());

                cout << "Yes" << '\n';
                cout << ans.size() << '\n';
                for (auto x : ans) {
                    cout << x << ' ';
                }
                return;
            }
        }
        cout << "No" << '\n';
        return;
    }
    if (n == 2) {
        vector<int> aa0 = {0}, aa1 = {0};
        for (auto x : a[0]) {
            aa0.push_back(x);
        }
        for (auto x : a[1]) {
            aa1.push_back(x);
        }
        vector<int> p1 = getPossible(aa0, aa0.size() - 1, s);
        vector<int> p2 = getPossible(aa1, aa1.size() - 1, s);
        
        map<int, int> mp;
        for (auto x : p1) {
            mp[x]++;
        }
        for (auto x : p2) {
            if (mp[s - x]) {
                vector<int> a1 = vosst(aa0, aa0.size() - 1, s, s - x);
                vector<int> a2 = vosst(aa1, aa1.size() - 1, s, x);

                cout << "Yes" << '\n';
                cout << a1.size() << '\n';
                for (auto q : a1) {
                    cout << q << ' ';
                }
                cout << '\n';
                cout << a2.size() << '\n';
                for (auto q : a2) {
                    cout << q << ' ';
                }
                return;
            }
        }
        cout << "No";
        return;
    }
    if (mnk == 1) {
        int curr = 0;
        for (int i = 0; i < n; i++) {
            curr += a[i][0];
        }
        if (s == curr) {
            cout << "Yes" << '\n';
            for (int i = 0; i < n; i++) {
                cout << 1 << '\n' << 1 << '\n';
            }
        } else {
            cout << "No" << '\n';
        }
        return;
    }
}

signed main() {
    cin.tie(0); cout.tie(0);
    // freopen("in.txt", "r", stdin); freopen("out.txt", "w", stdout);
    solve();
}