#include <iostream>
#include <vector>
#include <algorithm>
#define deb(x) cout << (#x) << ": " << x << "\n";

using namespace std;

using ll = long long;
using bll = __int128_t;

vector<vector<ll>> w;
vector<int> k;
vector<vector<bool>> dp;
vector<vector<bll>> ansm;
int n, s, row;

void rec_base(int ind, ll sum, bll mask) {
    if (ind == k[0]) {
        dp[0][sum] = true;
        ansm[0][sum] = mask;
        return;
    }
    if (sum + w[0][ind] <= s)
        rec_base(ind + 1, sum + w[0][ind], mask | (1 << ind));
    rec_base(ind + 1, sum, mask);
}

void rec(int j, ll sum, bll mask) {
    if (j == k[row]) {
        if (sum != 0) {
            for (int ss = sum + 1; ss <= s; ++ss) {
                dp[row][ss] = (dp[row][ss] || dp[row - 1][ss - sum]);
                if (dp[row][ss] && ansm[row][ss] == -1)
                    ansm[row][ss] = mask;
            }
        }
        return;
    }
    if (sum + w[row][j] <= s)
        rec(j + 1, sum + w[row][j], mask | (1 << j));
    rec(j + 1, sum, mask);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> s;
    w.resize(n);
    k.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> k[i];
        w[i].resize(k[i]);
        for (auto &j: w[i]) cin >> j;
        sort(w[i].begin(), w[i].end(), greater<ll>());
    }
    ansm.resize(n, vector<bll>(s + 1, -1));
    dp.resize(n, vector<bool>(s + 1, false));
    rec_base(0, 0, 0);
    dp[0][0] = false;
    for (row = 1; row < n; ++row)
        rec(0, 0, 0);
    
    if (!dp[n - 1][s]) {
        cout << "No\n";
        return 0;
    }

    cout << "Yes\n";
    vector<vector<int>> ans(n);
    int rr = n - 1;
    ll sum = s;
    for (; rr >= 0; --rr) {
        bll msk = ansm[rr][sum];
        for (int i = 0; i < k[rr]; ++i)
            if (msk & (1 << i)) {
                ans[rr].push_back(i);
                sum -= w[rr][i];
            }
    }
    for (auto &i: ans) {
        cout << i.size() << "\n";
        for (auto &j: i)
            cout << j + 1 << " ";
        cout << "\n";
    }
}