class SegmentTree:
    def __init__(self, arr, op=sum):
        self.arr = arr
        self.op = op
        self.tree = [None] * (len(self.arr) * 4)
        self.build(0, len(self.arr) - 1, 1)
    def build(self, start, end, node):
        if start == end:
            self.tree[node] = self.arr[start]
            return self.arr[start]
        mid = (start + end) // 2
        left = self.build(start, mid, node * 2)
        right = self.build(mid + 1, end, node * 2 + 1)
        self.tree[node] = self.op([left, right])
        return self.tree[node]
    def query(self, left, right):
        return self._query(0, len(self.arr) - 1, 1, left, right)
    def _query(self, start, end, node, left, right):
        if start >= left and right >= end:
            return self.tree[node]
        if end < left or right < start:
            return None
        mid = (start + end) // 2
        _left = self._query(start, mid, node * 2, left, right)
        _right = self._query(mid + 1, end, node * 2 + 1, left, right)
        if _left is None:
            return _right
        elif _right is None:
            return _left
        else:
            return self.op([_left, _right])
n, k = list(map(int, input().split()))
data = list(map(int, input().split()))
data_l = len(data)
line = n - k + 1
data_s = [0, data[0]]
tr_mi = SegmentTree(data, op=min)
for i in range(1, len(data)):
    data_s.append(data[i] + data_s[i])
def su(left, right, data):
    return data[right + 1] - data[left]
result = -1
if k != 2:
    for i in range(line, 0, -1):
        for j in range(n - i + 1):
            ma = su(j, j + i - 1, data_s)
            left = tr_mi.query(0, j)
            right = tr_mi.query(j + i, data_l - 1)
            #print(i, j, ma, left, right)
            if left is None:
                mi = right
            elif right is None:
                mi = left
            else:
                mi = min(left, right)
            if result < ma - mi:
                result = ma - mi
    print(result)
else:
    print(max(sum(data[1:]) - data[0], sum(data[:-1]) - data[-1]))















