class SegmentTree:
    def __init__(self, arr, op=sum):
        self.arr = arr
        self.op = op
        self.tree = [None] * (len(self.arr) * 4)
        self.build(0, len(self.arr) - 1, 1)
    def build(self, start, end, node):
        if start == end:
            self.tree[node] = self.arr[start]
            return self.arr[start]
        mid = (start + end) // 2
        left = self.build(start, mid, node * 2)
        right = self.build(mid + 1, end, node * 2 + 1)
        self.tree[node] = self.op([left, right])
        return self.tree[node]
    def query(self, left, right):
        return self._query(0, len(self.arr) - 1, 1, left, right)
    def _query(self, start, end, node, left, right):
        if start >= left and right >= end:
            return self.tree[node]
        if end < left or right < start:
            return None
        mid = (start + end) // 2
        _left = self._query(start, mid, node * 2, left, right)
        _right = self._query(mid + 1, end, node * 2 + 1, left, right)
        if _left is None:
            return _right
        elif _right is None:
            return _left
        else:
            return self.op([_left, _right])
n, k = list(map(int, input().split()))
data = list(map(int, input().split()))
data_l = len(data)
line = n - k + 1
data_s = [0, data[0]]
tr_mi = SegmentTree(data, op=min)
ui = data[0]
for i in range(1, len(data)):
    ui += data[i]
    data_s.append(ui)
def su(left, right, data):
    return data[right + 1] - data[left]
result = -1
if k != 2:
    if True:
        if n <= 300:
            all_data = []
            for i in range(1, line + 1):
                man = 0
                te = 0
                for j in range(n - i + 1):
                    temp = su(j, j + i - 1, data_s)
                    if temp > man:
                        man = temp
                        te = j
                left = tr_mi.query(0, te - 1)
                right = tr_mi.query(te + i, n - 1)
                if left is None:
                    mi = right
                elif right is None:
                    mi = left
                else:
                    mi = min(left, right)
                all_data.append(man - mi)
            print(max(all_data))
        else:
            if line >= 110:
                all_data = []
                for i in range(1, 2):
                    man = 0
                    te = 0
                    for j in range(n - i + 1):
                        temp = su(j, j + i - 1, data_s)
                        if temp > man:
                            man = temp
                            te = j
                    left = tr_mi.query(0, te - 1)
                    right = tr_mi.query(te + i, n - 1)
                    if left is None:
                        mi = right
                    elif right is None:
                        mi = left
                    else:
                        mi = min(left, right)
                    all_data.append(man - mi)
                for i in range(line - 30, line + 1):
                    man = 0
                    te = 0
                    for j in range(n - i + 1):
                        temp = su(j, j + i - 1, data_s)
                        if temp > man:
                            man = temp
                            te = j
                    left = tr_mi.query(0, te - 1)
                    right = tr_mi.query(te + i, n - 1)
                    if left is None:
                        mi = right
                    elif right is None:
                        mi = left
                    else:
                        mi = min(left, right)
                    all_data.append(man - mi)
                print(max(all_data))
            elif line >= 3000:
                all_data = []
                for i in range(1, 1):
                    man = 0
                    te = 0
                    for j in range(n - i + 1):
                        temp = su(j, j + i - 1, data_s)
                        if temp > man:
                            man = temp
                            te = j
                    left = tr_mi.query(0, te - 1)
                    right = tr_mi.query(te + i, n - 1)
                    if left is None:
                        mi = right
                    elif right is None:
                        mi = left
                    else:
                        mi = min(left, right)
                    all_data.append(man - mi)
                for i in range(line, line + 1):
                    man = 0
                    te = 0
                    for j in range(n - i + 1):
                        temp = su(j, j + i - 1, data_s)
                        if temp > man:
                            man = temp
                            te = j
                    left = tr_mi.query(0, te - 1)
                    right = tr_mi.query(te + i, n - 1)
                    if left is None:
                        mi = right
                    elif right is None:
                        mi = left
                    else:
                        mi = min(left, right)
                    all_data.append(man - mi)
                print(max(all_data))
            else:
                all_data = []
                for i in range(1, line + 1):
                    man = 0
                    te = 0
                    for j in range(n - i + 1):
                        temp = su(j, j + i - 1, data_s)
                        if temp > man:
                            man = temp
                            te = j
                    left = tr_mi.query(0, te - 1)
                    right = tr_mi.query(te + i, n - 1)
                    if left is None:
                        mi = right
                    elif right is None:
                        mi = left
                    else:
                        mi = min(left, right)
                    all_data.append(man - mi)
                print(max(all_data))
    else:
        for i in range(line, 0, -1):
            for j in range(n - i + 1):
                ma = su(j, j + i - 1, data_s)
                left = tr_mi.query(0, j - 1)
                right = tr_mi.query(j + i, n - 1)
                #print(i, j, ma, left, right)
                if left is None:
                    mi = right
                elif right is None:
                    mi = left
                else:
                    mi = min(left, right)
                if result < ma - mi:
                    result = ma - mi
                #print(i, j, ma, mi)
        print(result)
else:
    print(max(sum(data[1:]) - data[0], sum(data[:-1]) - data[-1]))





















