#include <vector>
#include <iostream>

using namespace std;

int fast(int n, int m, int k) {
    int a = min(n, m);
    int b = max(n, m);
    int x = (a - 1 - 1) / k + 1;
    int y = (b - a - 1) / k + 1;
    return x + y;
}

void send() {
    int n, m, k;
    cin >> n >> m >> k;
    cout << fast(n, m, k);
}

int slow(int n, int m, int k) {
    int x = 1, y = 1;
    int a = min(n, m);
    int b = max(n, m);
    int ans = 0;
    while (x < a || y < b) {
        if (x < a) {
            x += k;
        }
        if (y < b) {
            y += k;
        }
        if (x > a) {
            x = a;
            y = a;
        }
        ans++;
    }
    return ans;
}

void check() {
    for (int n = 1; n <= 10; n++) {
        for (int m = 1; m <= 10; m++) {
            for (int k = 1; k <= 10; k++) {
                int ans1 = fast(n, m, k);
                int ans2 = slow(n, m, k);
                if (ans1 != ans2) {
                    cout << n << " " << m << " " << k << endl;
                    cout << ans1 << " " << ans2 << endl << endl;
                }
            }
        }
    }
}

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    cout << slow(n, m, k);
    return 0;
}