#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

#define ll long long

using namespace std;

ll prostWithLength(int length) {
    return 4 * length;
}

// нужные простые: 2 3 5 7
ll prostWithoutGranicas(int llength, int rlength) {
    ll l = llength + 1;
    ll r = rlength - 1;
    return 4 * (r * (r + 1) / 2 - l * (l - 1) / 2); // 4 * сумма длин от l до r
}

bool isProst(vector<int> x) {
    int n = x.size();
    int prod = 1;
    for (int i = 0; i < n; i++) {
        prod *= x[i];
        if (prod == 0 || prod == 4 || prod == 6 || prod >= 8) {
            return false;
        }
    }
    if (prod == 1) {
        return false;
    } else {
        return true;
    }
}

vector<int> firstProst(vector<int> l) {
    if (isProst(l)) {
        return l;
    }

    int n = l.size();
    vector<int> first;
    int i = 0;
    while (l[i] == 1 && i < n) {
        first.push_back(1);
        i++;
    }
    if (i == n) {
        first.pop_back();
        first.push_back(2);
        return first;
    }

    if (l[i] == 0) {
        first.push_back(1);
        i++;
        while (i < n) {
            first.push_back(1);
            i++;
        }
    } else if (l[i] == 2) {
        first.push_back(3);
        i++;
        while (i < n) {
            first.push_back(1);
            i++;
        }
    } else if (l[i] == 3 || l[i] == 4) {
        first.push_back(5);
        i++;
        while (i < n) {
            first.push_back(1);
            i++;
        }
    } else if (l[i] == 5 || l[i] == 6) {
        first.push_back(7);
        i++;
        while (i < n) {
            first.push_back(1);
            i++;
        }
    } else if (l[i] == 7 || l[i] == 8 || l[i] == 9) {
        first.pop_back();
        first.push_back(2);
        while (i < n) {
            first.push_back(1);
            i++;
        }
    }
    return first;
}

vector<int> lastProst(vector<int> r) {
    if (isProst(r)) {
        return r;
    }
    int n = r.size();
    vector<int> last;

    int i = 0;
    while (r[i] == 1 && i < n) {
        last.push_back(1);
        i++;
    }
    if (i == n) {
        // r = 1111...1
        // простоватых значит нет
        last.push_back(0);
        return last;
    }

    if (r[i] == 0) {
        // r = 111...10______
        // простоватых тоже нет
        last.push_back(0);
        return last;
    } else if (r[i] == 2) {
        // r == 111...12____
        last.push_back(2);
        i++;
        while (i < n) {
            last.push_back(1);
            i++;
        }
    } else if (r[i] == 3 || r[i] == 4) {
        last.push_back(3);
        i++;
        while (i < n) {
            last.push_back(1);
            i++;
        }
    } else if (r[i] == 5 || r[i] == 6) {
        last.push_back(5);
        i++;
        while (i < n) {
            last.push_back(1);
            i++;
        }
    } else if (r[i] == 7 || r[i] == 8 || r[i] == 9) {
        last.push_back(7);
        i++;
        while (i < n) {
            last.push_back(1);
            i++;
        }
    }
    return last; // вернуть не простоватое если нет последнего простоватого длины как у r
}

int firstPIndex(vector<int> x) {
    int i = 0;
    while (x[i] == 1 && i < x.size()) {
        i++;
    }
    return i;
}

ll prostInLowerGranica(vector<int> l) {
    int n = l.size();
    vector<int> first = firstProst(l);
    int firstIndex = firstPIndex(first);
    ll ans = prostWithLength(firstIndex + 1);
    if (first[firstIndex] == 3) {
        ans -= 1;
    } else if (first[firstIndex] == 5) {
        ans -= 2;
    } else if (first[firstIndex] == 7) {
        ans -= 3;
    }
    return ans;
}

ll prostInUpperGranica(vector<int> r) {
    int n = r.size();
    vector<int> last = lastProst(r);
    if (!isProst(last)) {
        return 0;
    }
    int firstIndex = firstPIndex(last);
    ll ans = prostWithLength(n - firstIndex);
    if (last[firstIndex] == 5) {
        ans -= 1;
    } else if (last[firstIndex] == 3) {
        ans -= 2;
    } else if (last[firstIndex] == 2) {
        ans -= 3;
    }
    return ans;
}

ll fast(vector<int> l, vector<int> r) {
    ll ans = 0;
    if (l.size() != r.size()) {
        ans += prostWithoutGranicas(l.size(), r.size());
        ans += prostInLowerGranica(l);
        ans += prostInUpperGranica(r);
    } else {
        ll lower = prostInLowerGranica(l);
        ll upper = prostInUpperGranica(r);
        ll len = prostWithLength(l.size());
        ans += len;
        ans -= len - upper;
        ans -= len - lower;
        ans = max(0ll, ans);
    }
    return ans;
}

int main() {
    string ls, rs;
    getline(cin, ls);
    getline(cin, rs);
    vector<int> l(ls.size()), r(rs.size());
    for (int i = 0; i < ls.size(); i++) {
        l[i] = ls[i] - '0';
    }
    for (int i = 0; i < rs.size(); i++) {
        r[i] = rs[i] - '0';
    }
    cout << fast(l, r);
    return 0;
}