#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

#define ll long long

using namespace std;

ll prostWithLength(int length) {
    return 4 * length;
}

// нужные простые: 2 3 5 7
ll prostWithoutGranicas(int llength, int rlength) {
    ll l = llength + 1;
    ll r = rlength - 1;
    return 4 * (r * (r + 1) / 2 - l * (l - 1) / 2); // 4 * сумма длин от l до r
}

bool isProst(vector<int> x) {
    int n = x.size();
    int prod = 1;
    for (int i = 0; i < n; i++) {
        prod *= x[i];
        if (prod == 0 || prod == 4 || prod == 6 || prod >= 8) {
            return false;
        }
    }
    if (prod == 1) {
        return false;
    } else {
        return true;
    }
}

vector<int> firstProst(vector<int> l) {
    if (isProst(l)) {
        return l;
    }

    int n = l.size();
    vector<int> first;
    int i = 0;
    while (l[i] == 1 && i < n) {
        first.push_back(1);
        i++;
    }
    if (i == n) {
        first.pop_back();
        first.push_back(2);
        return first;
    }

    if (l[i] == 0) {
        first.push_back(1);
        i++;
        while (i < n - 1) {
            first.push_back(1);
            i++;
        }
        first.push_back(2);
        i++;
    } else if (l[i] == 2) {
        first.push_back(3);
        i++;
        while (i < n) {
            first.push_back(1);
            i++;
        }
    } else if (l[i] == 3 || l[i] == 4) {
        first.push_back(5);
        i++;
        while (i < n) {
            first.push_back(1);
            i++;
        }
    } else if (l[i] == 5 || l[i] == 6) {
        first.push_back(7);
        i++;
        while (i < n) {
            first.push_back(1);
            i++;
        }
    } else if (l[i] == 7 || l[i] == 8 || l[i] == 9) {
        if (first.size() == 0) {
            first.push_back(0);
            return first;
        }
        first.pop_back();
        first.push_back(2);
        while (i < n) {
            first.push_back(1);
            i++;
        }
    }
    return first;
}

vector<int> lastProst(vector<int> r) {
    if (isProst(r)) {
        return r;
    }
    int n = r.size();
    vector<int> last;

    int i = 0;
    while (r[i] == 1 && i < n) {
        last.push_back(1);
        i++;
    }
    if (i == n) {
        // r = 1111...1
        // простоватых значит нет
        last.push_back(0);
        return last;
    }

    int current = r[i];
    int thatIndex = i;

    if (current == 0) {
        // r = 111...10______
        // простоватых тоже нет
        last.push_back(0);
        return last;
    } else if (current == 2) {
        // r == 111...12____
        last.push_back(2);
        i++;
        bool flag = true;
        while (i < n) {
            if (r[i] != 0 && r[i] != 1) {
                flag = false;
            }
            if (r[i] == 0 && flag && current == 2) {
                last[thatIndex] = 1;
                if (i == thatIndex + 1) {
                    last.push_back(7);
                    i++;
                } else {
                    last[thatIndex + 1] = 7;
                }
                while (i < n) {
                    last.push_back(1);
                    i++;
                }
                return last;
            }
            last.push_back(1);
            i++;
        }
    } else if (current == 3 || current == 4) {
        last.push_back(3);
        i++;
        bool flag = true;
        while (i < n) {
            if (r[i] != 0 && r[i] != 1) {
                flag = false;
            }
            if (r[i] == 0 && flag && current == 3) {
                last[thatIndex] = 2;
            }
            last.push_back(1);
            i++;
        }
    } else if (current == 5 || current == 6) {
        last.push_back(5);
        i++;
        bool flag = true;
        while (i < n) {
            if (r[i] != 0 && r[i] != 1) {
                flag = false;
            }
            if (r[i] == 0 && flag && current == 5) {
                last[thatIndex] = 3;
            }
            last.push_back(1);
            i++;
        }
    } else if (current == 7 || current == 8 || current == 9) {
        last.push_back(7);
        i++;
        bool flag = true;
        while (i < n) {
            if (r[i] != 0 && r[i] != 1) {
                flag = false;
            }
            if (r[i] == 0 && flag && current == 7) {
                last[thatIndex] = 5;
            }
            last.push_back(1);
            i++;
        }
    }
    // надо проверить, нет ли нулей после
    return last; // вернуть не простоватое если нет последнего простоватого длины как у r
}

int firstPIndex(vector<int> x) {
    int i = 0;
    while (x[i] == 1 && i < x.size()) {
        i++;
    }
    return i;
}

ll prostInLowerGranica(vector<int> l) {
    int n = l.size();
    vector<int> first = firstProst(l);
    if (!isProst(first)) {
        return 0ll;
    }
    int firstIndex = firstPIndex(first);
    ll ans = prostWithLength(firstIndex + 1);
    if (first[firstIndex] == 3) {
        ans -= 1;
    } else if (first[firstIndex] == 5) {
        ans -= 2;
    } else if (first[firstIndex] == 7) {
        ans -= 3;
    }
    return ans;
}

ll prostInUpperGranica(vector<int> r) {
    int n = r.size();
    auto last = lastProst(r);
    if (!isProst(last)) {
        return 0;
    }
    int firstIndex = firstPIndex(last);
    ll ans = prostWithLength(n - firstIndex);
    if (last[firstIndex] == 5) {
        ans -= 1;
    } else if (last[firstIndex] == 3) {
        ans -= 2;
    } else if (last[firstIndex] == 2) {
        ans -= 3;
    }
    return ans;
}

ll fast(vector<int> l, vector<int> r) {
    ll ans = 0;
    if (l.size() != r.size()) {
        ans += prostWithoutGranicas(l.size(), r.size());
        ans += prostInLowerGranica(l);
        ans += prostInUpperGranica(r);
    } else {
        ll lower = prostInLowerGranica(l);
        ll upper = prostInUpperGranica(r);
        ll len = prostWithLength(l.size());
        ans += len;
        ans -= len - upper;
        ans -= len - lower;
        ans = max(0ll, ans);
    }
    return ans;
}

ll slow(int li, int ri) {
    int ans = 0;
    for (int n = li; n <= ri; n++) {
        int m = n;
        int prod = 1;
        while (m > 0) {
            prod *= m % 10;
            m /= 10;
        }
        if (prod == 2 || prod == 3 || prod == 5 || prod == 7) {
            ans++;
        }
    }
    return ans;
}

ll slow(vector<int> l, vector<int> r) {
    // i think l <= 10^6, r <= 10^6
    int li = 0, ri = 0;
    for (int i : l) {
        li *= 10;
        li += i;
    }
    for (int i : r) {
        ri *= 10;
        ri += i;
    }
    return slow(li, ri);
}

void solve_fast() {
    string ls, rs;
    getline(cin, ls);
    getline(cin, rs);
    vector<int> l(ls.size()), r(rs.size());
    for (int i = 0; i < ls.size(); i++) {
        l[i] = ls[i] - '0';
    }
    for (int i = 0; i < rs.size(); i++) {
        r[i] = rs[i] - '0';
    }
    cout << fast(l, r);
}

void solve_slow() {
    ll l, r;
    cin >> l;
    cin >> r;
    cout << slow(l, r);
}

void check() {
    for (int li = 1; li <= 10000; li++) {
        vector<int> lv;
        int lii = li;
        while (lii > 0) {
            lv.push_back(lii % 10);
            lii /= 10;
        }
        vector<int> l(lv.rbegin(), lv.rend());
        for (int ri = li; ri <= 10000; ri++) {
            vector<int> rv;
            int rii = ri;
            while (rii > 0) {
                rv.push_back(rii % 10);
                rii /= 10;
            }
            vector<int> r(rv.rbegin(), rv.rend());

            ll ans1 = fast(l, r);
            ll ans2 = slow(l, r);
            if (ans1 != ans2) {
                cout << li << endl;
                cout << ri << endl;
                cout << ans1 << endl;
                cout << ans2 << endl << endl;
            }
        }
    }
}

int main() {
    solve_fast();
    return 0;
}