#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

#define ll long long

using namespace std;

int glubina(vector<int> s) {
    int l = 0;
    int r = s.size() - 1;
    int w = 0;
    for (int p = l; p <= r; p++) {
        int lp = s[l];
        for (int pp = l; pp <= p; pp++) {
            lp = max(lp, s[pp]);
        }
        int rp = s[p];
        for (int pp = p; pp <= r; pp++) {
            rp = max(rp, s[pp]);
        }
        int dp = min(lp, rp) - s[p];
        dp = max(0, dp);
        w += dp;
    }
    return w;
}

void fast(int n, vector<int> h, vector<int> k) {
    vector<vector<int>> s(n, vector<int> (1));
    for (int i = 0; i < n; i++) {
        s[i][0] = h[i];
    }
    for (int j = 0; j < n - 1; j++) {
        int kj = k[j] - 1;
        for (int si : s[kj + 1]) {
            s[kj].push_back(si);
        }
        for (int i = kj + 2; i < s.size(); i++) {
            s[i - 1] = s[i];
        }
        s.pop_back();

        cout << glubina(s[kj]) << endl;
    }
}

void solve() {
    int n;
    cin >> n;
    vector<int> h(n);
    for (int i = 0; i < n; i++) {
        cin >> h[i];
    }
    vector<int> k(n - 1);
    for (int i = 0; i < n - 1; i++) {
        cin >> k[i];
    }
    
    fast(n, h, k);
}

int main() {
    solve();
    return 0;
}