#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

#define ll long long

using namespace std;

int max(vector<int> h, int l, int r) {
    int ans = 0;
    for (int i = l; i <= r; i++) {
        ans = max(ans, h[i]);
    }
    return ans;
}

int glubina(vector<int> h, pair<int, int> s) {
    int l = s.first;
    int r = s.second;
    int w = 0;
    for (int p = l; p <= r; p++) {
        int lp = max(h, l, p);
        int rp = max(h, p, r);
        int d = min(lp, rp) - h[p];
        w += d;
    }
    return w;
}

void slow(int n, vector<int> h, vector<int> k) {
    vector<pair<int, int>> s(n);
    for (int i = 0; i < n; i++) {
        s[i] = pair<int, int> {i, i};
    }
    for (int j = 0; j < n - 1; j++) {
        s[k[j]].second = s[k[j] + 1].second;
        for (int i = k[j] + 2; i < s.size(); i++) {
            s[i - 1] = s[i];
        }
        s.pop_back();

        cout << glubina(h, s[k[j]]) << endl;
    }
}

void solve() {
    int n;
    cin >> n;
    vector<int> h(n);
    for (int i = 0; i < n; i++) {
        cin >> h[i];
    }
    vector<int> k(n - 1);
    for (int i = 0; i < n - 1; i++) {
        int ki;
        cin >> ki;
        k[i] = ki - 1;
    }
    
    slow(n, h, k);
}

int main() {
    solve();
    return 0;
}