#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <deque>

#define ll long long

ll MOD = 1000000007; // prime

using namespace std;

ll add(ll a, ll b) {
    return (a + b) % MOD;
}

ll sub(ll a, ll b) {
    return (a - b) % MOD;
}

ll mul(ll a, ll b) {
    return (a * b) % MOD;
}

ll pow(ll a, ll b) {
    if (b == 0) {
        return 1;
    } else if (b % 2 == 0) {
        ll c = pow(a, b / 2);
        return mul(c, c);
    } else {
        ll c = pow(a, b / 2);
        return mul(mul(c, c), a);
    }
}

ll divide(ll a, ll b) {
    return mul(a, pow(b, MOD - 1));
}

bool basicCheck(int n, int k, vector<int> b) {
    for (int i = 0; i < n; i++) {
        if (b[i] > (k * k + k) / 2) {
            return false;
        }
    }
    return true;
}

int slow(int n, int k, vector<int> b) {
    if (!basicCheck(n, k, b)) {
        return 0;
    }
    // nk <= 25
    vector<vector<bool>> table(k, vector<bool> (n));
    return 1;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> b(n);
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    cout << slow(n, k, b);
}

int main() {
    solve();
    return 0;
}