#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

#define ll long long

using namespace std;

ll perekos(vector<ll> &sums) {
    ll mini = 9223372036854775807;
    ll maxi = -9223372036854775808;
    for (ll i : sums) {
        mini = min(i, mini);
        maxi = max(i, maxi);
    }
    return maxi - mini;
}

void recurse(int n, int k, vector<int> &a, int l, vector<ll> &sums, ll &pereko) {
    if (k == 1) {
        ll sum = 0;
        for (int i = l; i < n; i++) {
            sum += a[i];
        }
        sums.push_back(sum);
        pereko = max(pereko, perekos(sums));
        sums.pop_back();
        return;
    }
    for (int r = l; r < n - k + 1; r++) {
        ll sum = 0;
        for (int i = l; i <= r; i++) {
            sum += a[i];
        }
        sums.push_back(sum);
        recurse(n, k - 1, a, r + 1, sums, pereko);
        sums.pop_back();
    }
}

ll solve(int n, int k, vector<int> &a) {
    if (k == 1) {
        return 0;
    }
    ll ans = -9223372036854775808;
    vector<ll> sums;
    recurse(n, k, a, 0, sums, ans);
    return ans;
}

void fast_solver() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    cout << solve(n, k, a);
}

int main() {
    fast_solver();
    return 0;
}