#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

#define ll long long

using namespace std;

ll sumArray(vector<int> a) {
    ll sum = 0;
    for (ll i : a) {
        sum += i;
    }
    return sum;
}

ll sumArray(vector<ll> a) {
    ll sum = 0;
    for (ll i : a) {
        sum += i;
    }
    return sum;
}

ll perekos(vector<ll> &sums) {
    ll mini = 9223372036854775807;
    ll maxi = -9223372036854775808;
    for (ll i : sums) {
        mini = min(i, mini);
        maxi = max(i, maxi);
    }
    return maxi - mini;
}

void recurse(int n, int k, vector<int> &a, int l, vector<ll> &sums, ll &pereko) {
    if (k == 1) {
        ll sum = 0;
        for (int i = l; i < n; i++) {
            sum += a[i];
        }
        sums.push_back(sum);
        pereko = max(pereko, perekos(sums));
        sums.pop_back();
        return;
    }
    for (int r = l; r < n - k + 1; r++) {
        ll sum = 0;
        for (int i = l; i <= r; i++) {
            sum += a[i];
        }
        sums.push_back(sum);
        recurse(n, k - 1, a, r + 1, sums, pereko);
        sums.pop_back();
    }
}

ll slow1_solve(int n, int k, vector<int> &a) {
    ll ans = -9223372036854775808;
    vector<ll> sums;
    recurse(n, k, a, 0, sums, ans);
    return ans;
}

ll slow2_solve(int n, int k, vector<int> &a) {
    ll ans = -9223372036854775808;
    ll summ = sumArray(a);

    ll mini = 9223372036854775807;
    ll maxi = -9223372036854775808;
    ll sum = 0;
    for (int i = 0; i < n - k + 1; i++) {
        sum += a[i];
        maxi = max(sum, maxi);
        mini = min(sum, mini);
    }
    ll antimini = summ - mini;
    ll antimaxi = summ - maxi;
    return max(abs(maxi - antimaxi), abs(antimini - mini));
}

void solver() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    if (n <= 15) {
        cout << slow1_solve(n, k, a);
    } else if (k = 2) {
        cout << slow2_solve(n, k, a);
    }
}

int main() {
    solver();
    return 0;
}