#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

#define ll long long

using namespace std;

ll sumArray(vector<int> &a) {
    ll sum = 0;
    for (ll i : a) {
        sum += i;
    }
    return sum;
}

ll sumArray(vector<int> &a, int l) {
    ll sum = 0;
    for (int i = l; i < a.size(); i++) {
        sum += a[i];
    }
    return sum;
}

ll sumArray(vector<int> &a, int l, int r) {
    ll sum = 0;
    for (int i = l; i <= r; i++) {
        sum += a[i];
    }
    return sum;
}

ll perekos(vector<ll> &sums) {
    ll mini = 9223372036854775807;
    ll maxi = -9223372036854775808;
    for (ll i : sums) {
        mini = min(i, mini);
        maxi = max(i, maxi);
    }
    return maxi - mini;
}

void recurse(int n, int k, vector<int> &a, int l, vector<ll> &sums, ll &pereko) {
    if (k == 1) {
        ll sum = 0;
        for (int i = l; i < n; i++) {
            sum += a[i];
        }
        sums.push_back(sum);
        pereko = max(pereko, perekos(sums));
        sums.pop_back();
        return;
    }
    for (int r = l; r < n - k + 1; r++) {
        ll sum = 0;
        for (int i = l; i <= r; i++) {
            sum += a[i];
        }
        sums.push_back(sum);
        recurse(n, k - 1, a, r + 1, sums, pereko);
        sums.pop_back();
    }
}

ll slow1_solve(int n, int k, vector<int> &a) {
    ll ans = -9223372036854775808;
    vector<ll> sums;
    recurse(n, k, a, 0, sums, ans);
    return ans;
}

ll slow2_solve(int n, int k, vector<int> &a) {
    ll ans = -9223372036854775808;
    ll summ = sumArray(a);

    ll mini = 9223372036854775807;
    ll maxi = -9223372036854775808;
    ll sum = 0;
    for (int i = 0; i < n - k + 1; i++) {
        sum += a[i];
        maxi = max(sum, maxi);
        mini = min(sum, mini);
    }
    ll antimini = summ - mini;
    ll antimaxi = summ - maxi;
    return max(maxi - antimaxi, antimini - mini);
}

pair<ll, ll> dpp(int l, int k, vector<vector<pair<ll, ll>>> &dp, vector<int> &a, vector<vector<ll>> &dpf) {
    if (l == 6 && k == 1) {
        cout << "";
    }
    vector<int> b(a.begin() + l, a.end());
    bool treb = true;
    // bool treb = l >= a.size() - (k + 1); // || l <= a.size() - (k + 1) + 1 && dp[l + 1][k].first == -1; // требуется медленный подсчет
    if (dp[l][k].first != -1) {
        return dp[l][k];
    } else if (k == 1 - 1) {
        dp[l][k].first = sumArray(a, l);
        dp[l][k].second = dp[l][k].first;
        dpf[l][k] = dp[l][k].first;
        return dp[l][k];
    } else if (k == 2 - 1) {
        if (treb) {
            ll ans = -9223372036854775808;
            ll summ = sumArray(a, l);

            ll mini = 9223372036854775807;
            ll maxi = -9223372036854775808;
            ll sum = 0;
            for (int i = l; i < a.size() - (k + 1) + 1; i++) {
                sum += a[i];
                maxi = max(sum, maxi);
                mini = min(sum, mini);
            }
            ll antimini = summ - mini;
            ll antimaxi = summ - maxi;
            if (maxi - antimaxi > antimini - mini) {
                dp[l][k].first = maxi;
                dp[l][k].second = antimaxi;
                dpf[l][k] = maxi;
            } else {
                dp[l][k].first = antimini;
                dp[l][k].second = mini;
                dpf[l][k] = mini;
            }
            return dp[l][k];
        } else { // не требуется
            pair<ll, ll> an = dpp(l + 1, k, dp, a, dpf);
            ll newEl = a[l];
            ll summ = sumArray(a, l + 1);
            // 2 случая: новый элемент присоединился к левому отрезку и улучшил ситуацию, либо новый элемент и сумма старых делают два отрезка
            dpf[l][k] = dpf[l + 1][k] + newEl; // один отрезок
            ll other = summ + newEl - dpf[l][k]; // другой отрезок
            dp[l][k].first = max(dpf[l][k], other);
            dp[l][k].second = min(dpf[l][k], other);
            if (summ < newEl) {
                swap(summ, newEl);
            }
            if (summ - newEl > dp[l][k].first - dp[l][k].second) {
                dp[l][k].first = summ;
                dp[l][k].second = newEl;
                dpf[l][k] = newEl;
            }
            return dp[l][k];
        }
    } else {
        ll mini = 9223372036854775807;
        ll maxi = -9223372036854775808;
        ll sum = 0;
        for (int i = l; i < a.size() - (k + 1) + 1; i++) {
            pair<ll, ll> t = {-1, -1};
            sum += a[i];
            maxi = max(sum, maxi);
            mini = min(sum, mini);

            pair<ll, ll> an = dpp(i + 1, k - 1, dp, a, dpf);
            ll smaxi = an.first;
            ll smini = an.second;
            if (maxi > smaxi) {
                t.first = maxi;
            } else {
                t.first = smaxi;
            }
            if (mini < smini) {
                t.second = mini;
            } else {
                t.second = smini;
            }
            if (t.first - t.second > dp[l][k].first - dp[l][k].second) {
                dp[l][k].first = t.first;
                dp[l][k].second = t.second;
                dpf[l][k] = sum;
            }
        }
        return dp[l][k];
    }
}

ll slow_solve(int n, int k, vector<int> &a) {
    vector<vector<pair<ll, ll>>> dp(n, vector<pair<ll, ll>> (k, {-1, -1}));
    vector<vector<ll>> dpf(n, vector<ll> (k, -1));
    pair<ll, ll> an = dpp(0, k - 1, dp, a, dpf);
    return an.first - an.second;
}

ll slow4_solve(int n, int k, vector<int> &a) {
    // k == 3.
    ll ans = 0;
    ll sum = sumArray(a);
    ll thatSum = a[0];
    for (int i = 1; i <= n - 2; i++) {
        ll sumCenterAndRight = sum - thatSum;
        ll sumLeft = sum - sumCenterAndRight;
        ll otherThatSum = thatSum + a[i];
        for (int j = i + 1; j <= n - 1; j++) {
            ll sumRight = sum - otherThatSum;
            ll sumCenter = sumCenterAndRight - sumRight;
            ll maxii = max(max(sumLeft, sumRight), sumCenter);
            ll minii = min(min(sumLeft, sumRight), sumCenter);
            ans = max(maxii - minii, ans);
            otherThatSum += a[j];
        }
        thatSum += a[i];
    }
    return ans;
}

ll max_sum(int l, int r, int k, vector<int> &a) {
    // отрезок с максимальной суммой - это обязательно отрезок с максимальной длиной. => все остальные - отрезки по длине 1.
    // (k-1) * 1 + 1 * x = length
    // x = length - k + 1 - длина отрезка с максимальной суммой
    int length = r - l + 1;
    int otrLength = length - k + 1;
    if (k == 0 && 0 < length) {
        return -1;
    } else if (k == 0 && 0 >= length) {
        return 0;
    } else if (k > length) {
        return -1;
    }
    ll maxsum = 0;
    ll sum = 0;
    for (int i = l; i <= r; i++) {
        while (i - l < otrLength) {
            sum += a[i];
            i++;
        }
        maxsum = max(maxsum, sum);
        // i - l == otrLength;
        sum -= a[i - otrLength];
        if (i <= r) {
            sum += a[i];
            maxsum = max(maxsum, sum);
        }
    }
    return maxsum;
}

ll fast_solve(int n, int k, vector<int> &a) {
    // у нас точно должен быть отрезок длины 1.
    // мы можем перебирать каждый элемент и затем смотреть на отрезки справа и слева.

    /*
    if (k == 2) {
        ll summ = sumArray(a);
        ll l = a[0];
        ll r = a[n - 1];
        return max(summ - 2 * l, summ - 2 * r);
    }
    */

    ll ans = 0;
    int changed = 0;
    int test = 0;
    int i = 0;

    while(i < n) {
        // i = rand() % n;
        int l1 = 0;
        int r1 = i - 1;
        int length1 = r1 - l1 + 1;
        int l2 = i + 1;
        int r2 = n - 1;
        int length2 = r2 - l2 + 1;
        ll maxsum = 0;
        if (i == 0) {
            maxsum = max_sum(1, n - 1, k - 1, a);
        } else if (i == n - 1) {
            maxsum = max_sum(0, n - 2, k - 1, a);
        }
        for (int j = length1; k - 1 - j > length2; j++) {
            ll left = max_sum(l1, r1, j, a);
            ll right = max_sum(l2, r2, k - 1 - j, a);
            if (left == -1 || right == -1) {
                continue;
            }
            maxsum = max(maxsum, max(left, right));
        }
        if (maxsum - a[i] > ans) {
            changed++;
        }
        ans = max(maxsum - a[i], ans);
        i++;
    }
    return ans;
}

void check() {
    for (int test = 0; test < 10; test++) {
        int n = rand() % (300000 - 2 + 1) + 2;
        // int k = rand() % (n - 2 + 1) + 2;
        int k = 2;
        vector<int> a(n);
        for (int i = 0; i < n; i++) {
            a[i] = rand() % (10 + 1);
        }

        ll ans1 = slow1_solve(n, k, a);
        ll ans2 = fast_solve(n, k, a);
        if (ans2 != ans1) {
            cout << n << " " << k << endl;
            for (int i = 0; i < n; i++) {
                cout << a[i] << " ";
            }
            cout << endl << ans1 << " " << ans2 << endl << endl;
        }
    }
}

void solver() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    cout << fast_solve(n, k, a);
}

int main() {
    solver();
    return 0;
}