#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

#define ll long long

using namespace std;

ll sumArray(vector<int> &a) {
    ll sum = 0;
    for (ll i : a) {
        sum += i;
    }
    return sum;
}

ll sumArray(vector<int> &a, int l) {
    ll sum = 0;
    for (int i = l; i < a.size(); i++) {
        sum += a[i];
    }
    return sum;
}

ll sumArray(vector<int> &a, int l, int r) {
    ll sum = 0;
    for (int i = l; i <= r; i++) {
        sum += a[i];
    }
    return sum;
}

ll perekos(vector<ll> &sums) {
    ll mini = 9223372036854775807;
    ll maxi = -9223372036854775808;
    for (ll i : sums) {
        mini = min(i, mini);
        maxi = max(i, maxi);
    }
    return maxi - mini;
}

void recurse(int n, int k, vector<int> &a, int l, vector<ll> &sums, ll &pereko) {
    if (k == 1) {
        ll sum = 0;
        for (int i = l; i < n; i++) {
            sum += a[i];
        }
        sums.push_back(sum);
        pereko = max(pereko, perekos(sums));
        sums.pop_back();
        return;
    }
    for (int r = l; r < n - k + 1; r++) {
        ll sum = 0;
        for (int i = l; i <= r; i++) {
            sum += a[i];
        }
        sums.push_back(sum);
        recurse(n, k - 1, a, r + 1, sums, pereko);
        sums.pop_back();
    }
}

ll slow1_solve(int n, int k, vector<int> &a) {
    ll ans = -9223372036854775808;
    vector<ll> sums;
    recurse(n, k, a, 0, sums, ans);
    return ans;
}

ll slow2_solve(int n, int k, vector<int> &a) {
    ll ans = -9223372036854775808;
    ll summ = sumArray(a);

    ll mini = 9223372036854775807;
    ll maxi = -9223372036854775808;
    ll sum = 0;
    for (int i = 0; i < n - k + 1; i++) {
        sum += a[i];
        maxi = max(sum, maxi);
        mini = min(sum, mini);
    }
    ll antimini = summ - mini;
    ll antimaxi = summ - maxi;
    return max(maxi - antimaxi, antimini - mini);
}

pair<ll, ll> dpp(int l, int k, vector<vector<pair<ll, ll>>> &dp, vector<int> &a) {
    vector<int> b(a.begin() + l, a.end());
    bool treb = l >= a.size() - (k + 1); // || l <= a.size() - (k + 1) + 1 && dp[l + 1][k].first == -1; // требуется медленный подсчет
    if (dp[l][k].first != -1) {
        return dp[l][k];
    } else if (k == 1 - 1) {
        dp[l][k].first = sumArray(a, l);
        dp[l][k].second = dp[l][k].first;
        return dp[l][k];
    } else if (k == 2 - 1) {
        if (treb) {
            ll ans = -9223372036854775808;
            ll summ = sumArray(a, l);

            ll mini = 9223372036854775807;
            ll maxi = -9223372036854775808;
            ll sum = 0;
            for (int i = l; i < a.size() - (k + 1) + 1; i++) {
                sum += a[i];
                maxi = max(sum, maxi);
                mini = min(sum, mini);
            }
            ll antimini = summ - mini;
            ll antimaxi = summ - maxi;
            if (maxi - antimaxi > antimini - mini) {
                dp[l][k].first = maxi;
                dp[l][k].second = antimaxi;
            } else {
                dp[l][k].first = antimini;
                dp[l][k].second = mini;
            }
            return dp[l][k];
        } else { // не требуется
            pair<ll, ll> an = dpp(l + 1, k, dp, a);
            ll newEl = a[l];
            ll summ = sumArray(a, l + 1);
            if (summ < newEl) {
                swap(summ, newEl);
            }
            dp[l][k].first = an.first + newEl;
            dp[l][k].second = an.second;
            if (summ - newEl > dp[l][k].first - dp[l][k].second) {
                dp[l][k].first = summ;
                dp[l][k].second = newEl;
            }
            return dp[l][k];
        }
    } else {
        ll mini = 9223372036854775807;
        ll maxi = -9223372036854775808;
        ll sum = 0;
        for (int i = l; i < a.size() - (k + 1) + 1; i++) {
            pair<ll, ll> t = {-1, -1};
            sum += a[i];
            maxi = max(sum, maxi);
            mini = min(sum, mini);

            pair<ll, ll> an = dpp(i + 1, k - 1, dp, a);
            ll smaxi = an.first;
            ll smini = an.second;
            if (maxi > smaxi) {
                t.first = maxi;
            } else {
                t.first = smaxi;
            }
            if (mini < smini) {
                t.second = mini;
            } else {
                t.second = smini;
            }
            if (t.first - t.second > dp[l][k].first - dp[l][k].second) {
                dp[l][k].first = t.first;
                dp[l][k].second = t.second;
            }
        }
        return dp[l][k];
    }
}

ll slow3_solve(int n, int k, vector<int> &a) {
    vector<vector<pair<ll, ll>>> dp(n, vector<pair<ll, ll>> (k, {-1, -1}));
    pair<ll, ll> an = dpp(0, k - 1, dp, a);
    return an.first - an.second;
}

void solver() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    cout << slow3_solve(n, k, a);
}

int main() {
    solver();
    return 0;
}