#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <map>

using namespace std;

typedef long long ll;

vector<ll> tree;
void build_tree(int v, int L, int R, vector<ll> a)
{
    if (L + 1 == R)
    {
        tree[v] = a[L];
        return;
    }
    int m = (L + R) / 2;
    build_tree(2 * v + 1, L, m, a);
    build_tree(2 * v + 2, m, R, a);
    tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

ll mx(int v, int l, int r, int L, int R)
{
    if (L >= l && R <= r)
        return tree[v];
    if (R <= l || L >= r)
        return 0;
    int m = (L + R) / 2;
    return max(mx(2 * v + 1, l, r, L, m), mx(2 * v + 2, l, r, m, R));
}

int main()
{
    int n;
    cin >> n;

    vector<ll> h(n);
    for (ll& i : h)
        cin >> i;

    ll nn = n;
    while (1 << __lg(n) != n)
    {
        n++;
        h.push_back(0);
    }

    tree.resize(2 * n, 0);
    build_tree(0, 0, n, h);

    vector<pair<int, int>> lr(nn);
    for (int i = 0; i < nn; i++)
        lr[i] = { i, i };

    nn--;
    while (nn--)
    {
        int x;
        cin >> x;

        lr[x - 1].second = lr[x].second;

        ll res = 0, v;
        for (int i = lr[x - 1].first; i <= lr[x - 1].second; i++)
        {
            //if (i == lr[x - 1].first || h[i] > h[i - 1])
                v = min(mx(0, lr[x - 1].first, i + 1, 0, n), mx(0, i + 1, lr[x - 1].second + 1, 0, n));
            res += (v - h[i]) * ((v - h[i]) > 0);
        }
        lr.erase(lr.begin() + x);

        cout << res << '\n';
    }

    return 0;
}

/*
8
9 1 8 1 5 2 3 6
3 3 1 3 3 2 1
*/

/*int solve(string l, string r, map<char, int> pr)
{
    int ans = 0;
    int lll = stoi(l), rrr = stoi(r);
    for (int i = lll; i <= rrr; i++)
    {
        string si = to_string(i);
        if (count(si.begin(), si.end(), '1') == si.size() - 1)
            for (char c : si)
                if (pr[c])
                    ans++;
    }
    return ans;
}

int main()
{
    string l, r;
    cin >> l >> r;

    map<char, int> pr;
    pr['2'] = 1;
    pr['3'] = 1;
    pr['5'] = 1;
    pr['7'] = 1;

    /*for (int i = 1; i <= 1111; i++)
        for (int j = i; j <= 1111; j++)
    {
        l = to_string(i);
        r = to_string(j);
    //int anss = solve(l, r, pr);

    bool z = 1;
    ll ans = 0, cntl = count(l.begin(), l.end(), '1'), cntr = count(r.begin(), r.end(), '1');
    while (cntl != l.size())
    {
        if (l.size() > r.size())
        {
            z = 0;
            break;
        }
        if (l == r)
            z = 0;
        if (!z)
            break;
        if (cntl == l.size() - 1)
        {
            for (char c : l)
                if (pr[c])
                    ans++;
        }
        l.back()++;
        if (l.back() == '1')
            cntl++;
        else if (l.back() == '2')
            cntl--;
        for (int i = l.size() - 1; i > 0 && l[i] > '9'; i--)
        {
            if (l[i - 1] == '1')
                cntl--;
            else if (l[i - 1] == '0')
                cntl++;
            l[i] = '0';
            l[i - 1]++;
        }

        if (l[0] > '9')
        {
            l[0] = '0';
            l = "1" + l;
            cntl++;
        }
        if (!z)
            break;
    }
    //cout << l << ' ' << ans << '\n';
    while (cntr != r.size() && z && r.size() >= l.size())
    {
        if (cntr == r.size() - 1)
        {
            for (char c : r)
                if (pr[c])
                    ans++;
        }
        r.back()--;
        if (r.back() == '1')
            cntr++;
        else if (r.back() == '0')
            cntr--;
        for (int i = r.size() - 1; i > 0 && r[i] < '0'; i--)
        {
            if (r[i - 1] == '1')
                cntr--;
            else if (r[i - 1] == '2')
                cntr++;
            r[i] = '9';
            r[i - 1]--;
        }

        if (r[0] < '1')
        {
            r.erase(r.begin());
        }
    }

    while (l.size() < r.size())
    {
        ans += l.size() * 4;
        l = '1' + l;
    }

        /*if (ans != anss)
            cout << i << ' ' << j << '\n';
    }
    //cout << anss << ' ' << ans << '\n';
    cout << ans << '\n';

    return 0;
}*/
