#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;

int n, k;
vector<ll> tree, a;
void build_tree(int v, int L, int R)
{
    if (L + 1 == R)
    {
        tree[v] = a[L];
        return;
    }
    int m = (L + R) / 2;
    build_tree(2 * v + 1, L, m);
    build_tree(2 * v + 2, m, R);
    tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
}

ll mn(int v, int l, int r, int L, int R)
{
    if (L >= l && R <= r)
        return tree[v];
    if (L >= r || R <= l)
        return 1e9;
    int m = (L + R) / 2;
    return min(mn(2 * v + 1, l, r, L, m), mn(2 * v + 2, l, r, m, R));
}

ll solve()
{
    ll ans = 0;
    for (int i = 0; i < k; i++)
    {
        ll sum = 0;
        for (int j = i; j < i + n - k + 1; j++)
            sum += a[j];
        ll mini = 1e9;
        for (int j = 0; j < i; j++)
            mini = min(mini, a[j]);
        for (int j = i + k; j < n; j++)
            mini = min(mini, a[j]);
        ans = max(ans, sum - mini);
    }
    return ans;
}

int main()
{
    cin >> n >> k;

    a.resize(n);
    for (ll& i : a)
        cin >> i;

    cout << solve();

    /*ll nn = n;
    while (1 << __lg(n) != n)
    {
        n++;
        a.push_back(1e9);
    }

    tree.resize(2 * n);
    build_tree(0, 0, n);

    ll ans = 0, sum = 0;
    for (int i = 0; i < nn - k + 1; i++)
        sum += a[i];
    int l = 0, r = nn - k + 1;
    for (; r < nn; r++, l++)
    {
        ans = max(ans, sum - min(mn(0, r - 1, nn, 0, n), mn(0, 0, l, 0, n)));
        sum -= a[l];
        sum += a[r];
    }
    ans = max(ans, sum - min(mn(0, r - 1, nn, 0, n), mn(0, 0, l, 0, n)));
    cout << ans;
*/
    return 0;
}
