#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <string>

using namespace std;

int dti(char x)
{
  return x - '0';
}

int primesIn(int a, int b)
{
  int res = 0;
  if (a <= 2 && b >= 2)
    res++;
  if (a <= 3 && b >= 3)
    res++;
  if (a <= 5 && b >= 5)
    res++;
  if (a <= 7 && b >= 7)
    res++;

  return res;
}

bool isPrime(int a)
{
  return a == 2 || a == 3 || a == 5 || a == 7;
}

int checkUp(const string &A)
{
  int answer = 0;
  bool isSmall = true;


  for (int i = 0; i < A.size(); i++)
  {
    if (A[i] > '1')
      isSmall = false;

    if (A[i] <= '1')
    {
      answer += 4;
    }
    else
    {
      answer += primesIn(dti(A[i]) + 1, 9);
      
      bool extra = isPrime(dti(A[i]));

      for (int j = i + 1; j < A.size() && extra; j++)
        if (A[j] > '1')
        {
          extra = false;
        }
        else if (A[j] == '0')
          break;

      answer += extra;

      if (!isSmall)
        break;
    }
  }
  return answer;
}

int checkDown(const string &B)
{
  int answer = 0;
  bool isSmall = true;
  bool foundEdge = false;

  for (int i = 0; i < B.size(); i++)
  {
    /*
    if (B[i] > '1')
      isSmall = false;
    /**/
    if (i == 0 || !foundEdge)
    {
      if (B[i] == '0')
        return answer;

      answer += primesIn(1, dti(B[i]) - 1);

      bool extra = isPrime(dti(B[i]));

      for (int j = i + 1; j < B.size() && extra; j++)
        if (B[j] == '0')
        {
          extra = false;
        }
        else if (B[j] > '1')
          break;

      answer += extra;

      if (B[i] != '1')
        foundEdge = true;
    }
    else
    {
      answer += 4;
    }
  }

  return answer;
}

bool check(const string &A)
{
  bool hasPrime = false;

  for (int i = 0; i < A.size(); i++)
    if (A[i] == '0')
      return false;
    else if (isPrime(dti(A[i])))
      if (hasPrime)
        return false;
      else
        hasPrime = true;
    else if (A[i] != '1')
      return false;

  return hasPrime;
}

int main()
{
  string l, r;
  int answer = 0;

  getline(cin, l);
  getline(cin, r);

  int lgL = l.size();
  int lgR = r.size();

  cout << checkDown(l) << endl << checkUp(l) << endl;
  //cout << check(l);

  if (lgL == lgR)
  {
    answer += checkUp(l);
    answer += checkDown(r);

    answer -= checkDown(l);
    answer -= checkUp(r);

    answer += check(l);
    answer += check(r);

    answer /= 2;
  }
  else
  {
    answer += checkUp(l);

    if (lgR - 1 > lgL)
      answer += 2 * ((lgR - 1) * lgR - lgL * (lgL + 1));

    answer += checkDown(r);
  }

  cout << answer;
  return 0;
}
