#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <string>

using namespace std;

struct splitting
{
  vector<long long> A = {};
  vector<int> Relation = {};
  vector<int> Sums = {};
  int lowest = 0, highest = 0;

  void append(long long Num)
  {
    if (Relation.empty())
    {
      A.push_back(Num);
      Relation.push_back(0);
      Sums.push_back(Num);
    }
    else
    {
      A.push_back(Num);
      Relation.push_back(Relation[Relation.size() - 1]);
      Sums[Relation[Relation.size() - 1]] += Num;
    }
  }
  
  void split(int start)
  {
    Sums.push_back(0);
    bool checkHigh = Relation[start] == highest;
    bool checkLow = lowest != Relation[start];

    for (int i = start; i < Relation.size(); i++)
    {
      Sums[Relation[i]] -= A[i];
      Relation[i]++;
      Sums[Relation[i]] += A[i];
    }
    
    if (checkLow)
    {
      if (Sums[Sums.size() - 1] < Sums[lowest])
        lowest = Sums.size() - 1;

      if (Sums[Sums.size() - 2] < Sums[lowest])
        lowest = Sums.size() - 2;
    }
    else
    {
      if (Sums[Sums.size() - 1] > Sums[Sums.size() - 2])
        lowest = Sums.size() - 2;
      else
        lowest = Sums.size() - 1;
    }

    if (checkHigh)
    {
      //reeval
      highest = 0;
      for (int i = 0; i < Sums.size(); i++)
        if (Sums[i] > Sums[highest])
          highest = i;
    }
  }

  void merge(int start)
  {
    Sums[Relation[start - 1]] += Sums[Relation[start]];
    Sums.erase(Sums.begin() + Relation[start], Sums.begin() + Relation[start] + 1);

    if (Relation[start] == highest)
      highest--;

    if (Relation[start - 1] == lowest || Relation[start] == lowest)
    {
      //reeval
      lowest = 0;
      for (int i = 0; i < Sums.size(); i++)
        if (Sums[i] < Sums[lowest])
          lowest = i;
    }

    for (int i = start; i < Relation.size(); i++)
      Relation[i]--;
  }

  long long perekos(void)
  {
    return Sums[highest] - Sums[lowest];
  }

  long long manualPerekos(void)
  {
    long long lowest = -1, highest = -1;
    int cur_rel = 0;
    long long cur_sum = 0;


    for (int i = 0; i < A.size(); i++)
    {
      if (Relation[i] != cur_rel)
      {
        //store sum
        if (lowest == -1 || cur_sum < lowest)
          lowest = cur_sum;
        if (highest == -1 || cur_sum > highest)
          highest = cur_sum;
        

        cur_sum = A[i];
        cur_rel = Relation[i];
      }
      else
      {
        cur_sum += A[i];
      }
    }

    //store sum
    if (lowest == -1 || cur_sum < lowest)
      lowest = cur_sum;
    if (highest == -1 || cur_sum > highest)
      highest = cur_sum;

    return highest - lowest;
  }
};

//vector<long long> A;

splitting S;

int n, k;

long long best_perekos = 0;

void Step(int previousSplit, int Depth)
{
  if (Depth == 1)
  {
    long long perekos = S.manualPerekos();
    /**
    for (auto Rel : S.Relation)
      cout << Rel << " ";
    cout << endl;

    for (int i = 0; i < S.Sums.size(); i++)
      cout << S.Sums[i] << (i == S.lowest ? "." : "") << (i == S.highest ? "'" : "") << " ";
    cout << "-> " << perekos << endl;
    /**/
    if (perekos > best_perekos)
      best_perekos = perekos;
  }
  else
  {
    for (int i = previousSplit + 1; i + Depth - 1 <= n; i++)
    {
      S.split(i);
      Step(i, Depth - 1);
      S.merge(i);
    }
  }
}

int main()
{
  

  cin >> n;
  cin >> k;
  
  for (int i = 0; i < n; i++)
  {
    long long a;
    cin >> a;
    //A.push_back(a);
    S.append(a);
  }

  /*
  S.split(1);
  cout << S.perekos() << endl;
  S.split(3);
  cout << S.perekos() << endl;
  S.merge(1);
  cout << S.perekos() << endl;
  /**/
  Step(0, k);

  cout << best_perekos;
  return 0;
}
