#include <iostream>
#include <cmath>
#include <string>

using namespace std;

typedef unsigned long long ll;

int primes[] = { 2, 3, 5, 7 };

ll sub_digi(const char* num, ll num_size)
{
	ll res = 0;

	for (int i = num_size - 1; i >= 0; i--)
		for (int j = 0; j < 4; j++)
		{
			bool flag = false;

			for (int k = 0; k < num_size; k++)
			{
				int d = 1;
				if (k == i)
					d = primes[j];
				
				if (num[k] - '0' < d)
					return res;
				else if (num[k] - '0' > d)
				{
					res++;
					flag = true;
					break;
				}
			}
			if (!flag)
				res++;
		}
	return res;
}

ll digi(const char* num, ll num_size)
{
	if (num_size == 0)
		return 0;
	int first_not_one = 0;

	while (first_not_one < num_size && num[first_not_one] == '1')
		first_not_one++;

	if (first_not_one >= num_size)
		return 2 * (num_size - 1) * num_size;

	ll res = sub_digi(num + first_not_one, num_size - first_not_one);
	if (num_size > 1)
		res += 2 * (num_size - 1) * num_size;
	return res;
}

bool is_primy(const char* num, ll num_size)
{
	bool prime_found = false;

	for (int i = 0; i < num_size; i++)
	{
		if (num[i] != '1')
		{
			if (prime_found)
				return false;
			for (int j = 0; j < 4; j++)
				if (num[i] - '0' == primes[j])
				{
					prime_found = true;
					break;
				}
			if (!prime_found)
				return false;
		}
	}
	return prime_found;
}

ll main1(const char *l, ll l_size, const char* r, ll r_size)
{
	return digi(r, r_size) - digi(l, l_size) + is_primy(l, l_size);
}

ll string_to_num(string& num)
{
	ll mul = 1, res = 0;

	for (int i = num.size() - 1; i >= 0; i--)
	{
		res += (num[i] - '0') * mul;
		mul *= 10;
	}
	return res;
}

ll main2(ll l, ll r)
{
	ll res = 0;
	for (ll n = l; n <= r; n++)
	{
		bool prime_found = false;
		ll n1 = n;

		while (n1 > 0)
		{
			if (n1 % 10 != 1)
			{
				if (prime_found)
				{
					prime_found = false;
					break;
				}
				for (int j = 0; j < 4; j++)
					if (n1 % 10 == primes[j])
					{
						prime_found = true;
						break;
					}
				if (!prime_found)
					break;
			}
			n1 /= 10;
		}
		res += prime_found;
	}
	return res;
}

void num_to_string(ll num, string& str)
{
	while (num > 0)
	{
		str += (num % 10) + '0';
		num /= 10;
	}
	for (int i = 0; i < str.size() / 2; i++)
		swap(str[i], str[str.size() - 1 - i]);
}

int main()
{
	string l, r;

	cin >> l >> r;
	cout << main1(l.c_str(), l.size(), r.c_str(), r.size());
	/*
	string l = "1";

	for (ll i = 1; i <= 100000; i++)
	{
		string r = "";
		num_to_string(i, r);
		ll res1 = main1(l.c_str(), 1, r.c_str(), r.size()), res2 = main2(1, i);

		if (res1 != res2)
		{
			cout << "ERROR: " << res1 << " != " << res2 << endl;
			cout << "INFO: l = 1, r = " << r << ", i = " << i << endl;
			break;
		}

		if (i % 100 == 0)
			cout << i << endl;
	}
	*/
	return 0;
}