#include <iostream>
#include <cmath>
#include <string>
#include <vector>

using namespace std;

typedef long long ll;

struct block
{
	ll h, maxl, maxr, d, dl, dr;
};

vector<vector<block>> segments {};

void concat(ll k)
{
	ll p = segments[k].size();

	// Concatinating vectors
	segments[k].reserve(segments[k].size() + segments[k + 1].size());
	for (ll i = 0; i < segments[k + 1].size(); i++)
		segments[k].push_back(segments[k + 1][i]);
	segments.erase(segments.begin() + k + 1);

	// Concatinating values and calculating summory
	
	ll d = 0, d1 = 0;

	// right part
	for (ll i = p; i < segments[k].size(); i++)
	{
		segments[k][i].maxl = max(segments[k][i - 1].maxl, segments[k][i - 1].h);
		segments[k][i].d = max((ll)0, min(segments[k][i].maxl, segments[k][i].maxr) - segments[k][i].h);
		d += segments[k][i].d;
		segments[k][i].dl = d1;
		d1 += segments[k][i].d;
		if (segments[k][i].h > segments[k][i].maxl)
		{
			d += segments[k][i].dr;
			break;
		}
	}
	// left part
	d1 = 0;
	for (ll i = p - 1; i >= 0; i--)
	{
		segments[k][i].maxr = max(segments[k][i + 1].maxr, segments[k][i + 1].h);
		segments[k][i].d = max((ll)0, min(segments[k][i].maxl, segments[k][i].maxr) - segments[k][i].h);
		d += segments[k][i].d;
		segments[k][i].dr = d1;
		d1 += segments[k][i].d;
		if (segments[k][i].h > segments[k][i].maxr)
		{
			d += segments[k][i].dl;
			break;
		}
	}

	cout << d << endl;
}

int main()
{
	int n;
	cin >> n;

	segments.reserve(n);

	for (int i = 0; i < n; i++)
	{
		ll h;

		cin >> h;
		segments.push_back({});
		segments[segments.size() - 1].push_back(block{h, 0, 0, 0, 0, 0});
	}

	for (int i = 0; i < n - 1; i++)
	{
		ll k;

		cin >> k;
		k--;
		concat(k);
	}
	return 0;
}