#include <iostream>
#include <algorithm>
#include <vector>


using namespace std;

using str = string;
using ll = long long;


struct node {
	int mx, ind;

	node() : mx(0), ind(-1) {}
	node(int mx, int ind) : mx(mx), ind(ind) {}
};

node operator+(node& a, node& b) {
	if (a.mx >= b.mx) {
		return node(a.mx, a.ind);
	}
	return node(b.mx, b.ind);
}


struct seg_tree {
	int sz;
	vector<int> a;
	vector<node> t;

	seg_tree(vector<int>& arr) {
		sz = (int)arr.size();
		a = arr;
		t.resize(4 * sz);
		build(0, 0, sz);
	}

	void build(int v, int l, int r) {
		if (l + 1 == r) {
			t[v] = node(a[l], l);
			return;
		}
		int m = (l + r) / 2;
		int l_u = 2 * v + 1, r_u = 2 * v + 2;
		build(l_u, l, m);
		build(r_u, m, r);
		t[v] = t[l_u] + t[r_u];
	}

	int get(int ql, int qr) {
		return get_(0, 0, sz, ql, qr).mx;
	}
	node get_(int v, int l, int r, int ql, int qr) {
		if (qr <= l || r <= ql) return node();
		if (ql <= l && r <= qr) return t[v];
		int m = (l + r) / 2;
		int l_u = 2 * v + 1, r_u = 2 * v + 2;
		node res_l = get_(l_u, l, m, ql, qr);
		node res_r = get_(r_u, m, r, ql, qr);
		return (res_l + res_r);
	}
};


signed main() {
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);


	int n;
	cin >> n;
	vector<int> h(n);
	for (auto& i : h) {
		cin >> i;
	}


	vector<int> num(n);
	seg_tree st(h);
	for (int i = 0; i < n; i++) num[i] = i;
	for (int i = 0; i < n - 1; i++) {
		int k;
		cin >> k;
		k--;
		int l;
		for (int j = 0; j < n; j++) {
			if (num[j] == k) {
				l = j;
				break;
			}
		}
		int r;
		for (int j = n - 1; j >= 0; j--) {
			if (num[j] == k + 1) {
				r = j;
				break;
			}
		}
		for (int j = 0; j < n; j++) {
			if (num[j] > k) num[j]--;
		}
		ll ans = 0;
		for (int j = l; j <= r; j++) {
			ans += min(st.get(l, j + 1), st.get(j, r + 1)) - h[j];
		}
		cout << ans << "\n";
	}
} 