#include <iostream>
#include <algorithm>
#include <vector>


using namespace std;

using str = string;
using ll = long long;

#define int ll


struct node_mx {
	int mx, ind;

	node_mx() : mx(0), ind(-1) {}
	node_mx(int mx, int ind) : mx(mx), ind(ind) {}
};
node_mx operator+(node_mx& a, node_mx& b) {
	if (a.mx >= b.mx) {
		return node_mx(a.mx, a.ind);
	}
	return node_mx(b.mx, b.ind);
}
struct seg_tree_mx {
	int sz;
	vector<int> a;
	vector<node_mx> t;

	void init(vector<int>& arr) {
		sz = (int)arr.size();
		a = arr;
		t.resize(4 * sz);
		build(0, 0, sz);
	}

	void build(int v, int l, int r) {
		if (l + 1 == r) {
			t[v] = node_mx(a[l], l);
			return;
		}
		int m = (l + r) / 2;
		int l_u = 2 * v + 1, r_u = 2 * v + 2;
		build(l_u, l, m);
		build(r_u, m, r);
		t[v] = t[l_u] + t[r_u];
	}

	node_mx get(int ql, int qr) {
		return get_(0, 0, sz, ql, qr);
	}
	node_mx get_(int v, int l, int r, int ql, int qr) {
		if (qr <= l || r <= ql) return node_mx();
		if (ql <= l && r <= qr) return t[v];
		int m = (l + r) / 2;
		int l_u = 2 * v + 1, r_u = 2 * v + 2;
		node_mx res_l = get_(l_u, l, m, ql, qr);
		node_mx res_r = get_(r_u, m, r, ql, qr);
		return (res_l + res_r);
	}

	int getl(int ql, int x) {
		return getl_(0, 0, sz, ql, x);
	}
	int getl_(int v, int l, int r, int ql, int x) {
		if (r <= ql || t[v].mx < x) return -1;
		if (l + 1 == r) return l;
		int m = (l + r) / 2;
		int l_u = 2 * v + 1, r_u = 2 * v + 2;
		int res = getl_(l_u, l, m, ql, x);
		if (res == -1) {
			res = getl_(r_u, m, r, ql, x);
		}
		return res;
	}

	int getr(int qr, int x) {
		return getr_(0, 0, sz, qr, x);
	}
	int getr_(int v, int l, int r, int qr, int x) {
		if (qr <= l || t[v].mx < x) return -1;
		if (l + 1 == r) return l;
		int m = (l + r) / 2;
		int l_u = 2 * v + 1, r_u = 2 * v + 2;
		int res = getr_(r_u, m, r, qr, x);
		if (res == -1) {
			res = getr_(l_u, l, m, qr, x);
		}
		return res;
	}
};


struct node_num {
	int mx, mn, add;

	node_num() : mx(-1), mn(1e9), add(0) {}
	node_num(int x) : mx(x), mn(x), add(0) {}
	node_num(int mx, int mn) : mx(mx), mn(mn), add(0) {}
};
node_num operator+(node_num& a, node_num& b) {
	return node_num(max(a.mx, b.mx), min(a.mn, b.mn));
}
struct seg_tree_num {
	int sz;
	vector<node_num> t;

	void init(int sz_) {
		sz = sz_;
		t.resize(4 * sz);
		build(0, 0, sz);
	}

	void build(int v, int l, int r) {
		if (l + 1 == r) {
			t[v] = node_num(l);
			return;
		}
		int m = (l + r) / 2;
		int l_u = 2 * v + 1, r_u = 2 * v + 2;
		build(l_u, l, m);
		build(r_u, m, r);
		t[v] = t[l_u] + t[r_u];
	}

	void apply(int v, int add) {
		t[v].mx += add;
		t[v].mn += add;
		t[v].add += add;
	}
	void push(int v) {
		if (t[v].add == 0) return;
		int l_u = 2 * v + 1, r_u = 2 * v + 2;
		apply(l_u, t[v].add);
		apply(r_u, t[v].add);
		t[v].add = 0;
	}

	void upd(int ql) {
		upd_(0, 0, sz, ql, sz, -1);
	}
	void upd_(int v, int l, int r, int ql, int qr, int add) {
		if (qr <= l || r <= ql) return;
		if (ql <= l && r <= qr) {
			apply(v, add);
			return;
		}
		push(v);
		int m = (l + r) / 2;
		int l_u = 2 * v + 1, r_u = 2 * v + 2;
		upd_(l_u, l, m, ql, qr, add);
		upd_(r_u, m, r, ql, qr, add);
		t[v] = t[l_u] + t[r_u];
	}

	int getl(int x) {
		return getl_(0, 0, sz, x);
	}
	int getl_(int v, int l, int r, int x) {
		if (t[v].mx < x || x < t[v].mn) return -1;
		if (l + 1 == r) return l;
		push(v);
		int m = (l + r) / 2;
		int l_u = 2 * v + 1, r_u = 2 * v + 2;
		int res = getl_(l_u, l, m, x);
		if (res == -1) {
			res = getl_(r_u, m, r, x);
		}
		return res;
	}

	int getr(int x) {
		return getr_(0, 0, sz, x);
	}
	int getr_(int v, int l, int r, int x) {
		if (t[v].mx < x || x < t[v].mn) return -1;
		if (l + 1 == r) return l;
		push(v);
		int m = (l + r) / 2;
		int l_u = 2 * v + 1, r_u = 2 * v + 2;
		int res = getr_(r_u, m, r, x);
		if (res == -1) {
			res = getr_(l_u, l, m, x);
		}
		return res;
	}
};


struct node {
	ll sm;
	bool push;

	node() : sm(0), push(false) {}
	node(int x) : sm(x), push(false) {}
};
node operator+(node& a, node& b) {
	return node(a.sm + b.sm);
}
struct seg_tree {
	int sz;
	vector<int> a;
	vector<node> t;

	void init(vector<int>& arr) {
		sz = (int)arr.size();
		a = arr;
		t.resize(4 * sz);
		build(0, 0, sz);
	}

	void build(int v, int l, int r) {
		if (l + 1 == r) {
			t[v] = node(a[l]);
			return;
		}
		int m = (l + r) / 2;
		int l_u = 2 * v + 1, r_u = 2 * v + 2;
		build(l_u, l, m);
		build(r_u, m, r);
		t[v] = t[l_u] + t[r_u];
	}

	void apply(int v) {
		t[v].sm = 0;
		t[v].push = true;
	}
	void push(int v) {
		if (!t[v].push) return;
		int l_u = 2 * v + 1, r_u = 2 * v + 2;
		apply(l_u);
		apply(r_u);
		t[v].push = false;
	}

	void upd(int ind, int x) {
		upd_(0, 0, sz, ind, x);
	}
	void upd_(int v, int l, int r, int ind, int x) {
		if (l + 1 == r) {
			t[v] = node(x);
			return;
		}
		push(v);
		int m = (l + r) / 2;
		int l_u = 2 * v + 1, r_u = 2 * v + 2;
		if (ind < m) {
			upd_(l_u, l, m, ind, x);
		}
		else {
			upd_(r_u, m, r, ind, x);
		}
		t[v] = t[l_u] + t[r_u];
	}

	void updlr(int ql, int qr) {
		return updlr_(0, 0, sz, ql, qr);
	}
	void updlr_(int v, int l, int r, int ql, int qr) {
		if (qr <= l || r <= ql) return;
		if (ql <= l && r <= qr) {
			apply(v);
			return;
		}
		push(v);
		int m = (l + r) / 2;
		int l_u = 2 * v + 1, r_u = 2 * v + 2;
		updlr_(l_u, l, m, ql, qr);
		updlr_(r_u, m, r, ql, qr);
		t[v] = t[l_u] + t[r_u];
	}

	ll get(int ql, int qr) {
		return get_(0, 0, sz, ql, qr).sm;
	}
	node get_(int v, int l, int r, int ql, int qr) {
		if (qr <= l || r <= ql) return node();
		if (ql <= l && r <= qr) return t[v];
		push(v);
		int m = (l + r) / 2;
		int l_u = 2 * v + 1, r_u = 2 * v + 2;
		node res_l = get_(l_u, l, m, ql, qr);
		node res_r = get_(r_u, m, r, ql, qr);
		return (res_l + res_r);
	}
};



seg_tree_mx st_mx;
seg_tree_num st_num;
seg_tree st1, st2;

vector<ll> ps;


void upd(int l, int m, int r) {
	node_mx mx1 = st_mx.get(l, m);
	node_mx mx2 = st_mx.get(m, r);
	//if (mx1.mx == mx2.mx) {
	//	st2.updlr(mx1.ind + 1, r);
	//	st2.upd(mx1.ind, 1ll * mx1.mx * (r - mx1.ind));
	//	st1.upd(mx2.ind, 1ll * mx2.mx * (mx2.ind - l + 1));
	//	st1.updlr(l, mx2.ind);
	//}
	if (mx1.mx >= mx2.mx) {
		int i = st_mx.getr(m, mx2.mx);
		if (i == -1) {
			i = l - 1;
		}
		st1.updlr(i + 1, m);
		st1.upd(mx2.ind, 1ll * mx2.mx * (mx2.ind - i));
		st2.upd(mx1.ind, 1ll * mx1.mx * (r - mx1.ind));
		st2.updlr(mx1.ind + 1, r);
	}
	else {
		int i = st_mx.getl(m, mx1.mx);
		st2.updlr(m, i);
		st2.upd(mx1.ind, 1ll * mx1.mx * (i - mx1.ind));
		st1.upd(mx2.ind, 1ll * mx2.mx * (mx2.ind - l + 1));
		st1.updlr(l, mx2.ind);
	}
}


ll get(int l, int r) {
	node_mx mx = st_mx.get(l, r);
	ll del = ps[r] - ps[l];
	ll ans = st2.get(l, mx.ind) + st1.get(mx.ind + 1, r) - del + mx.mx;
	return ans;
}



signed main() {
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);


	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	st_mx.init(a);
	st_num.init(n);


	ps.resize(n + 1);
	ps[0] = 0;
	for (int i = 1; i <= n; i++) ps[i] = ps[i - 1] + a[i - 1];


	st_mx.init(a);
	st_num.init(n);
	st1.init(a);
	st2.init(a);
	for (int i = 0; i < n - 1; i++) {
		int k;
		cin >> k;
		k--;
		int l1 = st_num.getl(k);
		int r1 = st_num.getr(k);
		int l2 = r1 + 1;
		int r2 = st_num.getr(k + 1);
		st_num.upd(l2);
		upd(l1, l2, r2 + 1);
		cout << get(l1, r2 + 1) << "\n";
		//for (int i = 0; i < n; i++) {
		//	cout << st1.get(i, i + 1) << " ";
		//}
		//cout << "\n";
		//for (int i = 0; i < n; i++) {
		//	cout << st2.get(i, i + 1) << " ";
		//}
		//cout << "\n";
	}
}