#include <iostream>
#include <algorithm>
#include <vector>


using namespace std;

using str = string;
using ll = long long;
using pii = pair<int, int>;

//#define int ll


const int MOD = 1e9 + 7;


vector<int> fact;
void make_fact(int sz) {
	fact.resize(sz);
	fact[0] = 1;
	for (int i = 1; i < sz; i++) {
		fact[i] = (1ll * fact[i - 1] * i) % MOD;
	}
}

int pow(int x, int deg) {
	if (deg == 0) return 1;
	if (deg % 2 == 0) {
		int res = pow(x, deg / 2);
		return (1ll * res * res) % MOD;
	}
	else {
		int res = pow(x, deg - 1);
		return (1ll * res * x) % MOD;
	}
}

int inv(int x) {
	return pow(x, MOD - 2);
}

int cnk(int n, int k) {
	int res = fact[n];
	res = (1ll * res * inv(fact[n - k])) % MOD;
	res = (1ll * res * inv(fact[k])) % MOD;
	return res;
}


signed main() {
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);


	int n, m, k;
	cin >> n >> m >> k;


	make_fact(n + m + 1);
	if (k == 0) {
		cout << cnk(n + m - 2, n - 1);
	}
}