#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = 1e9 + 7;

int binpow(ll x, ll pw) {
    ll res = 1;
    ll cur = x;
    while (pw) {
        if (pw & 1) res = res * cur % mod;
        cur = cur * cur % mod;
        pw >>= 1;
    }
    return res;
}

int rev(int x) {
    return binpow(x, mod - 2);
}

void add(int &a, int b) {
    a += b;
    if (a >= mod) a -= mod;
}

int sum(int a, int b) {
    a += b;
    if (a >= mod) a -= mod;
    return a;
}

void sub(int &a, int b) {
    a -= b;
    if (a < 0) a += mod;
}

int dif(int a, int b) {
    a -= b;
    if (a < 0) a += mod;
    return a;
}

int mult(int a, int b) {
    return 1LL * a * b % mod;
}

const int MAXA = 2020202;
int f[MAXA];
int rf[MAXA];

int C(int n, int k) {
    if (k < 0 || k > n) return 0;
    return 1LL * f[n] * rf[k] % mod * rf[n - k] % mod;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m, k;
    cin >> n >> m >> k;
    vector<array<int, 2>> p(k);
    for (int i = 0; i < k; i++) cin >> p[i][0] >> p[i][1];

    f[0] = 1;
    for (int i = 1; i <= n + m; i++) f[i] = 1LL * f[i - 1] * i % mod;
    rf[n + m] = rev(f[n + m]);
    for (int i = n + m; i >= 1; i--) rf[i - 1] = 1LL * rf[i] * i % mod;

    array<int, 2> start = {1, 1};
    array<int, 2> finish = {n, m};

    assert(k == 0);
    int ans = mult(C(n + m - 4, n - 2), C(n + m - 4, n - 2));
    sub(ans, mult(C(n + m - 6, n - 3), C(n + m - 6, n - 3)));
    ans = mult(ans, 2);
    cout << ans << '\n';
}
