def merge_blocks(index: int, h) -> None:
    new_segment = []

    if isinstance(h[index], list):
        new_segment.extend(h[index])
    else:
        new_segment.append(h[index])

    if isinstance(h[index + 1], list):
        new_segment.extend(h[index + 1])
    else:
        new_segment.append(h[index + 1])

    h[index] = new_segment
    h.pop(index + 1)


def count_segment_depth(index: int, h) -> int:
    segment = h[index]
    segment_depth = 0

    for block_index in range(1, len(segment) - 1):
        block = segment[block_index]
        max_left_block = max(segment[:block_index])
        max_right_block = max(segment[block_index + 1:])

        if block >= max_left_block or block >= max_right_block:
            continue

        segment_depth += min(max_left_block, max_right_block) - block

    return segment_depth


def main():
    n = int(input())
    h = list(map(int, input().split()))
    k = map(int, input().split())

    for kj in k:
        kj -= 1
        merge_blocks(kj, h)
        print(count_segment_depth(kj, h))


if __name__ == "__main__":
    main()