﻿#include "iostream"
#include "vector"
#include "set"
#include "map"
#include "algorithm"
#include <string>

using namespace std;

#define int long long

int inf = 1000 * 1000 * 1000 * 2;

struct node
{
	int sum;
	int mn;
	int mx;
};

struct st
{
	vector <node> t;
	vector <int> p;
	vector <int> a;

	void build(vector <int>& aa)
	{
		a = aa;
		t.resize(4 * a.size());
		p.resize(4 * a.size());

		build2(0, 0, a.size() - 1);
	}

	node merge(node a, node b)
	{
		node ans;
		ans.sum = a.sum + b.sum;
		ans.mn = min(a.mn, b.mn);
		ans.mx = max(a.mx, b.mx);
		return ans;
	}

	void push(int v, int l, int r)
	{
		if (p[v] != 0)
		{
			p[v * 2 + 1] = 0;
			p[v * 2 + 2] = 0;
			t[v * 2 + 1].mn = p[v];
			t[v * 2 + 2].mn = p[v];
			t[v * 2 + 1].mx = p[v];
			t[v * 2 + 2].mx = p[v];
			int m = (l + r) / 2;
			t[v * 2 + 1].sum = p[v] * (m - l + 1);
			t[v * 2 + 2].sum = p[v] * (r - m);
			p[v] = 0;
		}
	}

	void build2(int v, int l, int r)
	{
		if (l == r)
		{
			t[v].sum = a[l];
			t[v].mn = a[l];
			t[v].mx = a[l];
			return;
		}
		int m = (l + r) / 2;
		build2(v * 2 + 1, l, m);
		build2(v * 2 + 2, m + 1, r);
		t[v] = merge(t[v * 2 + 1], t[v * 2 + 2]);
	}

	int get_sum(int v, int l, int r, int ll, int rr)
	{
		if (ll > rr)
		{
			return 0;
		}
		if (l == ll && r == rr)
		{
			return t[v].sum;
		}

		push(v, l, r);
		int m = (l + r) / 2;
		return get_sum(v * 2 + 1, l, m, ll, min(m, rr)) + get_sum(v * 2 + 2, m + 1, r, max(m + 1, ll), rr);
	}

	int get_mn(int v, int l, int r, int ll, int rr)
	{
		if (ll > rr)
		{
			return inf;
		}
		if (l == ll && r == rr)
		{
			return t[v].mn;
		}

		push(v, l, r);
		int m = (l + r) / 2;
		return min(get_mn(v * 2 + 1, l, m, ll, min(m, rr)), get_mn(v * 2 + 2, m + 1, r, max(m + 1, ll), rr));
	}

	int get_mx(int v, int l, int r, int ll, int rr)
	{
		if (ll > rr)
		{
			return 0;
		}
		if (l == ll && r == rr)
		{
			return t[v].mx;
		}

		push(v, l, r);
		int m = (l + r) / 2;
		return max(get_mx(v * 2 + 1, l, m, ll, min(m, rr)), get_mx(v * 2 + 2, m + 1, r, max(m + 1, ll), rr));
	}

	void update(int v, int l, int r, int ll, int rr, int x)
	{
		if (ll > rr)
		{
			return;
		}

		if (l == ll && r == rr)
		{
			if (t[v].mx < x)
			{
				p[v] = x;
				t[v].mn = x;
				t[v].mx = x;
				t[v].sum = x * (r - l + 1);
				return;
			}
		}

		int m = (l + r) / 2;
		push(v, l, r);
		if (ll >= m + 1)
		{
			if (get_mn(0, 0, a.size() - 1, m + 1, r) < x)
			{
				update(v * 2 + 2, m + 1, r, ll, rr, x);
				t[v] = merge(t[v * 2 + 1], t[v * 2 + 2]);
			}
		}
		else if (rr <= m)
		{
			if (get_mn(0, 0, a.size() - 1, l, m) < x)
			{
				update(v * 2 + 1, l, m, ll, rr, x);
				t[v] = merge(t[v * 2 + 1], t[v * 2 + 2]);
			}
		}
		else
		{
			if (get_mn(0, 0, a.size() - 1, l, m) < x)
			{
				update(v * 2 + 1, l, m, ll, m, x);
			}
			if (get_mn(0, 0, a.size() - 1, m + 1, r) < x)
			{
				update(v * 2 + 2, m + 1, r, m + 1, rr, x);
			}
			t[v] = merge(t[v * 2 + 1], t[v * 2 + 2]);
		}
	}
};

struct st2
{
	vector <int> t;
	vector <int> h;
	
	void build(vector <int> hh)
	{
		h = hh;
		t.resize(4 * h.size());
		build2(0, 0, h.size() - 1);
	}

	int merge(int a, int b)
	{
		if (h[a] > h[b])
		{
			return a;
		}
		return b;
	}

	void build2(int v, int l, int r)
	{
		if (l == r)
		{
			t[v] = l;
			return;
		}
		int m = (l + r) / 2;
		build2(v * 2 + 1, l, m);
		build2(v * 2 + 2, m + 1, r);
		t[v] = merge(t[v * 2 + 1], t[v * 2 + 2]);
	}

	int get(int v, int l, int r, int ll, int rr)
	{
		if (l == ll && r == rr)
		{
			return t[v];
		}
		int m = (l + r) / 2;
		if (rr <= m)
		{
			return get(v * 2 + 1, l, m, ll, rr);
		}
		if (ll >= m + 1)
		{
			return get(v * 2 + 2, m + 1, r, ll, rr);
		}
		return merge(get(v * 2 + 1, l, m, ll, m), get(v * 2 + 2, m + 1, r, m + 1, rr));
	}
};

struct st3
{
	vector <int> t;
	vector <int> h;

	void build(vector <int> hh)
	{
		h = hh;
		t.resize(4 * h.size());
		build2(0, 0, h.size() - 1);
	}

	int merge(int a, int b)
	{
		return a + b;
	}

	void build2(int v, int l, int r)
	{
		if (l == r)
		{
			t[v] = h[l];
			return;
		}
		int m = (l + r) / 2;
		build2(v * 2 + 1, l, m);
		build2(v * 2 + 2, m + 1, r);
		t[v] = merge(t[v * 2 + 1], t[v * 2 + 2]);
	}

	int get(int v, int l, int r, int ll, int rr)
	{
		if (l == ll && r == rr)
		{
			return t[v];
		}
		int m = (l + r) / 2;
		if (rr <= m)
		{
			return get(v * 2 + 1, l, m, ll, rr);
		}
		if (ll >= m + 1)
		{
			return get(v * 2 + 2, m + 1, r, ll, rr);
		}
		return merge(get(v * 2 + 1, l, m, ll, m), get(v * 2 + 2, m + 1, r, m + 1, rr));
	}
};

struct st4
{
	vector <int> t;

	void build(int n)
	{
		t.resize(4 * n, 1);

		build2(0, 0, n - 1);
	}

	void build2(int v, int l, int r)
	{
		if (l == r)
		{
			t[v] = 1;
			return;
		}
		int m = (l + r) / 2;
		build2(v * 2 + 1, l, m);
		build2(v * 2 + 2, m + 1, r);
		t[v] = r - l + 1;
	}

	int merge(int a, int b)
	{
		return a + b;
	}

	int get(int v, int l, int r, int k)
	{
		if (l == r)
		{
			return l;
		}
		int m = (l + r) / 2;
		if (t[v * 2 + 1] >= k)
		{
			return get(v * 2 + 1, l, m, k);
		}
		return get(v * 2 + 2, m + 1, r, k - t[v * 2 + 1]);
	}

	void update(int v, int l, int r, int i, int x)
	{
		if (l == r)
		{
			t[v] = x;
			return;
		}
		int m = (l + r) / 2;
		if (i <= m)
		{
			update(v * 2 + 1, l, m, i, x);
		}
		else
		{
			update(v * 2 + 2, m + 1, r, i, x);
		}
		t[v] = merge(t[v * 2 + 1], t[v * 2 + 2]);
	}
};

void solve()
{
	int n;
	cin >> n;
	vector <int> h(n);
	for (int i = 0; i < n; i++)
	{
		cin >> h[i];
	}

	st2 st2;
	st2.build(h);

	st3 st3;
	st3.build(h);

	st4 st4;
	st4.build(n);

	vector <pair <int, int>> otr(n);
	for (int i = 0; i < n; i++)
	{
		otr[i] = { i, i };
	}

	st st_l;
	st st_r;

	st_l.build(h);
	st_r.build(h);

	for (int i = 0; i < n - 1; i++)
	{
		int k;
		cin >> k;

		int k2 = st4.get(0, 0, n - 1, k + 1);
		k = st4.get(0, 0, n - 1, k);

		//cout << k << " " << k2 << '\n';

		//cout << k << " g" << '\n';

		auto [l1, r1] = otr[k];
		auto [l2, r2] = otr[k2];

		int ind = st2.get(0, 0, n - 1, l1, r2);

		if (ind >= l2)
		{
			st_r.update(0, 0, n - 1, l1, r1, h[ind]);
			st_l.update(0, 0, n - 1, l2, r2, h[st2.get(0, 0, n - 1, l1, r1)]);

			//cout << st_l.get_sum(0, 0, n - 1, l1, ind - 1) << " " << st_r.get_sum(0, 0, n - 1, ind + 1, r2) << " " << h[ind] << " " << st3.get(0, 0, n - 1, l1, r2) << '\n';
		}
		else
		{
			st_l.update(0, 0, n - 1, l2, r2, h[ind]);
			st_r.update(0, 0, n - 1, l1, r1, h[st2.get(0, 0, n - 1, l2, r2)]);

			//cout << st_l.get_sum(0, 0, n - 1, l1, ind - 1) << " " << st_r.get_sum(0, 0, n - 1, ind + 1, r2) << " " << h[ind] << " " << st3.get(0, 0, n - 1, l1, r2) << '\n';
		}

		cout << st_l.get_sum(0, 0, n - 1, l1, ind - 1) + st_r.get_sum(0, 0, n - 1, ind + 1, r2) + h[ind] - st3.get(0, 0, n - 1, l1, r2) << '\n';

		otr[k2] = { l1, r2 };
		st4.update(0, 0, n - 1, k, 0);
	}
}

signed main()
{
#ifdef local
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif


	int _ = 1;
	//cin >> _;
	while (_--)
	{
		solve();
	}
}
