#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;
using ll = long long;
#define all(v) (v).begin(), (v).end()

const int mod = 1e9 + 7;

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<pair<int, int>> v(k);
    for (auto& [a, b] : v) {
        cin >> a >> b;
        a--, b--;
    }

    vector<vector<int>> diag(n + m - 1);
    for (auto [a, b] : v) {
        diag[a + b].push_back(a);
    }

    vector dp(n + m - 2, vector(n, vector<int>(n)));
    dp[0][0][0] = 1;
    for (int l = 1; l < dp.size(); l++) {
        if (diag[l].size() > 2) {
            cout << 0;
            return;
        }
        sort(all(diag[l]));

        for (int a = 0; a <= min(l, n - 1); a++) {
            for (int b = a + 1; b <= min(l, n - 1); b++) {
                if (diag[l].size() == 1 && a != diag[l][0] && b != diag[l][0]) continue;
                if (diag[l].size() == 2 && (a != diag[l][0] || b != diag[l][1])) continue;

                dp[l][a][b] = dp[l - 1][a][b];
                if (a > 0) {
                    dp[l][a][b] += dp[l - 1][a - 1][b];
                    if (dp[l][a][b] >= mod) dp[l][a][b] -= mod;
                    dp[l][a][b] += dp[l - 1][a - 1][b - 1];
                    if (dp[l][a][b] >= mod) dp[l][a][b] -= mod;
                }
                if (b > 0) {
                    dp[l][a][b] += dp[l - 1][a][b - 1];
                    if (dp[l][a][b] >= mod) dp[l][a][b] -= mod;
                }
            }
        }
    }

    // for (int l = 0; l < dp.size(); l++) {
    //     for (int a = 0; a < n; a++) {
    //         for (int b = 0; b < n; b++) {
    //             cout << l << " " << a << " " << b << ": " << dp[l][a][b] << "\n";
    //         }
    //     }
    // }

    cout << dp.back()[n - 2][n - 1] * 2 % mod;
}

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    solve();
}