#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;

int main() {
    ll n, k;

    cin >> n >> k;

    vector <ll> arr(n);
    vector <ll> pref_sum(n);

    for (int i = 0; i < n; i++) {
        cin >> arr[i];

        if (i != 0) {
            pref_sum[i] = pref_sum[i - 1] + arr[i];
        } else {
            pref_sum[0] = arr[0];
        }
    }

    ll l = 0;
    ll r = n - 1;

    ll min_el = LONG_MAX;
    ll max_el = LONG_MIN;

    ll last_right = n - 1;
    ll last_left = 0;

    ll all_sum = 0;

    for (ll i = 0; i < k - 1; i++) {
        if (arr[l] > arr[r]) {
            r--;

            ll need = pref_sum[r + 1] - pref_sum[r];

            min_el = min(need, min_el);
            max_el = max(need, max_el);     
        } else if (arr[l] == arr[r]) {
            int left = l;
            int right = r;

            bool flag = true;

            // true: r--
            // false: l++

            while (left < right) {
                left++;
                right--;

                if (arr[left] < arr[right]) {
                    flag = true;

                    break;
                } else if (arr[right] < arr[left]) {
                    flag = false;

                    break;
                }
            } 

            if (flag) {
                r--;

                ll need = pref_sum[r + 1] - pref_sum[r];

                min_el = min(need, min_el);
                max_el = max(need, max_el);  
            } else {
                ll need = pref_sum[l];

                if (l > 0) {
                    need -= pref_sum[l - 1];
                }

                min_el = min(need, min_el);
                max_el = max(need, max_el);

                l++;
            }
        } else {
            ll need = pref_sum[l];

            if (l > 0) {
                need -= pref_sum[l - 1];
            }

            min_el = min(need, min_el);
            max_el = max(need, max_el);

            l++;
        }
    }

    all_sum = pref_sum[r];

    if (l > 0) {
        all_sum -= pref_sum[l - 1];
    }

    min_el = min(min_el, all_sum);
    max_el = max(max_el, all_sum);

    // cout << min_el << " " << max_el << "\n";
    // cout << l << " " << r << "\n";

    cout << abs(max_el - min_el) << "\n";
}