﻿#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
ll mod = 1e9 + 7;

vector <int> tree;
vector <ll> a;

void build(int v, int l, int r) {
    if (l + 1 == r) {
        tree[v] = a[l];
        return;
    }
    build(v * 2 + 1, l, (l + r) / 2);
    build(v * 2 + 2, (l + r) / 2, r);
    tree[v] = min(tree[v * 2 + 1], tree[v * 2 + 2]);
}

ll get(int v, int l, int r, int ql, int qr) {
    if (l >= qr || r <= ql) return 1e10;
    if (l >= ql && r <= qr) return tree[v];
    return min(get(v * 2 + 1, l, (l + r) / 2, ql, qr), get(v * 2 + 2, (l + r) / 2, r, ql, qr));
}

void solB() {
    int n, k;
    cin >> n >> k;
    a.resize(n + 1); tree.resize(n * 10, 1e10);
    vector <ll> pref(n + 2);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pref[i] = pref[i - 1] + a[i];
    }
    a[0] = 1e10;
    build(0, 1, n + 1);
    ll ans = 0;
    int t = k;
    for (int i = 0; i <= t; i++) {
        if (ans < (pref[i + n - t + 1] - pref[i]) - min(get(0, 1, n + 1, 0, i + 1), get(0, 1, n + 1, i + n - t + 2, n + 1))) 
            ans = pref[i + n - t + 1] - pref[i] - min(get(0, 1, n + 1, 0, i + 1), get(0, 1, n + 1, i + n - t + 2, n + 1));
    }
    t--;
    for (int i = 0; i <= t; i++) {
        if (ans < (pref[i + n - t + 1] - pref[i]) - min(get(0, 1, n + 1, 0, i + 1), get(0, 1, n + 1, i + n - t + 2, n + 1)))
            ans = pref[i + n - t + 1] - pref[i] - min(get(0, 1, n + 1, 0, i + 1), get(0, 1, n + 1, i + n - t + 2, n + 1));
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int o = 1;
    //cin >> 0;
    for (int oo = 0; oo < o; oo++) {
        solB();
    }
    return 0;
}
