﻿#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
ll mod = 1e9 + 7;

vector <int> tree;
vector <ll> a;

void build(int v, int l, int r) {
    if (l + 1 == r) {
        tree[v] = a[l];
        return;
    }
    build(v * 2 + 1, l, (l + r) / 2);
    build(v * 2 + 2, (l + r) / 2, r);
    tree[v] = min(tree[v * 2 + 1], tree[v * 2 + 2]);
}

ll get(int v, int l, int r, int ql, int qr) {
    if (l >= qr || r <= ql) return 1e10;
    if (l >= ql && r <= qr) return tree[v];
    return min(get(v * 2 + 1, l, (l + r) / 2, ql, qr), get(v * 2 + 2, (l + r) / 2, r, ql, qr));
}

void for2(int n) {
    a.resize(n + 1); tree.resize(n * 10, 1e10);
    vector <ll> pref(n + 2);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pref[i] = pref[i - 1] + a[i];
    }
    a[0] = 1e10;
    build(0, 1, n + 1);
    ll ans = 0;
    int t = 2;
    for (int i = 0; i <= t; i++) {
        if (ans < (pref[i + n - t + 1] - pref[i]) - min(get(0, 1, n + 1, 0, i + 1), get(0, 1, n + 1, i + n - t + 2, n + 1)))
            ans = pref[i + n - t + 1] - pref[i] - min(get(0, 1, n + 1, 0, i + 1), get(0, 1, n + 1, i + n - t + 2, n + 1));
    }
    cout << ans;
}

void solB() {
    int n, k;
    cin >> n >> k;
    if (k == 2) {
        for2(n);
        return;
    }

    a.resize(n + 1); tree.resize(n * 10, 1e10);
    vector <ll> pref(n + 2);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pref[i] = pref[i - 1] + a[i];
    }
    a[0] = 1e10;
    vector <int> t;
    t.push_back(1);
    for (int i = 2; i <= n; i++) {
        if (a[i] < a[t[0]]) {
            t.clear();
            t.push_back(i);
        }
        if (a[i] == a[t[0]]) t.push_back(i);
    }

    vector <ll> maxs(n + 1), maxsr(n + 1);
    for (int i = 1; i <= k; i++) maxs[i] = max(maxs[i - 1], pref[i + n - k] - pref[i - 1]);
    for (int i = k; i > 0; i--) maxsr[i] = max(maxsr[i + 1], pref[i + n - k] - pref[i - 1]);

    ll ans = 0;
    for (int c : t) {
        if (c == 1) ans = max(ans, maxsr[2]);
        else if (c == n) ans = max(ans, maxs[n - 1]);
        else if (c <= n - k + 1) ans = max(ans, max(pref[c - 1], maxsr[c + 1]));
        else if (c >= k) ans = max(ans, max(pref[n] - pref[c], maxs[c - 1]));
        else ans = max(ans, max(maxs[c - 1], maxsr[c + 1]));
    }
    cout << ans - a[t[0]];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int o = 1;
    //cin >> 0;
    for (int oo = 0; oo < o; oo++) {
        solB();
    }
    return 0;
}
