﻿#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
ll mod = 1e9 + 7;

vector <int> tree;
vector <ll> a;

void build(int v, int l, int r) {
    if (l + 1 == r) {
        tree[v] = a[l];
        return;
    }
    build(v * 2 + 1, l, (l + r) / 2);
    build(v * 2 + 2, (l + r) / 2, r);
    tree[v] = min(tree[v * 2 + 1], tree[v * 2 + 2]);
}

ll get(int v, int l, int r, int ql, int qr) {
    if (l >= qr || r <= ql) return 1e10;
    if (l >= ql && r <= qr) return tree[v];
    return min(get(v * 2 + 1, l, (l + r) / 2, ql, qr), get(v * 2 + 2, (l + r) / 2, r, ql, qr));
}

void for2(int n) {
    a.resize(n + 1); tree.resize(n * 10, 1e10);
    vector <ll> pref(n + 2);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pref[i] = pref[i - 1] + a[i];
    }
    a[0] = 1e10;
    build(0, 1, n + 1);
    ll ans = 0;
    int t = 2;
    for (int i = 0; i <= t; i++) {
        if (ans < (pref[i + n - t + 1] - pref[i]) - min(get(0, 1, n + 1, 0, i + 1), get(0, 1, n + 1, i + n - t + 2, n + 1)))
            ans = pref[i + n - t + 1] - pref[i] - min(get(0, 1, n + 1, 0, i + 1), get(0, 1, n + 1, i + n - t + 2, n + 1));
    }
    cout << ans;
}

void solB() {
    int n, k;
    cin >> n >> k;
    if (k == 2) {
        for2(n);
        return;
    }

    a.resize(n + 1); tree.resize(n * 10, 1e10);
    vector <ll> pref(n + 2);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pref[i] = pref[i - 1] + a[i];
    }
    a[0] = 1e10;
    vector <int> t;
    t.push_back(1);
    for (int i = 2; i <= n; i++) {
        if (a[i] == a[t[0]]) t.push_back(i);
        if (a[i] < a[t[0]]) {
            t.clear();
            t.push_back(i);
        }
    }

    vector <ll> maxs(n + 1), maxsr(n + 1);
    for (int i = n - k + 1; i <= n; i++) maxs[i] = max(maxs[i - 1], pref[i] - pref[i - n + k - 1]);
    for (int i = k; i > 0; i--) maxsr[i] = max(maxsr[i + 1], pref[i + n - k] - pref[i - 1]);

    ll ans = 0;
    for (int c : t) {
        if (c <= n - k + 1) ans = max(ans, max(pref[c - 1], maxsr[c + 1]));
        if (c >= k) ans = max(ans, max(pref[n] - pref[c], maxs[c - 1]));
        if (c < k && c > n - k + 1) ans = max(ans, max(maxs[c - 1], maxsr[c + 1]));
    }
    ans -= a[t[0]];
    build(0, 1, n + 1);
    for (int i = 0; i <= k; i++) {
        if (ans < (pref[i + n - k + 1] - pref[i]) - min(get(0, 1, n + 1, 0, i + 1), get(0, 1, n + 1, i + n - k + 2, n + 1)))
            ans = pref[i + n - k + 1] - pref[i] - min(get(0, 1, n + 1, 0, i + 1), get(0, 1, n + 1, i + n - k + 2, n + 1));
    }
    cout << ans;
}

void solC() {
    int n, s;
    cin >> n >> s;
    struct problem {
        int i, j, w;
    };
    vector <vector <int>> c(n);
    int k, t;
    for (int i = 0; i < n; i++) {
        cin >> k;
        c[i].resize(k);
        for (int j = 0; j < k; j++) cin >> c[i][j];
    }

    vector <vector <bool>> dp(n, vector <bool>(s + 1));
    vector <vector <pair <int, int>>> pr(n, vector <pair <int, int>>(s + 1));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < c[i].size(); j++) {
            if (c[i][j] > s) continue;
            dp[i][c[i][j]] = 1;
            pr[i][c[i][j]] = { i, j };
            //dp[i][0] = 1;
        }
    }
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < c[i].size(); j++) {
            for (int w = c[i][j]; w <= s; w++) {
                if (dp[i - 1][w - c[i][j]]) {
                    dp[i][w] = 1;
                    pr[i][w] = { i, j };
                }
                /*
                else if (dp[i - 1][j]) {
                    dp[i][j] = 1;
                    pr[i][j] = pr[i - 1][j];
                }
                */
            }
        }
    }

    if (dp[n - 1][s]) {
        cout << "Yes\n";
        pair <int, int> p = pr[n - 1][s];
        vector <pair <int, int>> ans;
        while (s > 0) {
            ans.push_back(p);
            s -= c[p.first][p.second];
            if (p.first > 0 && dp[p.first - 1][s]) p = pr[p.first - 1][s];
            else p = pr[p.first][s];
        }
        sort(ans.begin(), ans.end());
        vector <vector <int>> fin(n);
        for (auto p : ans) fin[p.first].push_back(p.second);
        for (auto c : fin) {
            cout << c.size();
            for (auto d : c) cout << " " << d + 1;
            cout << '\n';
        }
    }
    else {
        cout << "No";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int o = 1;
    //cin >> 0;
    for (int oo = 0; oo < o; oo++) {
        solC();
    }
    return 0;
}
