﻿#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
ll mod = 1e9 + 7;

void solC() {
    int n, s;
    cin >> n >> s;
    struct problem {
        int i, j, w;
    };
    vector <vector <int>> c(n);
    vector <vector <bool>> used(n);
    int k, t;
    for (int i = 0; i < n; i++) {
        cin >> k;
        c[i].resize(k);
        used[i].resize(k);
        for (int j = 0; j < k; j++) cin >> c[i][j];
    }

    vector <vector <bool>> dp(n, vector <bool>(s + 1));
    vector <vector <pair <int, int>>> pr(n, vector <pair <int, int>>(s + 1));
    dp[0][0] = 1;
    pr[0][0] = { -1, -1 };
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < c[i].size(); j++) {
            for (int w = c[i][j]; w <= s; w++) {
                if (dp[i][w - c[i][j]] && pr[i][w - c[i][j]].first != i && pr[i][w - c[i][j]].second != j) {
                    dp[i][w] = 1;
                    pr[i][w] = { i, j };
                }
                if (i > 0 && w != c[i][j] && dp[i - 1][w - c[i][j]]) {
                    dp[i][w] = 1;
                    pr[i][w] = { i, j };
                }
            }
        }
    }

    if (dp[n - 1][s]) {
        cout << "Yes\n";
        pair <int, int> p = pr[n - 1][s];
        used[p.first][p.second] = 1;
        vector <pair <int, int>> ans;
        while (s > 0) {
            ans.push_back(p);
            s -= c[p.first][p.second];

            if (p.first > 0 && dp[p.first - 1][s]) {
                for (int j = 0; j < c[p.first - 1].size(); j++) {
                    if (c[p.first - 1][j] > s || used[p.first - 1][j]) continue;
                    if (dp[p.first - 1][s - c[p.first - 1][j]]) {
                        p = { p.first - 1, j };
                        used[p.first][j] = 1;
                        break;
                    }
                }
            }
            else {
                for (int j = 0; j < c[p.first].size(); j++) {
                    if (c[p.first][j] > s || used[p.first][j]) continue;
                    if (dp[p.first][s - c[p.first][j]]) {
                        p = { p.first, j };
                        used[p.first][j] = 1;
                        break;
                    }
                }
            }
        }
        sort(ans.begin(), ans.end());
        vector <vector <int>> fin(n);
        for (auto p : ans) fin[p.first].push_back(p.second);
        for (auto c : fin) {
            cout << c.size();
            for (auto d : c) cout << " " << d + 1;
            cout << '\n';
        }
    }
    else {
        cout << "No";
    }
}

void solD() {
    int n, m, k;
    cin >> n >> m >> k;
    vector <vector <ll>> p(n, vector <ll>(m));
    p[0][0] = 1;
    vector <pair <int, int>> x(k);
    for (int i = 0; i < k; i++) {
        cin >> x[i].first >> x[i].second;
        x[i].first--;
        x[i].second--;
    }
    x.push_back({ 0, 0 });
    x.push_back({ n - 1, m - 1 });
    sort(x.begin(), x.end());
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i == 0 && j == 0) continue;
            if (i == 0) p[i][j] = p[i][j - 1];
            else if (j == 0) p[i][j] = p[i - 1][j];
            else p[i][j] = p[i - 1][j] + p[i][j - 1];
        }
    }

    /*bool f = 1;
    vector <ll> t1(n), t2(m);
    for (int i = 1; i <= k; i++) {
        t1[x[i].first]++;
        t2[x[i].second]++;
        if (t1[x[i].first] > 2 || t2[x[i].second] > 2) f = 0;
    }
    */

    ll ans = 2;
    for (int i = 1; i <= k + 1; i++) {
        if (x[i].first - x[i - 1].first < 0 || x[i].second - x[i - 1].second < 0) ans *= 0;
        ans = (ans * p[x[i].first - x[i - 1].first][x[i].second - x[i - 1].second]) % mod;
    }
    cout << ans * 2;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int o = 1;
    //cin >> 0;
    for (int oo = 0; oo < o; oo++) {
        solD();
    }
    return 0;
}
