def add_bounds(v, k, w, h):
    horiz = min(w, v[0] + k) - v[0]
    vert = min(h, v[1] + k) - v[1]
    kd = min(horiz, vert)
    
    if 2*kd > horiz and 2*kd > vert:
        return (v[0] + kd, v[1] + kd)
    elif horiz > vert:
        return (v[0] + horiz, v[1])
    else:
        return (v[0], v[1] + vert)

def fast_diag(k, w, h):
    kdp = min((w - 1) // k, (h - 1) // k)
    return (1 + k*kdp, 1 + k*kdp), kdp
    
n, m, k = (int(c) for c in input().split())

pos, moves = fast_diag(k, n, m)
while pos != (n, m):
    pos = add_bounds(pos, k, n, m)
    assert(pos[0] <= n)
    assert(pos[1] <= m)
    moves += 1

print(moves)
