def add_bounds(v, k, w, h):
    horiz = min(w, v[0] + k) - v[0]
    vert = min(h, v[1] + k) - v[1]
    kd = min(horiz, vert)
    
    if 2*kd > horiz and 2*kd > vert:
        return (v[0] + kd, v[1] + kd)
    elif horiz > vert:
        return (v[0] + horiz, v[1])
    else:
        return (v[0], v[1] + vert)

def fast_diag(k, w, h):
    horiz = w - 1
    vert = h - 1
    kd = min(horiz, vert)
    kdp = kd // k + (kd % k != 0)
    return (1 + kd, 1 + kd), kdp

def fast_direct(pos, k, w, h):
    assert(pos[0] == w or pos[1] == h)
    pos1 = [0, 0]
    dis = None
    cnt = 0
    if pos[0] == w:
        dis = h - pos[1]
    else:
        dis = w - pos[0]
    return dis // k + (dis % k != 0)
    
n, m, k = (int(c) for c in input().split())

pos, moves = fast_diag(k, n, m)
'''
pos1, moves1 = pos, moves

while pos != (n, m):
    pos = add_bounds(pos, k, n, m)
    assert(pos[0] <= n)
    assert(pos[1] <= m)
    moves += 1
assert(fast_direct(pos1, k, n, m) + moves1 == moves)
'''
print(fast_direct(pos, k, n, m) + moves)
