#include <iostream>
#include <cmath>
#include <cinttypes>
#include <vector>
#include <cassert>

using namespace std;

bool is_square(uint64_t x)
{
    static vector<bool> square_table;
    if (x >= square_table.size())
    {
        uint64_t old_size = square_table.size();
        uint64_t new_size = ceil(sqrt((float)x));
        new_size *= new_size;
        square_table.resize(new_size, false);
        for (uint64_t i = sqrt((float)old_size); i*i < new_size; i++)
        {
            square_table[i*i] = true;
        }
        return new_size == x;
    }
    else
        return square_table[x];
}

int main()
{
    uint64_t l, r, d;
    cin >> d >> l >> r;
    uint64_t l_s = ceil(sqrt(l));
    uint64_t pairs = 0;
    for (uint64_t y = l_s; 1; y++)
    {
        uint64_t x_s = y*y + d;
        if (x_s > r)
            break;
        //uint64_t x = sqrt((float)x_s);
        //if (x*x == x_s)
        if (is_square(x_s))
            pairs++;
    }
    cout << pairs << endl;
    return 0;
}
