#include <iostream>
#include <cmath>
#include <cinttypes>
#include <vector>
#include <deque>

using namespace std;

uint32_t max_skew(const vector<uint32_t> &numbers, deque<size_t> segments, size_t k)
{
    if (segments.size() == k)
    {
        size_t pos = 0;
        uint64_t min_sum = -1;
        uint64_t max_sum = 0;
        for (auto it = segments.begin(); it != segments.end(); it++)
        {
            size_t end = *it;
            if (next(it) == segments.end())
                end = numbers.size();
            uint64_t sum = 0;
            for (size_t i = pos; i < end; i++)
                sum += numbers[i];
            if (sum > max_sum)
                max_sum = sum;
            if (sum < min_sum || min_sum == -1)
                min_sum = sum;
            pos = end;
        }
        return max_sum - min_sum;
    }
    if (segments.size() > k)
        return 0;
    if (segments.size() == 0)
    {
        segments.push_back(1);
    }
    uint64_t r1 = 0;
    size_t last_value = segments.back();
    if (numbers.size() - last_value < k - segments.size())
        return 0;
    segments.pop_back();
    segments.push_back(last_value+1);
    r1 = max_skew(numbers, segments, k);
    segments.pop_back();
    segments.push_back(last_value);
    segments.push_back(last_value+1);
    uint64_t r2 = max_skew(numbers, segments, k);
    return r1 > r2? r1 : r2;
}

int main()
{
    size_t n, k;
    cin >> n >> k;
    vector<uint32_t> numbers(n);
    for (size_t i = 0; i < n; i++)
        cin >> numbers[i];
    deque<size_t> segments;
    cout << max_skew(numbers, segments, k) << endl;
    return 0;
}
