
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
typedef tree<int, null_type, std::less<int>, rb_tree_tag, tree_order_statistics_node_update> dtree;
using namespace std;

template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
	for (auto& item: vec)
		in >> item;
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& vec) {
	for (auto& item : vec)
		out << item << " ";
	return out;
}
#define int long long

struct segTree {
    vector<int> t;
    vector<int> s;
    int sz;

    void build (vector<int> &a) {
        sz = 1;
        while (sz < a.size())
            sz *= 2;
        t.resize(sz * 2 - 1, 0);
        s.resize(sz * 2 - 1, -1);
        build (0, 0, sz, a);
    }

    void build (int v, int l, int r, vector<int> &a) {
        if (r - l == 1) {
            if (l < a.size())
                t[v] = a[l];
            return;
        }
        int mid = (l + r) / 2;
        build (v * 2 + 1, l, mid, a);
        build (v * 2 + 2, mid, r, a);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }

    void push (int v, int l, int r) {
        if (s[v] != -1)
            t[v] = s[v] * (r - l);
        if (r - l > 1 && s[v] != -1) {
            s[v * 2 + 1] = s[v * 2 + 2] = s[v];
        }
        s[v] = -1;
    }

    void update (int v, int lv, int rv, int l, int r, int val) {
        push(v, lv, rv);
        if (lv >= l && rv <= r) {
            s[v] = val;
            push(v, lv, rv);
            return;
        }
        if (lv >= r || rv <= l)
            return;
        int mid = (lv + rv) / 2;
        update (v * 2 + 1, lv, mid, l, r, val);
        update (v * 2 + 2, mid, rv, l, r, val);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }

    void update (int l, int r, int val) {
        update (0, 0, sz, l, r, val);
    }

    int get (int v, int lv, int rv, int l, int r) {
        push(v, lv, rv);
        if (lv >= l && rv <= r)
            return t[v];
        if (lv >= r || rv <= l)
            return 0;
        int mid = (lv + rv) / 2;
        return get(v * 2 + 1, lv, mid, l, r) + get(v * 2 + 2, mid, rv, l, r);
    }

    int get (int l, int r) {
        return get(0, 0, sz, l, r);
    }
};

vector<int> p;
vector<int> ans;
vector<pair<int, int>> mx;
vector<pair<int, int>> seg;

int get(int v) {
    if (p[v] == v)
        return v;
    return p[v] = get(p[v]);
}

int merg(int v, int u, vector<int> &prev, vector<int> &next, segTree &treeL, segTree &treeR, segTree &treeH) {
    v = get(v);
    u = get(u);
    if (seg[v].first > seg[u].first)
        swap(u, v);
    int l = seg[v].first;
    int r = seg[u].second;
    int ansU = 0;
    int nextL = next[mx[v].second] - 1;
    if (nextL >= r) {
        ansU = treeR.get(seg[u].first, seg[u].second + 1) - treeH.get(seg[u].first, seg[u].second + 1);
    } else {
        ansU = (nextL - seg[u].first + 1) * mx[v].first - treeL.get(seg[u].first, nextL + 1) + ans[u];
    }

    int ansV = 0;
    int prevR = prev[mx[u].second] + 1;
    if (prevR <= l) {
        ansV = treeL.get(l, seg[v].second + 1) - treeH.get(l, seg[v].second + 1);
    } else {
        ansV = (seg[v].second - prevR + 1) * mx[u].first - treeR.get(prevR, seg[v].second + 1) + ans[v];
    }

    if (nextL < r)
        treeL.update(seg[u].first, nextL + 1, mx[v].first);
    else
        treeL.update(seg[u].first, seg[u].second + 1, mx[v].first);
    if (prevR > l)
        treeR.update(prevR, seg[v].second + 1, mx[u].first);
    else
        treeR.update(l, seg[v].second + 1, mx[u].first);
    p[u] = v;
    ans[v] = ansU + ansV;
    seg[v] = {l, r};
    mx[v] = max(mx[v], mx[u]);
    return ans[v];
}

struct segTreeFind {
    vector<int> cnt;
    int sz = 1;

    void build (int n) {
        while (sz < n)
            sz *= 2;
        cnt.resize(sz * 2 - 1, 0);
        build (0, 0, sz, n);
    }

    void build (int v, int l, int r, int n) {
        if (r - l == 1) {
            if (l < n)
                cnt[v] = 1;
            return;
        }
        int mid = (l + r) / 2;
        build (v * 2 + 1, l, mid, n);
        build (v * 2 + 2, mid, r, n);
        cnt[v] = cnt[v * 2 + 1] + cnt[v * 2 + 2];
    }

    int find (int v, int l, int r, int k) {
        if (r - l == 1)
            return l;
        int mid = (l + r) / 2;
        if (cnt[v * 2 + 1] >= k)
            return find (v * 2 + 1, l, mid, k);
        else
            return find (v * 2 + 2, mid, r, k - cnt[v * 2 + 1]);
    }

    int find(int k) {
        return find (0, 0, sz, k);
    }

    void update (int v, int l, int r, int ind) {
        cnt[v]--;
        if (r - l == 1)
            return;
        int mid = (l + r) / 2;
        if (ind < mid)
            update (v * 2 + 1, l, mid, ind);
        else
            update (v * 2 + 2, mid, r, ind);
    }

    void update(int ind) {
        update(0, 0, sz, ind);
    }
};


int32_t main()
{


	int n;
	cin >> n;
	vector<int> h(n);
	cin >> h;

	vector<int> prev(n, -1);
	vector<pair<int, int>> st;
	for (int i = 0; i < n; i++) {
        while (!st.empty() && st.back().first <= h[i])
            st.pop_back();
        if (!st.empty())
            prev[i] = st.back().second;
        st.push_back({h[i], i});
	}

	vector<int> next(n, n);
	st.clear();
	for (int i = n - 1; i >= 0; i--) {
        while (!st.empty() && st.back().first <= h[i])
            st.pop_back();
        if (!st.empty())
            next[i] = st.back().second;
        st.push_back({h[i], i});
	}

	p.resize(n);
    ans.resize(n, 0);
	for (int i = 0; i < n; i++)
        p[i] = i;
    mx.resize(n);
    for (int i = 0; i < n; i++)
        mx[i] = {h[i], i};
    seg.resize(n);
    for (int i = 0; i < n; i++) {
        seg[i] = {i, i};
    }
    segTree treeL, treeR, treeH;
    segTreeFind treeFind;
    treeL.build(h);
    treeR.build(h);
    treeH.build(h);
    treeFind.build(n);
    for (int i = 0; i < n - 1; i++) {
        int k;
        cin >> k;
        int ind_v = treeFind.find(k);
        int ind_u = treeFind.find(k + 1);
        treeFind.update(ind_u);
        cout << merg(ind_u, ind_v, prev, next, treeL, treeR, treeH) << "\n";
    }
}

/*
8
9 1 8 1 5 2 3 6
3 3 1 3 3 2 1
*/
