#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <deque>

using namespace std;

typedef long long ll;

vector<ll> h;

struct segment_tree
{
	struct node
	{
		ll l, r;
		ll w, mx;
	};
};

struct segment
{
	ll l, r, w;
};

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n;
	cin >> n;
	h.resize(n);

	for (ll& i : h)
		cin >> i;
	
	deque<segment> S(n);
	for (ll i = 0; i < n; i++)
		S[i].l = i, S[i].r = i + 1, S[i].w = 0;

	vector<ll> prefh(n + 1);
	for (ll i = 1; i < n + 1; i++)
		prefh[i] = prefh[i - 1] + h[i - 1];
	for (ll i = 0; i < n - 1; i++)
	{
		ll k;
		cin >> k;
		k--;
		segment ns{ S[k].l, S[k + 1].r };
		ll w = 0;
		if (h[S[k + 1].l] < h[S[k].r - 1])
			w += max((S[k + 1].r - S[k + 1].l - 1) * min(h[S[k].r - 1], h[S[k + 1].r - 1]) - (prefh[S[k + 1].r] - prefh[S[k + 1].l + 1]), 0ll) + S[k].w;
		else if (h[S[k + 1].l] > h[S[k].r - 1])
			w += max((S[k].r - S[k].l - 1) * min(h[S[k].l], h[S[k + 1].l]) - (prefh[S[k].r] - prefh[S[k].l + 1]), 0ll) + S[k + 1].w;
		if (h[S[k].l] > max(h[S[k].r - 1], h[S[k + 1].l]) &&
			h[S[k + 1].r - 1] > max(h[S[k].r - 1], h[S[k + 1].l]))
			w = max((ns.r - ns.l - 2) * min(h[ns.r - 1], h[ns.l]) - (prefh[ns.r - 1] - prefh[ns.l + 1]), 0ll);
		cout << w << '\n';
		ns.w = w;
		S.insert(S.erase(S.erase(S.begin() + k)), ns);
	}
}
