from random import randint
from math import log10

prime_nums = [2, 3, 5, 7]

def subfactorial(n):
    return (n * (n + 1)) // 2

def tokenize(n: int):
    size = int(log10(n)) + 1
    
    result = [0] * size
    
    for i in range(size):
        result[i] = n // (10 ** (size - i - 1))
        n %= 10 ** (size - i - 1)

    return result    

def brootforce(l, r):
    result = 0
    
    result = 0
    size = int(log10(r) + 1)
    
    templates = [0]
    
    for i in range(size):
        templates.append(templates[-1] + (10 ** i))
    del templates[0]
    
    for i in range(len(templates)):
        for j in range(i + 1):
            a = templates[i]
            a -= 10 ** j
            
            for k in prime_nums:
                a += (10 ** j) * k
                
                if l <= a <= r:
                   # print(a)
                    result += 1
                elif a > r:
                    return result
                
                a -= (10 ** j) * k
    return result

def reverse(number):
    result = 0
    size = int(log10(number)) + 1
    
    for i in range(size):
        result += (10 ** i) * (number // (10 ** (size - i - 1)))
        number %= 10 ** (size - i - 1)
    
    return result

def get_first_or_except(number: list[int]) -> bool:
    if number[0] > 7:
        return True
    elif number[0] == 7:
        for i in number[1:]:
            if i > 1:
                return True
            elif i < 1:
                return False

    return False
    
def get_first_or_2_except(number):
    if number[0] > 1:
        return False
    else:
        for i in number:
            if i > 1:
                return False
            if i < 1:
                return True
    
    return False

def get_first_with_len_1(number: list[int]):
    for i in prime_nums:
        if i >= number[0]:
            return [i]
    return [1, 2]

def get_first(number: list[int]):
    if len(number) == 1:
        return get_first_with_len_1(number)
    
    if get_first_or_except(number):
        #print("n", number)
        return [1] * len(number) + [2]
    elif get_first_or_2_except(number):
        return [1] * (len(number) - 1) + [2]
    
    result = [1] * len(number)
    i = 0

    while i < len(result):
        result[i] = 7
                    
        if result < number:            
            result[i] = 1
            break
            
        result[i] = 1
        i += 1

        
    while True:
        if i >= len(result):
            i = len(result) - 1

        for num in prime_nums:
            result[i] = num
                            
            if result >= number:
                return result
            
        result[i] = 1
            
        i -= 1

            
def get_last(number: list[int]):
    result = get_first(number)

    #print("first", result)
       
    if result == number:
        return result
    
    for i in range(len(result)):
        if result[i] != 1:
            index = prime_nums.index(result[i])
                        
            if index == 0:
                if i < len(result) - 1:
                    result[i] = 1
                    i += 1
                    result[i] = 7
                elif number != [1]:
                    result[i] = 1
                    del result[0]
                    result[0] = 7
            else:
                result[i] = prime_nums[index - 1]
            
            break
    
    return result
                    
def before(number: list[int]):
    result = len(prime_nums) * subfactorial(len(number) - 1)
        
    i = 0
    
    while number[i] == 1:
        i += 1
        
    result += (len(number) - i - 1) * 4 + prime_nums.index(number[i])
    
    return result

def after(number: list[int]):
    i = 0
    
    while number[i] == 1:
        i += 1
    
    return 4 * i + (3 - prime_nums.index(number[i]))

def solution(number_from, number_to):
    if number_to == 1:
        return 0

    number_from_list = get_first(tokenize(number_from))
    number_to_list = get_last(tokenize(number_to))

    # print(number_from_list)
    # print(number_to_list)
    
    before_items = before(number_from_list)
    after_items = after(number_to_list)
    
    # print(before_items)
    # print(after_items)
    
    total_items = subfactorial(len(number_to_list)) * len(prime_nums)
    
    total_items -= before_items
    total_items -= after_items
    
    return total_items

# args = (1738059937994631842018, 7003056348630314063552)

# print(brootforce(*args))
# print(solution(*args))

a = int(input())
b = int(input())

print(solution(a, b))
# for _ in range(100000):
#     a, b = sorted([randint(1, 10 ** 100), randint(1, 23523534)])
#
#     if solution(a, b) != brootforce(a, b):
#         try:
#             print((a, b), solution(a, b), brootforce(a, b))
#         except Exception as e:
#             print(e)
#     else:
#         print("Sucess " + str((a, b)))
      
# print(solution(42, 1790000000), brootforce(42, 1790000000)) 

# print(reverse(927634897263489762134))

# def solution(l, r):
#     first = get_first(l)

# a = int(input())
# b = int(input())
# print(brootforce(a, b))
