class SortedList(list):
    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.sort()
    
    def index(self, value, return_left=False):
        left = 0
        right = len(self) - 1
                
        while left <= right:
            middle = (left + right) // 2
            
            if self[middle] > value:
                right = middle - 1
            elif self[middle] < value:
                left = middle + 1
            else:
                return middle
        
        if return_left:
            return left

    def append(self, value):
        self.insert(self.index(value, return_left=True), value)

class SpecList:
    def __init__(self, *args, **kwargs):
        self.list = list(*args, **kwargs)
        self.sorted_list = SortedList(*args, **kwargs)

    def pop(self, index):
        result = self.list.pop(0)
        
        index = self.sorted_list.index(result)
        del self.sorted_list[index]
        
        return result

    def append(self, value):
        self.list.append(value)
        self.sorted_list.append(value)
    
    def __len__(self):
        return len(self.list)

    def __str__(self):
        return str(self.list)
    

def count_water(item: list[int]):
    result = 0
    
    if len(item) < 3:
        return 0
    
    before = SpecList()
    after = SpecList(item)
    
    while len(after):
        current = after.pop(0)
        
        compare = min(before.sorted_list[-1] if before.sorted_list else 0, after.sorted_list[-1] if after.sorted_list else 0)
        
        if compare - current > 0:
            result += compare - current
                
        before.append(current)
        
    return result
    

def solution(items: list[list[int]], actions: list[int]):
    result = []
    
    for i in actions:
        items[i] += items.pop(i + 1)
        result.append(count_water(items[i]))
    
    return result

_ = input()
b = list(map(lambda x: [x], map(int, input().split())))
a = list(map(lambda x: x - 1, map(int, input().split())))

print("\n".join(map(str, solution(b, a))))

# print(count_water([9, 1, 8, 1, 5,2,3,6]))