﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>

using namespace std;

vector<long long> tree;
vector<long long> a;

void build(int x, int xl, int xr) {
	if (xl == xr - 1)
		tree[x] = a[xl];
	else {
		int xm = (xr + xl) / 2;
		build(x * 2 + 1, xl, xm);
		build(x * 2 + 2, xm, xr);
		tree[x] = min(tree[x * 2 + 1], tree[x * 2 + 2]);
	}
}

int MINN(int l, int r, int x, int xl, int xr) {
	if (xl >= l && xr <= r)
		return tree[x];
	if (xl >= r || xr <= l)
		return 100000000000000;

	int xm = (xr + xl) / 2;
	return min(MINN(l, r, x * 2 + 1, xl, xm),
	MINN(l, r, x * 2 + 2, xm, xr));
}

int main() {
	long long n, k;
	cin >> n >> k;
	a.resize(n);
	tree.resize(n * 4, 100000000000000);
	for (long long& i : a)
		cin >> i;
	build(0, 0, n);
	vector<long long> pref(n + 1);
	pref[0] = 0;
	for (long long i = 1; i < n + 1; ++i)
		pref[i] = pref[i - 1] + a[i - 1];

	long long max = 0;
	long long minn = 0;
	long long l = n - k + 1;
	for (int l = 1; l <= n - k + 1; ++l) {
		for (int i = 0; i < n - l + 1; ++i) {
			long long m = pref[i + l] - pref[i];
			if (i == 0)
				minn = MINN(i + l, n, 0, 0, n);
			else if (i + l == n)
				minn = MINN(0, i, 0, 0, n);
			else
				minn = min(MINN(0, i, 0, 0, n), MINN(i + l, n, 0, 0, n));
			if (m - minn > max)
				max = m - minn;
		}
	}
		

	cout << max;
}
