﻿#include <iostream>
#include <vector>
using namespace std;
using ll = long long;

ll res = 0;
ll mod = 1e9 + 7;

void dfs2(const int& n, const int& m, const int& k, int mins, vector<vector<int>> used, int cnt, int nowX, int nowY) {
    used[nowX][nowY] = 1;
    if (nowX == 0 && nowY == 0 && mins == 2 * n + 2 * m - 4 && cnt == k) {
        res++;
        res %= mod;
        return;
    }
    vector<pair<int, int>> next = { { nowX - 1, nowY }, { nowX, nowY - 1 }, {nowX + 1, nowY}, {nowX, nowY + 1} };
    for (auto u : next) {
        if (u.first < 0 || u.first >= n || u.second < 0 || u.second >= m) continue;
        if (used[u.first][u.second] == 0) {
            dfs2(n, m, k, mins + 1, used, cnt, u.first, u.second);
        }
        else if (used[u.first][u.second] == -1) {
            dfs2(n, m, k, mins + 1, used, cnt + 1, u.first, u.second);
        }
    }
}

void dfs1(const int& n, const int& m, const int& k, int mins, vector<vector<int>> used, int cnt, int nowX, int nowY) {
    used[nowX][nowY] = 1;
    if (nowX == n - 1 && nowY == m - 1) {
        used[0][0] = 0;
        dfs2(n, m, k, mins, used, cnt, nowX, nowY);
        return;
    }
    vector<pair<int, int>> next = { { nowX - 1, nowY }, { nowX, nowY - 1 }, {nowX + 1, nowY}, {nowX, nowY + 1} };
    for (auto u : next) {
        if (u.first < 0 || u.first >= n || u.second < 0 || u.second >= m) continue;
        if (used[u.first][u.second] == 0) {
            dfs1(n, m, k, mins + 1, used, cnt, u.first, u.second);
        }
        else if (used[u.first][u.second] == -1) {
            dfs1(n, m, k, mins + 1, used, cnt + 1, u.first, u.second);
        }
    }
}
int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, m, k; cin >> n >> m >> k;
    vector<vector<int>> used(n, vector<int>(m));
    for (int i = 0; i < k; ++i) {
        int x, y; cin >> x >> y;
        x--; y--;
        used[x][y] = -1;
    }
    if(used[0][0] == -1) dfs1(n, m, k, 0, used, 1, 0, 0);
    else dfs1(n, m, k, 0, used, 0, 0, 0);
    cout << res;
}

/*
    A
    ll d, l, r; cin >> d >> l >> r;
    ll res = 0;
    ll sqStart = ceil(sqrt(l));
    ll sq2 = floor(sqrt(r));
    ll range = 0;
    for (ll k = sqStart + 1; k < sq2; ++k) {
        ll m = sqrt(k);
        if (m * m == k) {
            range = k - sqStart;
            break;
        }
    }
    for (ll y = sqStart; y < r; y += range, range += 2) {
        ll x = y + d;
        ll sq3 = floor(sqrt(x));
        if (sq3 * sq3 == x && x <= r) {
            res++;
        }
    }
    cout << res;
*/

/*
    A
    ll d, l, r; cin >> d >> l >> r;
    ll res = 0;
    ll sq1 = ceil(sqrt(l));
    ll sq2 = floor(sqrt(r));
    for (ll y = sq1; y < sq2; ++y) {
        ll x = y * y + d;
        ll sq3 = floor(sqrt(x));
        if (sq3 * sq3 == x && x <= r) {
            res++;
        }
    }
    cout << res;
*/

/*
    C
    void solve(const vector<vector<int>>& c, int i, int now, int s, vector<vector<int>> res, int prev) {
    if (now == s && i == c.size() - 1 && res[i].size() != 0) {
        cout << "Yes" << '\n';
        for (int i = 0; i < res.size(); ++i) {
            cout << res[i].size() << '\n';
            for (int j = 0; j < res[i].size(); ++j) {
                cout << res[i][j] << '\n';
            }
        }
        exit(0);
    }
    if (now > s || i >= c.size()) return;
    for (int j = prev + 1; j < c[i].size(); ++j) {
        res[i].push_back(j + 1);
        solve(c, i, now + c[i][j], s, res, j);
        solve(c, i + 1, now + c[i][j], s, res, -1);
        res[i].pop_back();
    }
}

int main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, s; cin >> n >> s;
    vector<vector<int>> c(n);
    for (int i = 0; i < n; ++i) {
        int k; cin >> k;
        for (int j = 0; j < k; ++j) {
            int m; cin >> m;
            c[i].push_back(m);
        }
    }
    vector<vector<int>> res(n);
    solve(c, 0, 0, s, res, -1);
    cout << "No";
}
*/