#include <iostream>
#include <math.h>
#include <vector>

using namespace std;
typedef long long ll;

struct otr 
{   
    ll min_sub;
    ll max_sub;
    otr (ll min, ll max): min_sub(min), max_sub(max) {};
    otr (ll x): otr(x, x) {};
};

otr get_optimal (vector<ll> &sums, int l, int r, int k) {
    if (k == 1) {
        otr ret(sums[r] - sums[l - 1]);
        return ret; 
    }   

    vector <otr> variants;

    for (int i = l; i <= r - k + 1; i++) {
        ll s = sums[i] - sums[l - 1];

        otr kek = get_optimal(sums, i + 1, r, k - 1);
        if (s < kek.min_sub) { 
            otr pb(s, kek.max_sub);
            variants.push_back(pb);
        }
        else if (s > kek.max_sub) { 
            otr pb(kek.min_sub, s);
            variants.push_back(pb); 
        };
    }

    int max_i = 0;
    ll max_p = 0;
    for (int i = 0; i < variants.size(); i++) {
        ll p = variants[i].max_sub - variants[i].min_sub;
        if (p > max_p) {
            max_p = p;
            max_i = i;
        }
    }

    cout << variants[max_i].max_sub << endl;
    return variants[max_i];

}

int main () {
    
    int n, k; cin >> n >> k;

    vector<ll> sums(n);
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        int x; cin >> x;
        a[i] = x;
        if (i > 0) sums[i] = sums[i - 1] + x;
        else sums[i] = x;
    }

    for (auto x: a) cout << x << " ";
    cout << endl;
    for (auto x: sums) cout << x << " ";
    cout << endl;

    otr v = get_optimal(sums, 0, sums.size(), k);
    cout << v.max_sub - v.min_sub;

    return 0;
}