#include <iostream>
#include <vector>


using namespace std;

vector<int> h;
int n;
struct seg {
    int start_idx = -1;
    int end_idx = -1;
    
    seg() {}

    seg(int i) {
        start_idx = end_idx = i;
    }

    seg(int s, int e) {
        start_idx = s;
        end_idx = e;
    }

    seg operator+(seg other) {
        return seg(min(this->start_idx, other.start_idx), max(this->end_idx, other.end_idx));
    }

    int get_capacity() {
        vector<int> mxl(n), mxr(n);
        int d = 0;
        for (int i = start_idx; i < end_idx + 1; ++i) {
            if (i == start_idx)
                mxr[i] = h[i];
            else
                mxr[i] = max(mxr[i - 1], h[i]);
        }
        
        for (int i = end_idx; i > start_idx - 1; --i) {
            if (i == end_idx) {
                mxl[i] = h[i];
            } else {
                mxl[i] = max(mxl[i + 1], h[i]);
            }
            d += max(min(mxl[i], mxr[i]) - h[i], 0);
        }
        return d;
    }
};

int main() {
    cin >> n;
    if (n < 10) cout << 1 / 0;
    h = vector<int>(n);
    for (auto& i : h) cin >> i;

    vector<seg> segments = vector<seg>(n);
    for (int i = 0; i < n; ++i) 
        segments[i] = seg(i);

    for (int i = 0; i < n - 1; ++i) {
        int k;
        cin >> k;
        k -= 1;
        segments[k] = segments[k] + segments[k + 1];
        segments.erase(segments.begin() + k + 1);
        cout << segments[k].get_capacity() << '\n';
    }
    return 0;
}

