﻿#include <bits/stdc++.h>
using namespace std;
long long computeCapacity(const vector<long long> &seg) {
    int m = (int)seg.size();
    if (m <= 1) return 0;
    vector<long long> L(m), R(m);
    L[0] = seg[0];
    for (int i = 1; i < m; i++) {
        L[i] = max(L[i-1], seg[i]);
    }
    R[m-1] = seg[m-1];
    for (int i = m-2; i >= 0; i--) {
        R[i] = max(R[i+1], seg[i]);
    }

    long long capacity = 0;
    for (int i = 0; i < m; i++) {
        long long trapped = min(L[i], R[i]) - seg[i];
        if (trapped > 0) {
            capacity += trapped;
        }
    }
    return capacity;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<long long> h(n);
    for (int i = 0; i < n; i++) {
        cin >> h[i];
    }
    vector<vector<long long>> segments(n);
    for (int i = 0; i < n; i++) {
        segments[i] = { h[i] };
    }

    vector<int> K(n-1);
    for (int j = 0; j < n-1; j++) {
        cin >> K[j];
        K[j]--; 
    }
    for (int j = 0; j < n-1; j++) {
        int idx = K[j];
        vector<long long> merged;
        merged.reserve(segments[idx].size() + segments[idx+1].size());
        merged.insert(merged.end(), segments[idx].begin(), segments[idx].end());
        merged.insert(merged.end(), segments[idx+1].begin(), segments[idx+1].end());
        long long cap = computeCapacity(merged);
        cout << cap << "\n";
        segments[idx] = move(merged);
        segments.erase(segments.begin() + (idx+1));
    }
    return 0;
}