#include <iostream>
#include <math.h>
#include <vector>
#include <algorithm>
#include <unordered_map>
using namespace std;
using ll = long long;

void solve() {
	ll n, s; cin >> n >> s;
	vector<vector<ll>> tasks;
	for (int i = 0; i < n; i++) {
		ll k; cin >> k;
		for (int j = 0; j < k; j++) {
			ll score; cin >> score;
			tasks.push_back({ score, i + 1, j + 1 });
		}
	}

	sort(tasks.begin(), tasks.end());

	ll count = tasks[0][0];
	ll l = 0;
	ll r = 1;
	bool flag = false;
	while (l <= r && r < (int)tasks.size()) {
		// cout << l << ' ' << r << '\n';
		if (count == s) {
			flag = true;
			break;
		}

		if (count < s && count + tasks[r][0] <= s) {
			count += tasks[r][0];
			r++;
		}
		
		else {
			count -= tasks[l][0];
			l++;
		}
	}

	if (count == s) flag = true;
	if (!flag) {
		cout << "No\n";
	}
	else {
		cout << "Yes\n";
		unordered_map<ll, vector<ll>> um;
		for (ll i = l; i < r; i++) {
			um[tasks[i][1]].push_back(tasks[i][2]);
		}

		for (auto kval : um) {
			cout << kval.second.size() << '\n';
			for (auto el : kval.second) cout << el << ' ';
			cout << '\n';
		}
	}
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	solve();
	return 0;
}



/*
#include <iostream>
#include <math.h>
using namespace std;
using ll = long long;

void solve() {
	ll d, l, r;
	cin >> d >> l >> r;

	ll total = 0;
	for (ll x = ceil(sqrt(l)); x < ceil(sqrt(r + 1)); x++) {
		ll y = pow(x, 2LL) - d;
		if (y > 0 && (ll) sqrt(y) * (ll) sqrt(y) == y) total++;
	}

	cout << total;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	solve();
	return 0;
}
*/