#include <iostream>
#include <algorithm>
#include <string>
#include <string_view>

using ull = unsigned long long;
using ll = long long;
using namespace std;
ull biggereq_than_ones(std::string_view number) {
	for (auto ch : number)
		if (ch > '1')
			return true;
		else if (ch == '0')
			return false;
	return true;
}
ull lesseq_than_ones(std::string_view number) {
	for (auto ch : number)
		if (ch == '0')
			return true;
		else if (ch > '1')
			return false;
	return true;
}

// Count amount of simple numbers from number to 9999999...(number.size())
ull count_simple_first( std::string_view number ) {
	if (number.size() == 0)
		return 0;
	switch (number[0]) {
	case '0':
		return number.size() * 4; // Really any combination
	case '1':
		return 4/*2/3/5/7 is first*/ + count_simple_first(number.substr(1));
	case '2':
		return 3/*3/5/7 is first*/ + lesseq_than_ones(number.substr(1));
	case '3':
		return 2/*5/7 is first*/ + lesseq_than_ones(number.substr(1));
	case '4':
		return 2/*5/7 is first*/;
	case '5':
		return 1/*7 is first*/ + lesseq_than_ones(number.substr(1));
	case '6':
		return 1/*7 is first*/;
	case '7':
		return lesseq_than_ones(number.substr(1));
	case '8':
		return 0;
	case '9':
		return 0;
	}
}
// Count amount of simple numbers from 11111111...(number.size()) up to number
ull count_simple_last( std::string_view number ) {
	if (number.size() == 0)
		return 0;
	switch (number[0]) {
	case '0':
		return 0;
	case '1':
		return count_simple_last(number.substr(1));
	case '2':
		return (number.size() - 1) * 4/*First digit is 1*/ + biggereq_than_ones(number.substr(1));
	case '3':
		return (number.size() - 1) * 4/*First digit is 1*/ + 1/*First digit is 2*/ + biggereq_than_ones(number.substr(1));
	case '4':
		return (number.size() - 1) * 4/*First digit is 1*/ + 2/*First digit is 2/3*/;
	case '5':
		return (number.size() - 1) * 4/*First digit is 1*/ + 2/*First digit is 2/3*/ + biggereq_than_ones(number.substr(1));
	case '6':
		return (number.size() - 1) * 4/*First digit is 1*/ + 3/*First digit is 2/3/5*/;
	case '7':
		return (number.size() - 1) * 4/*First digit is 1*/ + 3/*First digit is 2/3/5*/ + biggereq_than_ones(number.substr(1));
	case '8':
		return (number.size() - 1) * 4/*First digit is 1*/ + 4/*First digit is 2/3/5/7*/;
	case '9':
		return (number.size() - 1) * 4/*First digit is 1*/ + 4/*First digit is 2/3/5/7*/;
	}
}

// Count amount of simple numbers from n1 to n2 of equal length
ull count_same_digitn(std::string_view n1, std::string_view n2) {
	if (n1.size() == 0)
		return 0;
	if (n1[0] > n2[0])
		return 0;
	if (n1[0] == n2[0]) {
		if (n1[0] == '1')
			return count_same_digitn(n1.substr(1), n2.substr(1));
		if (n1[0] == '2' || n1[0] == '3' || n1[0] == '5' || n1[0] == '7')
			return biggereq_than_ones(n1.substr(1)) && lesseq_than_ones(n2.substr(1));
	}
	if (n1[0] < n2[0])
		return count_simple_first(n1) + count_simple_last(n2) - n1.size() * 4; // Set intersection
}
auto count_simple(string l, string r) {
	if (l.size() == r.size())
		return count_same_digitn(l, r);
	// for loop on decimal places of l.size to r.size()	
	// I skip the first and the last p for now
	ull simple = 0;
	for (ull p = l.size() + 1; p < r.size(); p++) // p is the index of the digit i currently handle
		simple += p * 4;

	return simple + count_simple_last(r) + count_simple_first(l);
}
int main()
{
	string l, r;
	//for (int i = 0; i < 1000000; i++) {
	//	l = std::to_string(rand());
	//	r = std::to_string(rand());
	//	cout << l << "->" << r << ": " << count_simple(l, r) << "\n";
	//}
	cin >> l >> r;
	cout << count_simple(l, r);
}
