#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <numeric>

using ull = unsigned long long;
using ll = long long;
using namespace std;

struct subrange {
	int max_begin, max_end;
	ll diff = 0;
};
ll max_subrange(const vector<ll>& target, ull size) {
	subrange best{};
	for (int start = 0; start < target.size(); start++) {
		ll sum = 0;
		for (int end = start + 1; end <= start + size && end <= target.size(); end++) {
			sum += target[end - 1];
			ll min = std::min(start == 0 ? LLONG_MAX : *min_element(target.begin(), target.begin() + start), 
				end == target.size() ? LLONG_MAX : *min_element(target.begin() + end, target.end())); // TODO: optimize n3 out here;
			ll diff = sum - min;
			if (diff > best.diff)
				best = { start, end, diff };
		}
	}
	return best.diff;
}
ll max_subrange2(const vector<ll>& target)
{
	if (target.front() < target.back())
		return accumulate(target.begin() + 1, target.end(), -target.front());
	return accumulate(target.begin(), target.end() - 1, -target.back());

	/* */
	ll best_diff = 0;
	ll suml = 0;
	ll sumr = accumulate(target.begin(), target.end(), 0);
	for (int d = 0; d < target.size() - 1; d++) {
		suml += target[d];
		sumr -= target[d];
		best_diff = std::max(best_diff, abs(sumr - suml));
	}
	return best_diff;
}

ll max_subrange3(const vector<ll>& target)
{
	ll best_diff = 0;
	ll suml = 0, sumr = accumulate(target.begin() + 1, target.end(), 0);
	for (ll m = 1; m < target.size() - 1; m++) {
		suml += target[m - 1];
		sumr -= target[m];
		best_diff = std::max({ best_diff, abs(suml - target[m]), abs(sumr - target[m]), abs(suml - sumr) });
	}
	return best_diff;
}


int main()
{
	ll n, k;
	cin >> n >> k;
	vector<ll> arr(n);
	for (auto &i: arr)
		cin >> i;
	subrange max_subr;
	if (k == 2)
		cout << max_subrange2(arr);
	else if (k == 3)
		cout << max_subrange3(arr);
	else
		cout << max_subrange(arr, n - (k - 1)); // k - 1 is just all subranges beside the max
	return 0;
}
