#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <numeric>

using ull = unsigned long long;
using ll = long long;
using namespace std;

struct subrange {
	int max_begin, max_end;
	ll diff = 0;
};
subrange max_subrange(const vector<ull>& target, ull size) {
	subrange best{};
	for (int start = 0; start < target.size(); start++) {
		ll sum = 0;
		for (int end = start + 1; end <= start + size && end <= target.size(); end++) {
			sum += target[end - 1];
			ll min = std::min(start == 0 ? LLONG_MAX : *min_element(target.begin(), target.begin() + start), 
				end == target.size() ? LLONG_MAX : *min_element(target.begin() + end, target.end())); // TODO: optimize n3 out here;
			ll diff = sum - min;
			if (diff > best.diff)
				best = { start, end, diff };
		}
	}
	return best;
}


int main()
{
	ull n, k;
	cin >> n >> k;
	vector<ull> arr(n);
	for (int i = 0; i < n; i++)
		cin >> arr[i];
	subrange max_subr = max_subrange(arr, n - (k - 1)); // k - 1 is just all subranges beside the max
	cout << max_subr.diff;
}

// 4 2   2 1 3 4
// 5 4   2 1 3 4 1