#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <numeric>

using ull = unsigned long long;
using ll = long long;
using namespace std;

struct subrange {
	int max_begin, max_end;
	ll diff = 0;
};
subrange max_subrange(const vector<ull>& target, ull size) {
	subrange best{};
	for (int start = 0; start < target.size(); start++) {
		ll sum = 0;
		ll min_left_id = start == 0 ? -1 : distance(target.begin(), min_element(target.begin(), target.begin() + start));
		ll min_left = min_left_id == -1 ? LLONG_MAX : target[min_left_id];
		ll min_id = start;
		ll min = LLONG_MAX;
		for (int end = start + 1; end <= start + size && end <= target.size(); end++) {
			sum += target[end - 1];
			if (min_id < end || min_id >= start) // If I have eaten the min
			{
				auto min_right_it = min_element(target.begin() + end, target.end());
				if (*min_right_it < min_left)
					min_id = distance(target.begin(), min_right_it);
				else
					min_id = min_left_id;
				min = target[min_id];
			}
			ll diff = sum - min;
			if (diff > best.diff)
				best = { start, end, diff };
		}
	}
	return best;
}


int main()
{
	ull n, k;
	cin >> n >> k;
	vector<ull> arr(n);
	for (auto &i : arr)
		cin >> i;
	subrange max_subr = max_subrange(arr, n - (k - 1)); // k - 1 is just all subranges beside the max
	cout << max_subr.diff;
}

// 4 2   2 1 3 4
// 5 4   2 1 3 4 1