import java.io.*;
import java.util.*;

public class G2 {
    int n;
    int s;
    int[][] c;
    int K = 0;
    public void solve() throws IOException {
        n = nextInt();
        s = nextInt();

        c = new int[n][];
        LinkedList<Integer> tasksList = new LinkedList<>();
        for (int i = 0; i < n; i++) {
            int k = nextInt();
            K += k;
            c[i] = new int[k];
            for (int j = 0; j < k; j++) {
                int t = nextInt();
                c[i][j] = t;
                tasksList.add(t);
            }
        }

        int cnt = 0;
        int[] tasks = new int[tasksList.size()];
        for (int i : tasksList) {
            tasks[cnt] = i;
            cnt++;
        }


        boolean[][] dp = new boolean[s + 1][];
        for (int i = 0; i < s + 1; i++) {
            dp[i] = new boolean[K + 1];
            dp[i][0] = false;
        }
        for (int i = 0; i < K; i++) {
            dp[0][i] = true;
        }
        for (int i = 0; i < s + 1; i++ ) {
            for (int j = 1; j < K + 1; j++) {
                dp[i][j] = dp[i][j - 1] || ((i - tasks[j - 1]) >= 0 && (dp[i - tasks[j - 1]][j - 1]));
            }
        }
//        for (int i = 0; i < s + 1; i++) {
//            out.println(Arrays.toString(dp[i]));
//        }


        if (dp[s][K]) {
            out.println("Yes");
            int i = s;
            int j = K;
            LinkedList<Integer> res = new LinkedList<>();
            while (i > 0 || j > 0) {
                if ((i - tasks[j - 1]) >= 0 && (dp[i - tasks[j - 1]][j - 1])) {
                    res.add(j - 1);
                    j -= 1;
                    i -= tasks[j];
                } else if (dp[i][j - 1]) {
                    j -= 1;
                }
            }
            out.println(res.size());
            for (int l : res) {
                out.print(l + 1 + " ");
            }
        } else {
            out.println("No");
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new G2().run();
    }

}