#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

vector<vector<bool>> knapsack(vector<int>& wt) {
    int n = wt.size();
    int maxWt = 1;
    for (int i: wt) {
        maxWt += i;
    }

    vector<vector<bool>> dp(n + 1, vector<bool> (maxWt));
    dp[0][0] = true;
    for (int i = 1; i <= n; i++) {
        for (int w = 0; w < maxWt; w++) {
            bool v = dp[i - 1][w];
            if (wt[i - 1] <= w) {
                v |= dp[i - 1][w - wt[i - 1]];
            }
            dp[i][w] = v;
        }
    }
    return dp;
}

vector<int> path(int w, vector<int>& wt, vector<vector<bool>>& dp) {
    int ind = dp.size() - 1;
    vector<int> inds;

    while (ind != 0) {
        if (wt[ind - 1] <= w && dp[ind - 1][w - wt[ind - 1]])  {
            inds.push_back(ind);
            w -= wt[ind - 1];
        }
        ind--;
    }
    return inds;
}

int main()
{
    /*
    1.  
    2.  ,     ,        
    4.    ,    ,     
      ,   24 .
    */

    int n, s; cin >> n >> s;
    vector<vector<int>> table(n);
    vector<vector<vector<bool>>> dps(n);

    bool anyIsOne = true;
    for (int i = 0; i < n; i++) {
        int k; cin >> k;
        table[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> table[i][j];
            anyIsOne &= (table[i][j] == 1);
        }
        dps[i] = knapsack(table[i]);
    }

    if (n == 1) {
        long long summ = 0;
        for (int i: table[0]) {
            summ += i;
        }

        int quan = table[0].size();
        if (s > summ || !dps[0][quan][s]) {
            cout << "No" << endl;
        } else {
            vector<int> inds = path(s, table[0], dps[0]);
            reverse(inds.begin(), inds.end());

            cout << "Yes" << endl;
            cout << inds.size() << endl;
            for (int& i: inds) {
                cout << i << " ";
            } cout << endl;
        }
        return 0;
    }

    if (anyIsOne) {
        if (s < n) {
            cout << "No" << endl;
            return 0;
        }
        vector<int> ans(n, 1);

        s -= n;
        for (int i = 0; i < n; i++) {
            ans[i] = min((int) table[i].size(), 1 + s);
            s -= min((int)table[i].size(), s);
            if (s == 0) {
                break;
            }
        }

        cout << "Yes" << endl;
        for (int i = 0; i < n; i++) {
            cout << ans[i] << endl;
            for (int j = 0; j < ans[i]; j++) {
                cout << j + 1 << " ";
            } cout << endl;
        }
        return 0;
    }

    return 0;
}
