#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

vector<vector<bool>> knapsack(vector<int>& wt) {
    int n = wt.size();
    int maxWt = 1;
    for (int i: wt) {
        maxWt += i;
    }

    vector<vector<bool>> dp(n + 1, vector<bool> (maxWt));
    dp[0][0] = true;
    for (int i = 1; i <= n; i++) {
        for (int w = 0; w < maxWt; w++) {
            bool v = dp[i - 1][w];
            if (wt[i - 1] <= w) {
                v |= dp[i - 1][w - wt[i - 1]];
            }
            dp[i][w] = v;
        }
    }
    return dp;
}

vector<int> path(int w, vector<int>& wt, vector<vector<bool>>& dp) {
    int ind = dp.size() - 1;
    vector<int> inds;

    while (ind != 0) {
        if (wt[ind - 1] <= w && dp[ind - 1][w - wt[ind - 1]])  {
            inds.push_back(ind);
            w -= wt[ind - 1];
        }
        ind--;
    }
    return inds;
}

int main()
{
    int n, s; cin >> n >> s;
    vector<vector<int>> table(n);
    vector<vector<vector<bool>>> dps(n);

    bool anyIsOne = true;
    for (int i = 0; i < n; i++) {
        int k; cin >> k;
        table[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> table[i][j];
            if (table[i][j] != 1) {
                anyIsOne = false;
            }
        }
        dps[i] = knapsack(table[i]);
    }

    if (anyIsOne) {
        int quan = 0;
        for (int i = 0; i < n; i++) {
            quan += table[i].size();
        }

        if (s < n || quan < s) {
            cout << "No" << endl;
            return 0;
        }

        vector<int> ans(n);
        for (int i = 0; i < n; i++) {
            int x = s - n + i + 1;
            x = min(x, (int)table[i].size());
            s -= x;
            ans[i] = x;
        }

        cout << "Yes" << endl;
        for (int i = 0; i < n; i++) {
            cout << ans[i] << endl;
            for (int j = 1; j <= ans[i]; j++) {
                cout << j << " ";
            } cout << endl;
        }
        return 0;
    }

    if (n == 1) {
        long long summ = 0;
        for (int i: table[0]) {
            summ += i;
        }

        int quan = table[0].size();
        if (s > summ || !dps[0][quan][s]) {
            cout << "No" << endl;
        } else {
            vector<int> inds = path(s, table[0], dps[0]);
            reverse(inds.begin(), inds.end());

            cout << "Yes" << endl;
            cout << inds.size() << endl;
            for (int& i: inds) {
                cout << i << " ";
            } cout << endl;
        }
        return 0;
    }

    if (n == 2) {
        int q1 = table[0].size();
        int q2 = table[1].size();

        set<long long> suitWt;
        vector<bool> k1 = dps[0][q1];
        vector<bool> k2 = dps[0][q2];

        for (int i = 0; i < k1.size(); i++) {
            if (k1[i]) {
                suitWt.insert(i);
            }
        }

        int suit1 = -1, suit2 = -1;
        for (int i = 0; i < k2.size(); i++) {
            if (k2[i] && suitWt.find(s - i) != suitWt.end()) {
                suit1 = s - i;
                suit2 = i;
            }
        }

        if (suit1 == -1) {
            cout << "No" << endl;
        } else {
            vector<int> inds1 = path(suit1, table[0], dps[0]);
            vector<int> inds2 = path(suit2, table[1], dps[1]);
            reverse(inds1.begin(), inds1.end());
            reverse(inds2.begin(), inds2.end());

            cout << "Yes" << endl;
            cout << inds1.size() << endl;
            for (int i: inds1) {
                cout << i << " ";
            } cout << endl;
            cout << inds2.size() << endl;
            for (int i: inds2) {
                cout << i << " ";
            } cout << endl;
        }
        return 0;
    }

    return 0;
}
